﻿// Implementation file for parser generated by fsyacc
module internal FSharp.Compiler.Parser
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open FSharp.Compiler
open Internal.Utilities.Text.Lexing
open Internal.Utilities.Text.Parsing.ParseHelpers
//# 3 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"


#nowarn "1182"  // generated code has lots of unused "parseState"

open Internal.Utilities

open FSharp.Compiler.AbstractIL
open FSharp.Compiler.AbstractIL.Internal
open FSharp.Compiler.AbstractIL.Internal.Library
open FSharp.Compiler
open Internal.Utilities.Text.Parsing

open System
open FSharp.Compiler.Range
open FSharp.Compiler.Ast
open FSharp.Compiler.Lib
open FSharp.Compiler.PrettyNaming
open FSharp.Compiler.ErrorLogger
open FSharp.Compiler.Features

#if DEBUG
let debugPrint(s) =
    if Internal.Utilities.Text.Parsing.Flags.debug then 
        printfn "\n%s" s
#else
let debugPrint(s) = ignore s
#endif

let exprFromParseError (e:SynExpr) = SynExpr.FromParseError (e,e.Range)
let patFromParseError (e:SynPat) = SynPat.FromParseError(e, e.Range)

let mkSynOptionalExpr (m: range) xopt = 
    let m = m.MakeSynthetic()
    match xopt with 
    | None -> mkSynLidGet m Ast.FSharpLib.CorePath "None"
    | Some x  -> SynExpr.App (ExprAtomicFlag.NonAtomic, false, mkSynLidGet m Ast.FSharpLib.CorePath "Some",x,m)

// record bindings returned by the recdExprBindings rule has shape:
// (binding, separator-before-this-binding)
// this function converts arguments from form
// binding1 (binding2*sep1, binding3*sep2...) sepN
// to form
// binding1*sep1, binding2*sep2
let rebindRanges first fields lastSep = 
    let rec run (name, value) l acc = 
        match l with
        | [] -> List.rev ((name, value, lastSep) :: acc)
        | (f, m) :: xs -> run f xs ((name, value, m) :: acc)
    run first fields []

let mkUnderscoreRecdField m = LongIdentWithDots([ident("_", m)], []), false
let mkRecdField lidwd = lidwd, true

let mkSynDoBinding (vis,strict,expr,m) = 
    match vis with
    | Some vis -> errorR(Error(FSComp.SR.parsDoCannotHaveVisibilityDeclarations (vis.ToString()),m))
    | None -> ()
    Binding (None,
             (if strict then DoBinding else StandaloneExpression),
             false,false,[],PreXmlDoc.Empty,SynInfo.emptySynValData,
             (if strict then SynPat.Const(SynConst.Unit,m) else SynPat.Wild m),
             None,expr,m,NoSequencePointAtDoBinding)

let mkSynDoDecl (e: SynExpr) = 
    let spExpr = if IsControlFlowExpression e then NoSequencePointAtDoBinding else SequencePointAtBinding e.Range in
    SynModuleDecl.DoExpr(spExpr, e, e.Range)

let addAttribs attrs p =  SynPat.Attrib(p,attrs,p.Range)


// This function is called by the generated parser code. Returning initiates error recovery 
// It must be called precisely "parse_error_rich"
let parse_error_rich = Some (fun (ctxt: ParseErrorContext<_>) -> 
    errorR(SyntaxError(box ctxt, ctxt.ParseState.LexBuffer.LexemeRange)))

let reportParseErrorAt m s = errorR(Error(s,m))

let unionRangeWithPos (r:range) p =
    let r2 = mkRange r.FileName p p
    unionRanges r r2

let raiseParseErrorAt m s = 
    reportParseErrorAt m s; 
    // This initiates error recovery
    raise RecoverableParseError 

let checkEndOfFileError t = 
  match t with 
  | LexCont.IfDefSkip(_,_,m)                      -> reportParseErrorAt m (FSComp.SR.parsEofInHashIf())
  | LexCont.String (_,m)                          -> reportParseErrorAt m (FSComp.SR.parsEofInString())
  | LexCont.TripleQuoteString (_,m)               -> reportParseErrorAt m (FSComp.SR.parsEofInTripleQuoteString())
  | LexCont.VerbatimString (_,m)                  -> reportParseErrorAt m (FSComp.SR.parsEofInVerbatimString())
  | LexCont.Comment (_,_,m)                       -> reportParseErrorAt m (FSComp.SR.parsEofInComment())
  | LexCont.SingleLineComment (_,_,m)             -> reportParseErrorAt m (FSComp.SR.parsEofInComment())
  | LexCont.StringInComment (_,_,m)               -> reportParseErrorAt m (FSComp.SR.parsEofInStringInComment())
  | LexCont.VerbatimStringInComment (_,_,m)       -> reportParseErrorAt m (FSComp.SR.parsEofInVerbatimStringInComment())
  | LexCont.TripleQuoteStringInComment (_,_,m)    -> reportParseErrorAt m (FSComp.SR.parsEofInTripleQuoteStringInComment())
  | LexCont.MLOnly (_,m)                          -> reportParseErrorAt m (FSComp.SR.parsEofInIfOcaml())
  | LexCont.EndLine(LexerEndlineContinuation.Skip(_,_,m)) -> reportParseErrorAt m (FSComp.SR.parsEofInDirective())
  | LexCont.EndLine(LexerEndlineContinuation.Token(stack))
  | LexCont.Token(stack) -> 
      match stack with 
      | [] -> ()
      | (_,m) :: _  -> reportParseErrorAt m (FSComp.SR.parsNoHashEndIfFound())

//                BindingSetPreAttrs(letRange, isRec, isUse, builderFunction, wholeRange)
type BindingSet = BindingSetPreAttrs of range * bool * bool * (SynAttributes -> SynAccess option -> SynAttributes * SynBinding list) * range

let mkClassMemberLocalBindings(isStatic,initialRangeOpt,attrs,vis,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,bindingSetRange)) = 
   let ignoredFreeAttrs,decls = declsPreAttrs attrs vis
   let wholeRange = 
       match initialRangeOpt with 
       | None -> bindingSetRange
       | Some m -> unionRanges m bindingSetRange
   if not (isNil ignoredFreeAttrs) then warning(Error(FSComp.SR.parsAttributesIgnored(),wholeRange));
   if isUse then errorR(Error(FSComp.SR.parsUseBindingsIllegalInImplicitClassConstructors(),wholeRange))
   SynMemberDefn.LetBindings (decls,isStatic,isRec,wholeRange)

let mkLocalBindings (mWhole,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,_),body) = 
   let ignoredFreeAttrs,decls = declsPreAttrs [] None 
   if not (isNil ignoredFreeAttrs) then warning(Error(FSComp.SR.parsAttributesIgnored(),mWhole))
   SynExpr.LetOrUse (isRec,isUse,decls,body,mWhole) 

let mkDefnBindings (mWhole,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,_bindingSetRange),attrs,vis,attrsm) = 
    if isUse then warning(Error(FSComp.SR.parsUseBindingsIllegalInModules(),mWhole))
    let freeAttrs,decls = declsPreAttrs attrs vis 
    let letDecls = [ SynModuleDecl.Let (isRec,decls,mWhole) ] 
    let attrDecls = if not (isNil freeAttrs) then [ SynModuleDecl.Attributes (freeAttrs,attrsm) ] else [] 
    attrDecls @ letDecls

let idOfPat (parseState:IParseState) m p = 
    match p with
    | SynPat.Wild r when parseState.LexBuffer.SupportsFeature LanguageFeature.WildCardInForLoop ->
        mkSynId r "_"
    | SynPat.Named (SynPat.Wild _,id,false,_,_) -> id
    | SynPat.LongIdent(LongIdentWithDots([id],_),_,None, SynConstructorArgs.Pats [], None,_) -> id
    | _ -> raiseParseErrorAt m (FSComp.SR.parsIntegerForLoopRequiresSimpleIdentifier())

let checkForMultipleAugmentations m a1 a2 = 
    if not (isNil a1) && not (isNil a2) then raiseParseErrorAt m (FSComp.SR.parsOnlyOneWithAugmentationAllowed())
    a1 @ a2

let grabXmlDoc(parseState:IParseState,elemIdx) = 
    LexbufLocalXmlDocStore.GrabXmlDocBeforeMarker(parseState.LexBuffer,rhs parseState elemIdx)

let unionRangeWithListBy projectRangeFromThing m listOfThing = 
    (m, listOfThing) ||> List.fold (fun m thing -> unionRanges m (projectRangeFromThing thing))

let rangeOfNonNilAttrs(attrs:SynAttributes) =
    (attrs.Head.Range,attrs.Tail) ||> unionRangeWithListBy (fun a -> a.Range)

let rangeOfLongIdent(lid:LongIdent) =
    System.Diagnostics.Debug.Assert(not lid.IsEmpty, "the parser should never produce a long-id that is the empty list") 
    (lid.Head.idRange,lid) ||> unionRangeWithListBy (fun id -> id.idRange) 


//# 164 "pars.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | HASH_IF of (range * string * Ast.LexerWhitespaceContinuation)
  | HASH_ELSE of (range * string * Ast.LexerWhitespaceContinuation)
  | HASH_ENDIF of (range * string * Ast.LexerWhitespaceContinuation)
  | COMMENT of (Ast.LexerWhitespaceContinuation)
  | WHITESPACE of (Ast.LexerWhitespaceContinuation)
  | HASH_LINE of (Ast.LexerWhitespaceContinuation)
  | HASH_LIGHT of (Ast.LexerWhitespaceContinuation)
  | INACTIVECODE of (Ast.LexerWhitespaceContinuation)
  | LINE_COMMENT of (Ast.LexerWhitespaceContinuation)
  | STRING_TEXT of (Ast.LexerWhitespaceContinuation)
  | EOF of (Ast.LexerWhitespaceContinuation)
  | LEX_FAILURE of (string)
  | ODUMMY of (token)
  | FIXED
  | OINTERFACE_MEMBER
  | OBLOCKEND
  | OBLOCKEND_COMING_SOON
  | OBLOCKEND_IS_HERE
  | ORIGHT_BLOCK_END
  | ODECLEND
  | OEND
  | OBLOCKSEP
  | OBLOCKBEGIN
  | ORESET
  | OFUN
  | OFUNCTION
  | OWITH
  | OELSE
  | OTHEN
  | ODO_BANG
  | ODO
  | OBINDER of (string)
  | OLET of (bool)
  | HIGH_PRECEDENCE_TYAPP
  | HIGH_PRECEDENCE_PAREN_APP
  | HIGH_PRECEDENCE_BRACK_APP
  | TYPE_COMING_SOON
  | TYPE_IS_HERE
  | MODULE_COMING_SOON
  | MODULE_IS_HERE
  | EXTERN
  | VOID
  | PUBLIC
  | PRIVATE
  | INTERNAL
  | GLOBAL
  | STATIC
  | MEMBER
  | CLASS
  | ABSTRACT
  | OVERRIDE
  | DEFAULT
  | CONSTRUCTOR
  | INHERIT
  | GREATER_RBRACK
  | STRUCT
  | SIG
  | BAR
  | RBRACK
  | RBRACE
  | RBRACE_COMING_SOON
  | RBRACE_IS_HERE
  | MINUS
  | DOLLAR
  | BAR_RBRACK
  | BAR_RBRACE
  | UNDERSCORE
  | SEMICOLON_SEMICOLON
  | LARROW
  | EQUALS
  | LBRACK
  | LBRACK_BAR
  | LBRACE_BAR
  | LBRACK_LESS
  | LBRACE
  | QMARK
  | QMARK_QMARK
  | DOT
  | COLON
  | COLON_COLON
  | COLON_GREATER
  | COLON_QMARK_GREATER
  | COLON_QMARK
  | COLON_EQUALS
  | SEMICOLON
  | WHEN
  | WHILE
  | WITH
  | HASH
  | AMP
  | AMP_AMP
  | QUOTE
  | LPAREN
  | RPAREN
  | RPAREN_COMING_SOON
  | RPAREN_IS_HERE
  | STAR
  | COMMA
  | RARROW
  | GREATER_BAR_RBRACK
  | LPAREN_STAR_RPAREN
  | OPEN
  | OR
  | REC
  | THEN
  | TO
  | TRUE
  | TRY
  | TYPE
  | VAL
  | INLINE
  | INTERFACE
  | INSTANCE
  | CONST
  | LAZY
  | OLAZY
  | MATCH
  | MATCH_BANG
  | MUTABLE
  | NEW
  | OF
  | EXCEPTION
  | FALSE
  | FOR
  | FUN
  | FUNCTION
  | IF
  | IN
  | JOIN_IN
  | FINALLY
  | DO_BANG
  | AND
  | AS
  | ASSERT
  | OASSERT
  | ASR
  | BEGIN
  | DO
  | DONE
  | DOWNTO
  | ELSE
  | ELIF
  | END
  | DOT_DOT
  | BAR_BAR
  | UPCAST
  | DOWNCAST
  | NULL
  | RESERVED
  | MODULE
  | NAMESPACE
  | DELEGATE
  | CONSTRAINT
  | BASE
  | LQUOTE of (string * bool)
  | RQUOTE of (string * bool)
  | RQUOTE_DOT of (string * bool)
  | PERCENT_OP of (string)
  | BINDER of (string)
  | LESS of (bool)
  | GREATER of (bool)
  | LET of (bool)
  | YIELD of (bool)
  | YIELD_BANG of (bool)
  | BIGNUM of ((string * string))
  | DECIMAL of (System.Decimal)
  | CHAR of (char)
  | IEEE64 of (double)
  | IEEE32 of (single)
  | NATIVEINT of (int64)
  | UNATIVEINT of (uint64)
  | UINT64 of (uint64)
  | UINT32 of (uint32)
  | UINT16 of (uint16)
  | UINT8 of (byte)
  | INT64 of (int64 * bool)
  | INT32 of (int32 * bool)
  | INT32_DOT_DOT of (int32 * bool)
  | INT16 of (int16 * bool)
  | INT8 of (sbyte * bool)
  | FUNKY_OPERATOR_NAME of (string)
  | ADJACENT_PREFIX_OP of (string)
  | PLUS_MINUS_OP of (string)
  | INFIX_AMP_OP of (string)
  | INFIX_STAR_DIV_MOD_OP of (string)
  | PREFIX_OP of (string)
  | INFIX_BAR_OP of (string)
  | INFIX_AT_HAT_OP of (string)
  | INFIX_COMPARE_OP of (string)
  | INFIX_STAR_STAR_OP of (string)
  | IDENT of (string)
  | KEYWORD_STRING of (string)
  | STRING of (string)
  | BYTEARRAY of (byte[])
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_HASH_IF
    | TOKEN_HASH_ELSE
    | TOKEN_HASH_ENDIF
    | TOKEN_COMMENT
    | TOKEN_WHITESPACE
    | TOKEN_HASH_LINE
    | TOKEN_HASH_LIGHT
    | TOKEN_INACTIVECODE
    | TOKEN_LINE_COMMENT
    | TOKEN_STRING_TEXT
    | TOKEN_EOF
    | TOKEN_LEX_FAILURE
    | TOKEN_ODUMMY
    | TOKEN_FIXED
    | TOKEN_OINTERFACE_MEMBER
    | TOKEN_OBLOCKEND
    | TOKEN_OBLOCKEND_COMING_SOON
    | TOKEN_OBLOCKEND_IS_HERE
    | TOKEN_ORIGHT_BLOCK_END
    | TOKEN_ODECLEND
    | TOKEN_OEND
    | TOKEN_OBLOCKSEP
    | TOKEN_OBLOCKBEGIN
    | TOKEN_ORESET
    | TOKEN_OFUN
    | TOKEN_OFUNCTION
    | TOKEN_OWITH
    | TOKEN_OELSE
    | TOKEN_OTHEN
    | TOKEN_ODO_BANG
    | TOKEN_ODO
    | TOKEN_OBINDER
    | TOKEN_OLET
    | TOKEN_HIGH_PRECEDENCE_TYAPP
    | TOKEN_HIGH_PRECEDENCE_PAREN_APP
    | TOKEN_HIGH_PRECEDENCE_BRACK_APP
    | TOKEN_TYPE_COMING_SOON
    | TOKEN_TYPE_IS_HERE
    | TOKEN_MODULE_COMING_SOON
    | TOKEN_MODULE_IS_HERE
    | TOKEN_EXTERN
    | TOKEN_VOID
    | TOKEN_PUBLIC
    | TOKEN_PRIVATE
    | TOKEN_INTERNAL
    | TOKEN_GLOBAL
    | TOKEN_STATIC
    | TOKEN_MEMBER
    | TOKEN_CLASS
    | TOKEN_ABSTRACT
    | TOKEN_OVERRIDE
    | TOKEN_DEFAULT
    | TOKEN_CONSTRUCTOR
    | TOKEN_INHERIT
    | TOKEN_GREATER_RBRACK
    | TOKEN_STRUCT
    | TOKEN_SIG
    | TOKEN_BAR
    | TOKEN_RBRACK
    | TOKEN_RBRACE
    | TOKEN_RBRACE_COMING_SOON
    | TOKEN_RBRACE_IS_HERE
    | TOKEN_MINUS
    | TOKEN_DOLLAR
    | TOKEN_BAR_RBRACK
    | TOKEN_BAR_RBRACE
    | TOKEN_UNDERSCORE
    | TOKEN_SEMICOLON_SEMICOLON
    | TOKEN_LARROW
    | TOKEN_EQUALS
    | TOKEN_LBRACK
    | TOKEN_LBRACK_BAR
    | TOKEN_LBRACE_BAR
    | TOKEN_LBRACK_LESS
    | TOKEN_LBRACE
    | TOKEN_QMARK
    | TOKEN_QMARK_QMARK
    | TOKEN_DOT
    | TOKEN_COLON
    | TOKEN_COLON_COLON
    | TOKEN_COLON_GREATER
    | TOKEN_COLON_QMARK_GREATER
    | TOKEN_COLON_QMARK
    | TOKEN_COLON_EQUALS
    | TOKEN_SEMICOLON
    | TOKEN_WHEN
    | TOKEN_WHILE
    | TOKEN_WITH
    | TOKEN_HASH
    | TOKEN_AMP
    | TOKEN_AMP_AMP
    | TOKEN_QUOTE
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_RPAREN_COMING_SOON
    | TOKEN_RPAREN_IS_HERE
    | TOKEN_STAR
    | TOKEN_COMMA
    | TOKEN_RARROW
    | TOKEN_GREATER_BAR_RBRACK
    | TOKEN_LPAREN_STAR_RPAREN
    | TOKEN_OPEN
    | TOKEN_OR
    | TOKEN_REC
    | TOKEN_THEN
    | TOKEN_TO
    | TOKEN_TRUE
    | TOKEN_TRY
    | TOKEN_TYPE
    | TOKEN_VAL
    | TOKEN_INLINE
    | TOKEN_INTERFACE
    | TOKEN_INSTANCE
    | TOKEN_CONST
    | TOKEN_LAZY
    | TOKEN_OLAZY
    | TOKEN_MATCH
    | TOKEN_MATCH_BANG
    | TOKEN_MUTABLE
    | TOKEN_NEW
    | TOKEN_OF
    | TOKEN_EXCEPTION
    | TOKEN_FALSE
    | TOKEN_FOR
    | TOKEN_FUN
    | TOKEN_FUNCTION
    | TOKEN_IF
    | TOKEN_IN
    | TOKEN_JOIN_IN
    | TOKEN_FINALLY
    | TOKEN_DO_BANG
    | TOKEN_AND
    | TOKEN_AS
    | TOKEN_ASSERT
    | TOKEN_OASSERT
    | TOKEN_ASR
    | TOKEN_BEGIN
    | TOKEN_DO
    | TOKEN_DONE
    | TOKEN_DOWNTO
    | TOKEN_ELSE
    | TOKEN_ELIF
    | TOKEN_END
    | TOKEN_DOT_DOT
    | TOKEN_BAR_BAR
    | TOKEN_UPCAST
    | TOKEN_DOWNCAST
    | TOKEN_NULL
    | TOKEN_RESERVED
    | TOKEN_MODULE
    | TOKEN_NAMESPACE
    | TOKEN_DELEGATE
    | TOKEN_CONSTRAINT
    | TOKEN_BASE
    | TOKEN_LQUOTE
    | TOKEN_RQUOTE
    | TOKEN_RQUOTE_DOT
    | TOKEN_PERCENT_OP
    | TOKEN_BINDER
    | TOKEN_LESS
    | TOKEN_GREATER
    | TOKEN_LET
    | TOKEN_YIELD
    | TOKEN_YIELD_BANG
    | TOKEN_BIGNUM
    | TOKEN_DECIMAL
    | TOKEN_CHAR
    | TOKEN_IEEE64
    | TOKEN_IEEE32
    | TOKEN_NATIVEINT
    | TOKEN_UNATIVEINT
    | TOKEN_UINT64
    | TOKEN_UINT32
    | TOKEN_UINT16
    | TOKEN_UINT8
    | TOKEN_INT64
    | TOKEN_INT32
    | TOKEN_INT32_DOT_DOT
    | TOKEN_INT16
    | TOKEN_INT8
    | TOKEN_FUNKY_OPERATOR_NAME
    | TOKEN_ADJACENT_PREFIX_OP
    | TOKEN_PLUS_MINUS_OP
    | TOKEN_INFIX_AMP_OP
    | TOKEN_INFIX_STAR_DIV_MOD_OP
    | TOKEN_PREFIX_OP
    | TOKEN_INFIX_BAR_OP
    | TOKEN_INFIX_AT_HAT_OP
    | TOKEN_INFIX_COMPARE_OP
    | TOKEN_INFIX_STAR_STAR_OP
    | TOKEN_IDENT
    | TOKEN_KEYWORD_STRING
    | TOKEN_STRING
    | TOKEN_BYTEARRAY
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startsignatureFile
    | NONTERM__startimplementationFile
    | NONTERM__startinteraction
    | NONTERM__starttypedSeqExprEOF
    | NONTERM__starttypEOF
    | NONTERM_interaction
    | NONTERM_interactiveTerminator
    | NONTERM_interactiveItemsTerminator
    | NONTERM_interactiveDefns
    | NONTERM_interactiveExpr
    | NONTERM_interactiveHash
    | NONTERM_interactiveSeparators
    | NONTERM_interactiveSeparator
    | NONTERM_hashDirective
    | NONTERM_hashDirectiveArgs
    | NONTERM_hashDirectiveArg
    | NONTERM_signatureFile
    | NONTERM_moduleIntro
    | NONTERM_namespaceIntro
    | NONTERM_fileNamespaceSpecs
    | NONTERM_fileNamespaceSpecList
    | NONTERM_fileNamespaceSpec
    | NONTERM_fileModuleSpec
    | NONTERM_moduleSpfnsPossiblyEmptyBlock
    | NONTERM_moduleSpfnsPossiblyEmpty
    | NONTERM_moduleSpfns
    | NONTERM_moduleSpfn
    | NONTERM_valSpfn
    | NONTERM_optLiteralValueSpfn
    | NONTERM_moduleSpecBlock
    | NONTERM_tyconSpfns
    | NONTERM_tyconSpfnList
    | NONTERM_tyconSpfn
    | NONTERM_tyconSpfnRhsBlock
    | NONTERM_tyconSpfnRhs
    | NONTERM_tyconClassSpfn
    | NONTERM_classSpfnBlockKindUnspecified
    | NONTERM_classSpfnBlock
    | NONTERM_classSpfnMembers
    | NONTERM_classSpfnMembersAtLeastOne
    | NONTERM_classMemberSpfn
    | NONTERM_classMemberSpfnGetSet
    | NONTERM_classMemberSpfnGetSetElements
    | NONTERM_memberSpecFlags
    | NONTERM_exconSpfn
    | NONTERM_opt_classSpfn
    | NONTERM_implementationFile
    | NONTERM_fileNamespaceImpls
    | NONTERM_fileNamespaceImplList
    | NONTERM_fileNamespaceImpl
    | NONTERM_fileModuleImpl
    | NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock
    | NONTERM_moduleDefnsOrExprPossiblyEmpty
    | NONTERM_moduleDefnsOrExpr
    | NONTERM_moduleDefns
    | NONTERM_moduleDefnOrDirective
    | NONTERM_moduleDefn
    | NONTERM_namedModuleAbbrevBlock
    | NONTERM_namedModuleDefnBlock
    | NONTERM_wrappedNamedModuleDefn
    | NONTERM_tyconDefnAugmentation
    | NONTERM_opt_attributes
    | NONTERM_attributes
    | NONTERM_attributeList
    | NONTERM_attributeListElements
    | NONTERM_attribute
    | NONTERM_attributeTarget
    | NONTERM_memberFlags
    | NONTERM_typeNameInfo
    | NONTERM_tyconDefnList
    | NONTERM_tyconDefn
    | NONTERM_tyconDefnRhsBlock
    | NONTERM_tyconDefnRhs
    | NONTERM_tyconClassDefn
    | NONTERM_classDefnBlockKindUnspecified
    | NONTERM_classDefnBlock
    | NONTERM_classDefnMembers
    | NONTERM_classDefnMembersAtLeastOne
    | NONTERM_classDefnMemberGetSet
    | NONTERM_classDefnMemberGetSetElements
    | NONTERM_classDefnMemberGetSetElement
    | NONTERM_memberCore
    | NONTERM_abstractMemberFlags
    | NONTERM_classDefnMember
    | NONTERM_valDefnDecl
    | NONTERM_autoPropsDefnDecl
    | NONTERM_opt_typ
    | NONTERM_atomicPatternLongIdent
    | NONTERM_opt_access
    | NONTERM_access
    | NONTERM_opt_declVisibility
    | NONTERM_opt_interfaceImplDefn
    | NONTERM_opt_classDefn
    | NONTERM_inheritsDefn
    | NONTERM_optAsSpec
    | NONTERM_asSpec
    | NONTERM_optBaseSpec
    | NONTERM_baseSpec
    | NONTERM_objectImplementationBlock
    | NONTERM_objectImplementationMembers
    | NONTERM_objectImplementationMember
    | NONTERM_memberOrOverride
    | NONTERM_tyconDefnOrSpfnSimpleRepr
    | NONTERM_braceFieldDeclList
    | NONTERM_anonRecdType
    | NONTERM_braceBarFieldDeclListCore
    | NONTERM_inlineAssemblyTyconRepr
    | NONTERM_classOrInterfaceOrStruct
    | NONTERM_interfaceMember
    | NONTERM_tyconNameAndTyparDecls
    | NONTERM_prefixTyparDecls
    | NONTERM_typarDeclList
    | NONTERM_typarDecl
    | NONTERM_postfixTyparDecls
    | NONTERM_explicitValTyparDeclsCore
    | NONTERM_explicitValTyparDecls
    | NONTERM_opt_explicitValTyparDecls
    | NONTERM_opt_explicitValTyparDecls2
    | NONTERM_opt_typeConstraints
    | NONTERM_typeConstraints
    | NONTERM_typeConstraint
    | NONTERM_typarAlts
    | NONTERM_unionTypeRepr
    | NONTERM_barAndgrabXmlDoc
    | NONTERM_attrUnionCaseDecls
    | NONTERM_attrUnionCaseDecl
    | NONTERM_unionCaseName
    | NONTERM_firstUnionCaseDeclOfMany
    | NONTERM_firstUnionCaseDecl
    | NONTERM_unionCaseReprElements
    | NONTERM_unionCaseReprElement
    | NONTERM_unionCaseRepr
    | NONTERM_recdFieldDeclList
    | NONTERM_recdFieldDecl
    | NONTERM_fieldDecl
    | NONTERM_exconDefn
    | NONTERM_exceptionAndGrabDoc
    | NONTERM_exconCore
    | NONTERM_exconIntro
    | NONTERM_exconRepr
    | NONTERM_openDecl
    | NONTERM_defnBindings
    | NONTERM_doBinding
    | NONTERM_hardwhiteLetBindings
    | NONTERM_hardwhiteDoBinding
    | NONTERM_classDefnBindings
    | NONTERM_hardwhiteDefnBindingsTerminator
    | NONTERM_cPrototype
    | NONTERM_cArgs
    | NONTERM_cMoreArgs
    | NONTERM_cArg
    | NONTERM_cType
    | NONTERM_cRetType
    | NONTERM_localBindings
    | NONTERM_moreLocalBindings
    | NONTERM_attr_localBinding
    | NONTERM_localBinding
    | NONTERM_typedExprWithStaticOptimizationsBlock
    | NONTERM_typedExprWithStaticOptimizations
    | NONTERM_opt_staticOptimizations
    | NONTERM_staticOptimization
    | NONTERM_staticOptimizationConditions
    | NONTERM_staticOptimizationCondition
    | NONTERM_rawConstant
    | NONTERM_rationalConstant
    | NONTERM_atomicUnsignedRationalConstant
    | NONTERM_atomicRationalConstant
    | NONTERM_constant
    | NONTERM_bindingPattern
    | NONTERM_simplePattern
    | NONTERM_simplePatternCommaList
    | NONTERM_simplePatterns
    | NONTERM_headBindingPattern
    | NONTERM_tuplePatternElements
    | NONTERM_conjPatternElements
    | NONTERM_namePatPairs
    | NONTERM_namePatPair
    | NONTERM_constrPattern
    | NONTERM_atomicPatsOrNamePatPairs
    | NONTERM_atomicPatterns
    | NONTERM_atomicPattern
    | NONTERM_parenPatternBody
    | NONTERM_parenPattern
    | NONTERM_tupleParenPatternElements
    | NONTERM_conjParenPatternElements
    | NONTERM_recordPatternElementsAux
    | NONTERM_recordPatternElement
    | NONTERM_listPatternElements
    | NONTERM_typedSeqExprBlock
    | NONTERM_declExprBlock
    | NONTERM_typedSeqExprBlockR
    | NONTERM_typedSeqExpr
    | NONTERM_typedSeqExprEOF
    | NONTERM_seqExpr
    | NONTERM_recover
    | NONTERM_declExpr
    | NONTERM_dynamicArg
    | NONTERM_withClauses
    | NONTERM_withPatternClauses
    | NONTERM_patternAndGuard
    | NONTERM_patternClauses
    | NONTERM_patternGuard
    | NONTERM_patternResult
    | NONTERM_ifExprCases
    | NONTERM_ifExprThen
    | NONTERM_ifExprElifs
    | NONTERM_tupleExpr
    | NONTERM_minusExpr
    | NONTERM_appExpr
    | NONTERM_argExpr
    | NONTERM_atomicExpr
    | NONTERM_atomicExprQualification
    | NONTERM_optRangeSeqExpr
    | NONTERM_optRange
    | NONTERM_atomicExprAfterType
    | NONTERM_beginEndExpr
    | NONTERM_quoteExpr
    | NONTERM_arrayExpr
    | NONTERM_parenExpr
    | NONTERM_parenExprBody
    | NONTERM_staticallyKnownHeadTypars
    | NONTERM_staticallyKnownHeadTyparAlts
    | NONTERM_braceExpr
    | NONTERM_braceExprBody
    | NONTERM_listExprElements
    | NONTERM_monadicExprInitial
    | NONTERM_rangeSequenceExpr
    | NONTERM_arrowThenExprR
    | NONTERM_forLoopBinder
    | NONTERM_forLoopRange
    | NONTERM_forLoopDirection
    | NONTERM_inlineAssemblyExpr
    | NONTERM_opt_curriedArgExprs
    | NONTERM_opt_atomicExprAfterType
    | NONTERM_opt_inlineAssemblyTypeArg
    | NONTERM_opt_inlineAssemblyReturnTypes
    | NONTERM_recdExpr
    | NONTERM_recdExprCore
    | NONTERM_opt_seps_recd
    | NONTERM_seps_recd
    | NONTERM_pathOrUnderscore
    | NONTERM_recdExprBindings
    | NONTERM_recdBinding
    | NONTERM_objExpr
    | NONTERM_objExprBaseCall
    | NONTERM_opt_objExprBindings
    | NONTERM_objExprBindings
    | NONTERM_objExprInterfaces
    | NONTERM_opt_objExprInterfaces
    | NONTERM_objExprInterface
    | NONTERM_braceBarExpr
    | NONTERM_braceBarExprCore
    | NONTERM_anonLambdaExpr
    | NONTERM_anonMatchingExpr
    | NONTERM_typeWithTypeConstraints
    | NONTERM_topTypeWithTypeConstraints
    | NONTERM_opt_topReturnTypeWithTypeConstraints
    | NONTERM_topType
    | NONTERM_topTupleType
    | NONTERM_topTupleTypeElements
    | NONTERM_topAppType
    | NONTERM_typ
    | NONTERM_typEOF
    | NONTERM_tupleType
    | NONTERM_tupleOrQuotTypeElements
    | NONTERM_appTypeCon
    | NONTERM_appTypeConPower
    | NONTERM_appType
    | NONTERM_arrayTypeSuffix
    | NONTERM_appTypePrefixArguments
    | NONTERM_typeArgListElements
    | NONTERM_powerType
    | NONTERM_atomTypeNonAtomicDeprecated
    | NONTERM_atomTypeOrAnonRecdType
    | NONTERM_atomType
    | NONTERM_typeArgsNoHpaDeprecated
    | NONTERM_typeArgsActual
    | NONTERM_typeArgActual
    | NONTERM_typeArgActualOrDummyIfEmpty
    | NONTERM_dummyTypeArg
    | NONTERM_measureTypeArg
    | NONTERM_measureTypeAtom
    | NONTERM_measureTypePower
    | NONTERM_measureTypeSeq
    | NONTERM_measureTypeExpr
    | NONTERM_typar
    | NONTERM_staticallyKnownHeadTypar
    | NONTERM_ident
    | NONTERM_path
    | NONTERM_opName
    | NONTERM_operatorName
    | NONTERM_activePatternCaseName
    | NONTERM_activePatternCaseNames
    | NONTERM_identOrOp
    | NONTERM_pathOp
    | NONTERM_nameop
    | NONTERM_topSeparator
    | NONTERM_topSeparators
    | NONTERM_opt_topSeparators
    | NONTERM_seps
    | NONTERM_declEnd
    | NONTERM_opt_declEnd
    | NONTERM_opt_ODECLEND
    | NONTERM_deprecated_opt_equals
    | NONTERM_opt_OBLOCKSEP
    | NONTERM_opt_seps
    | NONTERM_opt_rec
    | NONTERM_opt_bar
    | NONTERM_opt_inline
    | NONTERM_opt_mutable
    | NONTERM_doToken
    | NONTERM_doneDeclEnd
    | NONTERM_structOrBegin
    | NONTERM_sigOrBegin
    | NONTERM_colonOrEquals
    | NONTERM_stringOrKeywordString
    | NONTERM_opt_HIGH_PRECEDENCE_APP
    | NONTERM_opt_HIGH_PRECEDENCE_TYAPP
    | NONTERM_typeKeyword
    | NONTERM_moduleKeyword
    | NONTERM_rbrace
    | NONTERM_bar_rbrace
    | NONTERM_rparen
    | NONTERM_oblockend
    | NONTERM_ends_other_than_rparen_coming_soon_or_recover
    | NONTERM_ends_coming_soon_or_recover

// This function maps tokens to integer indexes
let tagOfToken (t:token) = 
  match t with
  | HASH_IF _ -> 0 
  | HASH_ELSE _ -> 1 
  | HASH_ENDIF _ -> 2 
  | COMMENT _ -> 3 
  | WHITESPACE _ -> 4 
  | HASH_LINE _ -> 5 
  | HASH_LIGHT _ -> 6 
  | INACTIVECODE _ -> 7 
  | LINE_COMMENT _ -> 8 
  | STRING_TEXT _ -> 9 
  | EOF _ -> 10 
  | LEX_FAILURE _ -> 11 
  | ODUMMY _ -> 12 
  | FIXED  -> 13 
  | OINTERFACE_MEMBER  -> 14 
  | OBLOCKEND  -> 15 
  | OBLOCKEND_COMING_SOON  -> 16 
  | OBLOCKEND_IS_HERE  -> 17 
  | ORIGHT_BLOCK_END  -> 18 
  | ODECLEND  -> 19 
  | OEND  -> 20 
  | OBLOCKSEP  -> 21 
  | OBLOCKBEGIN  -> 22 
  | ORESET  -> 23 
  | OFUN  -> 24 
  | OFUNCTION  -> 25 
  | OWITH  -> 26 
  | OELSE  -> 27 
  | OTHEN  -> 28 
  | ODO_BANG  -> 29 
  | ODO  -> 30 
  | OBINDER _ -> 31 
  | OLET _ -> 32 
  | HIGH_PRECEDENCE_TYAPP  -> 33 
  | HIGH_PRECEDENCE_PAREN_APP  -> 34 
  | HIGH_PRECEDENCE_BRACK_APP  -> 35 
  | TYPE_COMING_SOON  -> 36 
  | TYPE_IS_HERE  -> 37 
  | MODULE_COMING_SOON  -> 38 
  | MODULE_IS_HERE  -> 39 
  | EXTERN  -> 40 
  | VOID  -> 41 
  | PUBLIC  -> 42 
  | PRIVATE  -> 43 
  | INTERNAL  -> 44 
  | GLOBAL  -> 45 
  | STATIC  -> 46 
  | MEMBER  -> 47 
  | CLASS  -> 48 
  | ABSTRACT  -> 49 
  | OVERRIDE  -> 50 
  | DEFAULT  -> 51 
  | CONSTRUCTOR  -> 52 
  | INHERIT  -> 53 
  | GREATER_RBRACK  -> 54 
  | STRUCT  -> 55 
  | SIG  -> 56 
  | BAR  -> 57 
  | RBRACK  -> 58 
  | RBRACE  -> 59 
  | RBRACE_COMING_SOON  -> 60 
  | RBRACE_IS_HERE  -> 61 
  | MINUS  -> 62 
  | DOLLAR  -> 63 
  | BAR_RBRACK  -> 64 
  | BAR_RBRACE  -> 65 
  | UNDERSCORE  -> 66 
  | SEMICOLON_SEMICOLON  -> 67 
  | LARROW  -> 68 
  | EQUALS  -> 69 
  | LBRACK  -> 70 
  | LBRACK_BAR  -> 71 
  | LBRACE_BAR  -> 72 
  | LBRACK_LESS  -> 73 
  | LBRACE  -> 74 
  | QMARK  -> 75 
  | QMARK_QMARK  -> 76 
  | DOT  -> 77 
  | COLON  -> 78 
  | COLON_COLON  -> 79 
  | COLON_GREATER  -> 80 
  | COLON_QMARK_GREATER  -> 81 
  | COLON_QMARK  -> 82 
  | COLON_EQUALS  -> 83 
  | SEMICOLON  -> 84 
  | WHEN  -> 85 
  | WHILE  -> 86 
  | WITH  -> 87 
  | HASH  -> 88 
  | AMP  -> 89 
  | AMP_AMP  -> 90 
  | QUOTE  -> 91 
  | LPAREN  -> 92 
  | RPAREN  -> 93 
  | RPAREN_COMING_SOON  -> 94 
  | RPAREN_IS_HERE  -> 95 
  | STAR  -> 96 
  | COMMA  -> 97 
  | RARROW  -> 98 
  | GREATER_BAR_RBRACK  -> 99 
  | LPAREN_STAR_RPAREN  -> 100 
  | OPEN  -> 101 
  | OR  -> 102 
  | REC  -> 103 
  | THEN  -> 104 
  | TO  -> 105 
  | TRUE  -> 106 
  | TRY  -> 107 
  | TYPE  -> 108 
  | VAL  -> 109 
  | INLINE  -> 110 
  | INTERFACE  -> 111 
  | INSTANCE  -> 112 
  | CONST  -> 113 
  | LAZY  -> 114 
  | OLAZY  -> 115 
  | MATCH  -> 116 
  | MATCH_BANG  -> 117 
  | MUTABLE  -> 118 
  | NEW  -> 119 
  | OF  -> 120 
  | EXCEPTION  -> 121 
  | FALSE  -> 122 
  | FOR  -> 123 
  | FUN  -> 124 
  | FUNCTION  -> 125 
  | IF  -> 126 
  | IN  -> 127 
  | JOIN_IN  -> 128 
  | FINALLY  -> 129 
  | DO_BANG  -> 130 
  | AND  -> 131 
  | AS  -> 132 
  | ASSERT  -> 133 
  | OASSERT  -> 134 
  | ASR  -> 135 
  | BEGIN  -> 136 
  | DO  -> 137 
  | DONE  -> 138 
  | DOWNTO  -> 139 
  | ELSE  -> 140 
  | ELIF  -> 141 
  | END  -> 142 
  | DOT_DOT  -> 143 
  | BAR_BAR  -> 144 
  | UPCAST  -> 145 
  | DOWNCAST  -> 146 
  | NULL  -> 147 
  | RESERVED  -> 148 
  | MODULE  -> 149 
  | NAMESPACE  -> 150 
  | DELEGATE  -> 151 
  | CONSTRAINT  -> 152 
  | BASE  -> 153 
  | LQUOTE _ -> 154 
  | RQUOTE _ -> 155 
  | RQUOTE_DOT _ -> 156 
  | PERCENT_OP _ -> 157 
  | BINDER _ -> 158 
  | LESS _ -> 159 
  | GREATER _ -> 160 
  | LET _ -> 161 
  | YIELD _ -> 162 
  | YIELD_BANG _ -> 163 
  | BIGNUM _ -> 164 
  | DECIMAL _ -> 165 
  | CHAR _ -> 166 
  | IEEE64 _ -> 167 
  | IEEE32 _ -> 168 
  | NATIVEINT _ -> 169 
  | UNATIVEINT _ -> 170 
  | UINT64 _ -> 171 
  | UINT32 _ -> 172 
  | UINT16 _ -> 173 
  | UINT8 _ -> 174 
  | INT64 _ -> 175 
  | INT32 _ -> 176 
  | INT32_DOT_DOT _ -> 177 
  | INT16 _ -> 178 
  | INT8 _ -> 179 
  | FUNKY_OPERATOR_NAME _ -> 180 
  | ADJACENT_PREFIX_OP _ -> 181 
  | PLUS_MINUS_OP _ -> 182 
  | INFIX_AMP_OP _ -> 183 
  | INFIX_STAR_DIV_MOD_OP _ -> 184 
  | PREFIX_OP _ -> 185 
  | INFIX_BAR_OP _ -> 186 
  | INFIX_AT_HAT_OP _ -> 187 
  | INFIX_COMPARE_OP _ -> 188 
  | INFIX_STAR_STAR_OP _ -> 189 
  | IDENT _ -> 190 
  | KEYWORD_STRING _ -> 191 
  | STRING _ -> 192 
  | BYTEARRAY _ -> 193 

// This function maps integer indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_HASH_IF 
  | 1 -> TOKEN_HASH_ELSE 
  | 2 -> TOKEN_HASH_ENDIF 
  | 3 -> TOKEN_COMMENT 
  | 4 -> TOKEN_WHITESPACE 
  | 5 -> TOKEN_HASH_LINE 
  | 6 -> TOKEN_HASH_LIGHT 
  | 7 -> TOKEN_INACTIVECODE 
  | 8 -> TOKEN_LINE_COMMENT 
  | 9 -> TOKEN_STRING_TEXT 
  | 10 -> TOKEN_EOF 
  | 11 -> TOKEN_LEX_FAILURE 
  | 12 -> TOKEN_ODUMMY 
  | 13 -> TOKEN_FIXED 
  | 14 -> TOKEN_OINTERFACE_MEMBER 
  | 15 -> TOKEN_OBLOCKEND 
  | 16 -> TOKEN_OBLOCKEND_COMING_SOON 
  | 17 -> TOKEN_OBLOCKEND_IS_HERE 
  | 18 -> TOKEN_ORIGHT_BLOCK_END 
  | 19 -> TOKEN_ODECLEND 
  | 20 -> TOKEN_OEND 
  | 21 -> TOKEN_OBLOCKSEP 
  | 22 -> TOKEN_OBLOCKBEGIN 
  | 23 -> TOKEN_ORESET 
  | 24 -> TOKEN_OFUN 
  | 25 -> TOKEN_OFUNCTION 
  | 26 -> TOKEN_OWITH 
  | 27 -> TOKEN_OELSE 
  | 28 -> TOKEN_OTHEN 
  | 29 -> TOKEN_ODO_BANG 
  | 30 -> TOKEN_ODO 
  | 31 -> TOKEN_OBINDER 
  | 32 -> TOKEN_OLET 
  | 33 -> TOKEN_HIGH_PRECEDENCE_TYAPP 
  | 34 -> TOKEN_HIGH_PRECEDENCE_PAREN_APP 
  | 35 -> TOKEN_HIGH_PRECEDENCE_BRACK_APP 
  | 36 -> TOKEN_TYPE_COMING_SOON 
  | 37 -> TOKEN_TYPE_IS_HERE 
  | 38 -> TOKEN_MODULE_COMING_SOON 
  | 39 -> TOKEN_MODULE_IS_HERE 
  | 40 -> TOKEN_EXTERN 
  | 41 -> TOKEN_VOID 
  | 42 -> TOKEN_PUBLIC 
  | 43 -> TOKEN_PRIVATE 
  | 44 -> TOKEN_INTERNAL 
  | 45 -> TOKEN_GLOBAL 
  | 46 -> TOKEN_STATIC 
  | 47 -> TOKEN_MEMBER 
  | 48 -> TOKEN_CLASS 
  | 49 -> TOKEN_ABSTRACT 
  | 50 -> TOKEN_OVERRIDE 
  | 51 -> TOKEN_DEFAULT 
  | 52 -> TOKEN_CONSTRUCTOR 
  | 53 -> TOKEN_INHERIT 
  | 54 -> TOKEN_GREATER_RBRACK 
  | 55 -> TOKEN_STRUCT 
  | 56 -> TOKEN_SIG 
  | 57 -> TOKEN_BAR 
  | 58 -> TOKEN_RBRACK 
  | 59 -> TOKEN_RBRACE 
  | 60 -> TOKEN_RBRACE_COMING_SOON 
  | 61 -> TOKEN_RBRACE_IS_HERE 
  | 62 -> TOKEN_MINUS 
  | 63 -> TOKEN_DOLLAR 
  | 64 -> TOKEN_BAR_RBRACK 
  | 65 -> TOKEN_BAR_RBRACE 
  | 66 -> TOKEN_UNDERSCORE 
  | 67 -> TOKEN_SEMICOLON_SEMICOLON 
  | 68 -> TOKEN_LARROW 
  | 69 -> TOKEN_EQUALS 
  | 70 -> TOKEN_LBRACK 
  | 71 -> TOKEN_LBRACK_BAR 
  | 72 -> TOKEN_LBRACE_BAR 
  | 73 -> TOKEN_LBRACK_LESS 
  | 74 -> TOKEN_LBRACE 
  | 75 -> TOKEN_QMARK 
  | 76 -> TOKEN_QMARK_QMARK 
  | 77 -> TOKEN_DOT 
  | 78 -> TOKEN_COLON 
  | 79 -> TOKEN_COLON_COLON 
  | 80 -> TOKEN_COLON_GREATER 
  | 81 -> TOKEN_COLON_QMARK_GREATER 
  | 82 -> TOKEN_COLON_QMARK 
  | 83 -> TOKEN_COLON_EQUALS 
  | 84 -> TOKEN_SEMICOLON 
  | 85 -> TOKEN_WHEN 
  | 86 -> TOKEN_WHILE 
  | 87 -> TOKEN_WITH 
  | 88 -> TOKEN_HASH 
  | 89 -> TOKEN_AMP 
  | 90 -> TOKEN_AMP_AMP 
  | 91 -> TOKEN_QUOTE 
  | 92 -> TOKEN_LPAREN 
  | 93 -> TOKEN_RPAREN 
  | 94 -> TOKEN_RPAREN_COMING_SOON 
  | 95 -> TOKEN_RPAREN_IS_HERE 
  | 96 -> TOKEN_STAR 
  | 97 -> TOKEN_COMMA 
  | 98 -> TOKEN_RARROW 
  | 99 -> TOKEN_GREATER_BAR_RBRACK 
  | 100 -> TOKEN_LPAREN_STAR_RPAREN 
  | 101 -> TOKEN_OPEN 
  | 102 -> TOKEN_OR 
  | 103 -> TOKEN_REC 
  | 104 -> TOKEN_THEN 
  | 105 -> TOKEN_TO 
  | 106 -> TOKEN_TRUE 
  | 107 -> TOKEN_TRY 
  | 108 -> TOKEN_TYPE 
  | 109 -> TOKEN_VAL 
  | 110 -> TOKEN_INLINE 
  | 111 -> TOKEN_INTERFACE 
  | 112 -> TOKEN_INSTANCE 
  | 113 -> TOKEN_CONST 
  | 114 -> TOKEN_LAZY 
  | 115 -> TOKEN_OLAZY 
  | 116 -> TOKEN_MATCH 
  | 117 -> TOKEN_MATCH_BANG 
  | 118 -> TOKEN_MUTABLE 
  | 119 -> TOKEN_NEW 
  | 120 -> TOKEN_OF 
  | 121 -> TOKEN_EXCEPTION 
  | 122 -> TOKEN_FALSE 
  | 123 -> TOKEN_FOR 
  | 124 -> TOKEN_FUN 
  | 125 -> TOKEN_FUNCTION 
  | 126 -> TOKEN_IF 
  | 127 -> TOKEN_IN 
  | 128 -> TOKEN_JOIN_IN 
  | 129 -> TOKEN_FINALLY 
  | 130 -> TOKEN_DO_BANG 
  | 131 -> TOKEN_AND 
  | 132 -> TOKEN_AS 
  | 133 -> TOKEN_ASSERT 
  | 134 -> TOKEN_OASSERT 
  | 135 -> TOKEN_ASR 
  | 136 -> TOKEN_BEGIN 
  | 137 -> TOKEN_DO 
  | 138 -> TOKEN_DONE 
  | 139 -> TOKEN_DOWNTO 
  | 140 -> TOKEN_ELSE 
  | 141 -> TOKEN_ELIF 
  | 142 -> TOKEN_END 
  | 143 -> TOKEN_DOT_DOT 
  | 144 -> TOKEN_BAR_BAR 
  | 145 -> TOKEN_UPCAST 
  | 146 -> TOKEN_DOWNCAST 
  | 147 -> TOKEN_NULL 
  | 148 -> TOKEN_RESERVED 
  | 149 -> TOKEN_MODULE 
  | 150 -> TOKEN_NAMESPACE 
  | 151 -> TOKEN_DELEGATE 
  | 152 -> TOKEN_CONSTRAINT 
  | 153 -> TOKEN_BASE 
  | 154 -> TOKEN_LQUOTE 
  | 155 -> TOKEN_RQUOTE 
  | 156 -> TOKEN_RQUOTE_DOT 
  | 157 -> TOKEN_PERCENT_OP 
  | 158 -> TOKEN_BINDER 
  | 159 -> TOKEN_LESS 
  | 160 -> TOKEN_GREATER 
  | 161 -> TOKEN_LET 
  | 162 -> TOKEN_YIELD 
  | 163 -> TOKEN_YIELD_BANG 
  | 164 -> TOKEN_BIGNUM 
  | 165 -> TOKEN_DECIMAL 
  | 166 -> TOKEN_CHAR 
  | 167 -> TOKEN_IEEE64 
  | 168 -> TOKEN_IEEE32 
  | 169 -> TOKEN_NATIVEINT 
  | 170 -> TOKEN_UNATIVEINT 
  | 171 -> TOKEN_UINT64 
  | 172 -> TOKEN_UINT32 
  | 173 -> TOKEN_UINT16 
  | 174 -> TOKEN_UINT8 
  | 175 -> TOKEN_INT64 
  | 176 -> TOKEN_INT32 
  | 177 -> TOKEN_INT32_DOT_DOT 
  | 178 -> TOKEN_INT16 
  | 179 -> TOKEN_INT8 
  | 180 -> TOKEN_FUNKY_OPERATOR_NAME 
  | 181 -> TOKEN_ADJACENT_PREFIX_OP 
  | 182 -> TOKEN_PLUS_MINUS_OP 
  | 183 -> TOKEN_INFIX_AMP_OP 
  | 184 -> TOKEN_INFIX_STAR_DIV_MOD_OP 
  | 185 -> TOKEN_PREFIX_OP 
  | 186 -> TOKEN_INFIX_BAR_OP 
  | 187 -> TOKEN_INFIX_AT_HAT_OP 
  | 188 -> TOKEN_INFIX_COMPARE_OP 
  | 189 -> TOKEN_INFIX_STAR_STAR_OP 
  | 190 -> TOKEN_IDENT 
  | 191 -> TOKEN_KEYWORD_STRING 
  | 192 -> TOKEN_STRING 
  | 193 -> TOKEN_BYTEARRAY 
  | 196 -> TOKEN_end_of_input
  | 194 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startsignatureFile 
    | 1 -> NONTERM__startimplementationFile 
    | 2 -> NONTERM__startinteraction 
    | 3 -> NONTERM__starttypedSeqExprEOF 
    | 4 -> NONTERM__starttypEOF 
    | 5 -> NONTERM_interaction 
    | 6 -> NONTERM_interaction 
    | 7 -> NONTERM_interaction 
    | 8 -> NONTERM_interactiveTerminator 
    | 9 -> NONTERM_interactiveTerminator 
    | 10 -> NONTERM_interactiveItemsTerminator 
    | 11 -> NONTERM_interactiveItemsTerminator 
    | 12 -> NONTERM_interactiveItemsTerminator 
    | 13 -> NONTERM_interactiveItemsTerminator 
    | 14 -> NONTERM_interactiveItemsTerminator 
    | 15 -> NONTERM_interactiveItemsTerminator 
    | 16 -> NONTERM_interactiveItemsTerminator 
    | 17 -> NONTERM_interactiveDefns 
    | 18 -> NONTERM_interactiveDefns 
    | 19 -> NONTERM_interactiveExpr 
    | 20 -> NONTERM_interactiveHash 
    | 21 -> NONTERM_interactiveSeparators 
    | 22 -> NONTERM_interactiveSeparators 
    | 23 -> NONTERM_interactiveSeparator 
    | 24 -> NONTERM_interactiveSeparator 
    | 25 -> NONTERM_hashDirective 
    | 26 -> NONTERM_hashDirectiveArgs 
    | 27 -> NONTERM_hashDirectiveArgs 
    | 28 -> NONTERM_hashDirectiveArg 
    | 29 -> NONTERM_signatureFile 
    | 30 -> NONTERM_signatureFile 
    | 31 -> NONTERM_signatureFile 
    | 32 -> NONTERM_moduleIntro 
    | 33 -> NONTERM_namespaceIntro 
    | 34 -> NONTERM_fileNamespaceSpecs 
    | 35 -> NONTERM_fileNamespaceSpecs 
    | 36 -> NONTERM_fileNamespaceSpecList 
    | 37 -> NONTERM_fileNamespaceSpecList 
    | 38 -> NONTERM_fileNamespaceSpec 
    | 39 -> NONTERM_fileModuleSpec 
    | 40 -> NONTERM_fileModuleSpec 
    | 41 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 42 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 43 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 44 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 45 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 46 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 47 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 48 -> NONTERM_moduleSpfns 
    | 49 -> NONTERM_moduleSpfns 
    | 50 -> NONTERM_moduleSpfns 
    | 51 -> NONTERM_moduleSpfn 
    | 52 -> NONTERM_moduleSpfn 
    | 53 -> NONTERM_moduleSpfn 
    | 54 -> NONTERM_moduleSpfn 
    | 55 -> NONTERM_moduleSpfn 
    | 56 -> NONTERM_moduleSpfn 
    | 57 -> NONTERM_moduleSpfn 
    | 58 -> NONTERM_valSpfn 
    | 59 -> NONTERM_optLiteralValueSpfn 
    | 60 -> NONTERM_optLiteralValueSpfn 
    | 61 -> NONTERM_optLiteralValueSpfn 
    | 62 -> NONTERM_moduleSpecBlock 
    | 63 -> NONTERM_moduleSpecBlock 
    | 64 -> NONTERM_moduleSpecBlock 
    | 65 -> NONTERM_tyconSpfns 
    | 66 -> NONTERM_tyconSpfnList 
    | 67 -> NONTERM_tyconSpfnList 
    | 68 -> NONTERM_tyconSpfn 
    | 69 -> NONTERM_tyconSpfn 
    | 70 -> NONTERM_tyconSpfnRhsBlock 
    | 71 -> NONTERM_tyconSpfnRhsBlock 
    | 72 -> NONTERM_tyconSpfnRhs 
    | 73 -> NONTERM_tyconSpfnRhs 
    | 74 -> NONTERM_tyconSpfnRhs 
    | 75 -> NONTERM_tyconClassSpfn 
    | 76 -> NONTERM_tyconClassSpfn 
    | 77 -> NONTERM_tyconClassSpfn 
    | 78 -> NONTERM_tyconClassSpfn 
    | 79 -> NONTERM_classSpfnBlockKindUnspecified 
    | 80 -> NONTERM_classSpfnBlockKindUnspecified 
    | 81 -> NONTERM_classSpfnBlockKindUnspecified 
    | 82 -> NONTERM_classSpfnBlockKindUnspecified 
    | 83 -> NONTERM_classSpfnBlock 
    | 84 -> NONTERM_classSpfnBlock 
    | 85 -> NONTERM_classSpfnBlock 
    | 86 -> NONTERM_classSpfnMembers 
    | 87 -> NONTERM_classSpfnMembers 
    | 88 -> NONTERM_classSpfnMembersAtLeastOne 
    | 89 -> NONTERM_classMemberSpfn 
    | 90 -> NONTERM_classMemberSpfn 
    | 91 -> NONTERM_classMemberSpfn 
    | 92 -> NONTERM_classMemberSpfn 
    | 93 -> NONTERM_classMemberSpfn 
    | 94 -> NONTERM_classMemberSpfn 
    | 95 -> NONTERM_classMemberSpfn 
    | 96 -> NONTERM_classMemberSpfnGetSet 
    | 97 -> NONTERM_classMemberSpfnGetSet 
    | 98 -> NONTERM_classMemberSpfnGetSet 
    | 99 -> NONTERM_classMemberSpfnGetSet 
    | 100 -> NONTERM_classMemberSpfnGetSetElements 
    | 101 -> NONTERM_classMemberSpfnGetSetElements 
    | 102 -> NONTERM_memberSpecFlags 
    | 103 -> NONTERM_memberSpecFlags 
    | 104 -> NONTERM_memberSpecFlags 
    | 105 -> NONTERM_exconSpfn 
    | 106 -> NONTERM_opt_classSpfn 
    | 107 -> NONTERM_opt_classSpfn 
    | 108 -> NONTERM_implementationFile 
    | 109 -> NONTERM_implementationFile 
    | 110 -> NONTERM_implementationFile 
    | 111 -> NONTERM_fileNamespaceImpls 
    | 112 -> NONTERM_fileNamespaceImpls 
    | 113 -> NONTERM_fileNamespaceImplList 
    | 114 -> NONTERM_fileNamespaceImplList 
    | 115 -> NONTERM_fileNamespaceImpl 
    | 116 -> NONTERM_fileModuleImpl 
    | 117 -> NONTERM_fileModuleImpl 
    | 118 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 119 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 120 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 121 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 122 -> NONTERM_moduleDefnsOrExprPossiblyEmpty 
    | 123 -> NONTERM_moduleDefnsOrExprPossiblyEmpty 
    | 124 -> NONTERM_moduleDefnsOrExpr 
    | 125 -> NONTERM_moduleDefnsOrExpr 
    | 126 -> NONTERM_moduleDefnsOrExpr 
    | 127 -> NONTERM_moduleDefnsOrExpr 
    | 128 -> NONTERM_moduleDefnsOrExpr 
    | 129 -> NONTERM_moduleDefns 
    | 130 -> NONTERM_moduleDefns 
    | 131 -> NONTERM_moduleDefns 
    | 132 -> NONTERM_moduleDefns 
    | 133 -> NONTERM_moduleDefns 
    | 134 -> NONTERM_moduleDefnOrDirective 
    | 135 -> NONTERM_moduleDefnOrDirective 
    | 136 -> NONTERM_moduleDefn 
    | 137 -> NONTERM_moduleDefn 
    | 138 -> NONTERM_moduleDefn 
    | 139 -> NONTERM_moduleDefn 
    | 140 -> NONTERM_moduleDefn 
    | 141 -> NONTERM_moduleDefn 
    | 142 -> NONTERM_moduleDefn 
    | 143 -> NONTERM_moduleDefn 
    | 144 -> NONTERM_namedModuleAbbrevBlock 
    | 145 -> NONTERM_namedModuleAbbrevBlock 
    | 146 -> NONTERM_namedModuleDefnBlock 
    | 147 -> NONTERM_namedModuleDefnBlock 
    | 148 -> NONTERM_namedModuleDefnBlock 
    | 149 -> NONTERM_namedModuleDefnBlock 
    | 150 -> NONTERM_namedModuleDefnBlock 
    | 151 -> NONTERM_namedModuleDefnBlock 
    | 152 -> NONTERM_namedModuleDefnBlock 
    | 153 -> NONTERM_wrappedNamedModuleDefn 
    | 154 -> NONTERM_wrappedNamedModuleDefn 
    | 155 -> NONTERM_wrappedNamedModuleDefn 
    | 156 -> NONTERM_tyconDefnAugmentation 
    | 157 -> NONTERM_opt_attributes 
    | 158 -> NONTERM_opt_attributes 
    | 159 -> NONTERM_attributes 
    | 160 -> NONTERM_attributes 
    | 161 -> NONTERM_attributeList 
    | 162 -> NONTERM_attributeList 
    | 163 -> NONTERM_attributeList 
    | 164 -> NONTERM_attributeList 
    | 165 -> NONTERM_attributeListElements 
    | 166 -> NONTERM_attributeListElements 
    | 167 -> NONTERM_attribute 
    | 168 -> NONTERM_attribute 
    | 169 -> NONTERM_attribute 
    | 170 -> NONTERM_attributeTarget 
    | 171 -> NONTERM_attributeTarget 
    | 172 -> NONTERM_attributeTarget 
    | 173 -> NONTERM_attributeTarget 
    | 174 -> NONTERM_memberFlags 
    | 175 -> NONTERM_memberFlags 
    | 176 -> NONTERM_memberFlags 
    | 177 -> NONTERM_memberFlags 
    | 178 -> NONTERM_typeNameInfo 
    | 179 -> NONTERM_tyconDefnList 
    | 180 -> NONTERM_tyconDefnList 
    | 181 -> NONTERM_tyconDefn 
    | 182 -> NONTERM_tyconDefn 
    | 183 -> NONTERM_tyconDefn 
    | 184 -> NONTERM_tyconDefn 
    | 185 -> NONTERM_tyconDefnRhsBlock 
    | 186 -> NONTERM_tyconDefnRhsBlock 
    | 187 -> NONTERM_tyconDefnRhsBlock 
    | 188 -> NONTERM_tyconDefnRhs 
    | 189 -> NONTERM_tyconDefnRhs 
    | 190 -> NONTERM_tyconDefnRhs 
    | 191 -> NONTERM_tyconClassDefn 
    | 192 -> NONTERM_tyconClassDefn 
    | 193 -> NONTERM_tyconClassDefn 
    | 194 -> NONTERM_tyconClassDefn 
    | 195 -> NONTERM_classDefnBlockKindUnspecified 
    | 196 -> NONTERM_classDefnBlockKindUnspecified 
    | 197 -> NONTERM_classDefnBlock 
    | 198 -> NONTERM_classDefnBlock 
    | 199 -> NONTERM_classDefnBlock 
    | 200 -> NONTERM_classDefnMembers 
    | 201 -> NONTERM_classDefnMembers 
    | 202 -> NONTERM_classDefnMembers 
    | 203 -> NONTERM_classDefnMembersAtLeastOne 
    | 204 -> NONTERM_classDefnMemberGetSet 
    | 205 -> NONTERM_classDefnMemberGetSet 
    | 206 -> NONTERM_classDefnMemberGetSet 
    | 207 -> NONTERM_classDefnMemberGetSetElements 
    | 208 -> NONTERM_classDefnMemberGetSetElements 
    | 209 -> NONTERM_classDefnMemberGetSetElement 
    | 210 -> NONTERM_memberCore 
    | 211 -> NONTERM_memberCore 
    | 212 -> NONTERM_abstractMemberFlags 
    | 213 -> NONTERM_abstractMemberFlags 
    | 214 -> NONTERM_classDefnMember 
    | 215 -> NONTERM_classDefnMember 
    | 216 -> NONTERM_classDefnMember 
    | 217 -> NONTERM_classDefnMember 
    | 218 -> NONTERM_classDefnMember 
    | 219 -> NONTERM_classDefnMember 
    | 220 -> NONTERM_classDefnMember 
    | 221 -> NONTERM_classDefnMember 
    | 222 -> NONTERM_classDefnMember 
    | 223 -> NONTERM_classDefnMember 
    | 224 -> NONTERM_classDefnMember 
    | 225 -> NONTERM_valDefnDecl 
    | 226 -> NONTERM_autoPropsDefnDecl 
    | 227 -> NONTERM_opt_typ 
    | 228 -> NONTERM_opt_typ 
    | 229 -> NONTERM_atomicPatternLongIdent 
    | 230 -> NONTERM_atomicPatternLongIdent 
    | 231 -> NONTERM_atomicPatternLongIdent 
    | 232 -> NONTERM_atomicPatternLongIdent 
    | 233 -> NONTERM_opt_access 
    | 234 -> NONTERM_opt_access 
    | 235 -> NONTERM_access 
    | 236 -> NONTERM_access 
    | 237 -> NONTERM_access 
    | 238 -> NONTERM_opt_declVisibility 
    | 239 -> NONTERM_opt_declVisibility 
    | 240 -> NONTERM_opt_interfaceImplDefn 
    | 241 -> NONTERM_opt_interfaceImplDefn 
    | 242 -> NONTERM_opt_classDefn 
    | 243 -> NONTERM_opt_classDefn 
    | 244 -> NONTERM_inheritsDefn 
    | 245 -> NONTERM_inheritsDefn 
    | 246 -> NONTERM_inheritsDefn 
    | 247 -> NONTERM_optAsSpec 
    | 248 -> NONTERM_optAsSpec 
    | 249 -> NONTERM_asSpec 
    | 250 -> NONTERM_optBaseSpec 
    | 251 -> NONTERM_optBaseSpec 
    | 252 -> NONTERM_baseSpec 
    | 253 -> NONTERM_baseSpec 
    | 254 -> NONTERM_objectImplementationBlock 
    | 255 -> NONTERM_objectImplementationBlock 
    | 256 -> NONTERM_objectImplementationBlock 
    | 257 -> NONTERM_objectImplementationMembers 
    | 258 -> NONTERM_objectImplementationMembers 
    | 259 -> NONTERM_objectImplementationMember 
    | 260 -> NONTERM_objectImplementationMember 
    | 261 -> NONTERM_objectImplementationMember 
    | 262 -> NONTERM_objectImplementationMember 
    | 263 -> NONTERM_memberOrOverride 
    | 264 -> NONTERM_memberOrOverride 
    | 265 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 266 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 267 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 268 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 269 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 270 -> NONTERM_braceFieldDeclList 
    | 271 -> NONTERM_braceFieldDeclList 
    | 272 -> NONTERM_braceFieldDeclList 
    | 273 -> NONTERM_anonRecdType 
    | 274 -> NONTERM_anonRecdType 
    | 275 -> NONTERM_braceBarFieldDeclListCore 
    | 276 -> NONTERM_braceBarFieldDeclListCore 
    | 277 -> NONTERM_braceBarFieldDeclListCore 
    | 278 -> NONTERM_inlineAssemblyTyconRepr 
    | 279 -> NONTERM_classOrInterfaceOrStruct 
    | 280 -> NONTERM_classOrInterfaceOrStruct 
    | 281 -> NONTERM_classOrInterfaceOrStruct 
    | 282 -> NONTERM_interfaceMember 
    | 283 -> NONTERM_interfaceMember 
    | 284 -> NONTERM_tyconNameAndTyparDecls 
    | 285 -> NONTERM_tyconNameAndTyparDecls 
    | 286 -> NONTERM_tyconNameAndTyparDecls 
    | 287 -> NONTERM_prefixTyparDecls 
    | 288 -> NONTERM_prefixTyparDecls 
    | 289 -> NONTERM_typarDeclList 
    | 290 -> NONTERM_typarDeclList 
    | 291 -> NONTERM_typarDecl 
    | 292 -> NONTERM_postfixTyparDecls 
    | 293 -> NONTERM_explicitValTyparDeclsCore 
    | 294 -> NONTERM_explicitValTyparDeclsCore 
    | 295 -> NONTERM_explicitValTyparDeclsCore 
    | 296 -> NONTERM_explicitValTyparDecls 
    | 297 -> NONTERM_opt_explicitValTyparDecls 
    | 298 -> NONTERM_opt_explicitValTyparDecls 
    | 299 -> NONTERM_opt_explicitValTyparDecls2 
    | 300 -> NONTERM_opt_explicitValTyparDecls2 
    | 301 -> NONTERM_opt_typeConstraints 
    | 302 -> NONTERM_opt_typeConstraints 
    | 303 -> NONTERM_typeConstraints 
    | 304 -> NONTERM_typeConstraints 
    | 305 -> NONTERM_typeConstraint 
    | 306 -> NONTERM_typeConstraint 
    | 307 -> NONTERM_typeConstraint 
    | 308 -> NONTERM_typeConstraint 
    | 309 -> NONTERM_typeConstraint 
    | 310 -> NONTERM_typeConstraint 
    | 311 -> NONTERM_typeConstraint 
    | 312 -> NONTERM_typeConstraint 
    | 313 -> NONTERM_typeConstraint 
    | 314 -> NONTERM_typeConstraint 
    | 315 -> NONTERM_typarAlts 
    | 316 -> NONTERM_typarAlts 
    | 317 -> NONTERM_unionTypeRepr 
    | 318 -> NONTERM_unionTypeRepr 
    | 319 -> NONTERM_unionTypeRepr 
    | 320 -> NONTERM_barAndgrabXmlDoc 
    | 321 -> NONTERM_attrUnionCaseDecls 
    | 322 -> NONTERM_attrUnionCaseDecls 
    | 323 -> NONTERM_attrUnionCaseDecl 
    | 324 -> NONTERM_attrUnionCaseDecl 
    | 325 -> NONTERM_attrUnionCaseDecl 
    | 326 -> NONTERM_attrUnionCaseDecl 
    | 327 -> NONTERM_unionCaseName 
    | 328 -> NONTERM_unionCaseName 
    | 329 -> NONTERM_unionCaseName 
    | 330 -> NONTERM_firstUnionCaseDeclOfMany 
    | 331 -> NONTERM_firstUnionCaseDeclOfMany 
    | 332 -> NONTERM_firstUnionCaseDeclOfMany 
    | 333 -> NONTERM_firstUnionCaseDecl 
    | 334 -> NONTERM_firstUnionCaseDecl 
    | 335 -> NONTERM_unionCaseReprElements 
    | 336 -> NONTERM_unionCaseReprElements 
    | 337 -> NONTERM_unionCaseReprElement 
    | 338 -> NONTERM_unionCaseReprElement 
    | 339 -> NONTERM_unionCaseRepr 
    | 340 -> NONTERM_unionCaseRepr 
    | 341 -> NONTERM_recdFieldDeclList 
    | 342 -> NONTERM_recdFieldDeclList 
    | 343 -> NONTERM_recdFieldDecl 
    | 344 -> NONTERM_fieldDecl 
    | 345 -> NONTERM_exconDefn 
    | 346 -> NONTERM_exceptionAndGrabDoc 
    | 347 -> NONTERM_exconCore 
    | 348 -> NONTERM_exconIntro 
    | 349 -> NONTERM_exconIntro 
    | 350 -> NONTERM_exconRepr 
    | 351 -> NONTERM_exconRepr 
    | 352 -> NONTERM_openDecl 
    | 353 -> NONTERM_defnBindings 
    | 354 -> NONTERM_defnBindings 
    | 355 -> NONTERM_doBinding 
    | 356 -> NONTERM_hardwhiteLetBindings 
    | 357 -> NONTERM_hardwhiteDoBinding 
    | 358 -> NONTERM_classDefnBindings 
    | 359 -> NONTERM_classDefnBindings 
    | 360 -> NONTERM_classDefnBindings 
    | 361 -> NONTERM_classDefnBindings 
    | 362 -> NONTERM_hardwhiteDefnBindingsTerminator 
    | 363 -> NONTERM_hardwhiteDefnBindingsTerminator 
    | 364 -> NONTERM_cPrototype 
    | 365 -> NONTERM_cArgs 
    | 366 -> NONTERM_cArgs 
    | 367 -> NONTERM_cArgs 
    | 368 -> NONTERM_cMoreArgs 
    | 369 -> NONTERM_cMoreArgs 
    | 370 -> NONTERM_cArg 
    | 371 -> NONTERM_cArg 
    | 372 -> NONTERM_cType 
    | 373 -> NONTERM_cType 
    | 374 -> NONTERM_cType 
    | 375 -> NONTERM_cType 
    | 376 -> NONTERM_cType 
    | 377 -> NONTERM_cRetType 
    | 378 -> NONTERM_cRetType 
    | 379 -> NONTERM_localBindings 
    | 380 -> NONTERM_moreLocalBindings 
    | 381 -> NONTERM_moreLocalBindings 
    | 382 -> NONTERM_attr_localBinding 
    | 383 -> NONTERM_attr_localBinding 
    | 384 -> NONTERM_localBinding 
    | 385 -> NONTERM_localBinding 
    | 386 -> NONTERM_localBinding 
    | 387 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 388 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 389 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 390 -> NONTERM_typedExprWithStaticOptimizations 
    | 391 -> NONTERM_opt_staticOptimizations 
    | 392 -> NONTERM_opt_staticOptimizations 
    | 393 -> NONTERM_staticOptimization 
    | 394 -> NONTERM_staticOptimizationConditions 
    | 395 -> NONTERM_staticOptimizationConditions 
    | 396 -> NONTERM_staticOptimizationCondition 
    | 397 -> NONTERM_staticOptimizationCondition 
    | 398 -> NONTERM_rawConstant 
    | 399 -> NONTERM_rawConstant 
    | 400 -> NONTERM_rawConstant 
    | 401 -> NONTERM_rawConstant 
    | 402 -> NONTERM_rawConstant 
    | 403 -> NONTERM_rawConstant 
    | 404 -> NONTERM_rawConstant 
    | 405 -> NONTERM_rawConstant 
    | 406 -> NONTERM_rawConstant 
    | 407 -> NONTERM_rawConstant 
    | 408 -> NONTERM_rawConstant 
    | 409 -> NONTERM_rawConstant 
    | 410 -> NONTERM_rawConstant 
    | 411 -> NONTERM_rawConstant 
    | 412 -> NONTERM_rawConstant 
    | 413 -> NONTERM_rawConstant 
    | 414 -> NONTERM_rawConstant 
    | 415 -> NONTERM_rationalConstant 
    | 416 -> NONTERM_rationalConstant 
    | 417 -> NONTERM_rationalConstant 
    | 418 -> NONTERM_rationalConstant 
    | 419 -> NONTERM_atomicUnsignedRationalConstant 
    | 420 -> NONTERM_atomicUnsignedRationalConstant 
    | 421 -> NONTERM_atomicRationalConstant 
    | 422 -> NONTERM_atomicRationalConstant 
    | 423 -> NONTERM_constant 
    | 424 -> NONTERM_constant 
    | 425 -> NONTERM_bindingPattern 
    | 426 -> NONTERM_simplePattern 
    | 427 -> NONTERM_simplePattern 
    | 428 -> NONTERM_simplePattern 
    | 429 -> NONTERM_simplePattern 
    | 430 -> NONTERM_simplePatternCommaList 
    | 431 -> NONTERM_simplePatternCommaList 
    | 432 -> NONTERM_simplePatterns 
    | 433 -> NONTERM_simplePatterns 
    | 434 -> NONTERM_simplePatterns 
    | 435 -> NONTERM_simplePatterns 
    | 436 -> NONTERM_simplePatterns 
    | 437 -> NONTERM_headBindingPattern 
    | 438 -> NONTERM_headBindingPattern 
    | 439 -> NONTERM_headBindingPattern 
    | 440 -> NONTERM_headBindingPattern 
    | 441 -> NONTERM_headBindingPattern 
    | 442 -> NONTERM_headBindingPattern 
    | 443 -> NONTERM_tuplePatternElements 
    | 444 -> NONTERM_tuplePatternElements 
    | 445 -> NONTERM_conjPatternElements 
    | 446 -> NONTERM_conjPatternElements 
    | 447 -> NONTERM_namePatPairs 
    | 448 -> NONTERM_namePatPairs 
    | 449 -> NONTERM_namePatPair 
    | 450 -> NONTERM_constrPattern 
    | 451 -> NONTERM_constrPattern 
    | 452 -> NONTERM_constrPattern 
    | 453 -> NONTERM_constrPattern 
    | 454 -> NONTERM_constrPattern 
    | 455 -> NONTERM_constrPattern 
    | 456 -> NONTERM_atomicPatsOrNamePatPairs 
    | 457 -> NONTERM_atomicPatsOrNamePatPairs 
    | 458 -> NONTERM_atomicPatterns 
    | 459 -> NONTERM_atomicPatterns 
    | 460 -> NONTERM_atomicPatterns 
    | 461 -> NONTERM_atomicPatterns 
    | 462 -> NONTERM_atomicPattern 
    | 463 -> NONTERM_atomicPattern 
    | 464 -> NONTERM_atomicPattern 
    | 465 -> NONTERM_atomicPattern 
    | 466 -> NONTERM_atomicPattern 
    | 467 -> NONTERM_atomicPattern 
    | 468 -> NONTERM_atomicPattern 
    | 469 -> NONTERM_atomicPattern 
    | 470 -> NONTERM_atomicPattern 
    | 471 -> NONTERM_atomicPattern 
    | 472 -> NONTERM_atomicPattern 
    | 473 -> NONTERM_atomicPattern 
    | 474 -> NONTERM_atomicPattern 
    | 475 -> NONTERM_atomicPattern 
    | 476 -> NONTERM_atomicPattern 
    | 477 -> NONTERM_atomicPattern 
    | 478 -> NONTERM_atomicPattern 
    | 479 -> NONTERM_atomicPattern 
    | 480 -> NONTERM_atomicPattern 
    | 481 -> NONTERM_atomicPattern 
    | 482 -> NONTERM_parenPatternBody 
    | 483 -> NONTERM_parenPatternBody 
    | 484 -> NONTERM_parenPattern 
    | 485 -> NONTERM_parenPattern 
    | 486 -> NONTERM_parenPattern 
    | 487 -> NONTERM_parenPattern 
    | 488 -> NONTERM_parenPattern 
    | 489 -> NONTERM_parenPattern 
    | 490 -> NONTERM_parenPattern 
    | 491 -> NONTERM_parenPattern 
    | 492 -> NONTERM_tupleParenPatternElements 
    | 493 -> NONTERM_tupleParenPatternElements 
    | 494 -> NONTERM_conjParenPatternElements 
    | 495 -> NONTERM_conjParenPatternElements 
    | 496 -> NONTERM_recordPatternElementsAux 
    | 497 -> NONTERM_recordPatternElementsAux 
    | 498 -> NONTERM_recordPatternElement 
    | 499 -> NONTERM_listPatternElements 
    | 500 -> NONTERM_listPatternElements 
    | 501 -> NONTERM_listPatternElements 
    | 502 -> NONTERM_typedSeqExprBlock 
    | 503 -> NONTERM_typedSeqExprBlock 
    | 504 -> NONTERM_typedSeqExprBlock 
    | 505 -> NONTERM_declExprBlock 
    | 506 -> NONTERM_declExprBlock 
    | 507 -> NONTERM_typedSeqExprBlockR 
    | 508 -> NONTERM_typedSeqExprBlockR 
    | 509 -> NONTERM_typedSeqExpr 
    | 510 -> NONTERM_typedSeqExpr 
    | 511 -> NONTERM_typedSeqExprEOF 
    | 512 -> NONTERM_seqExpr 
    | 513 -> NONTERM_seqExpr 
    | 514 -> NONTERM_seqExpr 
    | 515 -> NONTERM_seqExpr 
    | 516 -> NONTERM_seqExpr 
    | 517 -> NONTERM_seqExpr 
    | 518 -> NONTERM_recover 
    | 519 -> NONTERM_recover 
    | 520 -> NONTERM_declExpr 
    | 521 -> NONTERM_declExpr 
    | 522 -> NONTERM_declExpr 
    | 523 -> NONTERM_declExpr 
    | 524 -> NONTERM_declExpr 
    | 525 -> NONTERM_declExpr 
    | 526 -> NONTERM_declExpr 
    | 527 -> NONTERM_declExpr 
    | 528 -> NONTERM_declExpr 
    | 529 -> NONTERM_declExpr 
    | 530 -> NONTERM_declExpr 
    | 531 -> NONTERM_declExpr 
    | 532 -> NONTERM_declExpr 
    | 533 -> NONTERM_declExpr 
    | 534 -> NONTERM_declExpr 
    | 535 -> NONTERM_declExpr 
    | 536 -> NONTERM_declExpr 
    | 537 -> NONTERM_declExpr 
    | 538 -> NONTERM_declExpr 
    | 539 -> NONTERM_declExpr 
    | 540 -> NONTERM_declExpr 
    | 541 -> NONTERM_declExpr 
    | 542 -> NONTERM_declExpr 
    | 543 -> NONTERM_declExpr 
    | 544 -> NONTERM_declExpr 
    | 545 -> NONTERM_declExpr 
    | 546 -> NONTERM_declExpr 
    | 547 -> NONTERM_declExpr 
    | 548 -> NONTERM_declExpr 
    | 549 -> NONTERM_declExpr 
    | 550 -> NONTERM_declExpr 
    | 551 -> NONTERM_declExpr 
    | 552 -> NONTERM_declExpr 
    | 553 -> NONTERM_declExpr 
    | 554 -> NONTERM_declExpr 
    | 555 -> NONTERM_declExpr 
    | 556 -> NONTERM_declExpr 
    | 557 -> NONTERM_declExpr 
    | 558 -> NONTERM_declExpr 
    | 559 -> NONTERM_declExpr 
    | 560 -> NONTERM_declExpr 
    | 561 -> NONTERM_declExpr 
    | 562 -> NONTERM_declExpr 
    | 563 -> NONTERM_declExpr 
    | 564 -> NONTERM_declExpr 
    | 565 -> NONTERM_declExpr 
    | 566 -> NONTERM_declExpr 
    | 567 -> NONTERM_declExpr 
    | 568 -> NONTERM_declExpr 
    | 569 -> NONTERM_declExpr 
    | 570 -> NONTERM_declExpr 
    | 571 -> NONTERM_declExpr 
    | 572 -> NONTERM_declExpr 
    | 573 -> NONTERM_declExpr 
    | 574 -> NONTERM_declExpr 
    | 575 -> NONTERM_declExpr 
    | 576 -> NONTERM_declExpr 
    | 577 -> NONTERM_declExpr 
    | 578 -> NONTERM_declExpr 
    | 579 -> NONTERM_declExpr 
    | 580 -> NONTERM_declExpr 
    | 581 -> NONTERM_declExpr 
    | 582 -> NONTERM_declExpr 
    | 583 -> NONTERM_declExpr 
    | 584 -> NONTERM_declExpr 
    | 585 -> NONTERM_declExpr 
    | 586 -> NONTERM_declExpr 
    | 587 -> NONTERM_declExpr 
    | 588 -> NONTERM_declExpr 
    | 589 -> NONTERM_declExpr 
    | 590 -> NONTERM_declExpr 
    | 591 -> NONTERM_declExpr 
    | 592 -> NONTERM_declExpr 
    | 593 -> NONTERM_declExpr 
    | 594 -> NONTERM_declExpr 
    | 595 -> NONTERM_declExpr 
    | 596 -> NONTERM_declExpr 
    | 597 -> NONTERM_declExpr 
    | 598 -> NONTERM_declExpr 
    | 599 -> NONTERM_declExpr 
    | 600 -> NONTERM_declExpr 
    | 601 -> NONTERM_declExpr 
    | 602 -> NONTERM_declExpr 
    | 603 -> NONTERM_declExpr 
    | 604 -> NONTERM_declExpr 
    | 605 -> NONTERM_declExpr 
    | 606 -> NONTERM_declExpr 
    | 607 -> NONTERM_declExpr 
    | 608 -> NONTERM_declExpr 
    | 609 -> NONTERM_declExpr 
    | 610 -> NONTERM_declExpr 
    | 611 -> NONTERM_declExpr 
    | 612 -> NONTERM_declExpr 
    | 613 -> NONTERM_declExpr 
    | 614 -> NONTERM_declExpr 
    | 615 -> NONTERM_declExpr 
    | 616 -> NONTERM_declExpr 
    | 617 -> NONTERM_declExpr 
    | 618 -> NONTERM_declExpr 
    | 619 -> NONTERM_declExpr 
    | 620 -> NONTERM_declExpr 
    | 621 -> NONTERM_declExpr 
    | 622 -> NONTERM_declExpr 
    | 623 -> NONTERM_dynamicArg 
    | 624 -> NONTERM_dynamicArg 
    | 625 -> NONTERM_withClauses 
    | 626 -> NONTERM_withClauses 
    | 627 -> NONTERM_withClauses 
    | 628 -> NONTERM_withPatternClauses 
    | 629 -> NONTERM_withPatternClauses 
    | 630 -> NONTERM_withPatternClauses 
    | 631 -> NONTERM_withPatternClauses 
    | 632 -> NONTERM_patternAndGuard 
    | 633 -> NONTERM_patternClauses 
    | 634 -> NONTERM_patternClauses 
    | 635 -> NONTERM_patternClauses 
    | 636 -> NONTERM_patternClauses 
    | 637 -> NONTERM_patternClauses 
    | 638 -> NONTERM_patternGuard 
    | 639 -> NONTERM_patternGuard 
    | 640 -> NONTERM_patternResult 
    | 641 -> NONTERM_ifExprCases 
    | 642 -> NONTERM_ifExprThen 
    | 643 -> NONTERM_ifExprThen 
    | 644 -> NONTERM_ifExprThen 
    | 645 -> NONTERM_ifExprElifs 
    | 646 -> NONTERM_ifExprElifs 
    | 647 -> NONTERM_ifExprElifs 
    | 648 -> NONTERM_ifExprElifs 
    | 649 -> NONTERM_ifExprElifs 
    | 650 -> NONTERM_ifExprElifs 
    | 651 -> NONTERM_tupleExpr 
    | 652 -> NONTERM_tupleExpr 
    | 653 -> NONTERM_tupleExpr 
    | 654 -> NONTERM_tupleExpr 
    | 655 -> NONTERM_minusExpr 
    | 656 -> NONTERM_minusExpr 
    | 657 -> NONTERM_minusExpr 
    | 658 -> NONTERM_minusExpr 
    | 659 -> NONTERM_minusExpr 
    | 660 -> NONTERM_minusExpr 
    | 661 -> NONTERM_minusExpr 
    | 662 -> NONTERM_minusExpr 
    | 663 -> NONTERM_minusExpr 
    | 664 -> NONTERM_minusExpr 
    | 665 -> NONTERM_minusExpr 
    | 666 -> NONTERM_minusExpr 
    | 667 -> NONTERM_appExpr 
    | 668 -> NONTERM_appExpr 
    | 669 -> NONTERM_argExpr 
    | 670 -> NONTERM_argExpr 
    | 671 -> NONTERM_atomicExpr 
    | 672 -> NONTERM_atomicExpr 
    | 673 -> NONTERM_atomicExpr 
    | 674 -> NONTERM_atomicExpr 
    | 675 -> NONTERM_atomicExpr 
    | 676 -> NONTERM_atomicExpr 
    | 677 -> NONTERM_atomicExpr 
    | 678 -> NONTERM_atomicExpr 
    | 679 -> NONTERM_atomicExpr 
    | 680 -> NONTERM_atomicExpr 
    | 681 -> NONTERM_atomicExpr 
    | 682 -> NONTERM_atomicExpr 
    | 683 -> NONTERM_atomicExpr 
    | 684 -> NONTERM_atomicExpr 
    | 685 -> NONTERM_atomicExpr 
    | 686 -> NONTERM_atomicExpr 
    | 687 -> NONTERM_atomicExpr 
    | 688 -> NONTERM_atomicExprQualification 
    | 689 -> NONTERM_atomicExprQualification 
    | 690 -> NONTERM_atomicExprQualification 
    | 691 -> NONTERM_atomicExprQualification 
    | 692 -> NONTERM_atomicExprQualification 
    | 693 -> NONTERM_atomicExprQualification 
    | 694 -> NONTERM_atomicExprQualification 
    | 695 -> NONTERM_atomicExprQualification 
    | 696 -> NONTERM_atomicExprQualification 
    | 697 -> NONTERM_atomicExprQualification 
    | 698 -> NONTERM_atomicExprQualification 
    | 699 -> NONTERM_atomicExprQualification 
    | 700 -> NONTERM_optRangeSeqExpr 
    | 701 -> NONTERM_optRangeSeqExpr 
    | 702 -> NONTERM_optRange 
    | 703 -> NONTERM_optRange 
    | 704 -> NONTERM_optRange 
    | 705 -> NONTERM_optRange 
    | 706 -> NONTERM_optRange 
    | 707 -> NONTERM_atomicExprAfterType 
    | 708 -> NONTERM_atomicExprAfterType 
    | 709 -> NONTERM_atomicExprAfterType 
    | 710 -> NONTERM_atomicExprAfterType 
    | 711 -> NONTERM_atomicExprAfterType 
    | 712 -> NONTERM_atomicExprAfterType 
    | 713 -> NONTERM_atomicExprAfterType 
    | 714 -> NONTERM_atomicExprAfterType 
    | 715 -> NONTERM_atomicExprAfterType 
    | 716 -> NONTERM_atomicExprAfterType 
    | 717 -> NONTERM_beginEndExpr 
    | 718 -> NONTERM_beginEndExpr 
    | 719 -> NONTERM_beginEndExpr 
    | 720 -> NONTERM_beginEndExpr 
    | 721 -> NONTERM_quoteExpr 
    | 722 -> NONTERM_quoteExpr 
    | 723 -> NONTERM_quoteExpr 
    | 724 -> NONTERM_quoteExpr 
    | 725 -> NONTERM_arrayExpr 
    | 726 -> NONTERM_arrayExpr 
    | 727 -> NONTERM_arrayExpr 
    | 728 -> NONTERM_arrayExpr 
    | 729 -> NONTERM_parenExpr 
    | 730 -> NONTERM_parenExpr 
    | 731 -> NONTERM_parenExpr 
    | 732 -> NONTERM_parenExpr 
    | 733 -> NONTERM_parenExpr 
    | 734 -> NONTERM_parenExpr 
    | 735 -> NONTERM_parenExpr 
    | 736 -> NONTERM_parenExpr 
    | 737 -> NONTERM_parenExpr 
    | 738 -> NONTERM_parenExprBody 
    | 739 -> NONTERM_parenExprBody 
    | 740 -> NONTERM_parenExprBody 
    | 741 -> NONTERM_staticallyKnownHeadTypars 
    | 742 -> NONTERM_staticallyKnownHeadTypars 
    | 743 -> NONTERM_staticallyKnownHeadTyparAlts 
    | 744 -> NONTERM_staticallyKnownHeadTyparAlts 
    | 745 -> NONTERM_braceExpr 
    | 746 -> NONTERM_braceExpr 
    | 747 -> NONTERM_braceExpr 
    | 748 -> NONTERM_braceExpr 
    | 749 -> NONTERM_braceExpr 
    | 750 -> NONTERM_braceExprBody 
    | 751 -> NONTERM_braceExprBody 
    | 752 -> NONTERM_braceExprBody 
    | 753 -> NONTERM_listExprElements 
    | 754 -> NONTERM_listExprElements 
    | 755 -> NONTERM_monadicExprInitial 
    | 756 -> NONTERM_monadicExprInitial 
    | 757 -> NONTERM_rangeSequenceExpr 
    | 758 -> NONTERM_rangeSequenceExpr 
    | 759 -> NONTERM_rangeSequenceExpr 
    | 760 -> NONTERM_arrowThenExprR 
    | 761 -> NONTERM_forLoopBinder 
    | 762 -> NONTERM_forLoopBinder 
    | 763 -> NONTERM_forLoopBinder 
    | 764 -> NONTERM_forLoopBinder 
    | 765 -> NONTERM_forLoopRange 
    | 766 -> NONTERM_forLoopRange 
    | 767 -> NONTERM_forLoopDirection 
    | 768 -> NONTERM_forLoopDirection 
    | 769 -> NONTERM_inlineAssemblyExpr 
    | 770 -> NONTERM_opt_curriedArgExprs 
    | 771 -> NONTERM_opt_curriedArgExprs 
    | 772 -> NONTERM_opt_atomicExprAfterType 
    | 773 -> NONTERM_opt_atomicExprAfterType 
    | 774 -> NONTERM_opt_inlineAssemblyTypeArg 
    | 775 -> NONTERM_opt_inlineAssemblyTypeArg 
    | 776 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 777 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 778 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 779 -> NONTERM_recdExpr 
    | 780 -> NONTERM_recdExpr 
    | 781 -> NONTERM_recdExprCore 
    | 782 -> NONTERM_recdExprCore 
    | 783 -> NONTERM_recdExprCore 
    | 784 -> NONTERM_recdExprCore 
    | 785 -> NONTERM_recdExprCore 
    | 786 -> NONTERM_recdExprCore 
    | 787 -> NONTERM_recdExprCore 
    | 788 -> NONTERM_opt_seps_recd 
    | 789 -> NONTERM_opt_seps_recd 
    | 790 -> NONTERM_seps_recd 
    | 791 -> NONTERM_seps_recd 
    | 792 -> NONTERM_seps_recd 
    | 793 -> NONTERM_seps_recd 
    | 794 -> NONTERM_pathOrUnderscore 
    | 795 -> NONTERM_pathOrUnderscore 
    | 796 -> NONTERM_recdExprBindings 
    | 797 -> NONTERM_recdExprBindings 
    | 798 -> NONTERM_recdBinding 
    | 799 -> NONTERM_recdBinding 
    | 800 -> NONTERM_recdBinding 
    | 801 -> NONTERM_recdBinding 
    | 802 -> NONTERM_recdBinding 
    | 803 -> NONTERM_objExpr 
    | 804 -> NONTERM_objExpr 
    | 805 -> NONTERM_objExpr 
    | 806 -> NONTERM_objExprBaseCall 
    | 807 -> NONTERM_objExprBaseCall 
    | 808 -> NONTERM_objExprBaseCall 
    | 809 -> NONTERM_opt_objExprBindings 
    | 810 -> NONTERM_opt_objExprBindings 
    | 811 -> NONTERM_objExprBindings 
    | 812 -> NONTERM_objExprBindings 
    | 813 -> NONTERM_objExprBindings 
    | 814 -> NONTERM_objExprInterfaces 
    | 815 -> NONTERM_opt_objExprInterfaces 
    | 816 -> NONTERM_opt_objExprInterfaces 
    | 817 -> NONTERM_opt_objExprInterfaces 
    | 818 -> NONTERM_objExprInterface 
    | 819 -> NONTERM_braceBarExpr 
    | 820 -> NONTERM_braceBarExpr 
    | 821 -> NONTERM_braceBarExprCore 
    | 822 -> NONTERM_braceBarExprCore 
    | 823 -> NONTERM_braceBarExprCore 
    | 824 -> NONTERM_braceBarExprCore 
    | 825 -> NONTERM_braceBarExprCore 
    | 826 -> NONTERM_anonLambdaExpr 
    | 827 -> NONTERM_anonLambdaExpr 
    | 828 -> NONTERM_anonLambdaExpr 
    | 829 -> NONTERM_anonLambdaExpr 
    | 830 -> NONTERM_anonLambdaExpr 
    | 831 -> NONTERM_anonLambdaExpr 
    | 832 -> NONTERM_anonLambdaExpr 
    | 833 -> NONTERM_anonLambdaExpr 
    | 834 -> NONTERM_anonMatchingExpr 
    | 835 -> NONTERM_anonMatchingExpr 
    | 836 -> NONTERM_typeWithTypeConstraints 
    | 837 -> NONTERM_typeWithTypeConstraints 
    | 838 -> NONTERM_topTypeWithTypeConstraints 
    | 839 -> NONTERM_topTypeWithTypeConstraints 
    | 840 -> NONTERM_opt_topReturnTypeWithTypeConstraints 
    | 841 -> NONTERM_opt_topReturnTypeWithTypeConstraints 
    | 842 -> NONTERM_topType 
    | 843 -> NONTERM_topType 
    | 844 -> NONTERM_topTupleType 
    | 845 -> NONTERM_topTupleType 
    | 846 -> NONTERM_topTupleTypeElements 
    | 847 -> NONTERM_topTupleTypeElements 
    | 848 -> NONTERM_topAppType 
    | 849 -> NONTERM_topAppType 
    | 850 -> NONTERM_topAppType 
    | 851 -> NONTERM_topAppType 
    | 852 -> NONTERM_topAppType 
    | 853 -> NONTERM_topAppType 
    | 854 -> NONTERM_typ 
    | 855 -> NONTERM_typ 
    | 856 -> NONTERM_typEOF 
    | 857 -> NONTERM_tupleType 
    | 858 -> NONTERM_tupleType 
    | 859 -> NONTERM_tupleType 
    | 860 -> NONTERM_tupleType 
    | 861 -> NONTERM_tupleOrQuotTypeElements 
    | 862 -> NONTERM_tupleOrQuotTypeElements 
    | 863 -> NONTERM_tupleOrQuotTypeElements 
    | 864 -> NONTERM_appTypeCon 
    | 865 -> NONTERM_appTypeCon 
    | 866 -> NONTERM_appTypeConPower 
    | 867 -> NONTERM_appTypeConPower 
    | 868 -> NONTERM_appType 
    | 869 -> NONTERM_appType 
    | 870 -> NONTERM_appType 
    | 871 -> NONTERM_appType 
    | 872 -> NONTERM_appType 
    | 873 -> NONTERM_appType 
    | 874 -> NONTERM_appType 
    | 875 -> NONTERM_arrayTypeSuffix 
    | 876 -> NONTERM_arrayTypeSuffix 
    | 877 -> NONTERM_arrayTypeSuffix 
    | 878 -> NONTERM_arrayTypeSuffix 
    | 879 -> NONTERM_appTypePrefixArguments 
    | 880 -> NONTERM_typeArgListElements 
    | 881 -> NONTERM_typeArgListElements 
    | 882 -> NONTERM_typeArgListElements 
    | 883 -> NONTERM_powerType 
    | 884 -> NONTERM_powerType 
    | 885 -> NONTERM_atomTypeNonAtomicDeprecated 
    | 886 -> NONTERM_atomTypeNonAtomicDeprecated 
    | 887 -> NONTERM_atomTypeOrAnonRecdType 
    | 888 -> NONTERM_atomTypeOrAnonRecdType 
    | 889 -> NONTERM_atomType 
    | 890 -> NONTERM_atomType 
    | 891 -> NONTERM_atomType 
    | 892 -> NONTERM_atomType 
    | 893 -> NONTERM_atomType 
    | 894 -> NONTERM_atomType 
    | 895 -> NONTERM_atomType 
    | 896 -> NONTERM_atomType 
    | 897 -> NONTERM_atomType 
    | 898 -> NONTERM_atomType 
    | 899 -> NONTERM_atomType 
    | 900 -> NONTERM_atomType 
    | 901 -> NONTERM_atomType 
    | 902 -> NONTERM_atomType 
    | 903 -> NONTERM_atomType 
    | 904 -> NONTERM_atomType 
    | 905 -> NONTERM_atomType 
    | 906 -> NONTERM_atomType 
    | 907 -> NONTERM_atomType 
    | 908 -> NONTERM_atomType 
    | 909 -> NONTERM_typeArgsNoHpaDeprecated 
    | 910 -> NONTERM_typeArgsNoHpaDeprecated 
    | 911 -> NONTERM_typeArgsActual 
    | 912 -> NONTERM_typeArgsActual 
    | 913 -> NONTERM_typeArgsActual 
    | 914 -> NONTERM_typeArgsActual 
    | 915 -> NONTERM_typeArgsActual 
    | 916 -> NONTERM_typeArgsActual 
    | 917 -> NONTERM_typeArgsActual 
    | 918 -> NONTERM_typeArgActual 
    | 919 -> NONTERM_typeArgActual 
    | 920 -> NONTERM_typeArgActual 
    | 921 -> NONTERM_typeArgActualOrDummyIfEmpty 
    | 922 -> NONTERM_typeArgActualOrDummyIfEmpty 
    | 923 -> NONTERM_dummyTypeArg 
    | 924 -> NONTERM_measureTypeArg 
    | 925 -> NONTERM_measureTypeArg 
    | 926 -> NONTERM_measureTypeAtom 
    | 927 -> NONTERM_measureTypeAtom 
    | 928 -> NONTERM_measureTypeAtom 
    | 929 -> NONTERM_measureTypePower 
    | 930 -> NONTERM_measureTypePower 
    | 931 -> NONTERM_measureTypePower 
    | 932 -> NONTERM_measureTypeSeq 
    | 933 -> NONTERM_measureTypeSeq 
    | 934 -> NONTERM_measureTypeExpr 
    | 935 -> NONTERM_measureTypeExpr 
    | 936 -> NONTERM_measureTypeExpr 
    | 937 -> NONTERM_measureTypeExpr 
    | 938 -> NONTERM_typar 
    | 939 -> NONTERM_typar 
    | 940 -> NONTERM_staticallyKnownHeadTypar 
    | 941 -> NONTERM_ident 
    | 942 -> NONTERM_path 
    | 943 -> NONTERM_path 
    | 944 -> NONTERM_path 
    | 945 -> NONTERM_path 
    | 946 -> NONTERM_opName 
    | 947 -> NONTERM_opName 
    | 948 -> NONTERM_opName 
    | 949 -> NONTERM_opName 
    | 950 -> NONTERM_opName 
    | 951 -> NONTERM_operatorName 
    | 952 -> NONTERM_operatorName 
    | 953 -> NONTERM_operatorName 
    | 954 -> NONTERM_operatorName 
    | 955 -> NONTERM_operatorName 
    | 956 -> NONTERM_operatorName 
    | 957 -> NONTERM_operatorName 
    | 958 -> NONTERM_operatorName 
    | 959 -> NONTERM_operatorName 
    | 960 -> NONTERM_operatorName 
    | 961 -> NONTERM_operatorName 
    | 962 -> NONTERM_operatorName 
    | 963 -> NONTERM_operatorName 
    | 964 -> NONTERM_operatorName 
    | 965 -> NONTERM_operatorName 
    | 966 -> NONTERM_operatorName 
    | 967 -> NONTERM_operatorName 
    | 968 -> NONTERM_operatorName 
    | 969 -> NONTERM_operatorName 
    | 970 -> NONTERM_operatorName 
    | 971 -> NONTERM_operatorName 
    | 972 -> NONTERM_operatorName 
    | 973 -> NONTERM_operatorName 
    | 974 -> NONTERM_operatorName 
    | 975 -> NONTERM_operatorName 
    | 976 -> NONTERM_operatorName 
    | 977 -> NONTERM_activePatternCaseName 
    | 978 -> NONTERM_activePatternCaseNames 
    | 979 -> NONTERM_activePatternCaseNames 
    | 980 -> NONTERM_identOrOp 
    | 981 -> NONTERM_identOrOp 
    | 982 -> NONTERM_pathOp 
    | 983 -> NONTERM_pathOp 
    | 984 -> NONTERM_pathOp 
    | 985 -> NONTERM_pathOp 
    | 986 -> NONTERM_nameop 
    | 987 -> NONTERM_topSeparator 
    | 988 -> NONTERM_topSeparator 
    | 989 -> NONTERM_topSeparator 
    | 990 -> NONTERM_topSeparators 
    | 991 -> NONTERM_topSeparators 
    | 992 -> NONTERM_opt_topSeparators 
    | 993 -> NONTERM_opt_topSeparators 
    | 994 -> NONTERM_seps 
    | 995 -> NONTERM_seps 
    | 996 -> NONTERM_seps 
    | 997 -> NONTERM_seps 
    | 998 -> NONTERM_declEnd 
    | 999 -> NONTERM_declEnd 
    | 1000 -> NONTERM_declEnd 
    | 1001 -> NONTERM_opt_declEnd 
    | 1002 -> NONTERM_opt_declEnd 
    | 1003 -> NONTERM_opt_declEnd 
    | 1004 -> NONTERM_opt_declEnd 
    | 1005 -> NONTERM_opt_ODECLEND 
    | 1006 -> NONTERM_opt_ODECLEND 
    | 1007 -> NONTERM_deprecated_opt_equals 
    | 1008 -> NONTERM_deprecated_opt_equals 
    | 1009 -> NONTERM_opt_OBLOCKSEP 
    | 1010 -> NONTERM_opt_OBLOCKSEP 
    | 1011 -> NONTERM_opt_seps 
    | 1012 -> NONTERM_opt_seps 
    | 1013 -> NONTERM_opt_rec 
    | 1014 -> NONTERM_opt_rec 
    | 1015 -> NONTERM_opt_bar 
    | 1016 -> NONTERM_opt_bar 
    | 1017 -> NONTERM_opt_inline 
    | 1018 -> NONTERM_opt_inline 
    | 1019 -> NONTERM_opt_mutable 
    | 1020 -> NONTERM_opt_mutable 
    | 1021 -> NONTERM_doToken 
    | 1022 -> NONTERM_doToken 
    | 1023 -> NONTERM_doneDeclEnd 
    | 1024 -> NONTERM_doneDeclEnd 
    | 1025 -> NONTERM_structOrBegin 
    | 1026 -> NONTERM_structOrBegin 
    | 1027 -> NONTERM_sigOrBegin 
    | 1028 -> NONTERM_sigOrBegin 
    | 1029 -> NONTERM_colonOrEquals 
    | 1030 -> NONTERM_colonOrEquals 
    | 1031 -> NONTERM_stringOrKeywordString 
    | 1032 -> NONTERM_stringOrKeywordString 
    | 1033 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1034 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1035 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1036 -> NONTERM_opt_HIGH_PRECEDENCE_TYAPP 
    | 1037 -> NONTERM_opt_HIGH_PRECEDENCE_TYAPP 
    | 1038 -> NONTERM_typeKeyword 
    | 1039 -> NONTERM_typeKeyword 
    | 1040 -> NONTERM_typeKeyword 
    | 1041 -> NONTERM_moduleKeyword 
    | 1042 -> NONTERM_moduleKeyword 
    | 1043 -> NONTERM_moduleKeyword 
    | 1044 -> NONTERM_rbrace 
    | 1045 -> NONTERM_rbrace 
    | 1046 -> NONTERM_rbrace 
    | 1047 -> NONTERM_bar_rbrace 
    | 1048 -> NONTERM_rparen 
    | 1049 -> NONTERM_rparen 
    | 1050 -> NONTERM_rparen 
    | 1051 -> NONTERM_oblockend 
    | 1052 -> NONTERM_oblockend 
    | 1053 -> NONTERM_oblockend 
    | 1054 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1055 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1056 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1057 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1058 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1059 -> NONTERM_ends_coming_soon_or_recover 
    | 1060 -> NONTERM_ends_coming_soon_or_recover 
    | 1061 -> NONTERM_ends_coming_soon_or_recover 
    | 1062 -> NONTERM_ends_coming_soon_or_recover 
    | 1063 -> NONTERM_ends_coming_soon_or_recover 
    | 1064 -> NONTERM_ends_coming_soon_or_recover 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 196 
let _fsyacc_tagOfErrorTerminal = 194

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | HASH_IF _ -> "HASH_IF" 
  | HASH_ELSE _ -> "HASH_ELSE" 
  | HASH_ENDIF _ -> "HASH_ENDIF" 
  | COMMENT _ -> "COMMENT" 
  | WHITESPACE _ -> "WHITESPACE" 
  | HASH_LINE _ -> "HASH_LINE" 
  | HASH_LIGHT _ -> "HASH_LIGHT" 
  | INACTIVECODE _ -> "INACTIVECODE" 
  | LINE_COMMENT _ -> "LINE_COMMENT" 
  | STRING_TEXT _ -> "STRING_TEXT" 
  | EOF _ -> "EOF" 
  | LEX_FAILURE _ -> "LEX_FAILURE" 
  | ODUMMY _ -> "ODUMMY" 
  | FIXED  -> "FIXED" 
  | OINTERFACE_MEMBER  -> "OINTERFACE_MEMBER" 
  | OBLOCKEND  -> "OBLOCKEND" 
  | OBLOCKEND_COMING_SOON  -> "OBLOCKEND_COMING_SOON" 
  | OBLOCKEND_IS_HERE  -> "OBLOCKEND_IS_HERE" 
  | ORIGHT_BLOCK_END  -> "ORIGHT_BLOCK_END" 
  | ODECLEND  -> "ODECLEND" 
  | OEND  -> "OEND" 
  | OBLOCKSEP  -> "OBLOCKSEP" 
  | OBLOCKBEGIN  -> "OBLOCKBEGIN" 
  | ORESET  -> "ORESET" 
  | OFUN  -> "OFUN" 
  | OFUNCTION  -> "OFUNCTION" 
  | OWITH  -> "OWITH" 
  | OELSE  -> "OELSE" 
  | OTHEN  -> "OTHEN" 
  | ODO_BANG  -> "ODO_BANG" 
  | ODO  -> "ODO" 
  | OBINDER _ -> "OBINDER" 
  | OLET _ -> "OLET" 
  | HIGH_PRECEDENCE_TYAPP  -> "HIGH_PRECEDENCE_TYAPP" 
  | HIGH_PRECEDENCE_PAREN_APP  -> "HIGH_PRECEDENCE_PAREN_APP" 
  | HIGH_PRECEDENCE_BRACK_APP  -> "HIGH_PRECEDENCE_BRACK_APP" 
  | TYPE_COMING_SOON  -> "TYPE_COMING_SOON" 
  | TYPE_IS_HERE  -> "TYPE_IS_HERE" 
  | MODULE_COMING_SOON  -> "MODULE_COMING_SOON" 
  | MODULE_IS_HERE  -> "MODULE_IS_HERE" 
  | EXTERN  -> "EXTERN" 
  | VOID  -> "VOID" 
  | PUBLIC  -> "PUBLIC" 
  | PRIVATE  -> "PRIVATE" 
  | INTERNAL  -> "INTERNAL" 
  | GLOBAL  -> "GLOBAL" 
  | STATIC  -> "STATIC" 
  | MEMBER  -> "MEMBER" 
  | CLASS  -> "CLASS" 
  | ABSTRACT  -> "ABSTRACT" 
  | OVERRIDE  -> "OVERRIDE" 
  | DEFAULT  -> "DEFAULT" 
  | CONSTRUCTOR  -> "CONSTRUCTOR" 
  | INHERIT  -> "INHERIT" 
  | GREATER_RBRACK  -> "GREATER_RBRACK" 
  | STRUCT  -> "STRUCT" 
  | SIG  -> "SIG" 
  | BAR  -> "BAR" 
  | RBRACK  -> "RBRACK" 
  | RBRACE  -> "RBRACE" 
  | RBRACE_COMING_SOON  -> "RBRACE_COMING_SOON" 
  | RBRACE_IS_HERE  -> "RBRACE_IS_HERE" 
  | MINUS  -> "MINUS" 
  | DOLLAR  -> "DOLLAR" 
  | BAR_RBRACK  -> "BAR_RBRACK" 
  | BAR_RBRACE  -> "BAR_RBRACE" 
  | UNDERSCORE  -> "UNDERSCORE" 
  | SEMICOLON_SEMICOLON  -> "SEMICOLON_SEMICOLON" 
  | LARROW  -> "LARROW" 
  | EQUALS  -> "EQUALS" 
  | LBRACK  -> "LBRACK" 
  | LBRACK_BAR  -> "LBRACK_BAR" 
  | LBRACE_BAR  -> "LBRACE_BAR" 
  | LBRACK_LESS  -> "LBRACK_LESS" 
  | LBRACE  -> "LBRACE" 
  | QMARK  -> "QMARK" 
  | QMARK_QMARK  -> "QMARK_QMARK" 
  | DOT  -> "DOT" 
  | COLON  -> "COLON" 
  | COLON_COLON  -> "COLON_COLON" 
  | COLON_GREATER  -> "COLON_GREATER" 
  | COLON_QMARK_GREATER  -> "COLON_QMARK_GREATER" 
  | COLON_QMARK  -> "COLON_QMARK" 
  | COLON_EQUALS  -> "COLON_EQUALS" 
  | SEMICOLON  -> "SEMICOLON" 
  | WHEN  -> "WHEN" 
  | WHILE  -> "WHILE" 
  | WITH  -> "WITH" 
  | HASH  -> "HASH" 
  | AMP  -> "AMP" 
  | AMP_AMP  -> "AMP_AMP" 
  | QUOTE  -> "QUOTE" 
  | LPAREN  -> "LPAREN" 
  | RPAREN  -> "RPAREN" 
  | RPAREN_COMING_SOON  -> "RPAREN_COMING_SOON" 
  | RPAREN_IS_HERE  -> "RPAREN_IS_HERE" 
  | STAR  -> "STAR" 
  | COMMA  -> "COMMA" 
  | RARROW  -> "RARROW" 
  | GREATER_BAR_RBRACK  -> "GREATER_BAR_RBRACK" 
  | LPAREN_STAR_RPAREN  -> "LPAREN_STAR_RPAREN" 
  | OPEN  -> "OPEN" 
  | OR  -> "OR" 
  | REC  -> "REC" 
  | THEN  -> "THEN" 
  | TO  -> "TO" 
  | TRUE  -> "TRUE" 
  | TRY  -> "TRY" 
  | TYPE  -> "TYPE" 
  | VAL  -> "VAL" 
  | INLINE  -> "INLINE" 
  | INTERFACE  -> "INTERFACE" 
  | INSTANCE  -> "INSTANCE" 
  | CONST  -> "CONST" 
  | LAZY  -> "LAZY" 
  | OLAZY  -> "OLAZY" 
  | MATCH  -> "MATCH" 
  | MATCH_BANG  -> "MATCH_BANG" 
  | MUTABLE  -> "MUTABLE" 
  | NEW  -> "NEW" 
  | OF  -> "OF" 
  | EXCEPTION  -> "EXCEPTION" 
  | FALSE  -> "FALSE" 
  | FOR  -> "FOR" 
  | FUN  -> "FUN" 
  | FUNCTION  -> "FUNCTION" 
  | IF  -> "IF" 
  | IN  -> "IN" 
  | JOIN_IN  -> "JOIN_IN" 
  | FINALLY  -> "FINALLY" 
  | DO_BANG  -> "DO_BANG" 
  | AND  -> "AND" 
  | AS  -> "AS" 
  | ASSERT  -> "ASSERT" 
  | OASSERT  -> "OASSERT" 
  | ASR  -> "ASR" 
  | BEGIN  -> "BEGIN" 
  | DO  -> "DO" 
  | DONE  -> "DONE" 
  | DOWNTO  -> "DOWNTO" 
  | ELSE  -> "ELSE" 
  | ELIF  -> "ELIF" 
  | END  -> "END" 
  | DOT_DOT  -> "DOT_DOT" 
  | BAR_BAR  -> "BAR_BAR" 
  | UPCAST  -> "UPCAST" 
  | DOWNCAST  -> "DOWNCAST" 
  | NULL  -> "NULL" 
  | RESERVED  -> "RESERVED" 
  | MODULE  -> "MODULE" 
  | NAMESPACE  -> "NAMESPACE" 
  | DELEGATE  -> "DELEGATE" 
  | CONSTRAINT  -> "CONSTRAINT" 
  | BASE  -> "BASE" 
  | LQUOTE _ -> "LQUOTE" 
  | RQUOTE _ -> "RQUOTE" 
  | RQUOTE_DOT _ -> "RQUOTE_DOT" 
  | PERCENT_OP _ -> "PERCENT_OP" 
  | BINDER _ -> "BINDER" 
  | LESS _ -> "LESS" 
  | GREATER _ -> "GREATER" 
  | LET _ -> "LET" 
  | YIELD _ -> "YIELD" 
  | YIELD_BANG _ -> "YIELD_BANG" 
  | BIGNUM _ -> "BIGNUM" 
  | DECIMAL _ -> "DECIMAL" 
  | CHAR _ -> "CHAR" 
  | IEEE64 _ -> "IEEE64" 
  | IEEE32 _ -> "IEEE32" 
  | NATIVEINT _ -> "NATIVEINT" 
  | UNATIVEINT _ -> "UNATIVEINT" 
  | UINT64 _ -> "UINT64" 
  | UINT32 _ -> "UINT32" 
  | UINT16 _ -> "UINT16" 
  | UINT8 _ -> "UINT8" 
  | INT64 _ -> "INT64" 
  | INT32 _ -> "INT32" 
  | INT32_DOT_DOT _ -> "INT32_DOT_DOT" 
  | INT16 _ -> "INT16" 
  | INT8 _ -> "INT8" 
  | FUNKY_OPERATOR_NAME _ -> "FUNKY_OPERATOR_NAME" 
  | ADJACENT_PREFIX_OP _ -> "ADJACENT_PREFIX_OP" 
  | PLUS_MINUS_OP _ -> "PLUS_MINUS_OP" 
  | INFIX_AMP_OP _ -> "INFIX_AMP_OP" 
  | INFIX_STAR_DIV_MOD_OP _ -> "INFIX_STAR_DIV_MOD_OP" 
  | PREFIX_OP _ -> "PREFIX_OP" 
  | INFIX_BAR_OP _ -> "INFIX_BAR_OP" 
  | INFIX_AT_HAT_OP _ -> "INFIX_AT_HAT_OP" 
  | INFIX_COMPARE_OP _ -> "INFIX_COMPARE_OP" 
  | INFIX_STAR_STAR_OP _ -> "INFIX_STAR_STAR_OP" 
  | IDENT _ -> "IDENT" 
  | KEYWORD_STRING _ -> "KEYWORD_STRING" 
  | STRING _ -> "STRING" 
  | BYTEARRAY _ -> "BYTEARRAY" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | HASH_IF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ELSE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ENDIF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | WHITESPACE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LINE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LIGHT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INACTIVECODE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LINE_COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING_TEXT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | EOF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LEX_FAILURE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ODUMMY _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FIXED  -> (null : System.Object) 
  | OINTERFACE_MEMBER  -> (null : System.Object) 
  | OBLOCKEND  -> (null : System.Object) 
  | OBLOCKEND_COMING_SOON  -> (null : System.Object) 
  | OBLOCKEND_IS_HERE  -> (null : System.Object) 
  | ORIGHT_BLOCK_END  -> (null : System.Object) 
  | ODECLEND  -> (null : System.Object) 
  | OEND  -> (null : System.Object) 
  | OBLOCKSEP  -> (null : System.Object) 
  | OBLOCKBEGIN  -> (null : System.Object) 
  | ORESET  -> (null : System.Object) 
  | OFUN  -> (null : System.Object) 
  | OFUNCTION  -> (null : System.Object) 
  | OWITH  -> (null : System.Object) 
  | OELSE  -> (null : System.Object) 
  | OTHEN  -> (null : System.Object) 
  | ODO_BANG  -> (null : System.Object) 
  | ODO  -> (null : System.Object) 
  | OBINDER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | OLET _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HIGH_PRECEDENCE_TYAPP  -> (null : System.Object) 
  | HIGH_PRECEDENCE_PAREN_APP  -> (null : System.Object) 
  | HIGH_PRECEDENCE_BRACK_APP  -> (null : System.Object) 
  | TYPE_COMING_SOON  -> (null : System.Object) 
  | TYPE_IS_HERE  -> (null : System.Object) 
  | MODULE_COMING_SOON  -> (null : System.Object) 
  | MODULE_IS_HERE  -> (null : System.Object) 
  | EXTERN  -> (null : System.Object) 
  | VOID  -> (null : System.Object) 
  | PUBLIC  -> (null : System.Object) 
  | PRIVATE  -> (null : System.Object) 
  | INTERNAL  -> (null : System.Object) 
  | GLOBAL  -> (null : System.Object) 
  | STATIC  -> (null : System.Object) 
  | MEMBER  -> (null : System.Object) 
  | CLASS  -> (null : System.Object) 
  | ABSTRACT  -> (null : System.Object) 
  | OVERRIDE  -> (null : System.Object) 
  | DEFAULT  -> (null : System.Object) 
  | CONSTRUCTOR  -> (null : System.Object) 
  | INHERIT  -> (null : System.Object) 
  | GREATER_RBRACK  -> (null : System.Object) 
  | STRUCT  -> (null : System.Object) 
  | SIG  -> (null : System.Object) 
  | BAR  -> (null : System.Object) 
  | RBRACK  -> (null : System.Object) 
  | RBRACE  -> (null : System.Object) 
  | RBRACE_COMING_SOON  -> (null : System.Object) 
  | RBRACE_IS_HERE  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | DOLLAR  -> (null : System.Object) 
  | BAR_RBRACK  -> (null : System.Object) 
  | BAR_RBRACE  -> (null : System.Object) 
  | UNDERSCORE  -> (null : System.Object) 
  | SEMICOLON_SEMICOLON  -> (null : System.Object) 
  | LARROW  -> (null : System.Object) 
  | EQUALS  -> (null : System.Object) 
  | LBRACK  -> (null : System.Object) 
  | LBRACK_BAR  -> (null : System.Object) 
  | LBRACE_BAR  -> (null : System.Object) 
  | LBRACK_LESS  -> (null : System.Object) 
  | LBRACE  -> (null : System.Object) 
  | QMARK  -> (null : System.Object) 
  | QMARK_QMARK  -> (null : System.Object) 
  | DOT  -> (null : System.Object) 
  | COLON  -> (null : System.Object) 
  | COLON_COLON  -> (null : System.Object) 
  | COLON_GREATER  -> (null : System.Object) 
  | COLON_QMARK_GREATER  -> (null : System.Object) 
  | COLON_QMARK  -> (null : System.Object) 
  | COLON_EQUALS  -> (null : System.Object) 
  | SEMICOLON  -> (null : System.Object) 
  | WHEN  -> (null : System.Object) 
  | WHILE  -> (null : System.Object) 
  | WITH  -> (null : System.Object) 
  | HASH  -> (null : System.Object) 
  | AMP  -> (null : System.Object) 
  | AMP_AMP  -> (null : System.Object) 
  | QUOTE  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | RPAREN  -> (null : System.Object) 
  | RPAREN_COMING_SOON  -> (null : System.Object) 
  | RPAREN_IS_HERE  -> (null : System.Object) 
  | STAR  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | RARROW  -> (null : System.Object) 
  | GREATER_BAR_RBRACK  -> (null : System.Object) 
  | LPAREN_STAR_RPAREN  -> (null : System.Object) 
  | OPEN  -> (null : System.Object) 
  | OR  -> (null : System.Object) 
  | REC  -> (null : System.Object) 
  | THEN  -> (null : System.Object) 
  | TO  -> (null : System.Object) 
  | TRUE  -> (null : System.Object) 
  | TRY  -> (null : System.Object) 
  | TYPE  -> (null : System.Object) 
  | VAL  -> (null : System.Object) 
  | INLINE  -> (null : System.Object) 
  | INTERFACE  -> (null : System.Object) 
  | INSTANCE  -> (null : System.Object) 
  | CONST  -> (null : System.Object) 
  | LAZY  -> (null : System.Object) 
  | OLAZY  -> (null : System.Object) 
  | MATCH  -> (null : System.Object) 
  | MATCH_BANG  -> (null : System.Object) 
  | MUTABLE  -> (null : System.Object) 
  | NEW  -> (null : System.Object) 
  | OF  -> (null : System.Object) 
  | EXCEPTION  -> (null : System.Object) 
  | FALSE  -> (null : System.Object) 
  | FOR  -> (null : System.Object) 
  | FUN  -> (null : System.Object) 
  | FUNCTION  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | IN  -> (null : System.Object) 
  | JOIN_IN  -> (null : System.Object) 
  | FINALLY  -> (null : System.Object) 
  | DO_BANG  -> (null : System.Object) 
  | AND  -> (null : System.Object) 
  | AS  -> (null : System.Object) 
  | ASSERT  -> (null : System.Object) 
  | OASSERT  -> (null : System.Object) 
  | ASR  -> (null : System.Object) 
  | BEGIN  -> (null : System.Object) 
  | DO  -> (null : System.Object) 
  | DONE  -> (null : System.Object) 
  | DOWNTO  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | ELIF  -> (null : System.Object) 
  | END  -> (null : System.Object) 
  | DOT_DOT  -> (null : System.Object) 
  | BAR_BAR  -> (null : System.Object) 
  | UPCAST  -> (null : System.Object) 
  | DOWNCAST  -> (null : System.Object) 
  | NULL  -> (null : System.Object) 
  | RESERVED  -> (null : System.Object) 
  | MODULE  -> (null : System.Object) 
  | NAMESPACE  -> (null : System.Object) 
  | DELEGATE  -> (null : System.Object) 
  | CONSTRAINT  -> (null : System.Object) 
  | BASE  -> (null : System.Object) 
  | LQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | RQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | RQUOTE_DOT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PERCENT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BINDER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LESS _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | GREATER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LET _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD_BANG _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BIGNUM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | DECIMAL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CHAR _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UNATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32_DOT_DOT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FUNKY_OPERATOR_NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ADJACENT_PREFIX_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PLUS_MINUS_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AMP_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_DIV_MOD_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PREFIX_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_BAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AT_HAT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_COMPARE_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_STAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IDENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | KEYWORD_STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BYTEARRAY _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 0us; 65535us; 0us; 65535us; 0us; 65535us; 0us; 65535us; 1us; 65535us; 4us; 5us; 7us; 65535us; 4us; 15us; 16us; 17us; 18us; 19us; 20us; 21us; 22us; 15us; 24us; 15us; 26us; 15us; 4us; 65535us; 4us; 10us; 22us; 23us; 24us; 25us; 26us; 27us; 5us; 65535us; 4us; 16us; 22us; 16us; 24us; 16us; 26us; 16us; 28us; 29us; 4us; 65535us; 4us; 18us; 22us; 18us; 24us; 18us; 26us; 18us; 4us; 65535us; 4us; 20us; 22us; 20us; 24us; 20us; 26us; 20us; 4us; 65535us; 16us; 22us; 18us; 24us; 20us; 26us; 34us; 35us; 4us; 65535us; 16us; 34us; 18us; 34us; 20us; 34us; 34us; 34us; 23us; 65535us; 0us; 84us; 2us; 256us; 4us; 33us; 22us; 33us; 24us; 33us; 26us; 33us; 61us; 84us; 65us; 84us; 69us; 84us; 79us; 84us; 82us; 84us; 111us; 84us; 114us; 84us; 118us; 84us; 223us; 256us; 227us; 256us; 230us; 256us; 242us; 256us; 246us; 256us; 248us; 256us; 253us; 256us; 277us; 256us; 287us; 256us; 1us; 65535us; 39us; 40us; 1us; 65535us; 40us; 41us; 1us; 65535us; 0us; 1us; 6us; 65535us; 31us; 268us; 64us; 65us; 87us; 88us; 226us; 227us; 240us; 268us; 258us; 268us; 4us; 65535us; 56us; 60us; 58us; 60us; 218us; 222us; 220us; 222us; 1us; 65535us; 0us; 43us; 2us; 65535us; 56us; 57us; 58us; 59us; 2us; 65535us; 56us; 58us; 58us; 58us; 2us; 65535us; 0us; 56us; 61us; 62us; 3us; 65535us; 0us; 67us; 61us; 67us; 65us; 66us; 6us; 65535us; 0us; 68us; 61us; 68us; 65us; 68us; 69us; 70us; 114us; 115us; 118us; 119us; 9us; 65535us; 0us; 76us; 61us; 76us; 65us; 76us; 69us; 76us; 79us; 80us; 82us; 83us; 111us; 112us; 114us; 76us; 118us; 76us; 9us; 65535us; 0us; 78us; 61us; 78us; 65us; 78us; 69us; 78us; 79us; 78us; 82us; 78us; 111us; 78us; 114us; 78us; 118us; 78us; 9us; 65535us; 0us; 85us; 61us; 85us; 65us; 85us; 69us; 85us; 79us; 85us; 82us; 85us; 111us; 85us; 114us; 85us; 118us; 85us; 2us; 65535us; 104us; 105us; 179us; 180us; 1us; 65535us; 89us; 91us; 2us; 65535us; 64us; 92us; 87us; 92us; 2us; 65535us; 121us; 122us; 124us; 125us; 3us; 65535us; 121us; 123us; 124us; 123us; 190us; 191us; 1us; 65535us; 127us; 128us; 2us; 65535us; 127us; 137us; 130us; 131us; 2us; 65535us; 127us; 140us; 130us; 140us; 2us; 65535us; 127us; 144us; 130us; 144us; 3us; 65535us; 145us; 146us; 155us; 156us; 209us; 210us; 8us; 65535us; 130us; 152us; 132us; 133us; 145us; 163us; 151us; 152us; 155us; 163us; 159us; 160us; 166us; 167us; 209us; 163us; 8us; 65535us; 130us; 164us; 132us; 164us; 145us; 164us; 151us; 164us; 155us; 164us; 159us; 164us; 166us; 164us; 209us; 164us; 11us; 65535us; 130us; 165us; 132us; 165us; 145us; 165us; 151us; 165us; 155us; 165us; 159us; 165us; 166us; 165us; 209us; 165us; 602us; 603us; 609us; 610us; 1373us; 1374us; 3us; 65535us; 178us; 179us; 430us; 431us; 460us; 461us; 2us; 65535us; 195us; 196us; 197us; 198us; 2us; 65535us; 170us; 172us; 171us; 172us; 2us; 65535us; 64us; 93us; 87us; 93us; 5us; 65535us; 126us; 129us; 133us; 134us; 135us; 136us; 137us; 138us; 207us; 208us; 1us; 65535us; 2us; 3us; 1us; 65535us; 2us; 212us; 2us; 65535us; 218us; 219us; 220us; 221us; 2us; 65535us; 218us; 220us; 220us; 220us; 2us; 65535us; 2us; 218us; 223us; 224us; 3us; 65535us; 2us; 229us; 223us; 229us; 227us; 228us; 5us; 65535us; 2us; 237us; 223us; 237us; 227us; 237us; 230us; 231us; 287us; 288us; 9us; 65535us; 2us; 238us; 223us; 238us; 227us; 238us; 230us; 238us; 242us; 243us; 248us; 249us; 253us; 254us; 277us; 281us; 287us; 238us; 10us; 65535us; 2us; 244us; 223us; 244us; 227us; 244us; 230us; 244us; 242us; 244us; 246us; 247us; 248us; 244us; 253us; 244us; 277us; 244us; 287us; 244us; 10us; 65535us; 2us; 246us; 223us; 246us; 227us; 246us; 230us; 246us; 242us; 246us; 246us; 246us; 248us; 246us; 253us; 246us; 277us; 246us; 287us; 246us; 15us; 65535us; 2us; 255us; 4us; 28us; 22us; 28us; 24us; 28us; 26us; 28us; 28us; 28us; 223us; 255us; 227us; 255us; 230us; 255us; 242us; 255us; 246us; 255us; 248us; 255us; 253us; 255us; 277us; 255us; 287us; 255us; 1us; 65535us; 89us; 90us; 1us; 65535us; 269us; 270us; 2us; 65535us; 269us; 285us; 277us; 278us; 1us; 65535us; 342us; 345us; 81us; 65535us; 0us; 63us; 2us; 225us; 4us; 30us; 22us; 30us; 24us; 30us; 26us; 30us; 28us; 257us; 61us; 63us; 65us; 86us; 69us; 86us; 79us; 86us; 82us; 86us; 96us; 97us; 111us; 86us; 114us; 86us; 118us; 86us; 121us; 336us; 124us; 336us; 127us; 519us; 130us; 169us; 132us; 168us; 145us; 168us; 151us; 168us; 155us; 168us; 159us; 168us; 166us; 168us; 190us; 336us; 209us; 168us; 223us; 225us; 227us; 239us; 230us; 239us; 242us; 239us; 246us; 257us; 248us; 239us; 253us; 239us; 264us; 336us; 277us; 239us; 287us; 239us; 292us; 413us; 339us; 336us; 342us; 346us; 343us; 519us; 351us; 519us; 353us; 414us; 355us; 413us; 369us; 413us; 373us; 413us; 375us; 413us; 379us; 413us; 385us; 413us; 388us; 413us; 399us; 400us; 446us; 336us; 478us; 506us; 481us; 413us; 498us; 506us; 504us; 506us; 531us; 669us; 540us; 669us; 560us; 569us; 565us; 569us; 566us; 569us; 572us; 569us; 577us; 569us; 602us; 168us; 609us; 168us; 618us; 628us; 621us; 628us; 626us; 628us; 666us; 669us; 679us; 680us; 692us; 743us; 698us; 743us; 710us; 737us; 715us; 724us; 720us; 724us; 722us; 724us; 740us; 743us; 1373us; 168us; 1477us; 507us; 1479us; 743us; 118us; 65535us; 0us; 295us; 2us; 271us; 4us; 271us; 22us; 271us; 24us; 271us; 26us; 271us; 28us; 271us; 61us; 295us; 65us; 295us; 69us; 295us; 79us; 295us; 82us; 295us; 96us; 295us; 103us; 1543us; 111us; 295us; 114us; 295us; 118us; 295us; 121us; 295us; 124us; 295us; 127us; 295us; 130us; 295us; 132us; 295us; 142us; 1543us; 145us; 295us; 151us; 295us; 155us; 295us; 159us; 295us; 166us; 295us; 177us; 1543us; 190us; 295us; 193us; 1543us; 209us; 295us; 223us; 271us; 227us; 271us; 230us; 271us; 242us; 271us; 246us; 271us; 248us; 271us; 253us; 271us; 264us; 295us; 277us; 271us; 287us; 271us; 292us; 295us; 296us; 297us; 339us; 295us; 342us; 295us; 343us; 295us; 351us; 295us; 353us; 295us; 355us; 295us; 366us; 1543us; 369us; 295us; 373us; 295us; 375us; 295us; 379us; 295us; 385us; 295us; 388us; 295us; 399us; 295us; 429us; 1543us; 446us; 295us; 478us; 295us; 481us; 295us; 498us; 295us; 504us; 295us; 531us; 295us; 540us; 295us; 560us; 295us; 565us; 295us; 566us; 295us; 572us; 295us; 577us; 295us; 602us; 295us; 609us; 295us; 618us; 295us; 621us; 295us; 626us; 295us; 635us; 1543us; 666us; 295us; 679us; 295us; 692us; 295us; 698us; 295us; 710us; 295us; 715us; 295us; 720us; 295us; 722us; 295us; 740us; 295us; 816us; 816us; 817us; 816us; 819us; 816us; 852us; 929us; 864us; 929us; 880us; 929us; 883us; 929us; 894us; 929us; 902us; 929us; 924us; 929us; 929us; 929us; 930us; 929us; 932us; 929us; 933us; 929us; 934us; 929us; 935us; 929us; 941us; 929us; 943us; 929us; 1039us; 929us; 1186us; 929us; 1188us; 929us; 1193us; 929us; 1200us; 929us; 1373us; 295us; 1477us; 295us; 1479us; 295us; 1523us; 929us; 1525us; 929us; 1532us; 1543us; 1535us; 1543us; 1538us; 1543us; 1541us; 1543us; 118us; 65535us; 0us; 296us; 2us; 296us; 4us; 296us; 22us; 296us; 24us; 296us; 26us; 296us; 28us; 296us; 61us; 296us; 65us; 296us; 69us; 296us; 79us; 296us; 82us; 296us; 96us; 296us; 103us; 296us; 111us; 296us; 114us; 296us; 118us; 296us; 121us; 296us; 124us; 296us; 127us; 296us; 130us; 296us; 132us; 296us; 142us; 296us; 145us; 296us; 151us; 296us; 155us; 296us; 159us; 296us; 166us; 296us; 177us; 296us; 190us; 296us; 193us; 296us; 209us; 296us; 223us; 296us; 227us; 296us; 230us; 296us; 242us; 296us; 246us; 296us; 248us; 296us; 253us; 296us; 264us; 296us; 277us; 296us; 287us; 296us; 292us; 296us; 296us; 296us; 339us; 296us; 342us; 296us; 343us; 296us; 351us; 296us; 353us; 296us; 355us; 296us; 366us; 296us; 369us; 296us; 373us; 296us; 375us; 296us; 379us; 296us; 385us; 296us; 388us; 296us; 399us; 296us; 429us; 296us; 446us; 296us; 478us; 296us; 481us; 296us; 498us; 296us; 504us; 296us; 531us; 296us; 540us; 296us; 560us; 296us; 565us; 296us; 566us; 296us; 572us; 296us; 577us; 296us; 602us; 296us; 609us; 296us; 618us; 296us; 621us; 296us; 626us; 296us; 635us; 296us; 666us; 296us; 679us; 296us; 692us; 296us; 698us; 296us; 710us; 296us; 715us; 296us; 720us; 296us; 722us; 296us; 740us; 296us; 816us; 296us; 817us; 296us; 819us; 296us; 852us; 296us; 864us; 296us; 880us; 296us; 883us; 296us; 894us; 296us; 902us; 296us; 924us; 296us; 929us; 296us; 930us; 296us; 932us; 296us; 933us; 296us; 934us; 296us; 935us; 296us; 941us; 296us; 943us; 296us; 1039us; 296us; 1186us; 296us; 1188us; 296us; 1193us; 296us; 1200us; 296us; 1373us; 296us; 1477us; 296us; 1479us; 296us; 1523us; 296us; 1525us; 296us; 1532us; 296us; 1535us; 296us; 1538us; 296us; 1541us; 296us; 1us; 65535us; 298us; 299us; 2us; 65535us; 298us; 308us; 309us; 310us; 2us; 65535us; 298us; 314us; 309us; 314us; 4us; 65535us; 170us; 204us; 171us; 204us; 415us; 419us; 416us; 419us; 6us; 65535us; 121us; 126us; 124us; 126us; 190us; 126us; 264us; 342us; 339us; 342us; 446us; 342us; 2us; 65535us; 265us; 266us; 340us; 341us; 3us; 65535us; 264us; 265us; 339us; 340us; 446us; 447us; 2us; 65535us; 343us; 344us; 351us; 352us; 3us; 65535us; 343us; 361us; 351us; 361us; 353us; 354us; 3us; 65535us; 343us; 364us; 351us; 364us; 353us; 364us; 3us; 65535us; 343us; 368us; 351us; 368us; 353us; 368us; 3us; 65535us; 292us; 293us; 369us; 370us; 481us; 482us; 10us; 65535us; 292us; 383us; 353us; 376us; 355us; 356us; 369us; 383us; 373us; 386us; 375us; 376us; 379us; 380us; 385us; 386us; 388us; 389us; 481us; 383us; 10us; 65535us; 292us; 384us; 353us; 384us; 355us; 384us; 369us; 384us; 373us; 384us; 375us; 384us; 379us; 384us; 385us; 384us; 388us; 384us; 481us; 384us; 1us; 65535us; 407us; 410us; 2us; 65535us; 390us; 391us; 392us; 393us; 3us; 65535us; 390us; 396us; 392us; 396us; 397us; 398us; 3us; 65535us; 419us; 420us; 508us; 509us; 514us; 515us; 2us; 65535us; 415us; 425us; 416us; 425us; 10us; 65535us; 292us; 387us; 353us; 387us; 355us; 387us; 369us; 387us; 373us; 387us; 375us; 387us; 379us; 387us; 385us; 387us; 388us; 387us; 481us; 387us; 3us; 65535us; 331us; 436us; 415us; 434us; 416us; 434us; 2us; 65535us; 419us; 438us; 508us; 511us; 1us; 65535us; 457us; 458us; 42us; 65535us; 400us; 854us; 405us; 854us; 440us; 889us; 747us; 854us; 837us; 854us; 838us; 854us; 842us; 854us; 843us; 854us; 844us; 854us; 845us; 854us; 852us; 854us; 855us; 889us; 857us; 889us; 859us; 889us; 864us; 854us; 868us; 889us; 870us; 889us; 872us; 889us; 880us; 854us; 883us; 854us; 894us; 854us; 902us; 854us; 924us; 854us; 929us; 854us; 930us; 854us; 932us; 854us; 933us; 854us; 934us; 854us; 935us; 854us; 941us; 854us; 943us; 854us; 1039us; 854us; 1066us; 854us; 1072us; 854us; 1186us; 854us; 1188us; 854us; 1193us; 854us; 1200us; 854us; 1505us; 889us; 1510us; 889us; 1523us; 854us; 1525us; 854us; 10us; 65535us; 49us; 50us; 99us; 100us; 173us; 174us; 336us; 554us; 449us; 450us; 455us; 456us; 628us; 629us; 671us; 672us; 680us; 681us; 711us; 712us; 64us; 65535us; 30us; 477us; 49us; 473us; 63us; 477us; 86us; 477us; 99us; 473us; 168us; 477us; 169us; 477us; 173us; 473us; 225us; 477us; 239us; 477us; 257us; 477us; 336us; 473us; 346us; 477us; 400us; 471us; 405us; 471us; 413us; 477us; 414us; 477us; 440us; 471us; 449us; 473us; 455us; 473us; 519us; 477us; 628us; 473us; 671us; 473us; 680us; 473us; 711us; 473us; 747us; 471us; 837us; 471us; 838us; 471us; 842us; 471us; 843us; 471us; 844us; 471us; 845us; 471us; 852us; 471us; 855us; 471us; 857us; 471us; 859us; 471us; 864us; 471us; 868us; 471us; 870us; 471us; 872us; 471us; 880us; 471us; 883us; 471us; 894us; 471us; 902us; 471us; 924us; 471us; 929us; 471us; 930us; 471us; 932us; 471us; 933us; 471us; 934us; 471us; 935us; 471us; 941us; 471us; 943us; 471us; 1039us; 471us; 1066us; 471us; 1072us; 471us; 1186us; 471us; 1188us; 471us; 1193us; 471us; 1200us; 471us; 1505us; 471us; 1510us; 471us; 1523us; 471us; 1525us; 471us; 12us; 65535us; 30us; 31us; 63us; 64us; 86us; 87us; 168us; 170us; 169us; 171us; 225us; 226us; 239us; 240us; 257us; 258us; 346us; 347us; 413us; 415us; 414us; 416us; 519us; 520us; 1us; 65535us; 423us; 424us; 4us; 65535us; 356us; 357us; 358us; 359us; 361us; 362us; 676us; 677us; 2us; 65535us; 415us; 433us; 416us; 433us; 2us; 65535us; 349us; 350us; 441us; 442us; 2us; 65535us; 349us; 491us; 441us; 491us; 2us; 65535us; 485us; 486us; 488us; 489us; 3us; 65535us; 485us; 494us; 488us; 494us; 1254us; 1475us; 2us; 65535us; 478us; 479us; 1477us; 1482us; 4us; 65535us; 478us; 502us; 498us; 499us; 504us; 505us; 1477us; 502us; 4us; 65535us; 478us; 503us; 498us; 503us; 504us; 503us; 1477us; 503us; 2us; 65535us; 506us; 508us; 507us; 508us; 5us; 65535us; 127us; 139us; 130us; 139us; 343us; 363us; 351us; 363us; 353us; 363us; 6us; 65535us; 171us; 527us; 416us; 527us; 520us; 527us; 632us; 663us; 654us; 663us; 685us; 663us; 66us; 65535us; 8us; 1622us; 103us; 1622us; 142us; 1622us; 171us; 1622us; 177us; 1622us; 181us; 1622us; 183us; 1622us; 193us; 1622us; 366us; 1622us; 416us; 1622us; 422us; 1622us; 429us; 1622us; 452us; 1622us; 462us; 1622us; 520us; 1622us; 528us; 1622us; 592us; 1622us; 595us; 1622us; 605us; 1622us; 615us; 1622us; 632us; 1622us; 635us; 1622us; 654us; 1622us; 657us; 1622us; 660us; 1622us; 674us; 1622us; 685us; 1622us; 770us; 1622us; 814us; 1622us; 861us; 1622us; 927us; 1622us; 957us; 1622us; 1129us; 1622us; 1131us; 1622us; 1133us; 1622us; 1421us; 1622us; 1424us; 1622us; 1426us; 1622us; 1490us; 1622us; 1532us; 1622us; 1535us; 1622us; 1538us; 1622us; 1541us; 1622us; 1543us; 1622us; 1545us; 1622us; 1549us; 1622us; 1552us; 1622us; 1556us; 1622us; 1559us; 1622us; 1564us; 1622us; 1566us; 1622us; 1568us; 1622us; 1571us; 1622us; 1573us; 1622us; 1587us; 1622us; 1592us; 1622us; 1595us; 1622us; 1606us; 1622us; 1610us; 1622us; 1616us; 1622us; 1627us; 1622us; 1633us; 1622us; 1634us; 1622us; 1657us; 1622us; 1659us; 1622us; 1670us; 1622us; 67us; 65535us; 8us; 539us; 103us; 539us; 142us; 539us; 171us; 539us; 177us; 539us; 181us; 539us; 183us; 539us; 193us; 539us; 366us; 539us; 416us; 539us; 422us; 539us; 429us; 539us; 452us; 539us; 462us; 539us; 520us; 539us; 528us; 539us; 537us; 538us; 592us; 539us; 595us; 539us; 605us; 539us; 615us; 539us; 632us; 539us; 635us; 539us; 654us; 539us; 657us; 539us; 660us; 539us; 674us; 539us; 685us; 539us; 770us; 539us; 814us; 539us; 861us; 539us; 927us; 539us; 957us; 539us; 1129us; 539us; 1131us; 539us; 1133us; 539us; 1421us; 539us; 1424us; 539us; 1426us; 539us; 1490us; 539us; 1532us; 539us; 1535us; 539us; 1538us; 539us; 1541us; 539us; 1543us; 539us; 1545us; 539us; 1549us; 539us; 1552us; 539us; 1556us; 539us; 1559us; 539us; 1564us; 539us; 1566us; 539us; 1568us; 539us; 1571us; 539us; 1573us; 539us; 1587us; 539us; 1592us; 539us; 1595us; 539us; 1606us; 539us; 1610us; 539us; 1616us; 539us; 1627us; 539us; 1633us; 539us; 1634us; 539us; 1657us; 539us; 1659us; 539us; 1670us; 539us; 1us; 65535us; 528us; 529us; 5us; 65535us; 127us; 145us; 130us; 145us; 343us; 369us; 351us; 369us; 353us; 369us; 9us; 65535us; 170us; 181us; 171us; 181us; 415us; 422us; 416us; 422us; 1471us; 1490us; 1473us; 1490us; 1484us; 1490us; 1486us; 1490us; 1488us; 1490us; 1us; 65535us; 336us; 337us; 1us; 65535us; 554us; 556us; 3us; 65535us; 560us; 561us; 572us; 563us; 577us; 564us; 5us; 65535us; 560us; 568us; 565us; 567us; 566us; 567us; 572us; 568us; 577us; 568us; 1us; 65535us; 555us; 558us; 1us; 65535us; 577us; 578us; 4us; 65535us; 101us; 581us; 175us; 581us; 427us; 581us; 854us; 582us; 3us; 65535us; 101us; 102us; 175us; 176us; 427us; 428us; 1us; 65535us; 854us; 855us; 3us; 65535us; 337us; 338us; 563us; 573us; 578us; 579us; 3us; 65535us; 583us; 584us; 1529us; 585us; 1531us; 586us; 4us; 65535us; 583us; 589us; 587us; 588us; 1529us; 589us; 1531us; 589us; 1us; 65535us; 605us; 606us; 3us; 65535us; 171us; 526us; 416us; 526us; 520us; 526us; 5us; 65535us; 171us; 618us; 416us; 618us; 520us; 618us; 620us; 621us; 625us; 626us; 3us; 65535us; 618us; 619us; 621us; 622us; 626us; 627us; 3us; 65535us; 618us; 625us; 621us; 625us; 626us; 625us; 1us; 65535us; 629us; 630us; 3us; 65535us; 171us; 620us; 416us; 620us; 520us; 620us; 3us; 65535us; 171us; 623us; 416us; 623us; 520us; 623us; 4us; 65535us; 632us; 664us; 654us; 664us; 657us; 658us; 685us; 664us; 4us; 65535us; 632us; 656us; 654us; 656us; 657us; 656us; 685us; 656us; 3us; 65535us; 632us; 633us; 654us; 655us; 685us; 686us; 3us; 65535us; 531us; 532us; 540us; 541us; 666us; 667us; 3us; 65535us; 531us; 665us; 540us; 665us; 666us; 665us; 3us; 65535us; 185us; 186us; 188us; 189us; 669us; 670us; 4us; 65535us; 31us; 267us; 226us; 267us; 240us; 267us; 258us; 267us; 6us; 65535us; 31us; 679us; 64us; 679us; 87us; 679us; 226us; 679us; 240us; 679us; 258us; 679us; 6us; 65535us; 31us; 676us; 64us; 207us; 87us; 207us; 226us; 676us; 240us; 676us; 258us; 676us; 1us; 65535us; 681us; 682us; 1us; 65535us; 682us; 683us; 15us; 65535us; 2us; 273us; 4us; 273us; 22us; 273us; 24us; 273us; 26us; 273us; 28us; 273us; 223us; 273us; 227us; 273us; 230us; 273us; 242us; 273us; 246us; 273us; 248us; 273us; 253us; 273us; 277us; 273us; 287us; 273us; 113us; 65535us; 6us; 988us; 31us; 260us; 106us; 988us; 108us; 988us; 226us; 260us; 240us; 260us; 258us; 259us; 262us; 988us; 331us; 704us; 403us; 988us; 408us; 988us; 415us; 704us; 416us; 704us; 443us; 988us; 459us; 988us; 695us; 988us; 701us; 988us; 750us; 988us; 754us; 988us; 764us; 988us; 945us; 988us; 950us; 988us; 964us; 988us; 966us; 988us; 969us; 988us; 972us; 988us; 989us; 988us; 992us; 988us; 995us; 988us; 1001us; 988us; 1005us; 988us; 1009us; 988us; 1013us; 988us; 1015us; 988us; 1020us; 988us; 1022us; 988us; 1024us; 988us; 1026us; 988us; 1028us; 988us; 1030us; 988us; 1041us; 988us; 1049us; 988us; 1056us; 988us; 1062us; 988us; 1064us; 988us; 1067us; 988us; 1070us; 988us; 1073us; 988us; 1076us; 988us; 1079us; 988us; 1082us; 988us; 1084us; 988us; 1089us; 988us; 1091us; 988us; 1135us; 988us; 1137us; 988us; 1141us; 988us; 1142us; 988us; 1143us; 988us; 1144us; 988us; 1145us; 988us; 1146us; 988us; 1147us; 988us; 1148us; 988us; 1149us; 988us; 1150us; 988us; 1151us; 988us; 1153us; 988us; 1154us; 988us; 1155us; 988us; 1156us; 988us; 1157us; 988us; 1158us; 988us; 1159us; 988us; 1160us; 988us; 1161us; 988us; 1183us; 988us; 1205us; 988us; 1206us; 988us; 1210us; 988us; 1212us; 988us; 1216us; 988us; 1218us; 988us; 1222us; 988us; 1225us; 988us; 1227us; 988us; 1291us; 988us; 1298us; 988us; 1305us; 988us; 1312us; 988us; 1322us; 988us; 1324us; 988us; 1325us; 988us; 1337us; 988us; 1344us; 988us; 1345us; 988us; 1351us; 988us; 1357us; 988us; 1358us; 988us; 1359us; 988us; 1375us; 988us; 1385us; 988us; 1398us; 988us; 1399us; 988us; 1401us; 988us; 1403us; 988us; 1407us; 988us; 1408us; 988us; 1435us; 988us; 1440us; 988us; 1465us; 988us; 1507us; 988us; 1512us; 988us; 7us; 65535us; 31us; 263us; 226us; 263us; 240us; 263us; 258us; 263us; 331us; 705us; 415us; 705us; 416us; 705us; 113us; 65535us; 6us; 972us; 31us; 262us; 106us; 992us; 108us; 992us; 226us; 262us; 240us; 262us; 258us; 261us; 262us; 972us; 331us; 706us; 403us; 972us; 408us; 972us; 415us; 706us; 416us; 706us; 443us; 972us; 459us; 972us; 695us; 972us; 701us; 972us; 750us; 972us; 754us; 972us; 764us; 972us; 945us; 972us; 950us; 972us; 964us; 972us; 966us; 972us; 969us; 972us; 972us; 972us; 989us; 972us; 992us; 972us; 995us; 972us; 1001us; 972us; 1005us; 972us; 1009us; 972us; 1013us; 972us; 1015us; 992us; 1020us; 992us; 1022us; 992us; 1024us; 992us; 1026us; 992us; 1028us; 992us; 1030us; 972us; 1041us; 972us; 1049us; 972us; 1056us; 972us; 1062us; 992us; 1064us; 992us; 1067us; 972us; 1070us; 972us; 1073us; 972us; 1076us; 972us; 1079us; 972us; 1082us; 972us; 1084us; 972us; 1089us; 992us; 1091us; 972us; 1135us; 992us; 1137us; 992us; 1141us; 992us; 1142us; 992us; 1143us; 992us; 1144us; 992us; 1145us; 992us; 1146us; 992us; 1147us; 992us; 1148us; 992us; 1149us; 992us; 1150us; 992us; 1151us; 992us; 1153us; 992us; 1154us; 992us; 1155us; 992us; 1156us; 992us; 1157us; 992us; 1158us; 992us; 1159us; 992us; 1160us; 992us; 1161us; 992us; 1183us; 972us; 1205us; 992us; 1206us; 972us; 1210us; 992us; 1212us; 972us; 1216us; 992us; 1218us; 972us; 1222us; 992us; 1225us; 992us; 1227us; 992us; 1291us; 972us; 1298us; 992us; 1305us; 972us; 1312us; 972us; 1322us; 992us; 1324us; 992us; 1325us; 992us; 1337us; 972us; 1344us; 972us; 1345us; 972us; 1351us; 972us; 1357us; 972us; 1358us; 972us; 1359us; 972us; 1375us; 972us; 1385us; 972us; 1398us; 992us; 1399us; 992us; 1401us; 972us; 1403us; 992us; 1407us; 992us; 1408us; 992us; 1435us; 992us; 1440us; 992us; 1465us; 992us; 1507us; 972us; 1512us; 972us; 112us; 65535us; 6us; 998us; 31us; 998us; 106us; 998us; 108us; 998us; 226us; 998us; 240us; 998us; 262us; 998us; 331us; 707us; 403us; 998us; 408us; 998us; 415us; 707us; 416us; 707us; 443us; 998us; 459us; 998us; 695us; 998us; 701us; 998us; 750us; 998us; 754us; 998us; 764us; 998us; 945us; 998us; 950us; 998us; 964us; 998us; 966us; 998us; 969us; 998us; 972us; 998us; 989us; 998us; 992us; 998us; 995us; 998us; 1001us; 998us; 1005us; 998us; 1009us; 998us; 1013us; 998us; 1015us; 998us; 1020us; 998us; 1022us; 998us; 1024us; 998us; 1026us; 998us; 1028us; 998us; 1030us; 998us; 1041us; 998us; 1049us; 998us; 1056us; 998us; 1062us; 998us; 1064us; 998us; 1067us; 998us; 1070us; 998us; 1073us; 998us; 1076us; 998us; 1079us; 998us; 1082us; 998us; 1084us; 998us; 1089us; 998us; 1091us; 998us; 1135us; 998us; 1137us; 998us; 1141us; 998us; 1142us; 998us; 1143us; 998us; 1144us; 998us; 1145us; 998us; 1146us; 998us; 1147us; 998us; 1148us; 998us; 1149us; 998us; 1150us; 998us; 1151us; 998us; 1153us; 998us; 1154us; 998us; 1155us; 998us; 1156us; 998us; 1157us; 998us; 1158us; 998us; 1159us; 998us; 1160us; 998us; 1161us; 998us; 1183us; 998us; 1205us; 998us; 1206us; 998us; 1210us; 998us; 1212us; 998us; 1216us; 998us; 1218us; 998us; 1222us; 998us; 1225us; 998us; 1227us; 998us; 1291us; 998us; 1298us; 998us; 1305us; 998us; 1312us; 998us; 1322us; 998us; 1324us; 998us; 1325us; 998us; 1337us; 998us; 1344us; 998us; 1345us; 998us; 1351us; 998us; 1357us; 998us; 1358us; 998us; 1359us; 998us; 1375us; 998us; 1385us; 998us; 1398us; 998us; 1399us; 998us; 1401us; 998us; 1403us; 998us; 1407us; 998us; 1408us; 998us; 1435us; 998us; 1440us; 998us; 1465us; 998us; 1507us; 998us; 1512us; 998us; 3us; 65535us; 331us; 418us; 415us; 417us; 416us; 417us; 4us; 65535us; 699us; 700us; 702us; 703us; 1074us; 1075us; 1085us; 1086us; 113us; 65535us; 6us; 694us; 31us; 694us; 106us; 694us; 108us; 694us; 226us; 694us; 240us; 694us; 258us; 694us; 262us; 694us; 331us; 694us; 403us; 694us; 408us; 694us; 415us; 694us; 416us; 694us; 443us; 694us; 459us; 694us; 695us; 694us; 701us; 694us; 750us; 694us; 754us; 694us; 764us; 694us; 945us; 694us; 950us; 694us; 964us; 694us; 966us; 694us; 969us; 694us; 972us; 694us; 989us; 694us; 992us; 694us; 995us; 694us; 1001us; 694us; 1005us; 694us; 1009us; 694us; 1013us; 694us; 1015us; 694us; 1020us; 694us; 1022us; 694us; 1024us; 694us; 1026us; 694us; 1028us; 694us; 1030us; 694us; 1041us; 694us; 1049us; 694us; 1056us; 694us; 1062us; 694us; 1064us; 694us; 1067us; 694us; 1070us; 694us; 1073us; 694us; 1076us; 694us; 1079us; 694us; 1082us; 694us; 1084us; 694us; 1089us; 694us; 1091us; 694us; 1135us; 694us; 1137us; 694us; 1141us; 694us; 1142us; 694us; 1143us; 694us; 1144us; 694us; 1145us; 694us; 1146us; 694us; 1147us; 694us; 1148us; 694us; 1149us; 694us; 1150us; 694us; 1151us; 694us; 1153us; 694us; 1154us; 694us; 1155us; 694us; 1156us; 694us; 1157us; 694us; 1158us; 694us; 1159us; 694us; 1160us; 694us; 1161us; 694us; 1183us; 694us; 1205us; 694us; 1206us; 694us; 1210us; 694us; 1212us; 694us; 1216us; 694us; 1218us; 694us; 1222us; 694us; 1225us; 694us; 1227us; 694us; 1291us; 694us; 1298us; 694us; 1305us; 694us; 1312us; 694us; 1322us; 694us; 1324us; 694us; 1325us; 694us; 1337us; 694us; 1344us; 694us; 1345us; 694us; 1351us; 694us; 1357us; 694us; 1358us; 694us; 1359us; 694us; 1375us; 694us; 1385us; 694us; 1398us; 694us; 1399us; 694us; 1401us; 694us; 1403us; 694us; 1407us; 694us; 1408us; 694us; 1435us; 694us; 1440us; 694us; 1465us; 694us; 1507us; 694us; 1512us; 694us; 1us; 65535us; 715us; 716us; 1us; 65535us; 715us; 718us; 3us; 65535us; 715us; 719us; 720us; 721us; 722us; 723us; 2us; 65535us; 724us; 725us; 737us; 728us; 1us; 65535us; 710us; 711us; 4us; 65535us; 692us; 693us; 698us; 699us; 1477us; 1478us; 1479us; 1480us; 2us; 65535us; 738us; 739us; 741us; 742us; 5us; 65535us; 692us; 738us; 698us; 738us; 740us; 741us; 1477us; 738us; 1479us; 738us; 2us; 65535us; 507us; 744us; 743us; 744us; 1us; 65535us; 750us; 751us; 2us; 65535us; 750us; 758us; 754us; 755us; 1us; 65535us; 759us; 760us; 1us; 65535us; 760us; 761us; 1us; 65535us; 762us; 763us; 2us; 65535us; 762us; 768us; 766us; 767us; 257us; 65535us; 6us; 805us; 8us; 1641us; 31us; 805us; 103us; 1641us; 106us; 805us; 108us; 805us; 142us; 1641us; 171us; 1641us; 177us; 1641us; 181us; 1641us; 183us; 1641us; 193us; 1641us; 226us; 805us; 240us; 805us; 262us; 805us; 312us; 805us; 316us; 805us; 321us; 805us; 366us; 1641us; 400us; 805us; 403us; 805us; 405us; 805us; 408us; 805us; 416us; 1641us; 422us; 1641us; 429us; 1641us; 440us; 805us; 443us; 805us; 452us; 1641us; 459us; 805us; 462us; 1641us; 484us; 1641us; 487us; 805us; 520us; 1641us; 528us; 1641us; 546us; 1641us; 592us; 1641us; 595us; 1641us; 605us; 1641us; 615us; 1641us; 632us; 1641us; 635us; 1641us; 638us; 805us; 650us; 805us; 654us; 1641us; 657us; 1641us; 660us; 1641us; 674us; 1641us; 685us; 1641us; 695us; 805us; 701us; 805us; 747us; 805us; 750us; 805us; 754us; 805us; 764us; 805us; 770us; 1641us; 814us; 1641us; 837us; 805us; 838us; 805us; 842us; 805us; 843us; 805us; 844us; 805us; 845us; 805us; 852us; 805us; 855us; 805us; 857us; 805us; 859us; 805us; 861us; 1641us; 864us; 805us; 868us; 805us; 870us; 805us; 872us; 805us; 880us; 805us; 883us; 805us; 894us; 805us; 902us; 805us; 924us; 805us; 927us; 1641us; 929us; 805us; 930us; 805us; 932us; 805us; 933us; 805us; 934us; 805us; 935us; 805us; 941us; 805us; 943us; 805us; 945us; 805us; 950us; 805us; 957us; 1641us; 964us; 805us; 966us; 805us; 969us; 805us; 972us; 805us; 989us; 805us; 992us; 805us; 995us; 805us; 1001us; 805us; 1005us; 805us; 1009us; 805us; 1013us; 805us; 1015us; 805us; 1020us; 805us; 1022us; 805us; 1024us; 805us; 1026us; 805us; 1028us; 805us; 1030us; 805us; 1039us; 805us; 1041us; 805us; 1049us; 805us; 1056us; 805us; 1062us; 805us; 1064us; 805us; 1066us; 805us; 1067us; 805us; 1070us; 805us; 1072us; 805us; 1073us; 805us; 1076us; 805us; 1079us; 805us; 1082us; 805us; 1084us; 805us; 1089us; 805us; 1091us; 805us; 1129us; 1641us; 1131us; 1641us; 1133us; 1641us; 1135us; 805us; 1137us; 805us; 1141us; 805us; 1142us; 805us; 1143us; 805us; 1144us; 805us; 1145us; 805us; 1146us; 805us; 1147us; 805us; 1148us; 805us; 1149us; 805us; 1150us; 805us; 1151us; 805us; 1153us; 805us; 1154us; 805us; 1155us; 805us; 1156us; 805us; 1157us; 805us; 1158us; 805us; 1159us; 805us; 1160us; 805us; 1161us; 805us; 1183us; 805us; 1186us; 805us; 1188us; 805us; 1193us; 805us; 1200us; 805us; 1205us; 805us; 1206us; 805us; 1210us; 805us; 1212us; 805us; 1216us; 805us; 1218us; 805us; 1222us; 805us; 1225us; 805us; 1227us; 805us; 1229us; 805us; 1230us; 805us; 1232us; 805us; 1233us; 805us; 1235us; 805us; 1236us; 805us; 1238us; 805us; 1239us; 805us; 1241us; 805us; 1242us; 805us; 1244us; 805us; 1245us; 805us; 1247us; 1641us; 1248us; 1641us; 1251us; 805us; 1252us; 805us; 1257us; 805us; 1259us; 805us; 1261us; 805us; 1262us; 805us; 1263us; 805us; 1266us; 805us; 1273us; 805us; 1274us; 805us; 1277us; 805us; 1278us; 805us; 1291us; 805us; 1298us; 805us; 1305us; 805us; 1312us; 805us; 1322us; 805us; 1324us; 805us; 1325us; 805us; 1337us; 805us; 1344us; 805us; 1345us; 805us; 1351us; 805us; 1357us; 805us; 1358us; 805us; 1359us; 805us; 1375us; 805us; 1385us; 805us; 1398us; 805us; 1399us; 805us; 1401us; 805us; 1403us; 805us; 1407us; 805us; 1408us; 805us; 1415us; 805us; 1421us; 1641us; 1424us; 1641us; 1426us; 1641us; 1428us; 1641us; 1430us; 805us; 1435us; 805us; 1440us; 805us; 1465us; 805us; 1490us; 1641us; 1498us; 805us; 1505us; 805us; 1507us; 805us; 1510us; 805us; 1512us; 805us; 1523us; 805us; 1525us; 805us; 1532us; 1641us; 1535us; 1641us; 1538us; 1641us; 1541us; 1641us; 1543us; 1641us; 1545us; 1641us; 1549us; 1641us; 1552us; 1641us; 1556us; 1641us; 1559us; 1641us; 1564us; 1641us; 1566us; 1641us; 1568us; 1641us; 1571us; 1641us; 1573us; 1641us; 1587us; 1641us; 1592us; 1641us; 1595us; 1641us; 1606us; 1641us; 1610us; 1641us; 1616us; 1641us; 1623us; 1641us; 1627us; 1641us; 1633us; 1641us; 1634us; 1641us; 1643us; 805us; 1657us; 1641us; 1659us; 1641us; 1670us; 1641us; 1us; 65535us; 799us; 800us; 4us; 65535us; 803us; 804us; 1580us; 802us; 1614us; 802us; 1685us; 802us; 3us; 65535us; 1580us; 1581us; 1614us; 1615us; 1685us; 1686us; 185us; 65535us; 6us; 1327us; 31us; 1327us; 106us; 1327us; 108us; 1327us; 226us; 1327us; 240us; 1327us; 262us; 1327us; 312us; 1327us; 316us; 1327us; 321us; 1327us; 400us; 890us; 403us; 1327us; 405us; 890us; 408us; 1327us; 440us; 890us; 443us; 1327us; 459us; 1327us; 487us; 1327us; 638us; 639us; 650us; 651us; 695us; 1327us; 701us; 1327us; 747us; 890us; 750us; 1327us; 754us; 1327us; 764us; 1327us; 837us; 890us; 838us; 890us; 842us; 890us; 843us; 890us; 844us; 890us; 845us; 890us; 852us; 890us; 855us; 890us; 857us; 890us; 859us; 890us; 864us; 890us; 868us; 890us; 870us; 890us; 872us; 890us; 880us; 890us; 883us; 890us; 894us; 890us; 902us; 890us; 924us; 890us; 929us; 890us; 930us; 890us; 932us; 890us; 933us; 890us; 934us; 890us; 935us; 890us; 941us; 890us; 943us; 890us; 945us; 1327us; 950us; 1327us; 964us; 1327us; 966us; 1327us; 969us; 1327us; 972us; 1327us; 989us; 1327us; 992us; 1327us; 995us; 1327us; 1001us; 1327us; 1005us; 1327us; 1009us; 1327us; 1013us; 1327us; 1015us; 1327us; 1020us; 1327us; 1022us; 1327us; 1024us; 1327us; 1026us; 1327us; 1028us; 1327us; 1030us; 1327us; 1039us; 890us; 1041us; 1327us; 1049us; 1327us; 1056us; 1327us; 1062us; 1327us; 1064us; 1327us; 1066us; 890us; 1067us; 1327us; 1070us; 1327us; 1072us; 890us; 1073us; 1327us; 1076us; 1327us; 1079us; 1327us; 1082us; 1327us; 1084us; 1327us; 1089us; 1327us; 1091us; 1327us; 1135us; 1327us; 1137us; 1327us; 1141us; 1327us; 1142us; 1327us; 1143us; 1327us; 1144us; 1327us; 1145us; 1327us; 1146us; 1327us; 1147us; 1327us; 1148us; 1327us; 1149us; 1327us; 1150us; 1327us; 1151us; 1327us; 1153us; 1327us; 1154us; 1327us; 1155us; 1327us; 1156us; 1327us; 1157us; 1327us; 1158us; 1327us; 1159us; 1327us; 1160us; 1327us; 1161us; 1327us; 1183us; 1327us; 1186us; 890us; 1188us; 890us; 1193us; 890us; 1200us; 890us; 1205us; 1327us; 1206us; 1327us; 1210us; 1327us; 1212us; 1327us; 1216us; 1327us; 1218us; 1327us; 1222us; 1327us; 1225us; 1327us; 1227us; 1327us; 1229us; 1327us; 1230us; 1327us; 1232us; 1327us; 1233us; 1327us; 1235us; 1327us; 1236us; 1327us; 1238us; 1327us; 1239us; 1327us; 1241us; 1327us; 1242us; 1327us; 1244us; 1327us; 1245us; 1327us; 1251us; 1327us; 1252us; 1327us; 1257us; 1327us; 1259us; 1327us; 1261us; 1327us; 1262us; 1327us; 1263us; 1327us; 1266us; 1327us; 1273us; 1327us; 1274us; 1327us; 1277us; 1327us; 1278us; 1327us; 1291us; 1327us; 1298us; 1327us; 1305us; 1327us; 1312us; 1327us; 1322us; 1327us; 1324us; 1327us; 1325us; 1327us; 1337us; 1327us; 1344us; 1327us; 1345us; 1327us; 1351us; 1327us; 1357us; 1327us; 1358us; 1327us; 1359us; 1327us; 1375us; 1327us; 1385us; 1327us; 1398us; 1327us; 1399us; 1327us; 1401us; 1327us; 1403us; 1327us; 1407us; 1327us; 1408us; 1327us; 1415us; 1327us; 1430us; 1327us; 1435us; 1327us; 1440us; 1327us; 1465us; 1327us; 1498us; 1327us; 1505us; 890us; 1507us; 1327us; 1510us; 890us; 1512us; 1327us; 1523us; 890us; 1525us; 890us; 1643us; 1327us; 3us; 65535us; 400us; 401us; 405us; 406us; 747us; 748us; 3us; 65535us; 816us; 812us; 817us; 813us; 819us; 813us; 2us; 65535us; 817us; 818us; 819us; 820us; 1us; 65535us; 348us; 349us; 11us; 65535us; 400us; 808us; 405us; 808us; 747us; 808us; 837us; 827us; 838us; 828us; 842us; 829us; 843us; 830us; 844us; 831us; 845us; 832us; 1066us; 833us; 1072us; 834us; 11us; 65535us; 400us; 839us; 405us; 839us; 747us; 839us; 837us; 839us; 838us; 839us; 842us; 839us; 843us; 839us; 844us; 839us; 845us; 839us; 1066us; 839us; 1072us; 839us; 11us; 65535us; 400us; 840us; 405us; 840us; 747us; 840us; 837us; 840us; 838us; 840us; 842us; 840us; 843us; 840us; 844us; 840us; 845us; 840us; 1066us; 840us; 1072us; 840us; 2us; 65535us; 848us; 849us; 864us; 865us; 2us; 65535us; 848us; 846us; 864us; 846us; 33us; 65535us; 400us; 841us; 405us; 841us; 747us; 841us; 837us; 841us; 838us; 841us; 842us; 841us; 843us; 841us; 844us; 841us; 845us; 841us; 852us; 931us; 864us; 931us; 880us; 931us; 883us; 931us; 894us; 931us; 902us; 931us; 924us; 931us; 929us; 931us; 930us; 931us; 932us; 931us; 933us; 931us; 934us; 931us; 935us; 931us; 941us; 931us; 943us; 931us; 1039us; 931us; 1066us; 841us; 1072us; 841us; 1186us; 931us; 1188us; 931us; 1193us; 931us; 1200us; 931us; 1523us; 931us; 1525us; 931us; 3us; 65535us; 855us; 856us; 857us; 858us; 859us; 860us; 8us; 65535us; 855us; 867us; 857us; 867us; 859us; 867us; 868us; 869us; 870us; 871us; 872us; 873us; 1505us; 1506us; 1510us; 1511us; 42us; 65535us; 400us; 863us; 405us; 863us; 440us; 441us; 747us; 863us; 837us; 863us; 838us; 863us; 842us; 863us; 843us; 863us; 844us; 863us; 845us; 863us; 852us; 863us; 855us; 868us; 857us; 868us; 859us; 868us; 864us; 863us; 868us; 868us; 870us; 868us; 872us; 868us; 880us; 863us; 883us; 863us; 894us; 863us; 902us; 863us; 924us; 863us; 929us; 863us; 930us; 863us; 932us; 863us; 933us; 863us; 934us; 863us; 935us; 863us; 941us; 863us; 943us; 863us; 1039us; 863us; 1066us; 863us; 1072us; 863us; 1186us; 863us; 1188us; 863us; 1193us; 863us; 1200us; 863us; 1505us; 868us; 1510us; 868us; 1523us; 863us; 1525us; 863us; 2us; 65535us; 864us; 895us; 894us; 895us; 22us; 65535us; 852us; 853us; 864us; 909us; 880us; 919us; 883us; 919us; 894us; 909us; 902us; 916us; 924us; 910us; 929us; 911us; 930us; 912us; 932us; 913us; 933us; 914us; 934us; 915us; 935us; 917us; 941us; 918us; 943us; 919us; 1039us; 920us; 1186us; 921us; 1188us; 921us; 1193us; 921us; 1200us; 921us; 1523us; 921us; 1525us; 921us; 22us; 65535us; 852us; 925us; 864us; 925us; 880us; 925us; 883us; 925us; 894us; 925us; 902us; 903us; 924us; 925us; 929us; 925us; 930us; 925us; 932us; 925us; 933us; 925us; 934us; 925us; 935us; 925us; 941us; 925us; 943us; 925us; 1039us; 925us; 1186us; 925us; 1188us; 925us; 1193us; 925us; 1200us; 925us; 1523us; 925us; 1525us; 925us; 22us; 65535us; 852us; 926us; 864us; 926us; 880us; 926us; 883us; 926us; 894us; 926us; 902us; 926us; 924us; 926us; 929us; 926us; 930us; 926us; 932us; 926us; 933us; 926us; 934us; 926us; 935us; 926us; 941us; 926us; 943us; 926us; 1039us; 926us; 1186us; 926us; 1188us; 926us; 1193us; 926us; 1200us; 926us; 1523us; 926us; 1525us; 926us; 2us; 65535us; 877us; 878us; 938us; 939us; 2us; 65535us; 877us; 936us; 938us; 936us; 3us; 65535us; 880us; 881us; 883us; 884us; 943us; 944us; 23us; 65535us; 262us; 993us; 403us; 404us; 408us; 409us; 443us; 444us; 459us; 460us; 695us; 696us; 701us; 702us; 764us; 765us; 972us; 993us; 992us; 993us; 995us; 996us; 1013us; 1014us; 1030us; 1031us; 1041us; 1042us; 1049us; 1050us; 1056us; 1057us; 1067us; 1068us; 1070us; 1071us; 1073us; 1074us; 1076us; 1077us; 1082us; 1083us; 1084us; 1085us; 1507us; 1508us; 6us; 65535us; 1024us; 1025us; 1026us; 1027us; 1137us; 1138us; 1435us; 1436us; 1440us; 1441us; 1465us; 1466us; 5us; 65535us; 1009us; 1010us; 1091us; 1092us; 1206us; 1207us; 1401us; 1402us; 1512us; 1513us; 50us; 65535us; 6us; 959us; 262us; 949us; 403us; 949us; 408us; 949us; 443us; 949us; 459us; 949us; 695us; 949us; 701us; 949us; 750us; 759us; 754us; 759us; 764us; 949us; 945us; 946us; 950us; 951us; 969us; 970us; 972us; 949us; 989us; 990us; 992us; 949us; 995us; 949us; 1001us; 1002us; 1005us; 1006us; 1009us; 954us; 1013us; 949us; 1030us; 949us; 1041us; 949us; 1049us; 949us; 1056us; 949us; 1067us; 949us; 1070us; 949us; 1073us; 949us; 1076us; 949us; 1079us; 1080us; 1082us; 949us; 1084us; 949us; 1091us; 954us; 1183us; 1184us; 1206us; 954us; 1212us; 1213us; 1218us; 1219us; 1305us; 1310us; 1312us; 1313us; 1337us; 1338us; 1344us; 1346us; 1345us; 1346us; 1357us; 1377us; 1358us; 1377us; 1359us; 1377us; 1375us; 1376us; 1401us; 954us; 1507us; 949us; 1512us; 954us; 1us; 65535us; 6us; 7us; 55us; 65535us; 6us; 956us; 262us; 956us; 403us; 956us; 408us; 956us; 443us; 956us; 459us; 956us; 695us; 956us; 701us; 956us; 750us; 956us; 754us; 956us; 764us; 956us; 945us; 956us; 950us; 956us; 964us; 965us; 966us; 967us; 969us; 956us; 972us; 956us; 989us; 956us; 992us; 956us; 995us; 956us; 1001us; 956us; 1005us; 956us; 1009us; 956us; 1013us; 956us; 1030us; 956us; 1041us; 956us; 1049us; 956us; 1056us; 956us; 1067us; 956us; 1070us; 956us; 1073us; 956us; 1076us; 956us; 1079us; 956us; 1082us; 956us; 1084us; 956us; 1091us; 956us; 1183us; 956us; 1206us; 956us; 1212us; 956us; 1218us; 956us; 1291us; 1396us; 1305us; 956us; 1312us; 956us; 1337us; 956us; 1344us; 956us; 1345us; 956us; 1351us; 1396us; 1357us; 956us; 1358us; 956us; 1359us; 956us; 1375us; 956us; 1385us; 1396us; 1401us; 956us; 1507us; 956us; 1512us; 956us; 98us; 65535us; 70us; 73us; 146us; 148us; 152us; 154us; 156us; 158us; 160us; 162us; 231us; 234us; 271us; 272us; 278us; 280us; 281us; 283us; 288us; 290us; 298us; 1832us; 300us; 1832us; 357us; 360us; 370us; 372us; 376us; 377us; 380us; 381us; 484us; 1832us; 499us; 501us; 523us; 524us; 532us; 534us; 541us; 543us; 699us; 709us; 702us; 709us; 749us; 753us; 755us; 757us; 819us; 826us; 820us; 823us; 864us; 900us; 894us; 900us; 895us; 897us; 902us; 908us; 903us; 905us; 920us; 1061us; 946us; 948us; 1002us; 1004us; 1006us; 1008us; 1010us; 1012us; 1015us; 1019us; 1016us; 1018us; 1028us; 1037us; 1029us; 1036us; 1031us; 1033us; 1039us; 1832us; 1040us; 1832us; 1041us; 1832us; 1042us; 1832us; 1048us; 1055us; 1049us; 1054us; 1050us; 1052us; 1074us; 709us; 1085us; 709us; 1117us; 1224us; 1140us; 1300us; 1151us; 1152us; 1189us; 1191us; 1213us; 1215us; 1219us; 1221us; 1225us; 1832us; 1227us; 1832us; 1279us; 1304us; 1282us; 1304us; 1291us; 1296us; 1292us; 1294us; 1312us; 1320us; 1313us; 1315us; 1316us; 1318us; 1338us; 1340us; 1344us; 1350us; 1345us; 1350us; 1346us; 1348us; 1351us; 1356us; 1352us; 1354us; 1357us; 1370us; 1358us; 1370us; 1359us; 1370us; 1361us; 1826us; 1385us; 1390us; 1386us; 1388us; 1398us; 1400us; 1403us; 1832us; 1464us; 1832us; 1465us; 1832us; 1498us; 1503us; 1499us; 1501us; 1512us; 1518us; 1513us; 1515us; 1582us; 1639us; 1609us; 1662us; 1628us; 1631us; 1629us; 1631us; 1633us; 1640us; 1634us; 1638us; 1635us; 1637us; 1652us; 1832us; 1657us; 1668us; 1659us; 1832us; 1664us; 1832us; 1706us; 1832us; 109us; 65535us; 6us; 961us; 31us; 32us; 106us; 107us; 108us; 109us; 226us; 241us; 240us; 241us; 262us; 961us; 403us; 961us; 408us; 961us; 443us; 961us; 459us; 961us; 695us; 961us; 701us; 961us; 750us; 961us; 754us; 961us; 764us; 961us; 945us; 961us; 950us; 961us; 964us; 961us; 966us; 961us; 969us; 961us; 972us; 961us; 989us; 961us; 992us; 961us; 995us; 961us; 1001us; 961us; 1005us; 961us; 1009us; 961us; 1013us; 961us; 1015us; 1016us; 1020us; 1021us; 1022us; 1023us; 1024us; 953us; 1026us; 953us; 1028us; 1029us; 1030us; 961us; 1041us; 961us; 1049us; 961us; 1056us; 961us; 1062us; 1063us; 1064us; 1065us; 1067us; 961us; 1070us; 961us; 1073us; 961us; 1076us; 961us; 1079us; 961us; 1082us; 961us; 1084us; 961us; 1089us; 1090us; 1091us; 961us; 1135us; 1093us; 1137us; 953us; 1141us; 1094us; 1142us; 1095us; 1143us; 1096us; 1144us; 1097us; 1145us; 1098us; 1146us; 1099us; 1147us; 1100us; 1148us; 1101us; 1149us; 1102us; 1150us; 1103us; 1151us; 1104us; 1153us; 1105us; 1154us; 1106us; 1155us; 1107us; 1156us; 1108us; 1157us; 1109us; 1158us; 1110us; 1159us; 1111us; 1160us; 1112us; 1161us; 1113us; 1183us; 961us; 1205us; 1114us; 1206us; 961us; 1210us; 1115us; 1212us; 961us; 1216us; 1116us; 1218us; 961us; 1222us; 1117us; 1225us; 1118us; 1227us; 1120us; 1291us; 963us; 1298us; 1119us; 1305us; 961us; 1312us; 962us; 1322us; 1121us; 1324us; 1122us; 1325us; 1123us; 1337us; 961us; 1344us; 961us; 1345us; 961us; 1351us; 963us; 1357us; 961us; 1358us; 961us; 1359us; 961us; 1375us; 961us; 1385us; 963us; 1398us; 1126us; 1399us; 1127us; 1401us; 961us; 1403us; 1124us; 1407us; 1125us; 1408us; 1128us; 1435us; 953us; 1440us; 953us; 1465us; 953us; 1507us; 961us; 1512us; 961us; 1us; 65535us; 1287us; 1288us; 3us; 65535us; 1002us; 1003us; 1006us; 1007us; 1010us; 1011us; 4us; 65535us; 1186us; 1187us; 1188us; 1189us; 1523us; 1524us; 1525us; 1526us; 6us; 65535us; 1186us; 1198us; 1188us; 1198us; 1193us; 1198us; 1200us; 1198us; 1523us; 1198us; 1525us; 1198us; 6us; 65535us; 1186us; 1192us; 1188us; 1192us; 1193us; 1194us; 1200us; 1201us; 1523us; 1192us; 1525us; 1192us; 1us; 65535us; 921us; 1197us; 1us; 65535us; 1198us; 1199us; 2us; 65535us; 1016us; 1017us; 1117us; 1223us; 2us; 65535us; 1016us; 1208us; 1117us; 1208us; 1us; 65535us; 1208us; 1209us; 109us; 65535us; 6us; 1139us; 31us; 1139us; 106us; 1139us; 108us; 1139us; 226us; 1139us; 240us; 1139us; 262us; 1139us; 403us; 1139us; 408us; 1139us; 443us; 1139us; 459us; 1139us; 695us; 1139us; 701us; 1139us; 750us; 1139us; 754us; 1139us; 764us; 1139us; 945us; 1139us; 950us; 1139us; 964us; 1139us; 966us; 1139us; 969us; 1139us; 972us; 1139us; 989us; 1139us; 992us; 1139us; 995us; 1139us; 1001us; 1139us; 1005us; 1139us; 1009us; 1139us; 1013us; 1139us; 1015us; 1139us; 1020us; 1139us; 1022us; 1139us; 1024us; 1139us; 1026us; 1139us; 1028us; 1139us; 1030us; 1139us; 1041us; 1139us; 1049us; 1139us; 1056us; 1139us; 1062us; 1139us; 1064us; 1139us; 1067us; 1139us; 1070us; 1139us; 1073us; 1139us; 1076us; 1139us; 1079us; 1139us; 1082us; 1139us; 1084us; 1139us; 1089us; 1139us; 1091us; 1139us; 1135us; 1139us; 1137us; 1139us; 1141us; 1139us; 1142us; 1139us; 1143us; 1139us; 1144us; 1139us; 1145us; 1139us; 1146us; 1139us; 1147us; 1139us; 1148us; 1139us; 1149us; 1139us; 1150us; 1139us; 1151us; 1139us; 1153us; 1139us; 1154us; 1139us; 1155us; 1139us; 1156us; 1139us; 1157us; 1139us; 1158us; 1139us; 1159us; 1139us; 1160us; 1139us; 1161us; 1139us; 1183us; 1139us; 1205us; 1139us; 1206us; 1139us; 1210us; 1139us; 1212us; 1139us; 1216us; 1139us; 1218us; 1139us; 1222us; 1139us; 1225us; 1139us; 1227us; 1139us; 1291us; 1139us; 1298us; 1140us; 1305us; 1139us; 1312us; 1139us; 1322us; 1139us; 1324us; 1139us; 1325us; 1139us; 1337us; 1139us; 1344us; 1139us; 1345us; 1139us; 1351us; 1139us; 1357us; 1139us; 1358us; 1139us; 1359us; 1139us; 1375us; 1139us; 1385us; 1139us; 1398us; 1139us; 1399us; 1139us; 1401us; 1139us; 1403us; 1139us; 1407us; 1139us; 1408us; 1139us; 1435us; 1139us; 1440us; 1139us; 1465us; 1139us; 1507us; 1139us; 1512us; 1139us; 123us; 65535us; 6us; 1136us; 31us; 1136us; 106us; 1136us; 108us; 1136us; 226us; 1136us; 240us; 1136us; 262us; 1136us; 403us; 1136us; 408us; 1136us; 443us; 1136us; 459us; 1136us; 695us; 1136us; 701us; 1136us; 750us; 1136us; 754us; 1136us; 764us; 1136us; 945us; 1136us; 950us; 1136us; 964us; 1136us; 966us; 1136us; 969us; 1136us; 972us; 1136us; 989us; 1136us; 992us; 1136us; 995us; 1136us; 1001us; 1136us; 1005us; 1136us; 1009us; 1136us; 1013us; 1136us; 1015us; 1136us; 1020us; 1136us; 1022us; 1136us; 1024us; 1136us; 1026us; 1136us; 1028us; 1136us; 1030us; 1136us; 1041us; 1136us; 1049us; 1136us; 1056us; 1136us; 1062us; 1136us; 1064us; 1136us; 1067us; 1136us; 1070us; 1136us; 1073us; 1136us; 1076us; 1136us; 1079us; 1136us; 1082us; 1136us; 1084us; 1136us; 1089us; 1136us; 1091us; 1136us; 1135us; 1136us; 1137us; 1136us; 1141us; 1136us; 1142us; 1136us; 1143us; 1136us; 1144us; 1136us; 1145us; 1136us; 1146us; 1136us; 1147us; 1136us; 1148us; 1136us; 1149us; 1136us; 1150us; 1136us; 1151us; 1136us; 1153us; 1136us; 1154us; 1136us; 1155us; 1136us; 1156us; 1136us; 1157us; 1136us; 1158us; 1136us; 1159us; 1136us; 1160us; 1136us; 1161us; 1136us; 1183us; 1136us; 1205us; 1136us; 1206us; 1136us; 1210us; 1136us; 1212us; 1136us; 1216us; 1136us; 1218us; 1136us; 1222us; 1136us; 1225us; 1136us; 1227us; 1136us; 1229us; 1231us; 1230us; 1231us; 1232us; 1234us; 1233us; 1234us; 1235us; 1237us; 1236us; 1237us; 1238us; 1240us; 1239us; 1240us; 1241us; 1243us; 1242us; 1243us; 1244us; 1246us; 1245us; 1246us; 1257us; 1258us; 1259us; 1260us; 1291us; 1136us; 1298us; 1136us; 1305us; 1136us; 1312us; 1136us; 1322us; 1136us; 1324us; 1136us; 1325us; 1136us; 1337us; 1136us; 1344us; 1136us; 1345us; 1136us; 1351us; 1136us; 1357us; 1136us; 1358us; 1136us; 1359us; 1136us; 1375us; 1136us; 1385us; 1136us; 1398us; 1136us; 1399us; 1136us; 1401us; 1136us; 1403us; 1136us; 1407us; 1136us; 1408us; 1136us; 1435us; 1136us; 1440us; 1136us; 1465us; 1136us; 1507us; 1136us; 1512us; 1136us; 124us; 65535us; 6us; 1261us; 31us; 1261us; 106us; 1261us; 108us; 1261us; 226us; 1261us; 240us; 1261us; 262us; 1261us; 403us; 1261us; 408us; 1261us; 443us; 1261us; 459us; 1261us; 695us; 1261us; 701us; 1261us; 750us; 1261us; 754us; 1261us; 764us; 1261us; 945us; 1261us; 950us; 1261us; 964us; 1261us; 966us; 1261us; 969us; 1261us; 972us; 1261us; 989us; 1261us; 992us; 1261us; 995us; 1261us; 1001us; 1261us; 1005us; 1261us; 1009us; 1261us; 1013us; 1261us; 1015us; 1261us; 1020us; 1261us; 1022us; 1261us; 1024us; 1261us; 1026us; 1261us; 1028us; 1261us; 1030us; 1261us; 1041us; 1261us; 1049us; 1261us; 1056us; 1261us; 1062us; 1261us; 1064us; 1261us; 1067us; 1261us; 1070us; 1261us; 1073us; 1261us; 1076us; 1261us; 1079us; 1261us; 1082us; 1261us; 1084us; 1261us; 1089us; 1261us; 1091us; 1261us; 1135us; 1261us; 1137us; 1261us; 1141us; 1261us; 1142us; 1261us; 1143us; 1261us; 1144us; 1261us; 1145us; 1261us; 1146us; 1261us; 1147us; 1261us; 1148us; 1261us; 1149us; 1261us; 1150us; 1261us; 1151us; 1261us; 1153us; 1261us; 1154us; 1261us; 1155us; 1261us; 1156us; 1261us; 1157us; 1261us; 1158us; 1261us; 1159us; 1261us; 1160us; 1261us; 1161us; 1261us; 1183us; 1261us; 1205us; 1261us; 1206us; 1261us; 1210us; 1261us; 1212us; 1261us; 1216us; 1261us; 1218us; 1261us; 1222us; 1261us; 1225us; 1261us; 1227us; 1261us; 1229us; 1261us; 1230us; 1261us; 1232us; 1261us; 1233us; 1261us; 1235us; 1261us; 1236us; 1261us; 1238us; 1261us; 1239us; 1261us; 1241us; 1261us; 1242us; 1261us; 1244us; 1261us; 1245us; 1261us; 1257us; 1261us; 1259us; 1261us; 1291us; 1261us; 1298us; 1261us; 1305us; 1261us; 1312us; 1261us; 1322us; 1261us; 1324us; 1261us; 1325us; 1261us; 1337us; 1261us; 1344us; 1261us; 1345us; 1261us; 1351us; 1261us; 1357us; 1261us; 1358us; 1261us; 1359us; 1261us; 1375us; 1261us; 1385us; 1262us; 1398us; 1261us; 1399us; 1261us; 1401us; 1261us; 1403us; 1261us; 1407us; 1261us; 1408us; 1261us; 1435us; 1261us; 1440us; 1261us; 1465us; 1261us; 1498us; 1263us; 1507us; 1261us; 1512us; 1261us; 4us; 65535us; 1261us; 1264us; 1262us; 1264us; 1263us; 1264us; 1415us; 1418us; 134us; 65535us; 6us; 1265us; 31us; 1265us; 106us; 1265us; 108us; 1265us; 226us; 1265us; 240us; 1265us; 262us; 1265us; 403us; 1265us; 408us; 1265us; 443us; 1265us; 459us; 1265us; 695us; 1265us; 701us; 1265us; 750us; 1265us; 754us; 1265us; 764us; 1265us; 945us; 1265us; 950us; 1265us; 964us; 1265us; 966us; 1265us; 969us; 1265us; 972us; 1265us; 989us; 1265us; 992us; 1265us; 995us; 1265us; 1001us; 1265us; 1005us; 1265us; 1009us; 1265us; 1013us; 1265us; 1015us; 1265us; 1020us; 1265us; 1022us; 1265us; 1024us; 1265us; 1026us; 1265us; 1028us; 1265us; 1030us; 1265us; 1041us; 1265us; 1049us; 1265us; 1056us; 1265us; 1062us; 1265us; 1064us; 1265us; 1067us; 1265us; 1070us; 1265us; 1073us; 1265us; 1076us; 1265us; 1079us; 1265us; 1082us; 1265us; 1084us; 1265us; 1089us; 1265us; 1091us; 1265us; 1135us; 1265us; 1137us; 1265us; 1141us; 1265us; 1142us; 1265us; 1143us; 1265us; 1144us; 1265us; 1145us; 1265us; 1146us; 1265us; 1147us; 1265us; 1148us; 1265us; 1149us; 1265us; 1150us; 1265us; 1151us; 1265us; 1153us; 1265us; 1154us; 1265us; 1155us; 1265us; 1156us; 1265us; 1157us; 1265us; 1158us; 1265us; 1159us; 1265us; 1160us; 1265us; 1161us; 1265us; 1183us; 1265us; 1205us; 1265us; 1206us; 1265us; 1210us; 1265us; 1212us; 1265us; 1216us; 1265us; 1218us; 1265us; 1222us; 1265us; 1225us; 1265us; 1227us; 1265us; 1229us; 1265us; 1230us; 1265us; 1232us; 1265us; 1233us; 1265us; 1235us; 1265us; 1236us; 1265us; 1238us; 1265us; 1239us; 1265us; 1241us; 1265us; 1242us; 1265us; 1244us; 1265us; 1245us; 1265us; 1257us; 1265us; 1259us; 1265us; 1261us; 1268us; 1262us; 1268us; 1263us; 1268us; 1266us; 1267us; 1273us; 1269us; 1274us; 1270us; 1277us; 1271us; 1278us; 1271us; 1291us; 1265us; 1298us; 1265us; 1305us; 1265us; 1312us; 1265us; 1322us; 1265us; 1324us; 1265us; 1325us; 1265us; 1337us; 1265us; 1344us; 1265us; 1345us; 1265us; 1351us; 1265us; 1357us; 1265us; 1358us; 1265us; 1359us; 1265us; 1375us; 1265us; 1385us; 1265us; 1398us; 1265us; 1399us; 1265us; 1401us; 1265us; 1403us; 1265us; 1407us; 1265us; 1408us; 1265us; 1415us; 1268us; 1435us; 1265us; 1440us; 1265us; 1465us; 1265us; 1498us; 1265us; 1507us; 1265us; 1512us; 1265us; 1643us; 1272us; 2us; 65535us; 1279us; 1280us; 1282us; 1283us; 2us; 65535us; 1312us; 1316us; 1322us; 1323us; 2us; 65535us; 1312us; 1321us; 1322us; 1321us; 141us; 65535us; 6us; 1301us; 31us; 1301us; 106us; 1301us; 108us; 1301us; 226us; 1301us; 240us; 1301us; 262us; 1301us; 312us; 1419us; 316us; 1419us; 321us; 1419us; 403us; 1301us; 408us; 1301us; 443us; 1301us; 459us; 1301us; 487us; 488us; 695us; 1301us; 701us; 1301us; 750us; 1301us; 754us; 1301us; 764us; 1301us; 945us; 1301us; 950us; 1301us; 964us; 1301us; 966us; 1301us; 969us; 1301us; 972us; 1301us; 989us; 1301us; 992us; 1301us; 995us; 1301us; 1001us; 1301us; 1005us; 1301us; 1009us; 1301us; 1013us; 1301us; 1015us; 1301us; 1020us; 1301us; 1022us; 1301us; 1024us; 1301us; 1026us; 1301us; 1028us; 1301us; 1030us; 1301us; 1041us; 1301us; 1049us; 1301us; 1056us; 1301us; 1062us; 1301us; 1064us; 1301us; 1067us; 1301us; 1070us; 1301us; 1073us; 1301us; 1076us; 1301us; 1079us; 1301us; 1082us; 1301us; 1084us; 1301us; 1089us; 1301us; 1091us; 1301us; 1135us; 1301us; 1137us; 1301us; 1141us; 1301us; 1142us; 1301us; 1143us; 1301us; 1144us; 1301us; 1145us; 1301us; 1146us; 1301us; 1147us; 1301us; 1148us; 1301us; 1149us; 1301us; 1150us; 1301us; 1151us; 1301us; 1153us; 1301us; 1154us; 1301us; 1155us; 1301us; 1156us; 1301us; 1157us; 1301us; 1158us; 1301us; 1159us; 1301us; 1160us; 1301us; 1161us; 1301us; 1183us; 1301us; 1205us; 1301us; 1206us; 1301us; 1210us; 1301us; 1212us; 1301us; 1216us; 1301us; 1218us; 1301us; 1222us; 1301us; 1225us; 1301us; 1227us; 1301us; 1229us; 1301us; 1230us; 1301us; 1232us; 1301us; 1233us; 1301us; 1235us; 1301us; 1236us; 1301us; 1238us; 1301us; 1239us; 1301us; 1241us; 1301us; 1242us; 1301us; 1244us; 1301us; 1245us; 1301us; 1251us; 1253us; 1252us; 1254us; 1257us; 1301us; 1259us; 1301us; 1261us; 1301us; 1262us; 1301us; 1263us; 1301us; 1266us; 1301us; 1273us; 1301us; 1274us; 1301us; 1277us; 1301us; 1278us; 1301us; 1291us; 1301us; 1298us; 1301us; 1305us; 1301us; 1312us; 1301us; 1322us; 1301us; 1324us; 1301us; 1325us; 1301us; 1337us; 1301us; 1344us; 1301us; 1345us; 1301us; 1351us; 1301us; 1357us; 1301us; 1358us; 1301us; 1359us; 1301us; 1375us; 1301us; 1385us; 1301us; 1398us; 1301us; 1399us; 1301us; 1401us; 1301us; 1403us; 1301us; 1407us; 1301us; 1408us; 1301us; 1415us; 1301us; 1430us; 1419us; 1435us; 1301us; 1440us; 1301us; 1465us; 1301us; 1498us; 1301us; 1507us; 1301us; 1512us; 1301us; 1643us; 1301us; 141us; 65535us; 6us; 1336us; 31us; 1336us; 106us; 1336us; 108us; 1336us; 226us; 1336us; 240us; 1336us; 262us; 1336us; 312us; 1336us; 316us; 1336us; 321us; 1336us; 403us; 1336us; 408us; 1336us; 443us; 1336us; 459us; 1336us; 487us; 1336us; 695us; 1336us; 701us; 1336us; 750us; 1336us; 754us; 1336us; 764us; 1336us; 945us; 1336us; 950us; 1336us; 964us; 1336us; 966us; 1336us; 969us; 1336us; 972us; 1336us; 989us; 1336us; 992us; 1336us; 995us; 1336us; 1001us; 1336us; 1005us; 1336us; 1009us; 1336us; 1013us; 1336us; 1015us; 1336us; 1020us; 1336us; 1022us; 1336us; 1024us; 1336us; 1026us; 1336us; 1028us; 1336us; 1030us; 1336us; 1041us; 1336us; 1049us; 1336us; 1056us; 1336us; 1062us; 1336us; 1064us; 1336us; 1067us; 1336us; 1070us; 1336us; 1073us; 1336us; 1076us; 1336us; 1079us; 1336us; 1082us; 1336us; 1084us; 1336us; 1089us; 1336us; 1091us; 1336us; 1135us; 1336us; 1137us; 1336us; 1141us; 1336us; 1142us; 1336us; 1143us; 1336us; 1144us; 1336us; 1145us; 1336us; 1146us; 1336us; 1147us; 1336us; 1148us; 1336us; 1149us; 1336us; 1150us; 1336us; 1151us; 1336us; 1153us; 1336us; 1154us; 1336us; 1155us; 1336us; 1156us; 1336us; 1157us; 1336us; 1158us; 1336us; 1159us; 1336us; 1160us; 1336us; 1161us; 1336us; 1183us; 1336us; 1205us; 1336us; 1206us; 1336us; 1210us; 1336us; 1212us; 1336us; 1216us; 1336us; 1218us; 1336us; 1222us; 1336us; 1225us; 1336us; 1227us; 1336us; 1229us; 1336us; 1230us; 1336us; 1232us; 1336us; 1233us; 1336us; 1235us; 1336us; 1236us; 1336us; 1238us; 1336us; 1239us; 1336us; 1241us; 1336us; 1242us; 1336us; 1244us; 1336us; 1245us; 1336us; 1251us; 1336us; 1252us; 1336us; 1257us; 1336us; 1259us; 1336us; 1261us; 1336us; 1262us; 1336us; 1263us; 1336us; 1266us; 1336us; 1273us; 1336us; 1274us; 1336us; 1277us; 1336us; 1278us; 1336us; 1291us; 1336us; 1298us; 1336us; 1305us; 1336us; 1312us; 1336us; 1322us; 1336us; 1324us; 1336us; 1325us; 1336us; 1337us; 1336us; 1344us; 1336us; 1345us; 1336us; 1351us; 1336us; 1357us; 1336us; 1358us; 1336us; 1359us; 1336us; 1375us; 1336us; 1385us; 1336us; 1398us; 1336us; 1399us; 1336us; 1401us; 1336us; 1403us; 1336us; 1407us; 1336us; 1408us; 1336us; 1415us; 1336us; 1430us; 1336us; 1435us; 1336us; 1440us; 1336us; 1465us; 1336us; 1498us; 1336us; 1507us; 1336us; 1512us; 1336us; 1643us; 1336us; 183us; 65535us; 6us; 1334us; 31us; 1334us; 106us; 1334us; 108us; 1334us; 226us; 1334us; 240us; 1334us; 262us; 1334us; 312us; 1334us; 316us; 1334us; 321us; 1334us; 400us; 874us; 403us; 1334us; 405us; 874us; 408us; 1334us; 440us; 874us; 443us; 1334us; 459us; 1334us; 487us; 1334us; 695us; 1334us; 701us; 1334us; 747us; 874us; 750us; 1334us; 754us; 1334us; 764us; 1334us; 837us; 874us; 838us; 874us; 842us; 874us; 843us; 874us; 844us; 874us; 845us; 874us; 852us; 874us; 855us; 874us; 857us; 874us; 859us; 874us; 864us; 874us; 868us; 874us; 870us; 874us; 872us; 874us; 880us; 874us; 883us; 874us; 894us; 874us; 902us; 874us; 924us; 874us; 929us; 874us; 930us; 874us; 932us; 874us; 933us; 874us; 934us; 874us; 935us; 874us; 941us; 874us; 943us; 874us; 945us; 1334us; 950us; 1334us; 964us; 1334us; 966us; 1334us; 969us; 1334us; 972us; 1334us; 989us; 1334us; 992us; 1334us; 995us; 1334us; 1001us; 1334us; 1005us; 1334us; 1009us; 1334us; 1013us; 1334us; 1015us; 1334us; 1020us; 1334us; 1022us; 1334us; 1024us; 1334us; 1026us; 1334us; 1028us; 1334us; 1030us; 1334us; 1039us; 874us; 1041us; 1334us; 1049us; 1334us; 1056us; 1334us; 1062us; 1334us; 1064us; 1334us; 1066us; 874us; 1067us; 1334us; 1070us; 1334us; 1072us; 874us; 1073us; 1334us; 1076us; 1334us; 1079us; 1334us; 1082us; 1334us; 1084us; 1334us; 1089us; 1334us; 1091us; 1334us; 1135us; 1334us; 1137us; 1334us; 1141us; 1334us; 1142us; 1334us; 1143us; 1334us; 1144us; 1334us; 1145us; 1334us; 1146us; 1334us; 1147us; 1334us; 1148us; 1334us; 1149us; 1334us; 1150us; 1334us; 1151us; 1334us; 1153us; 1334us; 1154us; 1334us; 1155us; 1334us; 1156us; 1334us; 1157us; 1334us; 1158us; 1334us; 1159us; 1334us; 1160us; 1334us; 1161us; 1334us; 1183us; 1334us; 1186us; 874us; 1188us; 874us; 1193us; 874us; 1200us; 874us; 1205us; 1334us; 1206us; 1334us; 1210us; 1334us; 1212us; 1334us; 1216us; 1334us; 1218us; 1334us; 1222us; 1334us; 1225us; 1334us; 1227us; 1334us; 1229us; 1334us; 1230us; 1334us; 1232us; 1334us; 1233us; 1334us; 1235us; 1334us; 1236us; 1334us; 1238us; 1334us; 1239us; 1334us; 1241us; 1334us; 1242us; 1334us; 1244us; 1334us; 1245us; 1334us; 1251us; 1334us; 1252us; 1334us; 1257us; 1334us; 1259us; 1334us; 1261us; 1334us; 1262us; 1334us; 1263us; 1334us; 1266us; 1334us; 1273us; 1334us; 1274us; 1334us; 1277us; 1334us; 1278us; 1334us; 1291us; 1334us; 1298us; 1334us; 1305us; 1334us; 1312us; 1334us; 1322us; 1334us; 1324us; 1334us; 1325us; 1334us; 1337us; 1334us; 1344us; 1334us; 1345us; 1334us; 1351us; 1334us; 1357us; 1334us; 1358us; 1334us; 1359us; 1334us; 1375us; 1334us; 1385us; 1334us; 1398us; 1334us; 1399us; 1334us; 1401us; 1334us; 1403us; 1334us; 1407us; 1334us; 1408us; 1334us; 1415us; 1334us; 1430us; 1334us; 1435us; 1334us; 1440us; 1334us; 1465us; 1334us; 1498us; 1334us; 1505us; 874us; 1507us; 1334us; 1510us; 874us; 1512us; 1334us; 1523us; 874us; 1525us; 874us; 1643us; 1334us; 141us; 65535us; 6us; 1335us; 31us; 1335us; 106us; 1335us; 108us; 1335us; 226us; 1335us; 240us; 1335us; 262us; 1335us; 312us; 1335us; 316us; 1335us; 321us; 1335us; 403us; 1335us; 408us; 1335us; 443us; 1335us; 459us; 1335us; 487us; 1335us; 695us; 1335us; 701us; 1335us; 750us; 1335us; 754us; 1335us; 764us; 1335us; 945us; 1335us; 950us; 1335us; 964us; 1335us; 966us; 1335us; 969us; 1335us; 972us; 1335us; 989us; 1335us; 992us; 1335us; 995us; 1335us; 1001us; 1335us; 1005us; 1335us; 1009us; 1335us; 1013us; 1335us; 1015us; 1335us; 1020us; 1335us; 1022us; 1335us; 1024us; 1335us; 1026us; 1335us; 1028us; 1335us; 1030us; 1335us; 1041us; 1335us; 1049us; 1335us; 1056us; 1335us; 1062us; 1335us; 1064us; 1335us; 1067us; 1335us; 1070us; 1335us; 1073us; 1335us; 1076us; 1335us; 1079us; 1335us; 1082us; 1335us; 1084us; 1335us; 1089us; 1335us; 1091us; 1335us; 1135us; 1335us; 1137us; 1335us; 1141us; 1335us; 1142us; 1335us; 1143us; 1335us; 1144us; 1335us; 1145us; 1335us; 1146us; 1335us; 1147us; 1335us; 1148us; 1335us; 1149us; 1335us; 1150us; 1335us; 1151us; 1335us; 1153us; 1335us; 1154us; 1335us; 1155us; 1335us; 1156us; 1335us; 1157us; 1335us; 1158us; 1335us; 1159us; 1335us; 1160us; 1335us; 1161us; 1335us; 1183us; 1335us; 1205us; 1335us; 1206us; 1335us; 1210us; 1335us; 1212us; 1335us; 1216us; 1335us; 1218us; 1335us; 1222us; 1335us; 1225us; 1335us; 1227us; 1335us; 1229us; 1335us; 1230us; 1335us; 1232us; 1335us; 1233us; 1335us; 1235us; 1335us; 1236us; 1335us; 1238us; 1335us; 1239us; 1335us; 1241us; 1335us; 1242us; 1335us; 1244us; 1335us; 1245us; 1335us; 1251us; 1335us; 1252us; 1335us; 1257us; 1335us; 1259us; 1335us; 1261us; 1335us; 1262us; 1335us; 1263us; 1335us; 1266us; 1335us; 1273us; 1335us; 1274us; 1335us; 1277us; 1335us; 1278us; 1335us; 1291us; 1335us; 1298us; 1335us; 1305us; 1335us; 1312us; 1335us; 1322us; 1335us; 1324us; 1335us; 1325us; 1335us; 1337us; 1335us; 1344us; 1335us; 1345us; 1335us; 1351us; 1335us; 1357us; 1335us; 1358us; 1335us; 1359us; 1335us; 1375us; 1335us; 1385us; 1335us; 1398us; 1335us; 1399us; 1335us; 1401us; 1335us; 1403us; 1335us; 1407us; 1335us; 1408us; 1335us; 1415us; 1335us; 1430us; 1335us; 1435us; 1335us; 1440us; 1335us; 1465us; 1335us; 1498us; 1335us; 1507us; 1335us; 1512us; 1335us; 1643us; 1335us; 141us; 65535us; 6us; 1328us; 31us; 1328us; 106us; 1328us; 108us; 1328us; 226us; 1328us; 240us; 1328us; 262us; 1328us; 312us; 1328us; 316us; 1328us; 321us; 1328us; 403us; 1328us; 408us; 1328us; 443us; 1328us; 459us; 1328us; 487us; 1328us; 695us; 1328us; 701us; 1328us; 750us; 1328us; 754us; 1328us; 764us; 1328us; 945us; 1328us; 950us; 1328us; 964us; 1328us; 966us; 1328us; 969us; 1328us; 972us; 1328us; 989us; 1328us; 992us; 1328us; 995us; 1328us; 1001us; 1328us; 1005us; 1328us; 1009us; 1328us; 1013us; 1328us; 1015us; 1328us; 1020us; 1328us; 1022us; 1328us; 1024us; 1328us; 1026us; 1328us; 1028us; 1328us; 1030us; 1328us; 1041us; 1328us; 1049us; 1328us; 1056us; 1328us; 1062us; 1328us; 1064us; 1328us; 1067us; 1328us; 1070us; 1328us; 1073us; 1328us; 1076us; 1328us; 1079us; 1328us; 1082us; 1328us; 1084us; 1328us; 1089us; 1328us; 1091us; 1328us; 1135us; 1328us; 1137us; 1328us; 1141us; 1328us; 1142us; 1328us; 1143us; 1328us; 1144us; 1328us; 1145us; 1328us; 1146us; 1328us; 1147us; 1328us; 1148us; 1328us; 1149us; 1328us; 1150us; 1328us; 1151us; 1328us; 1153us; 1328us; 1154us; 1328us; 1155us; 1328us; 1156us; 1328us; 1157us; 1328us; 1158us; 1328us; 1159us; 1328us; 1160us; 1328us; 1161us; 1328us; 1183us; 1328us; 1205us; 1328us; 1206us; 1328us; 1210us; 1328us; 1212us; 1328us; 1216us; 1328us; 1218us; 1328us; 1222us; 1328us; 1225us; 1328us; 1227us; 1328us; 1229us; 1328us; 1230us; 1328us; 1232us; 1328us; 1233us; 1328us; 1235us; 1328us; 1236us; 1328us; 1238us; 1328us; 1239us; 1328us; 1241us; 1328us; 1242us; 1328us; 1244us; 1328us; 1245us; 1328us; 1251us; 1328us; 1252us; 1328us; 1257us; 1328us; 1259us; 1328us; 1261us; 1328us; 1262us; 1328us; 1263us; 1328us; 1266us; 1328us; 1273us; 1328us; 1274us; 1328us; 1277us; 1328us; 1278us; 1328us; 1291us; 1328us; 1298us; 1328us; 1305us; 1328us; 1312us; 1328us; 1322us; 1328us; 1324us; 1328us; 1325us; 1328us; 1337us; 1328us; 1344us; 1328us; 1345us; 1328us; 1351us; 1328us; 1357us; 1328us; 1358us; 1328us; 1359us; 1328us; 1375us; 1328us; 1385us; 1328us; 1398us; 1328us; 1399us; 1328us; 1401us; 1328us; 1403us; 1328us; 1407us; 1328us; 1408us; 1328us; 1415us; 1328us; 1430us; 1328us; 1435us; 1328us; 1440us; 1328us; 1465us; 1328us; 1498us; 1328us; 1507us; 1328us; 1512us; 1328us; 1643us; 1328us; 3us; 65535us; 1357us; 1361us; 1358us; 1361us; 1359us; 1361us; 3us; 65535us; 1357us; 1371us; 1358us; 1371us; 1359us; 1371us; 1us; 65535us; 1358us; 1381us; 141us; 65535us; 6us; 1329us; 31us; 1329us; 106us; 1329us; 108us; 1329us; 226us; 1329us; 240us; 1329us; 262us; 1329us; 312us; 1329us; 316us; 1329us; 321us; 1329us; 403us; 1329us; 408us; 1329us; 443us; 1329us; 459us; 1329us; 487us; 1329us; 695us; 1329us; 701us; 1329us; 750us; 1329us; 754us; 1329us; 764us; 1329us; 945us; 1329us; 950us; 1329us; 964us; 1329us; 966us; 1329us; 969us; 1329us; 972us; 1329us; 989us; 1329us; 992us; 1329us; 995us; 1329us; 1001us; 1329us; 1005us; 1329us; 1009us; 1329us; 1013us; 1329us; 1015us; 1329us; 1020us; 1329us; 1022us; 1329us; 1024us; 1329us; 1026us; 1329us; 1028us; 1329us; 1030us; 1329us; 1041us; 1329us; 1049us; 1329us; 1056us; 1329us; 1062us; 1329us; 1064us; 1329us; 1067us; 1329us; 1070us; 1329us; 1073us; 1329us; 1076us; 1329us; 1079us; 1329us; 1082us; 1329us; 1084us; 1329us; 1089us; 1329us; 1091us; 1329us; 1135us; 1329us; 1137us; 1329us; 1141us; 1329us; 1142us; 1329us; 1143us; 1329us; 1144us; 1329us; 1145us; 1329us; 1146us; 1329us; 1147us; 1329us; 1148us; 1329us; 1149us; 1329us; 1150us; 1329us; 1151us; 1329us; 1153us; 1329us; 1154us; 1329us; 1155us; 1329us; 1156us; 1329us; 1157us; 1329us; 1158us; 1329us; 1159us; 1329us; 1160us; 1329us; 1161us; 1329us; 1183us; 1329us; 1205us; 1329us; 1206us; 1329us; 1210us; 1329us; 1212us; 1329us; 1216us; 1329us; 1218us; 1329us; 1222us; 1329us; 1225us; 1329us; 1227us; 1329us; 1229us; 1329us; 1230us; 1329us; 1232us; 1329us; 1233us; 1329us; 1235us; 1329us; 1236us; 1329us; 1238us; 1329us; 1239us; 1329us; 1241us; 1329us; 1242us; 1329us; 1244us; 1329us; 1245us; 1329us; 1251us; 1329us; 1252us; 1329us; 1257us; 1329us; 1259us; 1329us; 1261us; 1329us; 1262us; 1329us; 1263us; 1329us; 1266us; 1329us; 1273us; 1329us; 1274us; 1329us; 1277us; 1329us; 1278us; 1329us; 1291us; 1329us; 1298us; 1329us; 1305us; 1329us; 1312us; 1329us; 1322us; 1329us; 1324us; 1329us; 1325us; 1329us; 1337us; 1329us; 1344us; 1329us; 1345us; 1329us; 1351us; 1329us; 1357us; 1329us; 1358us; 1329us; 1359us; 1329us; 1375us; 1329us; 1385us; 1329us; 1398us; 1329us; 1399us; 1329us; 1401us; 1329us; 1403us; 1329us; 1407us; 1329us; 1408us; 1329us; 1415us; 1329us; 1430us; 1329us; 1435us; 1329us; 1440us; 1329us; 1465us; 1329us; 1498us; 1329us; 1507us; 1329us; 1512us; 1329us; 1643us; 1329us; 1us; 65535us; 1385us; 1386us; 2us; 65535us; 1291us; 1292us; 1351us; 1352us; 3us; 65535us; 1291us; 1395us; 1351us; 1395us; 1385us; 1394us; 5us; 65535us; 1291us; 1397us; 1351us; 1397us; 1385us; 1397us; 1403us; 1404us; 1407us; 1409us; 1us; 65535us; 1087us; 1088us; 1us; 65535us; 1039us; 1040us; 1us; 65535us; 1039us; 1048us; 1us; 65535us; 1125us; 1408us; 3us; 65535us; 1357us; 1378us; 1358us; 1378us; 1359us; 1378us; 1us; 65535us; 1414us; 1415us; 4us; 65535us; 312us; 313us; 316us; 317us; 321us; 322us; 1430us; 1431us; 1us; 65535us; 1413us; 1414us; 1us; 65535us; 1415us; 1416us; 1us; 65535us; 1385us; 1392us; 2us; 65535us; 1385us; 1434us; 1498us; 1499us; 6us; 65535us; 1432us; 1433us; 1437us; 1438us; 1442us; 1443us; 1446us; 1447us; 1448us; 1449us; 1452us; 1453us; 6us; 65535us; 1432us; 1456us; 1437us; 1456us; 1442us; 1456us; 1446us; 1456us; 1448us; 1455us; 1452us; 1456us; 3us; 65535us; 1444us; 1464us; 1448us; 1464us; 1456us; 1464us; 5us; 65535us; 1431us; 1432us; 1436us; 1437us; 1441us; 1442us; 1445us; 1446us; 1451us; 1452us; 3us; 65535us; 1444us; 1445us; 1448us; 1451us; 1456us; 1463us; 1us; 65535us; 1385us; 1393us; 1us; 65535us; 1385us; 1469us; 1us; 65535us; 1491us; 1492us; 2us; 65535us; 1469us; 1470us; 1491us; 1476us; 1us; 65535us; 1473us; 1474us; 4us; 65535us; 1471us; 1472us; 1484us; 1485us; 1486us; 1487us; 1488us; 1489us; 5us; 65535us; 1471us; 1486us; 1473us; 1484us; 1484us; 1486us; 1486us; 1486us; 1488us; 1486us; 141us; 65535us; 6us; 1330us; 31us; 1330us; 106us; 1330us; 108us; 1330us; 226us; 1330us; 240us; 1330us; 262us; 1330us; 312us; 1330us; 316us; 1330us; 321us; 1330us; 403us; 1330us; 408us; 1330us; 443us; 1330us; 459us; 1330us; 487us; 1330us; 695us; 1330us; 701us; 1330us; 750us; 1330us; 754us; 1330us; 764us; 1330us; 945us; 1330us; 950us; 1330us; 964us; 1330us; 966us; 1330us; 969us; 1330us; 972us; 1330us; 989us; 1330us; 992us; 1330us; 995us; 1330us; 1001us; 1330us; 1005us; 1330us; 1009us; 1330us; 1013us; 1330us; 1015us; 1330us; 1020us; 1330us; 1022us; 1330us; 1024us; 1330us; 1026us; 1330us; 1028us; 1330us; 1030us; 1330us; 1041us; 1330us; 1049us; 1330us; 1056us; 1330us; 1062us; 1330us; 1064us; 1330us; 1067us; 1330us; 1070us; 1330us; 1073us; 1330us; 1076us; 1330us; 1079us; 1330us; 1082us; 1330us; 1084us; 1330us; 1089us; 1330us; 1091us; 1330us; 1135us; 1330us; 1137us; 1330us; 1141us; 1330us; 1142us; 1330us; 1143us; 1330us; 1144us; 1330us; 1145us; 1330us; 1146us; 1330us; 1147us; 1330us; 1148us; 1330us; 1149us; 1330us; 1150us; 1330us; 1151us; 1330us; 1153us; 1330us; 1154us; 1330us; 1155us; 1330us; 1156us; 1330us; 1157us; 1330us; 1158us; 1330us; 1159us; 1330us; 1160us; 1330us; 1161us; 1330us; 1183us; 1330us; 1205us; 1330us; 1206us; 1330us; 1210us; 1330us; 1212us; 1330us; 1216us; 1330us; 1218us; 1330us; 1222us; 1330us; 1225us; 1330us; 1227us; 1330us; 1229us; 1330us; 1230us; 1330us; 1232us; 1330us; 1233us; 1330us; 1235us; 1330us; 1236us; 1330us; 1238us; 1330us; 1239us; 1330us; 1241us; 1330us; 1242us; 1330us; 1244us; 1330us; 1245us; 1330us; 1251us; 1330us; 1252us; 1330us; 1257us; 1330us; 1259us; 1330us; 1261us; 1330us; 1262us; 1330us; 1263us; 1330us; 1266us; 1330us; 1273us; 1330us; 1274us; 1330us; 1277us; 1330us; 1278us; 1330us; 1291us; 1330us; 1298us; 1330us; 1305us; 1330us; 1312us; 1330us; 1322us; 1330us; 1324us; 1330us; 1325us; 1330us; 1337us; 1330us; 1344us; 1330us; 1345us; 1330us; 1351us; 1330us; 1357us; 1330us; 1358us; 1330us; 1359us; 1330us; 1375us; 1330us; 1385us; 1330us; 1398us; 1330us; 1399us; 1330us; 1401us; 1330us; 1403us; 1330us; 1407us; 1330us; 1408us; 1330us; 1415us; 1330us; 1430us; 1330us; 1435us; 1330us; 1440us; 1330us; 1465us; 1330us; 1498us; 1330us; 1507us; 1330us; 1512us; 1330us; 1643us; 1330us; 143us; 65535us; 6us; 1497us; 31us; 1497us; 106us; 1497us; 108us; 1497us; 226us; 1497us; 240us; 1497us; 262us; 1497us; 312us; 1497us; 316us; 1497us; 321us; 1497us; 403us; 1497us; 408us; 1497us; 443us; 1497us; 459us; 1497us; 487us; 1497us; 695us; 1497us; 701us; 1497us; 750us; 1497us; 754us; 1497us; 764us; 1497us; 945us; 1497us; 950us; 1497us; 964us; 1497us; 966us; 1497us; 969us; 1497us; 972us; 1497us; 989us; 1497us; 992us; 1497us; 995us; 1497us; 1001us; 1497us; 1005us; 1497us; 1009us; 1497us; 1013us; 1497us; 1015us; 1497us; 1020us; 1497us; 1022us; 1497us; 1024us; 1497us; 1026us; 1497us; 1028us; 1497us; 1030us; 1497us; 1041us; 1497us; 1049us; 1497us; 1056us; 1497us; 1062us; 1497us; 1064us; 1497us; 1067us; 1497us; 1070us; 1497us; 1073us; 1497us; 1076us; 1497us; 1079us; 1497us; 1082us; 1497us; 1084us; 1497us; 1089us; 1497us; 1091us; 1497us; 1135us; 1497us; 1137us; 1497us; 1141us; 1497us; 1142us; 1497us; 1143us; 1497us; 1144us; 1497us; 1145us; 1497us; 1146us; 1497us; 1147us; 1497us; 1148us; 1497us; 1149us; 1497us; 1150us; 1497us; 1151us; 1497us; 1153us; 1497us; 1154us; 1497us; 1155us; 1497us; 1156us; 1497us; 1157us; 1497us; 1158us; 1497us; 1159us; 1497us; 1160us; 1497us; 1161us; 1497us; 1183us; 1497us; 1205us; 1497us; 1206us; 1497us; 1210us; 1497us; 1212us; 1497us; 1216us; 1497us; 1218us; 1497us; 1222us; 1497us; 1225us; 1497us; 1227us; 1497us; 1229us; 1497us; 1230us; 1497us; 1232us; 1497us; 1233us; 1497us; 1235us; 1497us; 1236us; 1497us; 1238us; 1497us; 1239us; 1497us; 1241us; 1497us; 1242us; 1497us; 1244us; 1497us; 1245us; 1497us; 1251us; 1497us; 1252us; 1497us; 1257us; 1497us; 1259us; 1497us; 1261us; 1497us; 1262us; 1497us; 1263us; 1497us; 1266us; 1497us; 1273us; 1497us; 1274us; 1497us; 1277us; 1497us; 1278us; 1497us; 1291us; 1497us; 1297us; 1496us; 1298us; 1497us; 1305us; 1497us; 1312us; 1497us; 1322us; 1497us; 1324us; 1497us; 1325us; 1497us; 1337us; 1497us; 1344us; 1497us; 1345us; 1497us; 1351us; 1497us; 1357us; 1497us; 1358us; 1497us; 1359us; 1497us; 1375us; 1497us; 1385us; 1497us; 1398us; 1497us; 1399us; 1497us; 1401us; 1497us; 1403us; 1497us; 1407us; 1497us; 1408us; 1497us; 1415us; 1497us; 1430us; 1497us; 1435us; 1497us; 1440us; 1497us; 1465us; 1497us; 1495us; 1496us; 1498us; 1497us; 1507us; 1497us; 1512us; 1497us; 1643us; 1497us; 109us; 65535us; 6us; 1000us; 31us; 1000us; 106us; 1000us; 108us; 1000us; 226us; 1000us; 240us; 1000us; 262us; 1000us; 403us; 1000us; 408us; 1000us; 443us; 1000us; 459us; 1000us; 695us; 1000us; 701us; 1000us; 750us; 1000us; 754us; 1000us; 764us; 1000us; 945us; 1000us; 950us; 1000us; 964us; 1000us; 966us; 1000us; 969us; 1000us; 972us; 1000us; 989us; 1000us; 992us; 1000us; 995us; 1000us; 1001us; 1000us; 1005us; 1000us; 1009us; 1000us; 1013us; 1000us; 1015us; 1000us; 1020us; 1000us; 1022us; 1000us; 1024us; 1000us; 1026us; 1000us; 1028us; 1000us; 1030us; 1000us; 1041us; 1000us; 1049us; 1000us; 1056us; 1000us; 1062us; 1000us; 1064us; 1000us; 1067us; 1000us; 1070us; 1000us; 1073us; 1000us; 1076us; 1000us; 1079us; 1000us; 1082us; 1000us; 1084us; 1000us; 1089us; 1000us; 1091us; 1000us; 1135us; 1000us; 1137us; 1000us; 1141us; 1000us; 1142us; 1000us; 1143us; 1000us; 1144us; 1000us; 1145us; 1000us; 1146us; 1000us; 1147us; 1000us; 1148us; 1000us; 1149us; 1000us; 1150us; 1000us; 1151us; 1000us; 1153us; 1000us; 1154us; 1000us; 1155us; 1000us; 1156us; 1000us; 1157us; 1000us; 1158us; 1000us; 1159us; 1000us; 1160us; 1000us; 1161us; 1000us; 1183us; 1000us; 1205us; 1000us; 1206us; 1000us; 1210us; 1000us; 1212us; 1000us; 1216us; 1000us; 1218us; 1000us; 1222us; 1000us; 1225us; 1000us; 1227us; 1000us; 1291us; 1000us; 1298us; 1000us; 1305us; 1000us; 1312us; 1000us; 1322us; 1000us; 1324us; 1000us; 1325us; 1000us; 1337us; 1000us; 1344us; 1000us; 1345us; 1000us; 1351us; 1000us; 1357us; 1000us; 1358us; 1000us; 1359us; 1000us; 1375us; 1000us; 1385us; 1000us; 1398us; 1000us; 1399us; 1000us; 1401us; 1000us; 1403us; 1000us; 1407us; 1000us; 1408us; 1000us; 1435us; 1000us; 1440us; 1000us; 1465us; 1000us; 1507us; 1000us; 1512us; 1000us; 109us; 65535us; 6us; 999us; 31us; 999us; 106us; 999us; 108us; 999us; 226us; 999us; 240us; 999us; 262us; 999us; 403us; 999us; 408us; 999us; 443us; 999us; 459us; 999us; 695us; 999us; 701us; 999us; 750us; 999us; 754us; 999us; 764us; 999us; 945us; 999us; 950us; 999us; 964us; 999us; 966us; 999us; 969us; 999us; 972us; 999us; 989us; 999us; 992us; 999us; 995us; 999us; 1001us; 999us; 1005us; 999us; 1009us; 999us; 1013us; 999us; 1015us; 999us; 1020us; 999us; 1022us; 999us; 1024us; 999us; 1026us; 999us; 1028us; 999us; 1030us; 999us; 1041us; 999us; 1049us; 999us; 1056us; 999us; 1062us; 999us; 1064us; 999us; 1067us; 999us; 1070us; 999us; 1073us; 999us; 1076us; 999us; 1079us; 999us; 1082us; 999us; 1084us; 999us; 1089us; 999us; 1091us; 999us; 1135us; 999us; 1137us; 999us; 1141us; 999us; 1142us; 999us; 1143us; 999us; 1144us; 999us; 1145us; 999us; 1146us; 999us; 1147us; 999us; 1148us; 999us; 1149us; 999us; 1150us; 999us; 1151us; 999us; 1153us; 999us; 1154us; 999us; 1155us; 999us; 1156us; 999us; 1157us; 999us; 1158us; 999us; 1159us; 999us; 1160us; 999us; 1161us; 999us; 1183us; 999us; 1205us; 999us; 1206us; 999us; 1210us; 999us; 1212us; 999us; 1216us; 999us; 1218us; 999us; 1222us; 999us; 1225us; 999us; 1227us; 999us; 1291us; 999us; 1298us; 999us; 1305us; 999us; 1312us; 999us; 1322us; 999us; 1324us; 999us; 1325us; 999us; 1337us; 999us; 1344us; 999us; 1345us; 999us; 1351us; 999us; 1357us; 999us; 1358us; 999us; 1359us; 999us; 1375us; 999us; 1385us; 999us; 1398us; 999us; 1399us; 999us; 1401us; 999us; 1403us; 999us; 1407us; 999us; 1408us; 999us; 1435us; 999us; 1440us; 999us; 1465us; 999us; 1507us; 999us; 1512us; 999us; 3us; 65535us; 814us; 815us; 927us; 928us; 957us; 958us; 5us; 65535us; 103us; 104us; 177us; 178us; 193us; 194us; 429us; 430us; 1532us; 1533us; 3us; 65535us; 401us; 402us; 406us; 407us; 748us; 749us; 9us; 65535us; 103us; 1530us; 142us; 143us; 177us; 1530us; 193us; 1530us; 366us; 367us; 429us; 1530us; 635us; 636us; 1532us; 1530us; 1535us; 1536us; 9us; 65535us; 103us; 1534us; 142us; 1534us; 177us; 1534us; 193us; 1534us; 366us; 1534us; 429us; 1534us; 635us; 1534us; 1532us; 1534us; 1535us; 1534us; 2us; 65535us; 1538us; 1539us; 1541us; 1542us; 11us; 65535us; 103us; 1537us; 142us; 1537us; 177us; 1537us; 193us; 1537us; 366us; 1537us; 429us; 1537us; 635us; 1537us; 1532us; 1537us; 1535us; 1537us; 1538us; 1540us; 1541us; 1540us; 31us; 65535us; 8us; 1561us; 171us; 525us; 416us; 525us; 452us; 453us; 462us; 463us; 520us; 525us; 528us; 1629us; 592us; 593us; 595us; 596us; 674us; 675us; 770us; 771us; 814us; 1528us; 927us; 1528us; 957us; 1528us; 1129us; 1130us; 1131us; 1132us; 1133us; 1134us; 1421us; 1422us; 1424us; 1425us; 1426us; 1629us; 1559us; 1560us; 1587us; 1629us; 1592us; 1593us; 1595us; 1596us; 1606us; 1669us; 1610us; 1669us; 1616us; 1629us; 1627us; 1628us; 1657us; 1669us; 1659us; 1669us; 1670us; 1671us; 1us; 65535us; 8us; 9us; 31us; 65535us; 8us; 1558us; 171us; 1558us; 416us; 1558us; 452us; 1558us; 462us; 1558us; 520us; 1558us; 528us; 1558us; 592us; 1558us; 595us; 1558us; 674us; 1558us; 770us; 1558us; 814us; 1558us; 927us; 1558us; 957us; 1558us; 1129us; 1558us; 1131us; 1558us; 1133us; 1558us; 1421us; 1558us; 1424us; 1558us; 1426us; 1558us; 1559us; 1558us; 1587us; 1558us; 1592us; 1558us; 1595us; 1558us; 1606us; 1558us; 1610us; 1558us; 1616us; 1558us; 1627us; 1558us; 1657us; 1558us; 1659us; 1558us; 1670us; 1558us; 6us; 65535us; 1564us; 1565us; 1566us; 1567us; 1568us; 1569us; 1571us; 1572us; 1573us; 1574us; 1634us; 1635us; 91us; 65535us; 8us; 1579us; 103us; 1579us; 142us; 1579us; 171us; 1579us; 177us; 1579us; 181us; 1579us; 182us; 1578us; 183us; 1579us; 184us; 1578us; 193us; 1579us; 366us; 1579us; 416us; 1579us; 422us; 1579us; 423us; 1578us; 429us; 1579us; 452us; 1579us; 462us; 1579us; 484us; 1579us; 520us; 1579us; 528us; 1579us; 546us; 1579us; 592us; 1579us; 595us; 1579us; 605us; 1579us; 615us; 1579us; 616us; 1578us; 617us; 1578us; 632us; 1579us; 635us; 1579us; 654us; 1579us; 657us; 1579us; 660us; 1579us; 661us; 1578us; 662us; 1578us; 674us; 1579us; 685us; 1579us; 770us; 1579us; 814us; 1579us; 861us; 1579us; 927us; 1579us; 957us; 1579us; 1129us; 1579us; 1131us; 1579us; 1133us; 1579us; 1247us; 1579us; 1248us; 1579us; 1421us; 1579us; 1424us; 1579us; 1426us; 1579us; 1428us; 1579us; 1490us; 1579us; 1491us; 1578us; 1532us; 1579us; 1535us; 1579us; 1538us; 1579us; 1541us; 1579us; 1543us; 1579us; 1544us; 1578us; 1545us; 1579us; 1546us; 1578us; 1549us; 1579us; 1550us; 1578us; 1551us; 1578us; 1552us; 1579us; 1553us; 1578us; 1556us; 1579us; 1557us; 1578us; 1559us; 1579us; 1563us; 1578us; 1564us; 1579us; 1566us; 1579us; 1568us; 1579us; 1570us; 1578us; 1571us; 1579us; 1573us; 1579us; 1582us; 1578us; 1587us; 1579us; 1589us; 1578us; 1592us; 1579us; 1595us; 1579us; 1606us; 1579us; 1610us; 1579us; 1616us; 1579us; 1618us; 1578us; 1623us; 1579us; 1627us; 1579us; 1633us; 1579us; 1634us; 1579us; 1657us; 1579us; 1659us; 1579us; 1670us; 1579us; 91us; 65535us; 8us; 1625us; 103us; 1625us; 142us; 1625us; 171us; 1625us; 177us; 1625us; 181us; 1625us; 182us; 1586us; 183us; 1625us; 184us; 1586us; 193us; 1625us; 366us; 1625us; 416us; 1625us; 422us; 1625us; 423us; 1586us; 429us; 1625us; 452us; 1625us; 462us; 1625us; 484us; 1625us; 520us; 1625us; 528us; 1625us; 546us; 1625us; 592us; 1625us; 595us; 1625us; 605us; 1625us; 615us; 1625us; 616us; 1586us; 617us; 1586us; 632us; 1625us; 635us; 1625us; 654us; 1625us; 657us; 1625us; 660us; 1625us; 661us; 1586us; 662us; 1586us; 674us; 1625us; 685us; 1625us; 770us; 1625us; 814us; 1625us; 861us; 1625us; 927us; 1625us; 957us; 1625us; 1129us; 1625us; 1131us; 1625us; 1133us; 1625us; 1247us; 1625us; 1248us; 1625us; 1421us; 1625us; 1424us; 1625us; 1426us; 1625us; 1428us; 1625us; 1490us; 1625us; 1491us; 1586us; 1532us; 1625us; 1535us; 1625us; 1538us; 1625us; 1541us; 1625us; 1543us; 1625us; 1544us; 1586us; 1545us; 1625us; 1546us; 1586us; 1549us; 1625us; 1550us; 1586us; 1551us; 1586us; 1552us; 1625us; 1553us; 1586us; 1556us; 1625us; 1557us; 1586us; 1559us; 1625us; 1563us; 1586us; 1564us; 1625us; 1566us; 1625us; 1568us; 1625us; 1570us; 1586us; 1571us; 1625us; 1573us; 1625us; 1582us; 1586us; 1587us; 1625us; 1589us; 1590us; 1592us; 1625us; 1595us; 1625us; 1606us; 1625us; 1610us; 1625us; 1616us; 1625us; 1618us; 1619us; 1623us; 1625us; 1627us; 1625us; 1633us; 1625us; 1634us; 1625us; 1657us; 1625us; 1659us; 1625us; 1670us; 1625us; 65us; 65535us; 8us; 1563us; 103us; 1551us; 142us; 1551us; 171us; 1563us; 177us; 1551us; 181us; 182us; 183us; 184us; 193us; 1551us; 366us; 1551us; 416us; 1563us; 422us; 423us; 429us; 1551us; 452us; 1563us; 462us; 1563us; 520us; 1563us; 528us; 1563us; 592us; 1563us; 595us; 1563us; 605us; 617us; 615us; 616us; 632us; 662us; 635us; 1551us; 654us; 662us; 657us; 662us; 660us; 661us; 674us; 1563us; 685us; 662us; 770us; 1563us; 814us; 1563us; 927us; 1563us; 957us; 1563us; 1129us; 1563us; 1131us; 1563us; 1133us; 1563us; 1421us; 1563us; 1424us; 1563us; 1426us; 1563us; 1490us; 1491us; 1532us; 1551us; 1535us; 1551us; 1538us; 1551us; 1541us; 1551us; 1543us; 1544us; 1545us; 1546us; 1549us; 1550us; 1552us; 1553us; 1556us; 1557us; 1559us; 1563us; 1564us; 1570us; 1566us; 1570us; 1568us; 1570us; 1571us; 1570us; 1573us; 1570us; 1587us; 1563us; 1592us; 1563us; 1595us; 1563us; 1606us; 1563us; 1610us; 1563us; 1616us; 1563us; 1627us; 1563us; 1633us; 1582us; 1634us; 1570us; 1657us; 1563us; 1659us; 1563us; 1670us; 1563us; 18us; 65535us; 182us; 1583us; 184us; 1583us; 423us; 1583us; 616us; 1583us; 617us; 1583us; 661us; 1583us; 662us; 1583us; 1491us; 1583us; 1544us; 1583us; 1546us; 1583us; 1550us; 1583us; 1551us; 1583us; 1553us; 1583us; 1557us; 1583us; 1563us; 1583us; 1570us; 1583us; 1582us; 1583us; 1584us; 1585us; 4us; 65535us; 528us; 1588us; 1426us; 1588us; 1587us; 1588us; 1616us; 1617us; 2us; 65535us; 1607us; 1608us; 1660us; 1609us; 65us; 65535us; 8us; 1591us; 103us; 1591us; 142us; 1591us; 171us; 1591us; 177us; 1591us; 181us; 1591us; 183us; 1591us; 193us; 1591us; 366us; 1591us; 416us; 1591us; 422us; 1591us; 429us; 1591us; 452us; 1591us; 462us; 1591us; 520us; 1591us; 528us; 1591us; 592us; 1591us; 595us; 1591us; 605us; 1591us; 615us; 1591us; 632us; 1591us; 635us; 1591us; 654us; 1591us; 657us; 1591us; 660us; 1591us; 674us; 1591us; 685us; 1591us; 770us; 1591us; 814us; 1591us; 927us; 1591us; 957us; 1591us; 1129us; 1591us; 1131us; 1591us; 1133us; 1591us; 1421us; 1591us; 1424us; 1591us; 1426us; 1591us; 1490us; 1591us; 1532us; 1591us; 1535us; 1591us; 1538us; 1591us; 1541us; 1591us; 1543us; 1591us; 1545us; 1591us; 1549us; 1591us; 1552us; 1591us; 1556us; 1591us; 1559us; 1591us; 1564us; 1591us; 1566us; 1591us; 1568us; 1591us; 1571us; 1591us; 1573us; 1591us; 1587us; 1591us; 1592us; 1591us; 1595us; 1591us; 1606us; 1591us; 1610us; 1591us; 1616us; 1591us; 1627us; 1591us; 1633us; 1591us; 1634us; 1591us; 1657us; 1591us; 1659us; 1591us; 1670us; 1591us; 4us; 65535us; 484us; 485us; 1247us; 1249us; 1248us; 1250us; 1428us; 1429us; 66us; 65535us; 8us; 1613us; 103us; 1613us; 142us; 1613us; 171us; 1613us; 177us; 1613us; 181us; 1613us; 183us; 1613us; 193us; 1613us; 366us; 1613us; 416us; 1613us; 422us; 1613us; 429us; 1613us; 452us; 1613us; 462us; 1613us; 520us; 1613us; 528us; 1613us; 592us; 1613us; 595us; 1613us; 605us; 1613us; 615us; 1613us; 632us; 1613us; 635us; 1613us; 654us; 1613us; 657us; 1613us; 660us; 1613us; 674us; 1613us; 685us; 1613us; 770us; 1613us; 814us; 1613us; 861us; 862us; 927us; 1613us; 957us; 1613us; 1129us; 1613us; 1131us; 1613us; 1133us; 1613us; 1421us; 1613us; 1424us; 1613us; 1426us; 1613us; 1490us; 1613us; 1532us; 1613us; 1535us; 1613us; 1538us; 1613us; 1541us; 1613us; 1543us; 1613us; 1545us; 1613us; 1549us; 1613us; 1552us; 1613us; 1556us; 1613us; 1559us; 1613us; 1564us; 1613us; 1566us; 1613us; 1568us; 1613us; 1571us; 1613us; 1573us; 1613us; 1587us; 1613us; 1592us; 1613us; 1595us; 1613us; 1606us; 1613us; 1610us; 1613us; 1616us; 1613us; 1627us; 1613us; 1633us; 1613us; 1634us; 1613us; 1657us; 1613us; 1659us; 1613us; 1670us; 1613us; 72us; 65535us; 8us; 1621us; 103us; 1621us; 142us; 1621us; 171us; 1621us; 177us; 1621us; 181us; 1621us; 183us; 1621us; 193us; 1621us; 366us; 1621us; 416us; 1621us; 422us; 1621us; 429us; 1621us; 452us; 1621us; 462us; 1621us; 484us; 1620us; 520us; 1621us; 528us; 1621us; 546us; 1624us; 592us; 1621us; 595us; 1621us; 605us; 1621us; 615us; 1621us; 632us; 1621us; 635us; 1621us; 654us; 1621us; 657us; 1621us; 660us; 1621us; 674us; 1621us; 685us; 1621us; 770us; 1621us; 814us; 1621us; 861us; 1621us; 927us; 1621us; 957us; 1621us; 1129us; 1621us; 1131us; 1621us; 1133us; 1621us; 1247us; 1620us; 1248us; 1620us; 1421us; 1621us; 1424us; 1621us; 1426us; 1621us; 1428us; 1620us; 1490us; 1621us; 1532us; 1621us; 1535us; 1621us; 1538us; 1621us; 1541us; 1621us; 1543us; 1621us; 1545us; 1621us; 1549us; 1621us; 1552us; 1621us; 1556us; 1621us; 1559us; 1621us; 1564us; 1621us; 1566us; 1621us; 1568us; 1621us; 1571us; 1621us; 1573us; 1621us; 1587us; 1621us; 1592us; 1621us; 1595us; 1621us; 1606us; 1621us; 1610us; 1621us; 1616us; 1621us; 1623us; 1624us; 1627us; 1621us; 1633us; 1621us; 1634us; 1621us; 1657us; 1621us; 1659us; 1621us; 1670us; 1621us; 4us; 65535us; 599us; 614us; 612us; 613us; 1579us; 1648us; 1650us; 1651us; 6us; 65535us; 599us; 1654us; 612us; 1654us; 1275us; 1276us; 1579us; 1654us; 1650us; 1654us; 1655us; 1656us; 8us; 65535us; 528us; 1605us; 1426us; 1605us; 1587us; 1605us; 1606us; 1607us; 1610us; 1611us; 1616us; 1605us; 1657us; 1664us; 1659us; 1672us; 2us; 65535us; 1657us; 1658us; 1659us; 1660us; 3us; 65535us; 1610us; 1612us; 1657us; 1673us; 1659us; 1673us; 1us; 65535us; 806us; 807us; 6us; 65535us; 1674us; 1684us; 1681us; 1684us; 1688us; 1684us; 1694us; 1684us; 1695us; 1684us; 1696us; 1684us; 6us; 65535us; 1674us; 1688us; 1681us; 1688us; 1688us; 1688us; 1694us; 1688us; 1695us; 1688us; 1696us; 1688us; 6us; 65535us; 1674us; 1690us; 1681us; 1690us; 1688us; 1689us; 1694us; 1690us; 1695us; 1690us; 1696us; 1690us; 5us; 65535us; 1674us; 1675us; 1681us; 1682us; 1694us; 1691us; 1695us; 1692us; 1696us; 1693us; 106us; 65535us; 8us; 1577us; 103us; 1577us; 142us; 1577us; 171us; 1577us; 177us; 1577us; 181us; 1577us; 182us; 1576us; 183us; 1577us; 184us; 1576us; 193us; 1577us; 366us; 1577us; 416us; 1577us; 422us; 1577us; 423us; 1576us; 429us; 1577us; 452us; 1577us; 462us; 1577us; 484us; 1576us; 520us; 1577us; 528us; 1577us; 546us; 1576us; 554us; 559us; 569us; 570us; 583us; 594us; 587us; 594us; 590us; 591us; 592us; 1577us; 595us; 1577us; 605us; 1577us; 615us; 1577us; 616us; 1576us; 617us; 1576us; 632us; 1577us; 635us; 1577us; 654us; 1577us; 657us; 1577us; 660us; 1577us; 661us; 1576us; 662us; 1576us; 674us; 1577us; 685us; 1577us; 762us; 769us; 766us; 769us; 770us; 1577us; 814us; 1577us; 861us; 1576us; 927us; 1577us; 957us; 1577us; 1129us; 1577us; 1131us; 1577us; 1133us; 1577us; 1247us; 1576us; 1248us; 1576us; 1421us; 1577us; 1424us; 1577us; 1426us; 1577us; 1428us; 1576us; 1490us; 1577us; 1491us; 1576us; 1529us; 594us; 1531us; 594us; 1532us; 1577us; 1535us; 1577us; 1538us; 1577us; 1541us; 1577us; 1543us; 1577us; 1544us; 1576us; 1545us; 1577us; 1546us; 1576us; 1549us; 1577us; 1550us; 1576us; 1551us; 1576us; 1552us; 1577us; 1553us; 1576us; 1556us; 1577us; 1557us; 1576us; 1559us; 1577us; 1563us; 1576us; 1564us; 1577us; 1566us; 1577us; 1568us; 1577us; 1570us; 1576us; 1571us; 1577us; 1573us; 1577us; 1582us; 1576us; 1587us; 1577us; 1589us; 1576us; 1592us; 1577us; 1595us; 1577us; 1606us; 1577us; 1610us; 1577us; 1616us; 1577us; 1618us; 1576us; 1623us; 1576us; 1627us; 1577us; 1633us; 1577us; 1634us; 1577us; 1657us; 1577us; 1659us; 1577us; 1670us; 1577us; 1674us; 1680us; 1681us; 1680us; 1688us; 1680us; 1694us; 1680us; 1695us; 1680us; 1696us; 1680us; 110us; 65535us; 8us; 1699us; 103us; 1699us; 142us; 1699us; 171us; 1699us; 177us; 1699us; 181us; 1699us; 182us; 1699us; 183us; 1699us; 184us; 1699us; 193us; 1699us; 366us; 1699us; 416us; 1699us; 422us; 1699us; 423us; 1699us; 429us; 1699us; 452us; 1699us; 462us; 1699us; 484us; 1699us; 520us; 1699us; 528us; 1699us; 546us; 1699us; 554us; 1699us; 569us; 1699us; 583us; 1699us; 587us; 1699us; 590us; 1699us; 592us; 1699us; 595us; 1699us; 605us; 1699us; 615us; 1699us; 616us; 1699us; 617us; 1699us; 632us; 1699us; 635us; 1699us; 654us; 1699us; 657us; 1699us; 660us; 1699us; 661us; 1699us; 662us; 1699us; 674us; 1699us; 685us; 1699us; 762us; 1699us; 766us; 1699us; 770us; 1699us; 814us; 1699us; 861us; 1699us; 927us; 1699us; 957us; 1699us; 1129us; 1699us; 1131us; 1699us; 1133us; 1699us; 1247us; 1699us; 1248us; 1699us; 1357us; 1379us; 1358us; 1380us; 1359us; 1379us; 1383us; 1384us; 1421us; 1699us; 1424us; 1699us; 1426us; 1699us; 1428us; 1699us; 1490us; 1699us; 1491us; 1699us; 1529us; 1699us; 1531us; 1699us; 1532us; 1699us; 1535us; 1699us; 1538us; 1699us; 1541us; 1699us; 1543us; 1699us; 1544us; 1699us; 1545us; 1699us; 1546us; 1699us; 1549us; 1699us; 1550us; 1699us; 1551us; 1699us; 1552us; 1699us; 1553us; 1699us; 1556us; 1699us; 1557us; 1699us; 1559us; 1699us; 1563us; 1699us; 1564us; 1699us; 1566us; 1699us; 1568us; 1699us; 1570us; 1699us; 1571us; 1699us; 1573us; 1699us; 1582us; 1699us; 1587us; 1699us; 1589us; 1699us; 1592us; 1699us; 1595us; 1699us; 1606us; 1699us; 1610us; 1699us; 1616us; 1699us; 1618us; 1699us; 1623us; 1699us; 1627us; 1699us; 1633us; 1699us; 1634us; 1699us; 1657us; 1699us; 1659us; 1699us; 1670us; 1699us; 1674us; 1699us; 1681us; 1699us; 1688us; 1699us; 1694us; 1699us; 1695us; 1699us; 1696us; 1699us; 333us; 65535us; 6us; 1752us; 8us; 1705us; 31us; 1752us; 51us; 1705us; 54us; 1705us; 89us; 1705us; 94us; 1705us; 100us; 1752us; 103us; 1705us; 106us; 1752us; 108us; 1752us; 111us; 1705us; 142us; 1705us; 171us; 648us; 174us; 1752us; 177us; 1705us; 181us; 1705us; 182us; 1705us; 183us; 1705us; 184us; 1705us; 193us; 1705us; 195us; 1752us; 197us; 1752us; 202us; 1752us; 226us; 1752us; 240us; 1752us; 262us; 1752us; 269us; 1705us; 298us; 327us; 309us; 327us; 314us; 1705us; 318us; 1705us; 366us; 1705us; 400us; 1754us; 403us; 1752us; 405us; 1754us; 408us; 1752us; 416us; 648us; 422us; 1705us; 423us; 1705us; 426us; 1752us; 429us; 1705us; 440us; 1754us; 443us; 1752us; 450us; 451us; 452us; 1705us; 456us; 457us; 459us; 1752us; 462us; 1705us; 465us; 1754us; 468us; 1754us; 471us; 1754us; 484us; 1705us; 492us; 493us; 495us; 496us; 520us; 648us; 528us; 1705us; 546us; 1705us; 554us; 1705us; 556us; 1705us; 592us; 1705us; 595us; 1705us; 605us; 1705us; 615us; 1705us; 616us; 1705us; 617us; 1705us; 629us; 1752us; 632us; 659us; 635us; 1705us; 654us; 659us; 657us; 659us; 660us; 1705us; 661us; 1705us; 662us; 1705us; 672us; 673us; 674us; 1705us; 681us; 684us; 685us; 659us; 687us; 1705us; 689us; 1705us; 695us; 1752us; 701us; 1752us; 712us; 713us; 724us; 1705us; 725us; 726us; 737us; 1705us; 747us; 1754us; 750us; 1752us; 754us; 1752us; 764us; 1752us; 770us; 1705us; 810us; 811us; 814us; 1705us; 816us; 809us; 817us; 809us; 819us; 809us; 835us; 836us; 837us; 1754us; 838us; 1754us; 842us; 1754us; 843us; 1754us; 844us; 1754us; 845us; 1754us; 848us; 850us; 852us; 1754us; 855us; 1754us; 857us; 1754us; 859us; 1754us; 861us; 1705us; 864us; 851us; 868us; 1754us; 870us; 1754us; 872us; 1754us; 877us; 1705us; 880us; 1754us; 883us; 1754us; 886us; 888us; 887us; 888us; 894us; 1754us; 902us; 1754us; 922us; 923us; 924us; 1754us; 927us; 1705us; 929us; 1754us; 930us; 1754us; 932us; 1754us; 933us; 1754us; 934us; 1754us; 935us; 1754us; 938us; 1705us; 941us; 1754us; 943us; 1754us; 945us; 1752us; 950us; 1752us; 957us; 1705us; 964us; 1752us; 966us; 1752us; 969us; 1752us; 972us; 1752us; 989us; 1752us; 992us; 1752us; 995us; 1752us; 1001us; 1752us; 1005us; 1752us; 1009us; 1752us; 1013us; 1752us; 1015us; 1752us; 1020us; 1752us; 1022us; 1752us; 1024us; 1752us; 1026us; 1752us; 1028us; 1752us; 1030us; 1752us; 1039us; 1754us; 1041us; 1752us; 1049us; 1752us; 1056us; 1752us; 1062us; 1752us; 1064us; 1752us; 1066us; 1754us; 1067us; 1752us; 1070us; 1752us; 1072us; 1754us; 1073us; 1752us; 1076us; 1752us; 1079us; 1752us; 1082us; 1752us; 1084us; 1752us; 1089us; 1752us; 1091us; 1752us; 1129us; 1705us; 1131us; 1705us; 1133us; 1705us; 1135us; 1752us; 1137us; 1752us; 1141us; 1752us; 1142us; 1752us; 1143us; 1752us; 1144us; 1752us; 1145us; 1752us; 1146us; 1752us; 1147us; 1752us; 1148us; 1752us; 1149us; 1752us; 1150us; 1752us; 1151us; 1752us; 1153us; 1752us; 1154us; 1752us; 1155us; 1752us; 1156us; 1752us; 1157us; 1752us; 1158us; 1752us; 1159us; 1752us; 1160us; 1752us; 1161us; 1752us; 1183us; 1752us; 1186us; 1754us; 1188us; 1754us; 1193us; 1754us; 1200us; 1754us; 1205us; 1752us; 1206us; 1752us; 1210us; 1752us; 1212us; 1752us; 1216us; 1752us; 1218us; 1752us; 1222us; 1752us; 1225us; 1752us; 1227us; 1752us; 1229us; 1752us; 1230us; 1752us; 1232us; 1752us; 1233us; 1752us; 1235us; 1752us; 1236us; 1752us; 1238us; 1752us; 1239us; 1752us; 1241us; 1752us; 1242us; 1752us; 1244us; 1752us; 1245us; 1752us; 1247us; 1705us; 1248us; 1705us; 1257us; 1752us; 1259us; 1752us; 1261us; 1752us; 1262us; 1752us; 1263us; 1752us; 1266us; 1752us; 1273us; 1752us; 1274us; 1752us; 1277us; 1752us; 1278us; 1752us; 1279us; 1752us; 1282us; 1752us; 1284us; 1752us; 1285us; 1752us; 1291us; 1752us; 1298us; 1752us; 1305us; 1752us; 1312us; 1752us; 1322us; 1752us; 1324us; 1752us; 1325us; 1752us; 1337us; 1752us; 1344us; 1752us; 1345us; 1752us; 1351us; 1752us; 1357us; 1752us; 1358us; 1752us; 1359us; 1752us; 1375us; 1752us; 1385us; 1752us; 1398us; 1752us; 1399us; 1752us; 1401us; 1752us; 1403us; 1752us; 1407us; 1752us; 1408us; 1752us; 1415us; 1752us; 1421us; 1705us; 1424us; 1705us; 1426us; 1705us; 1428us; 1705us; 1435us; 1752us; 1440us; 1752us; 1444us; 1705us; 1448us; 1705us; 1456us; 1705us; 1465us; 1752us; 1490us; 1705us; 1491us; 1705us; 1498us; 1752us; 1505us; 1754us; 1507us; 1752us; 1510us; 1754us; 1512us; 1752us; 1523us; 1754us; 1525us; 1754us; 1532us; 1705us; 1535us; 1705us; 1538us; 1705us; 1541us; 1705us; 1543us; 1705us; 1544us; 1705us; 1545us; 1705us; 1546us; 1705us; 1547us; 1548us; 1549us; 1705us; 1550us; 1705us; 1551us; 1705us; 1552us; 1705us; 1553us; 1705us; 1554us; 1555us; 1556us; 1705us; 1557us; 1705us; 1559us; 1705us; 1563us; 1705us; 1564us; 1705us; 1566us; 1705us; 1568us; 1705us; 1570us; 1705us; 1571us; 1705us; 1573us; 1705us; 1582us; 1705us; 1587us; 1705us; 1589us; 1705us; 1592us; 1705us; 1595us; 1705us; 1606us; 1705us; 1610us; 1705us; 1616us; 1705us; 1618us; 1705us; 1623us; 1705us; 1627us; 1705us; 1633us; 1705us; 1634us; 1705us; 1643us; 1752us; 1649us; 1705us; 1657us; 1705us; 1659us; 1705us; 1670us; 1705us; 1674us; 1705us; 1681us; 1705us; 1688us; 1705us; 1694us; 1705us; 1695us; 1705us; 1696us; 1705us; 1697us; 1698us; 1700us; 1702us; 1701us; 1702us; 1706us; 1707us; 1756us; 1754us; 119us; 65535us; 8us; 1575us; 51us; 52us; 54us; 55us; 89us; 276us; 94us; 95us; 103us; 1575us; 111us; 274us; 142us; 1575us; 171us; 521us; 177us; 1575us; 181us; 1575us; 182us; 1575us; 183us; 1575us; 184us; 1575us; 193us; 1575us; 269us; 286us; 298us; 311us; 309us; 311us; 314us; 315us; 318us; 319us; 366us; 1575us; 416us; 521us; 422us; 1575us; 423us; 1575us; 429us; 1575us; 452us; 1575us; 462us; 1575us; 484us; 1575us; 520us; 521us; 528us; 1575us; 546us; 1575us; 554us; 555us; 556us; 557us; 592us; 1575us; 595us; 1575us; 605us; 1575us; 615us; 1575us; 616us; 1575us; 617us; 1575us; 632us; 1575us; 635us; 1575us; 654us; 1575us; 657us; 1575us; 660us; 1575us; 661us; 1575us; 662us; 1575us; 674us; 1575us; 685us; 1575us; 687us; 688us; 689us; 690us; 724us; 727us; 737us; 727us; 770us; 1575us; 814us; 1575us; 861us; 1575us; 877us; 940us; 927us; 1575us; 938us; 940us; 957us; 1575us; 1129us; 1575us; 1131us; 1575us; 1133us; 1575us; 1247us; 1575us; 1248us; 1575us; 1421us; 1575us; 1424us; 1575us; 1426us; 1575us; 1428us; 1575us; 1444us; 1461us; 1448us; 1461us; 1456us; 1461us; 1490us; 1575us; 1491us; 1575us; 1532us; 1575us; 1535us; 1575us; 1538us; 1575us; 1541us; 1575us; 1543us; 1575us; 1544us; 1575us; 1545us; 1575us; 1546us; 1575us; 1549us; 1575us; 1550us; 1575us; 1551us; 1575us; 1552us; 1575us; 1553us; 1575us; 1556us; 1575us; 1557us; 1575us; 1559us; 1575us; 1563us; 1575us; 1564us; 1575us; 1566us; 1575us; 1568us; 1575us; 1570us; 1575us; 1571us; 1575us; 1573us; 1575us; 1582us; 1575us; 1587us; 1575us; 1589us; 1575us; 1592us; 1575us; 1595us; 1575us; 1606us; 1575us; 1610us; 1575us; 1616us; 1575us; 1618us; 1575us; 1623us; 1575us; 1627us; 1575us; 1633us; 1575us; 1634us; 1575us; 1649us; 1650us; 1657us; 1575us; 1659us; 1575us; 1670us; 1575us; 1674us; 1679us; 1681us; 1679us; 1688us; 1679us; 1694us; 1679us; 1695us; 1679us; 1696us; 1679us; 191us; 65535us; 6us; 1753us; 31us; 1753us; 100us; 1753us; 106us; 1753us; 108us; 1753us; 174us; 1753us; 195us; 1753us; 197us; 1753us; 202us; 1753us; 226us; 1753us; 240us; 1753us; 262us; 1753us; 400us; 1755us; 403us; 1753us; 405us; 1755us; 408us; 1753us; 426us; 1753us; 440us; 1755us; 443us; 1753us; 459us; 1753us; 465us; 1755us; 468us; 1755us; 471us; 1755us; 629us; 1753us; 695us; 1753us; 701us; 1753us; 747us; 1755us; 750us; 1753us; 754us; 1753us; 764us; 1753us; 837us; 1755us; 838us; 1755us; 842us; 1755us; 843us; 1755us; 844us; 1755us; 845us; 1755us; 852us; 1755us; 855us; 1755us; 857us; 1755us; 859us; 1755us; 864us; 1755us; 868us; 1755us; 870us; 1755us; 872us; 1755us; 880us; 1755us; 883us; 1755us; 894us; 1755us; 902us; 1755us; 924us; 1755us; 929us; 1755us; 930us; 1755us; 932us; 1755us; 933us; 1755us; 934us; 1755us; 935us; 1755us; 941us; 1755us; 943us; 1755us; 945us; 1753us; 950us; 1753us; 964us; 1753us; 966us; 1753us; 969us; 1753us; 972us; 1753us; 989us; 1753us; 992us; 1753us; 995us; 1753us; 1001us; 1753us; 1005us; 1753us; 1009us; 1753us; 1013us; 1753us; 1015us; 1753us; 1020us; 1753us; 1022us; 1753us; 1024us; 1753us; 1026us; 1753us; 1028us; 1753us; 1030us; 1753us; 1039us; 1755us; 1041us; 1753us; 1049us; 1753us; 1056us; 1753us; 1062us; 1753us; 1064us; 1753us; 1066us; 1755us; 1067us; 1753us; 1070us; 1753us; 1072us; 1755us; 1073us; 1753us; 1076us; 1753us; 1079us; 1753us; 1082us; 1753us; 1084us; 1753us; 1089us; 1753us; 1091us; 1753us; 1135us; 1753us; 1137us; 1753us; 1141us; 1753us; 1142us; 1753us; 1143us; 1753us; 1144us; 1753us; 1145us; 1753us; 1146us; 1753us; 1147us; 1753us; 1148us; 1753us; 1149us; 1753us; 1150us; 1753us; 1151us; 1753us; 1153us; 1753us; 1154us; 1753us; 1155us; 1753us; 1156us; 1753us; 1157us; 1753us; 1158us; 1753us; 1159us; 1753us; 1160us; 1753us; 1161us; 1753us; 1183us; 1753us; 1186us; 1755us; 1188us; 1755us; 1193us; 1755us; 1200us; 1755us; 1205us; 1753us; 1206us; 1753us; 1210us; 1753us; 1212us; 1753us; 1216us; 1753us; 1218us; 1753us; 1222us; 1753us; 1225us; 1753us; 1227us; 1753us; 1229us; 1753us; 1230us; 1753us; 1232us; 1753us; 1233us; 1753us; 1235us; 1753us; 1236us; 1753us; 1238us; 1753us; 1239us; 1753us; 1241us; 1753us; 1242us; 1753us; 1244us; 1753us; 1245us; 1753us; 1257us; 1753us; 1259us; 1753us; 1261us; 1753us; 1262us; 1753us; 1263us; 1753us; 1266us; 1753us; 1273us; 1753us; 1274us; 1753us; 1277us; 1753us; 1278us; 1753us; 1279us; 1753us; 1282us; 1753us; 1284us; 1753us; 1285us; 1753us; 1291us; 1753us; 1298us; 1753us; 1305us; 1753us; 1312us; 1753us; 1322us; 1753us; 1324us; 1753us; 1325us; 1753us; 1337us; 1753us; 1344us; 1753us; 1345us; 1753us; 1351us; 1753us; 1357us; 1753us; 1358us; 1753us; 1359us; 1753us; 1375us; 1753us; 1385us; 1753us; 1398us; 1753us; 1399us; 1753us; 1401us; 1753us; 1403us; 1753us; 1407us; 1753us; 1408us; 1753us; 1415us; 1753us; 1435us; 1753us; 1440us; 1753us; 1465us; 1753us; 1498us; 1753us; 1505us; 1755us; 1507us; 1753us; 1510us; 1755us; 1512us; 1753us; 1523us; 1755us; 1525us; 1755us; 1643us; 1753us; 1756us; 1755us; 7us; 65535us; 642us; 1710us; 864us; 1710us; 894us; 1710us; 1305us; 1710us; 1358us; 1710us; 1359us; 1710us; 1709us; 1710us; 2us; 65535us; 1716us; 1751us; 1749us; 1750us; 7us; 65535us; 642us; 1715us; 864us; 1715us; 894us; 1715us; 1305us; 1715us; 1358us; 1715us; 1359us; 1715us; 1709us; 1715us; 145us; 65535us; 6us; 1759us; 31us; 1759us; 100us; 1759us; 106us; 1759us; 108us; 1759us; 174us; 1759us; 195us; 1759us; 197us; 1759us; 202us; 1759us; 226us; 1759us; 240us; 1759us; 262us; 1759us; 403us; 1759us; 408us; 1759us; 426us; 1759us; 443us; 1759us; 459us; 1759us; 629us; 1759us; 695us; 1759us; 701us; 1759us; 750us; 1759us; 754us; 1759us; 764us; 1759us; 945us; 1759us; 950us; 1759us; 964us; 1759us; 966us; 1759us; 969us; 1759us; 972us; 1759us; 989us; 1759us; 992us; 1759us; 995us; 1759us; 1001us; 1759us; 1005us; 1759us; 1009us; 1759us; 1013us; 1759us; 1015us; 1759us; 1020us; 1759us; 1022us; 1759us; 1024us; 1759us; 1026us; 1759us; 1028us; 1759us; 1030us; 1759us; 1041us; 1759us; 1049us; 1759us; 1056us; 1759us; 1062us; 1759us; 1064us; 1759us; 1067us; 1759us; 1070us; 1759us; 1073us; 1759us; 1076us; 1759us; 1079us; 1759us; 1082us; 1759us; 1084us; 1759us; 1089us; 1759us; 1091us; 1759us; 1135us; 1759us; 1137us; 1759us; 1141us; 1759us; 1142us; 1759us; 1143us; 1759us; 1144us; 1759us; 1145us; 1759us; 1146us; 1759us; 1147us; 1759us; 1148us; 1759us; 1149us; 1759us; 1150us; 1759us; 1151us; 1759us; 1153us; 1759us; 1154us; 1759us; 1155us; 1759us; 1156us; 1759us; 1157us; 1759us; 1158us; 1759us; 1159us; 1759us; 1160us; 1759us; 1161us; 1759us; 1183us; 1759us; 1205us; 1759us; 1206us; 1759us; 1210us; 1759us; 1212us; 1759us; 1216us; 1759us; 1218us; 1759us; 1222us; 1759us; 1225us; 1759us; 1227us; 1759us; 1229us; 1759us; 1230us; 1759us; 1232us; 1759us; 1233us; 1759us; 1235us; 1759us; 1236us; 1759us; 1238us; 1759us; 1239us; 1759us; 1241us; 1759us; 1242us; 1759us; 1244us; 1759us; 1245us; 1759us; 1257us; 1759us; 1259us; 1759us; 1261us; 1759us; 1262us; 1759us; 1263us; 1759us; 1266us; 1759us; 1273us; 1759us; 1274us; 1759us; 1277us; 1759us; 1278us; 1759us; 1279us; 1302us; 1282us; 1302us; 1284us; 1759us; 1285us; 1759us; 1291us; 1759us; 1298us; 1759us; 1305us; 1759us; 1312us; 1759us; 1322us; 1759us; 1324us; 1759us; 1325us; 1759us; 1337us; 1759us; 1344us; 1759us; 1345us; 1759us; 1351us; 1759us; 1357us; 1759us; 1358us; 1759us; 1359us; 1759us; 1375us; 1759us; 1385us; 1759us; 1398us; 1759us; 1399us; 1759us; 1401us; 1759us; 1403us; 1759us; 1407us; 1759us; 1408us; 1759us; 1415us; 1759us; 1435us; 1759us; 1440us; 1759us; 1465us; 1759us; 1498us; 1759us; 1507us; 1759us; 1512us; 1759us; 1643us; 1759us; 46us; 65535us; 400us; 470us; 405us; 470us; 440us; 470us; 465us; 466us; 468us; 469us; 471us; 472us; 747us; 470us; 837us; 470us; 838us; 470us; 842us; 470us; 843us; 470us; 844us; 470us; 845us; 470us; 852us; 470us; 855us; 470us; 857us; 470us; 859us; 470us; 864us; 470us; 868us; 470us; 870us; 470us; 872us; 470us; 880us; 470us; 883us; 470us; 894us; 470us; 902us; 470us; 924us; 470us; 929us; 470us; 930us; 470us; 932us; 470us; 933us; 470us; 934us; 470us; 935us; 470us; 941us; 470us; 943us; 470us; 1039us; 470us; 1066us; 470us; 1072us; 470us; 1186us; 470us; 1188us; 470us; 1193us; 470us; 1200us; 470us; 1505us; 470us; 1510us; 470us; 1523us; 470us; 1525us; 470us; 1756us; 1757us; 143us; 65535us; 6us; 1290us; 31us; 1290us; 100us; 101us; 106us; 1290us; 108us; 1290us; 174us; 175us; 195us; 201us; 197us; 201us; 202us; 203us; 226us; 1290us; 240us; 1290us; 262us; 1290us; 403us; 1290us; 408us; 1290us; 426us; 427us; 443us; 1290us; 459us; 1290us; 629us; 641us; 695us; 1290us; 701us; 1290us; 750us; 1290us; 754us; 1290us; 764us; 1290us; 945us; 1290us; 950us; 1290us; 964us; 1290us; 966us; 1290us; 969us; 1290us; 972us; 1290us; 989us; 1290us; 992us; 1290us; 995us; 1290us; 1001us; 1290us; 1005us; 1290us; 1009us; 1290us; 1013us; 1290us; 1015us; 1290us; 1020us; 1290us; 1022us; 1290us; 1024us; 1290us; 1026us; 1290us; 1028us; 1290us; 1030us; 1290us; 1041us; 1290us; 1049us; 1290us; 1056us; 1290us; 1062us; 1290us; 1064us; 1290us; 1067us; 1290us; 1070us; 1290us; 1073us; 1290us; 1076us; 1290us; 1079us; 1290us; 1082us; 1290us; 1084us; 1290us; 1089us; 1290us; 1091us; 1290us; 1135us; 1290us; 1137us; 1290us; 1141us; 1290us; 1142us; 1290us; 1143us; 1290us; 1144us; 1290us; 1145us; 1290us; 1146us; 1290us; 1147us; 1290us; 1148us; 1290us; 1149us; 1290us; 1150us; 1290us; 1151us; 1290us; 1153us; 1290us; 1154us; 1290us; 1155us; 1290us; 1156us; 1290us; 1157us; 1290us; 1158us; 1290us; 1159us; 1290us; 1160us; 1290us; 1161us; 1290us; 1183us; 1290us; 1205us; 1290us; 1206us; 1290us; 1210us; 1290us; 1212us; 1290us; 1216us; 1290us; 1218us; 1290us; 1222us; 1290us; 1225us; 1290us; 1227us; 1290us; 1229us; 1290us; 1230us; 1290us; 1232us; 1290us; 1233us; 1290us; 1235us; 1290us; 1236us; 1290us; 1238us; 1290us; 1239us; 1290us; 1241us; 1290us; 1242us; 1290us; 1244us; 1290us; 1245us; 1290us; 1257us; 1290us; 1259us; 1290us; 1261us; 1290us; 1262us; 1290us; 1263us; 1290us; 1266us; 1290us; 1273us; 1290us; 1274us; 1290us; 1277us; 1290us; 1278us; 1290us; 1284us; 1286us; 1285us; 1286us; 1291us; 1290us; 1298us; 1290us; 1305us; 1290us; 1312us; 1290us; 1322us; 1290us; 1324us; 1290us; 1325us; 1290us; 1337us; 1290us; 1344us; 1290us; 1345us; 1290us; 1351us; 1290us; 1357us; 1290us; 1358us; 1290us; 1359us; 1290us; 1375us; 1290us; 1385us; 1290us; 1398us; 1290us; 1399us; 1290us; 1401us; 1290us; 1403us; 1290us; 1407us; 1290us; 1408us; 1290us; 1415us; 1290us; 1435us; 1290us; 1440us; 1290us; 1465us; 1290us; 1498us; 1290us; 1507us; 1290us; 1512us; 1290us; 1643us; 1290us; 14us; 65535us; 47us; 1763us; 74us; 1763us; 77us; 1763us; 78us; 1765us; 81us; 1763us; 216us; 1763us; 235us; 1763us; 241us; 1763us; 246us; 1763us; 250us; 1763us; 251us; 1763us; 252us; 1763us; 1763us; 1763us; 1765us; 1765us; 12us; 65535us; 47us; 82us; 74us; 82us; 77us; 82us; 81us; 82us; 216us; 253us; 235us; 253us; 241us; 242us; 246us; 248us; 250us; 253us; 251us; 253us; 252us; 253us; 1763us; 1764us; 2us; 65535us; 78us; 79us; 1765us; 1766us; 11us; 65535us; 165us; 1780us; 299us; 309us; 387us; 1780us; 503us; 1780us; 665us; 666us; 846us; 848us; 919us; 943us; 936us; 938us; 961us; 964us; 962us; 964us; 963us; 964us; 4us; 65535us; 210us; 211us; 293us; 294us; 479us; 480us; 482us; 483us; 2us; 65535us; 1482us; 1483us; 1492us; 1493us; 9us; 65535us; 420us; 421us; 431us; 432us; 434us; 435us; 436us; 437us; 438us; 439us; 444us; 445us; 509us; 510us; 511us; 512us; 515us; 516us; 2us; 65535us; 60us; 61us; 222us; 223us; 20us; 65535us; 71us; 72us; 131us; 132us; 232us; 233us; 301us; 302us; 304us; 305us; 354us; 355us; 623us; 653us; 630us; 631us; 633us; 634us; 636us; 637us; 639us; 640us; 648us; 649us; 651us; 652us; 1040us; 1087us; 1069us; 1070us; 1075us; 1076us; 1081us; 1082us; 1469us; 1473us; 1470us; 1471us; 1493us; 1494us; 8us; 65535us; 165us; 166us; 299us; 300us; 387us; 388us; 503us; 504us; 665us; 668us; 846us; 847us; 919us; 942us; 936us; 937us; 4us; 65535us; 50us; 51us; 53us; 54us; 691us; 692us; 697us; 698us; 0us; 65535us; 11us; 65535us; 97us; 98us; 172us; 173us; 390us; 399us; 392us; 399us; 397us; 399us; 419us; 405us; 425us; 426us; 507us; 746us; 508us; 405us; 514us; 405us; 743us; 746us; 7us; 65535us; 98us; 99us; 185us; 671us; 188us; 671us; 448us; 449us; 454us; 455us; 669us; 671us; 746us; 747us; 4us; 65535us; 977us; 1056us; 1029us; 1030us; 1040us; 1041us; 1048us; 1049us; 9us; 65535us; 974us; 1038us; 975us; 1045us; 976us; 1053us; 978us; 1060us; 1031us; 1032us; 1034us; 1035us; 1042us; 1043us; 1050us; 1051us; 1057us; 1058us; 2us; 65535us; 269us; 287us; 277us; 287us; 2us; 65535us; 89us; 118us; 111us; 114us; 2us; 65535us; 65us; 89us; 88us; 89us; 259us; 65535us; 6us; 789us; 8us; 789us; 31us; 789us; 40us; 42us; 103us; 789us; 106us; 789us; 108us; 789us; 142us; 789us; 171us; 789us; 177us; 789us; 181us; 789us; 183us; 789us; 193us; 789us; 226us; 789us; 240us; 789us; 262us; 789us; 312us; 789us; 316us; 789us; 321us; 789us; 366us; 789us; 400us; 789us; 403us; 789us; 405us; 789us; 408us; 789us; 416us; 789us; 422us; 789us; 429us; 789us; 440us; 789us; 443us; 789us; 452us; 789us; 459us; 789us; 462us; 789us; 484us; 789us; 487us; 789us; 520us; 789us; 528us; 789us; 546us; 547us; 592us; 789us; 595us; 789us; 605us; 789us; 615us; 789us; 632us; 789us; 635us; 789us; 638us; 789us; 650us; 789us; 654us; 789us; 657us; 789us; 660us; 789us; 674us; 789us; 685us; 789us; 695us; 789us; 701us; 789us; 747us; 789us; 750us; 789us; 754us; 789us; 764us; 789us; 770us; 789us; 814us; 789us; 837us; 789us; 838us; 789us; 842us; 789us; 843us; 789us; 844us; 789us; 845us; 789us; 852us; 789us; 855us; 789us; 857us; 789us; 859us; 789us; 861us; 789us; 864us; 789us; 868us; 789us; 870us; 789us; 872us; 789us; 880us; 789us; 883us; 789us; 894us; 789us; 902us; 789us; 924us; 789us; 927us; 789us; 929us; 789us; 930us; 789us; 932us; 789us; 933us; 789us; 934us; 789us; 935us; 789us; 941us; 789us; 943us; 789us; 945us; 789us; 950us; 789us; 957us; 789us; 964us; 789us; 966us; 789us; 969us; 789us; 972us; 789us; 989us; 789us; 992us; 789us; 995us; 789us; 1001us; 789us; 1005us; 789us; 1009us; 789us; 1013us; 789us; 1015us; 789us; 1020us; 789us; 1022us; 789us; 1024us; 789us; 1026us; 789us; 1028us; 789us; 1030us; 789us; 1039us; 789us; 1041us; 789us; 1049us; 789us; 1056us; 789us; 1062us; 789us; 1064us; 789us; 1066us; 789us; 1067us; 789us; 1070us; 789us; 1072us; 789us; 1073us; 789us; 1076us; 789us; 1079us; 789us; 1082us; 789us; 1084us; 789us; 1089us; 789us; 1091us; 789us; 1129us; 789us; 1131us; 789us; 1133us; 789us; 1135us; 789us; 1137us; 789us; 1141us; 789us; 1142us; 789us; 1143us; 789us; 1144us; 789us; 1145us; 789us; 1146us; 789us; 1147us; 789us; 1148us; 789us; 1149us; 789us; 1150us; 789us; 1151us; 789us; 1153us; 789us; 1154us; 789us; 1155us; 789us; 1156us; 789us; 1157us; 789us; 1158us; 789us; 1159us; 789us; 1160us; 789us; 1161us; 789us; 1183us; 789us; 1186us; 789us; 1188us; 789us; 1193us; 789us; 1200us; 789us; 1205us; 789us; 1206us; 789us; 1210us; 789us; 1212us; 789us; 1216us; 789us; 1218us; 789us; 1222us; 789us; 1225us; 789us; 1227us; 789us; 1229us; 789us; 1230us; 789us; 1232us; 789us; 1233us; 789us; 1235us; 789us; 1236us; 789us; 1238us; 789us; 1239us; 789us; 1241us; 789us; 1242us; 789us; 1244us; 789us; 1245us; 789us; 1247us; 789us; 1248us; 789us; 1251us; 789us; 1252us; 789us; 1257us; 789us; 1259us; 789us; 1261us; 789us; 1262us; 789us; 1263us; 789us; 1266us; 789us; 1273us; 789us; 1274us; 789us; 1277us; 789us; 1278us; 789us; 1291us; 789us; 1298us; 789us; 1305us; 789us; 1312us; 789us; 1322us; 789us; 1324us; 789us; 1325us; 789us; 1337us; 789us; 1344us; 789us; 1345us; 789us; 1351us; 789us; 1357us; 789us; 1358us; 789us; 1359us; 789us; 1375us; 789us; 1385us; 789us; 1398us; 789us; 1399us; 789us; 1401us; 789us; 1403us; 789us; 1407us; 789us; 1408us; 789us; 1412us; 1413us; 1415us; 789us; 1421us; 789us; 1424us; 789us; 1426us; 789us; 1428us; 789us; 1430us; 789us; 1435us; 789us; 1440us; 789us; 1465us; 789us; 1490us; 789us; 1498us; 789us; 1505us; 789us; 1507us; 789us; 1510us; 789us; 1512us; 789us; 1523us; 789us; 1525us; 789us; 1532us; 789us; 1535us; 789us; 1538us; 789us; 1541us; 789us; 1543us; 789us; 1545us; 789us; 1549us; 789us; 1552us; 789us; 1556us; 789us; 1559us; 789us; 1564us; 789us; 1566us; 789us; 1568us; 789us; 1571us; 789us; 1573us; 789us; 1587us; 789us; 1592us; 789us; 1595us; 789us; 1606us; 789us; 1610us; 789us; 1616us; 789us; 1623us; 789us; 1627us; 789us; 1633us; 789us; 1634us; 789us; 1643us; 789us; 1657us; 789us; 1659us; 789us; 1670us; 789us; 11us; 65535us; 311us; 312us; 315us; 316us; 320us; 321us; 347us; 348us; 485us; 487us; 713us; 714us; 725us; 729us; 728us; 729us; 1249us; 1251us; 1250us; 1252us; 1429us; 1430us; 5us; 65535us; 101us; 576us; 175us; 576us; 427us; 576us; 555us; 571us; 854us; 576us; 13us; 65535us; 31us; 264us; 64us; 121us; 87us; 121us; 187us; 190us; 226us; 264us; 240us; 264us; 258us; 264us; 298us; 325us; 309us; 325us; 331us; 446us; 1413us; 1420us; 1799us; 1801us; 1800us; 1801us; 10us; 65535us; 31us; 49us; 64us; 49us; 87us; 49us; 226us; 49us; 240us; 49us; 258us; 49us; 298us; 323us; 309us; 323us; 1804us; 1806us; 1805us; 1806us; 7us; 65535us; 532us; 533us; 535us; 536us; 878us; 879us; 985us; 1389us; 1385us; 1391us; 1386us; 1387us; 1809us; 1810us; 5us; 65535us; 541us; 542us; 544us; 545us; 986us; 1502us; 1498us; 1504us; 1499us; 1500us; 43us; 65535us; 529us; 530us; 561us; 562us; 603us; 604us; 606us; 607us; 610us; 611us; 643us; 644us; 646us; 647us; 716us; 717us; 800us; 801us; 819us; 822us; 820us; 821us; 824us; 825us; 865us; 866us; 895us; 896us; 898us; 899us; 903us; 904us; 906us; 907us; 983us; 1364us; 984us; 1365us; 1140us; 1299us; 1184us; 1185us; 1306us; 1307us; 1310us; 1311us; 1357us; 1360us; 1358us; 1360us; 1359us; 1360us; 1361us; 1362us; 1374us; 1375us; 1381us; 1382us; 1422us; 1423us; 1426us; 1427us; 1588us; 1589us; 1617us; 1618us; 1628us; 1630us; 1629us; 1630us; 1635us; 1636us; 1646us; 1647us; 1682us; 1683us; 1710us; 1711us; 1712us; 1713us; 1716us; 1717us; 1719us; 1720us; 1814us; 1815us; 26us; 65535us; 70us; 71us; 74us; 75us; 109us; 110us; 112us; 113us; 116us; 117us; 134us; 135us; 152us; 153us; 160us; 161us; 231us; 232us; 235us; 236us; 251us; 284us; 274us; 275us; 278us; 279us; 281us; 282us; 319us; 320us; 357us; 358us; 376us; 378us; 380us; 382us; 499us; 500us; 755us; 756us; 946us; 947us; 951us; 952us; 970us; 971us; 1213us; 1214us; 1219us; 1220us; 1818us; 1819us; 1us; 65535us; 1361us; 1363us; 17us; 65535us; 298us; 307us; 300us; 306us; 484us; 490us; 920us; 1406us; 1039us; 1059us; 1040us; 1047us; 1041us; 1046us; 1042us; 1044us; 1225us; 1226us; 1227us; 1228us; 1403us; 1405us; 1464us; 1468us; 1465us; 1467us; 1652us; 1653us; 1659us; 1663us; 1664us; 1666us; 1706us; 1708us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 2us; 3us; 4us; 5us; 7us; 15us; 20us; 26us; 31us; 36us; 41us; 46us; 70us; 72us; 74us; 76us; 83us; 88us; 90us; 93us; 96us; 99us; 103us; 110us; 120us; 130us; 140us; 143us; 145us; 148us; 151us; 155us; 157us; 160us; 163us; 166us; 170us; 179us; 188us; 200us; 204us; 207us; 210us; 213us; 219us; 221us; 223us; 226us; 229us; 232us; 236us; 242us; 252us; 263us; 274us; 290us; 292us; 294us; 297us; 299us; 381us; 500us; 619us; 621us; 624us; 627us; 632us; 639us; 642us; 646us; 649us; 653us; 657us; 661us; 665us; 676us; 687us; 689us; 692us; 696us; 700us; 703us; 714us; 718us; 721us; 723us; 766us; 777us; 842us; 855us; 857us; 862us; 865us; 868us; 871us; 874us; 878us; 881us; 886us; 891us; 894us; 900us; 907us; 974us; 1042us; 1044us; 1050us; 1060us; 1062us; 1064us; 1068us; 1074us; 1076us; 1078us; 1083us; 1087us; 1089us; 1093us; 1097us; 1102us; 1104us; 1108us; 1114us; 1118us; 1122us; 1124us; 1128us; 1132us; 1137us; 1142us; 1146us; 1150us; 1154us; 1158us; 1163us; 1170us; 1177us; 1179us; 1181us; 1197us; 1311us; 1319us; 1433us; 1546us; 1550us; 1555us; 1669us; 1671us; 1673us; 1677us; 1680us; 1682us; 1687us; 1690us; 1696us; 1699us; 1701us; 1704us; 1706us; 1708us; 1710us; 1713us; 1971us; 1973us; 1978us; 1982us; 2168us; 2172us; 2176us; 2179us; 2181us; 2193us; 2205us; 2217us; 2220us; 2223us; 2257us; 2261us; 2270us; 2313us; 2316us; 2339us; 2362us; 2385us; 2388us; 2391us; 2395us; 2419us; 2426us; 2432us; 2483us; 2485us; 2541us; 2640us; 2750us; 2752us; 2756us; 2761us; 2768us; 2775us; 2777us; 2779us; 2782us; 2785us; 2787us; 2897us; 3021us; 3146us; 3151us; 3286us; 3289us; 3292us; 3295us; 3437us; 3579us; 3763us; 3905us; 4047us; 4051us; 4055us; 4057us; 4199us; 4201us; 4204us; 4208us; 4214us; 4216us; 4218us; 4220us; 4222us; 4226us; 4228us; 4233us; 4235us; 4237us; 4239us; 4242us; 4249us; 4256us; 4260us; 4266us; 4270us; 4272us; 4274us; 4276us; 4279us; 4281us; 4286us; 4292us; 4434us; 4578us; 4688us; 4798us; 4802us; 4808us; 4812us; 4822us; 4832us; 4835us; 4847us; 4879us; 4881us; 4913us; 4920us; 5012us; 5104us; 5170us; 5189us; 5194us; 5197us; 5263us; 5268us; 5335us; 5408us; 5413us; 5420us; 5429us; 5432us; 5436us; 5438us; 5445us; 5452us; 5459us; 5465us; 5572us; 5683us; 6017us; 6137us; 6329us; 6337us; 6340us; 6348us; 6494us; 6541us; 6685us; 6700us; 6713us; 6716us; 6728us; 6733us; 6736us; 6746us; 6749us; 6770us; 6779us; 6784us; 6785us; 6797us; 6805us; 6810us; 6820us; 6823us; 6826us; 6829us; 7089us; 7101us; 7107us; 7121us; 7132us; 7140us; 7146us; 7190us; 7217us; 7219us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 3us; 1us; 3us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 6us; 1us; 7us; 1us; 8us; 1us; 9us; 1us; 10us; 2us; 11us; 14us; 1us; 11us; 2us; 12us; 15us; 1us; 12us; 2us; 13us; 16us; 1us; 13us; 1us; 14us; 1us; 14us; 1us; 15us; 1us; 15us; 1us; 16us; 1us; 16us; 2us; 17us; 18us; 1us; 18us; 7us; 19us; 136us; 137us; 138us; 139us; 140us; 141us; 7us; 19us; 136us; 137us; 138us; 139us; 140us; 141us; 48us; 19us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 20us; 2us; 21us; 22us; 1us; 22us; 1us; 23us; 1us; 24us; 1us; 25us; 1us; 25us; 2us; 25us; 27us; 1us; 27us; 1us; 28us; 2us; 29us; 30us; 1us; 29us; 1us; 30us; 1us; 30us; 3us; 31us; 46us; 49us; 1us; 31us; 1us; 32us; 1us; 32us; 1us; 32us; 3us; 32us; 944us; 945us; 1us; 33us; 1us; 33us; 3us; 33us; 944us; 945us; 2us; 34us; 35us; 1us; 35us; 2us; 36us; 37us; 1us; 36us; 1us; 38us; 1us; 38us; 1us; 38us; 6us; 39us; 53us; 54us; 55us; 56us; 58us; 6us; 39us; 53us; 54us; 55us; 56us; 58us; 3us; 39us; 53us; 54us; 1us; 39us; 1us; 40us; 1us; 41us; 3us; 42us; 43us; 44us; 2us; 42us; 43us; 1us; 42us; 1us; 42us; 1us; 43us; 3us; 44us; 46us; 49us; 1us; 44us; 1us; 45us; 2us; 46us; 49us; 2us; 48us; 50us; 2us; 48us; 50us; 1us; 48us; 1us; 49us; 1us; 49us; 1us; 49us; 1us; 51us; 1us; 52us; 5us; 53us; 54us; 55us; 56us; 58us; 5us; 53us; 54us; 55us; 56us; 58us; 2us; 53us; 54us; 2us; 53us; 54us; 1us; 53us; 1us; 54us; 1us; 55us; 1us; 56us; 1us; 57us; 3us; 57us; 944us; 945us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 2us; 60us; 61us; 48us; 60us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 61us; 48us; 61us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 61us; 3us; 62us; 63us; 144us; 1us; 62us; 1us; 62us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 64us; 1us; 64us; 1us; 64us; 1us; 65us; 1us; 65us; 2us; 66us; 67us; 1us; 66us; 1us; 66us; 2us; 68us; 69us; 1us; 68us; 1us; 68us; 1us; 69us; 3us; 70us; 79us; 80us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 71us; 1us; 71us; 1us; 72us; 1us; 73us; 1us; 74us; 1us; 74us; 1us; 74us; 1us; 75us; 3us; 76us; 77us; 78us; 2us; 76us; 77us; 1us; 76us; 1us; 77us; 1us; 78us; 1us; 78us; 2us; 79us; 80us; 2us; 79us; 80us; 1us; 79us; 1us; 80us; 2us; 81us; 82us; 2us; 81us; 82us; 1us; 81us; 1us; 82us; 2us; 83us; 84us; 2us; 83us; 84us; 1us; 83us; 1us; 84us; 1us; 85us; 1us; 86us; 1us; 88us; 1us; 88us; 1us; 88us; 7us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 12us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 265us; 266us; 267us; 268us; 269us; 7us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 12us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 265us; 266us; 267us; 268us; 269us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 90us; 4us; 90us; 868us; 869us; 870us; 1us; 91us; 4us; 91us; 868us; 869us; 870us; 1us; 92us; 1us; 92us; 3us; 93us; 94us; 174us; 1us; 93us; 1us; 93us; 1us; 94us; 1us; 94us; 1us; 95us; 1us; 95us; 1us; 95us; 1us; 97us; 1us; 97us; 2us; 98us; 99us; 2us; 98us; 99us; 1us; 98us; 1us; 99us; 2us; 100us; 101us; 1us; 101us; 1us; 101us; 1us; 102us; 2us; 103us; 104us; 1us; 104us; 1us; 105us; 1us; 105us; 1us; 106us; 1us; 106us; 1us; 106us; 2us; 108us; 109us; 1us; 108us; 1us; 109us; 1us; 109us; 2us; 110us; 133us; 1us; 110us; 2us; 111us; 112us; 1us; 112us; 2us; 113us; 114us; 1us; 113us; 1us; 115us; 1us; 115us; 1us; 115us; 11us; 116us; 124us; 125us; 126us; 128us; 136us; 137us; 138us; 139us; 140us; 141us; 10us; 116us; 124us; 125us; 126us; 136us; 137us; 138us; 139us; 140us; 141us; 2us; 116us; 141us; 1us; 116us; 1us; 117us; 3us; 118us; 119us; 120us; 2us; 118us; 119us; 1us; 118us; 1us; 118us; 1us; 119us; 2us; 120us; 133us; 1us; 120us; 1us; 121us; 1us; 122us; 10us; 124us; 125us; 126us; 128us; 136us; 137us; 138us; 139us; 140us; 141us; 9us; 124us; 125us; 126us; 136us; 137us; 138us; 139us; 140us; 141us; 50us; 124us; 125us; 126us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 2us; 124us; 125us; 1us; 124us; 1us; 127us; 1us; 128us; 4us; 129us; 130us; 131us; 132us; 1us; 129us; 2us; 130us; 132us; 1us; 130us; 1us; 133us; 2us; 133us; 150us; 2us; 133us; 155us; 1us; 133us; 1us; 133us; 1us; 134us; 1us; 135us; 6us; 136us; 137us; 138us; 139us; 140us; 141us; 6us; 136us; 137us; 138us; 139us; 140us; 141us; 1us; 136us; 3us; 136us; 520us; 521us; 1us; 137us; 5us; 137us; 522us; 523us; 524us; 525us; 1us; 138us; 1us; 139us; 1us; 139us; 1us; 139us; 1us; 140us; 1us; 141us; 1us; 141us; 1us; 141us; 2us; 142us; 157us; 1us; 142us; 1us; 143us; 3us; 144us; 944us; 945us; 1us; 144us; 3us; 145us; 944us; 945us; 5us; 146us; 147us; 148us; 149us; 150us; 2us; 146us; 147us; 1us; 146us; 1us; 147us; 2us; 148us; 149us; 1us; 148us; 1us; 149us; 1us; 150us; 1us; 151us; 3us; 152us; 944us; 945us; 3us; 153us; 154us; 155us; 2us; 153us; 154us; 1us; 153us; 1us; 154us; 1us; 155us; 1us; 156us; 1us; 156us; 1us; 156us; 1us; 157us; 2us; 159us; 160us; 1us; 160us; 4us; 161us; 162us; 163us; 164us; 3us; 161us; 163us; 166us; 2us; 161us; 163us; 1us; 161us; 1us; 161us; 2us; 162us; 518us; 1us; 162us; 1us; 162us; 1us; 163us; 1us; 164us; 1us; 165us; 2us; 166us; 1011us; 1us; 166us; 3us; 167us; 944us; 945us; 1us; 167us; 1us; 167us; 2us; 168us; 169us; 3us; 168us; 944us; 945us; 1us; 168us; 1us; 168us; 1us; 169us; 3us; 169us; 944us; 945us; 1us; 169us; 1us; 169us; 1us; 169us; 1us; 170us; 1us; 170us; 1us; 171us; 1us; 171us; 2us; 172us; 943us; 1us; 172us; 1us; 173us; 1us; 173us; 4us; 174us; 215us; 221us; 224us; 1us; 174us; 1us; 175us; 1us; 176us; 1us; 177us; 1us; 178us; 1us; 178us; 1us; 178us; 1us; 179us; 1us; 179us; 1us; 179us; 4us; 181us; 182us; 183us; 184us; 1us; 182us; 1us; 182us; 1us; 183us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 4us; 185us; 186us; 195us; 196us; 2us; 185us; 186us; 2us; 185us; 186us; 2us; 185us; 186us; 2us; 185us; 186us; 1us; 185us; 1us; 185us; 1us; 186us; 1us; 187us; 1us; 187us; 1us; 188us; 1us; 189us; 1us; 190us; 1us; 190us; 1us; 190us; 1us; 191us; 3us; 192us; 193us; 194us; 2us; 192us; 193us; 1us; 192us; 1us; 193us; 2us; 194us; 201us; 1us; 194us; 2us; 195us; 196us; 2us; 195us; 196us; 1us; 195us; 1us; 196us; 2us; 197us; 198us; 2us; 197us; 198us; 1us; 197us; 1us; 198us; 1us; 199us; 1us; 200us; 1us; 201us; 1us; 201us; 1us; 203us; 1us; 203us; 1us; 203us; 1us; 204us; 1us; 204us; 2us; 205us; 206us; 2us; 205us; 206us; 1us; 205us; 1us; 206us; 2us; 207us; 208us; 1us; 208us; 1us; 208us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 2us; 210us; 211us; 2us; 210us; 211us; 2us; 210us; 211us; 1us; 210us; 1us; 210us; 1us; 211us; 2us; 212us; 213us; 1us; 213us; 11us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 16us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 265us; 266us; 267us; 268us; 269us; 11us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 16us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 265us; 266us; 267us; 268us; 269us; 1us; 214us; 1us; 215us; 2us; 216us; 222us; 1us; 216us; 1us; 216us; 1us; 217us; 4us; 217us; 868us; 869us; 870us; 1us; 217us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 219us; 1us; 220us; 1us; 220us; 1us; 221us; 1us; 221us; 1us; 222us; 1us; 222us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 224us; 1us; 224us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 228us; 1us; 228us; 2us; 229us; 467us; 1us; 229us; 1us; 229us; 1us; 230us; 1us; 230us; 1us; 230us; 1us; 231us; 1us; 232us; 1us; 232us; 1us; 234us; 1us; 235us; 1us; 236us; 1us; 237us; 1us; 238us; 1us; 240us; 1us; 240us; 1us; 240us; 1us; 242us; 1us; 242us; 1us; 242us; 3us; 244us; 245us; 246us; 2us; 244us; 245us; 1us; 244us; 1us; 245us; 1us; 245us; 1us; 245us; 1us; 246us; 1us; 247us; 1us; 249us; 1us; 249us; 1us; 250us; 2us; 252us; 253us; 1us; 252us; 1us; 253us; 2us; 254us; 255us; 2us; 254us; 255us; 1us; 254us; 1us; 255us; 1us; 256us; 2us; 257us; 258us; 2us; 257us; 258us; 1us; 257us; 4us; 259us; 260us; 261us; 262us; 5us; 259us; 260us; 261us; 262us; 382us; 3us; 259us; 260us; 261us; 1us; 259us; 1us; 259us; 1us; 260us; 1us; 260us; 1us; 261us; 1us; 262us; 1us; 262us; 1us; 262us; 1us; 263us; 1us; 264us; 5us; 265us; 266us; 267us; 268us; 269us; 5us; 265us; 266us; 267us; 268us; 269us; 4us; 265us; 864us; 944us; 945us; 1us; 265us; 1us; 265us; 1us; 265us; 1us; 266us; 1us; 267us; 1us; 268us; 5us; 269us; 871us; 892us; 893us; 904us; 1us; 269us; 1us; 269us; 3us; 270us; 271us; 272us; 2us; 270us; 271us; 1us; 270us; 1us; 271us; 1us; 272us; 1us; 272us; 6us; 273us; 894us; 895us; 896us; 897us; 898us; 1us; 273us; 1us; 274us; 3us; 275us; 276us; 277us; 2us; 275us; 276us; 1us; 275us; 1us; 276us; 1us; 277us; 1us; 277us; 2us; 278us; 889us; 2us; 278us; 413us; 1us; 278us; 1us; 279us; 1us; 280us; 1us; 281us; 1us; 282us; 1us; 283us; 3us; 284us; 285us; 286us; 4us; 284us; 286us; 944us; 945us; 1us; 285us; 3us; 285us; 944us; 945us; 1us; 286us; 1us; 287us; 1us; 288us; 2us; 288us; 289us; 1us; 288us; 2us; 289us; 292us; 3us; 289us; 293us; 294us; 1us; 289us; 2us; 289us; 293us; 1us; 289us; 1us; 290us; 1us; 291us; 1us; 291us; 1us; 292us; 1us; 292us; 1us; 292us; 1us; 292us; 1us; 293us; 1us; 296us; 1us; 296us; 1us; 296us; 1us; 296us; 1us; 296us; 1us; 297us; 2us; 299us; 450us; 1us; 302us; 2us; 302us; 303us; 2us; 303us; 837us; 2us; 303us; 839us; 1us; 303us; 1us; 303us; 1us; 304us; 1us; 305us; 1us; 305us; 1us; 305us; 1us; 305us; 8us; 306us; 307us; 308us; 309us; 310us; 312us; 313us; 314us; 1us; 306us; 1us; 306us; 7us; 307us; 308us; 309us; 310us; 312us; 313us; 314us; 1us; 307us; 3us; 308us; 313us; 314us; 1us; 308us; 1us; 309us; 1us; 310us; 1us; 310us; 1us; 310us; 1us; 311us; 2us; 311us; 315us; 1us; 311us; 1us; 311us; 1us; 311us; 1us; 311us; 1us; 311us; 1us; 312us; 1us; 312us; 1us; 313us; 1us; 315us; 4us; 315us; 868us; 869us; 870us; 4us; 316us; 868us; 869us; 870us; 1us; 317us; 1us; 317us; 1us; 318us; 1us; 318us; 1us; 318us; 2us; 319us; 332us; 1us; 320us; 2us; 321us; 322us; 1us; 321us; 1us; 321us; 4us; 323us; 324us; 325us; 326us; 4us; 323us; 324us; 325us; 326us; 4us; 323us; 324us; 325us; 326us; 1us; 323us; 1us; 324us; 1us; 324us; 1us; 324us; 1us; 325us; 1us; 325us; 1us; 325us; 1us; 326us; 1us; 326us; 1us; 326us; 1us; 327us; 6us; 328us; 329us; 946us; 947us; 949us; 950us; 1us; 328us; 1us; 328us; 1us; 329us; 1us; 329us; 1us; 329us; 5us; 330us; 331us; 333us; 334us; 943us; 1us; 330us; 2us; 331us; 334us; 2us; 331us; 334us; 2us; 331us; 334us; 1us; 332us; 1us; 333us; 1us; 333us; 2us; 335us; 336us; 1us; 335us; 1us; 335us; 2us; 337us; 943us; 1us; 337us; 4us; 337us; 868us; 869us; 870us; 4us; 338us; 868us; 869us; 870us; 1us; 339us; 1us; 340us; 2us; 341us; 342us; 2us; 341us; 1011us; 1us; 341us; 1us; 342us; 1us; 343us; 1us; 343us; 1us; 344us; 1us; 344us; 1us; 344us; 1us; 344us; 1us; 344us; 1us; 345us; 1us; 345us; 1us; 346us; 1us; 347us; 1us; 347us; 1us; 347us; 1us; 347us; 1us; 347us; 2us; 348us; 349us; 1us; 349us; 1us; 349us; 1us; 351us; 3us; 351us; 944us; 945us; 1us; 352us; 3us; 352us; 944us; 945us; 1us; 353us; 1us; 353us; 1us; 353us; 1us; 354us; 1us; 355us; 1us; 355us; 1us; 356us; 1us; 356us; 1us; 356us; 1us; 356us; 1us; 357us; 1us; 357us; 1us; 357us; 1us; 358us; 1us; 359us; 1us; 360us; 1us; 361us; 1us; 362us; 1us; 363us; 1us; 364us; 1us; 364us; 1us; 364us; 1us; 364us; 1us; 364us; 1us; 364us; 1us; 364us; 1us; 364us; 2us; 365us; 368us; 2us; 366us; 369us; 1us; 368us; 1us; 368us; 1us; 369us; 1us; 369us; 2us; 370us; 371us; 5us; 370us; 371us; 373us; 374us; 375us; 1us; 371us; 3us; 372us; 944us; 945us; 4us; 373us; 374us; 375us; 377us; 1us; 373us; 1us; 373us; 1us; 373us; 1us; 374us; 1us; 375us; 1us; 376us; 2us; 376us; 378us; 1us; 376us; 2us; 377us; 378us; 1us; 379us; 1us; 379us; 1us; 380us; 1us; 380us; 1us; 380us; 1us; 382us; 1us; 382us; 1us; 383us; 3us; 384us; 385us; 386us; 3us; 384us; 385us; 386us; 3us; 384us; 385us; 386us; 3us; 384us; 385us; 386us; 2us; 384us; 385us; 1us; 384us; 1us; 385us; 1us; 386us; 2us; 387us; 388us; 2us; 387us; 388us; 1us; 387us; 1us; 388us; 1us; 389us; 1us; 390us; 2us; 390us; 391us; 1us; 391us; 1us; 393us; 2us; 393us; 394us; 1us; 393us; 1us; 393us; 1us; 394us; 1us; 394us; 1us; 395us; 2us; 396us; 397us; 1us; 396us; 1us; 396us; 1us; 397us; 1us; 398us; 1us; 399us; 1us; 400us; 1us; 401us; 1us; 402us; 1us; 403us; 1us; 404us; 1us; 405us; 1us; 406us; 1us; 407us; 1us; 408us; 1us; 409us; 1us; 410us; 2us; 410us; 463us; 1us; 411us; 1us; 412us; 1us; 413us; 1us; 414us; 2us; 415us; 417us; 1us; 415us; 1us; 415us; 2us; 416us; 418us; 2us; 416us; 418us; 1us; 416us; 1us; 416us; 1us; 419us; 1us; 420us; 1us; 420us; 1us; 420us; 1us; 421us; 1us; 422us; 1us; 422us; 2us; 423us; 424us; 1us; 424us; 1us; 424us; 6us; 425us; 437us; 438us; 439us; 444us; 446us; 1us; 426us; 1us; 427us; 1us; 427us; 2us; 428us; 429us; 3us; 428us; 430us; 431us; 1us; 428us; 1us; 428us; 1us; 429us; 1us; 431us; 1us; 431us; 5us; 432us; 433us; 434us; 435us; 436us; 2us; 432us; 434us; 1us; 432us; 1us; 433us; 1us; 434us; 2us; 435us; 518us; 1us; 435us; 1us; 436us; 6us; 437us; 438us; 438us; 439us; 444us; 446us; 6us; 437us; 438us; 439us; 439us; 444us; 446us; 6us; 437us; 438us; 439us; 443us; 444us; 446us; 6us; 437us; 438us; 439us; 444us; 444us; 446us; 6us; 437us; 438us; 439us; 444us; 445us; 446us; 6us; 437us; 438us; 439us; 444us; 446us; 446us; 6us; 437us; 438us; 439us; 444us; 446us; 567us; 7us; 437us; 438us; 439us; 444us; 446us; 568us; 569us; 1us; 437us; 1us; 437us; 1us; 438us; 1us; 439us; 2us; 440us; 443us; 2us; 441us; 445us; 1us; 442us; 1us; 443us; 1us; 444us; 1us; 445us; 1us; 446us; 2us; 447us; 448us; 1us; 447us; 2us; 448us; 1011us; 1us; 448us; 1us; 449us; 4us; 449us; 982us; 984us; 985us; 1us; 449us; 7us; 449us; 484us; 485us; 488us; 490us; 493us; 495us; 5us; 450us; 451us; 452us; 453us; 469us; 3us; 451us; 452us; 453us; 1us; 451us; 1us; 452us; 1us; 452us; 1us; 453us; 1us; 453us; 1us; 454us; 1us; 454us; 1us; 455us; 9us; 456us; 474us; 475us; 476us; 477us; 946us; 947us; 949us; 950us; 1us; 456us; 1us; 456us; 1us; 457us; 4us; 458us; 459us; 460us; 461us; 1us; 458us; 1us; 459us; 1us; 459us; 1us; 460us; 1us; 460us; 1us; 462us; 1us; 463us; 1us; 463us; 1us; 464us; 1us; 464us; 1us; 464us; 1us; 465us; 1us; 465us; 1us; 465us; 1us; 466us; 1us; 466us; 1us; 466us; 1us; 468us; 2us; 468us; 967us; 1us; 468us; 1us; 469us; 1us; 470us; 1us; 471us; 1us; 472us; 1us; 473us; 8us; 474us; 475us; 476us; 477us; 946us; 947us; 949us; 950us; 2us; 474us; 475us; 1us; 474us; 1us; 475us; 3us; 476us; 518us; 947us; 2us; 476us; 947us; 1us; 477us; 4us; 478us; 479us; 480us; 481us; 4us; 478us; 479us; 480us; 481us; 4us; 478us; 479us; 486us; 492us; 1us; 478us; 1us; 479us; 2us; 480us; 518us; 1us; 480us; 1us; 481us; 7us; 482us; 484us; 485us; 488us; 490us; 493us; 495us; 7us; 484us; 485us; 485us; 488us; 490us; 493us; 495us; 7us; 484us; 485us; 488us; 489us; 490us; 493us; 495us; 7us; 484us; 485us; 488us; 490us; 490us; 493us; 495us; 7us; 484us; 485us; 488us; 490us; 492us; 493us; 495us; 7us; 484us; 485us; 488us; 490us; 493us; 493us; 495us; 7us; 484us; 485us; 488us; 490us; 493us; 494us; 495us; 6us; 484us; 485us; 488us; 490us; 493us; 495us; 7us; 484us; 485us; 488us; 490us; 493us; 495us; 495us; 7us; 484us; 485us; 488us; 490us; 493us; 495us; 498us; 8us; 484us; 485us; 488us; 490us; 493us; 495us; 500us; 501us; 14us; 484us; 485us; 488us; 490us; 493us; 495us; 563us; 564us; 761us; 762us; 763us; 764us; 765us; 766us; 7us; 484us; 485us; 488us; 490us; 493us; 495us; 632us; 1us; 484us; 1us; 484us; 1us; 485us; 2us; 486us; 492us; 2us; 487us; 494us; 1us; 488us; 1us; 488us; 1us; 489us; 1us; 490us; 1us; 491us; 1us; 492us; 1us; 493us; 1us; 494us; 1us; 495us; 2us; 496us; 497us; 1us; 496us; 2us; 497us; 1011us; 1us; 497us; 3us; 498us; 944us; 945us; 1us; 498us; 1us; 500us; 2us; 501us; 1011us; 1us; 501us; 2us; 502us; 503us; 2us; 502us; 503us; 1us; 502us; 1us; 503us; 1us; 504us; 1us; 505us; 1us; 505us; 1us; 505us; 48us; 506us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 2us; 507us; 508us; 1us; 507us; 2us; 509us; 510us; 1us; 509us; 1us; 509us; 1us; 511us; 1us; 511us; 52us; 512us; 513us; 514us; 515us; 516us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 55us; 512us; 513us; 514us; 515us; 516us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 702us; 703us; 706us; 55us; 512us; 513us; 514us; 515us; 516us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 757us; 758us; 759us; 2us; 512us; 513us; 1us; 512us; 1us; 515us; 1us; 515us; 1us; 516us; 1us; 516us; 1us; 516us; 1us; 516us; 5us; 517us; 522us; 523us; 524us; 525us; 1us; 518us; 2us; 518us; 550us; 2us; 518us; 553us; 2us; 518us; 558us; 2us; 518us; 561us; 2us; 518us; 563us; 2us; 518us; 683us; 2us; 518us; 698us; 2us; 518us; 723us; 2us; 518us; 727us; 2us; 518us; 732us; 3us; 518us; 732us; 947us; 2us; 518us; 747us; 2us; 518us; 823us; 1us; 519us; 2us; 520us; 521us; 2us; 520us; 521us; 1us; 520us; 1us; 521us; 4us; 522us; 523us; 524us; 525us; 1us; 522us; 1us; 523us; 2us; 524us; 525us; 1us; 524us; 1us; 525us; 1us; 526us; 1us; 527us; 1us; 528us; 2us; 529us; 530us; 2us; 529us; 530us; 1us; 529us; 1us; 530us; 2us; 531us; 532us; 2us; 531us; 532us; 1us; 531us; 1us; 532us; 3us; 533us; 534us; 535us; 3us; 533us; 534us; 535us; 1us; 533us; 1us; 534us; 1us; 535us; 1us; 535us; 3us; 536us; 537us; 538us; 49us; 536us; 537us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 536us; 1us; 537us; 1us; 538us; 1us; 539us; 48us; 539us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 2us; 540us; 541us; 48us; 540us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 542us; 1us; 542us; 2us; 543us; 544us; 1us; 543us; 6us; 545us; 546us; 547us; 548us; 549us; 550us; 51us; 545us; 546us; 547us; 548us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 3us; 545us; 546us; 547us; 2us; 545us; 546us; 1us; 545us; 1us; 546us; 1us; 547us; 1us; 547us; 1us; 548us; 1us; 549us; 1us; 550us; 15us; 551us; 552us; 553us; 554us; 555us; 556us; 557us; 558us; 559us; 560us; 561us; 562us; 563us; 564us; 572us; 6us; 551us; 552us; 553us; 554us; 555us; 572us; 4us; 551us; 552us; 553us; 554us; 2us; 551us; 552us; 1us; 551us; 1us; 552us; 1us; 553us; 1us; 554us; 1us; 555us; 5us; 556us; 557us; 558us; 559us; 560us; 4us; 556us; 557us; 558us; 559us; 2us; 556us; 557us; 1us; 556us; 1us; 557us; 1us; 558us; 1us; 559us; 1us; 560us; 1us; 561us; 1us; 561us; 1us; 561us; 1us; 562us; 1us; 563us; 2us; 564us; 1064us; 1us; 565us; 48us; 565us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 566us; 48us; 566us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 567us; 1us; 567us; 1us; 567us; 1us; 567us; 1us; 567us; 1us; 567us; 2us; 568us; 569us; 2us; 568us; 569us; 2us; 568us; 569us; 2us; 568us; 569us; 2us; 568us; 569us; 1us; 568us; 1us; 569us; 1us; 570us; 1us; 570us; 1us; 570us; 1us; 570us; 1us; 570us; 1us; 571us; 1us; 571us; 1us; 571us; 1us; 572us; 1us; 572us; 1us; 573us; 48us; 573us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 1us; 574us; 1us; 574us; 48us; 575us; 576us; 577us; 578us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 638us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 642us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 646us; 653us; 654us; 49us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 649us; 650us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 651us; 653us; 654us; 47us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 654us; 50us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 702us; 703us; 706us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 702us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 704us; 51us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 757us; 758us; 759us; 761us; 51us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 757us; 758us; 759us; 765us; 49us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 757us; 758us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 758us; 48us; 575us; 576us; 577us; 578us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 621us; 653us; 654us; 765us; 1us; 575us; 1us; 575us; 1us; 576us; 1us; 576us; 1us; 577us; 1us; 577us; 1us; 578us; 2us; 579us; 622us; 1us; 579us; 1us; 579us; 3us; 580us; 651us; 652us; 5us; 580us; 651us; 652us; 685us; 686us; 2us; 581us; 602us; 2us; 582us; 603us; 2us; 583us; 604us; 2us; 584us; 605us; 2us; 585us; 606us; 2us; 586us; 607us; 2us; 587us; 608us; 2us; 588us; 609us; 2us; 589us; 610us; 2us; 590us; 611us; 3us; 591us; 592us; 612us; 1us; 592us; 2us; 593us; 613us; 2us; 594us; 614us; 2us; 595us; 615us; 2us; 596us; 616us; 2us; 597us; 617us; 2us; 598us; 618us; 2us; 599us; 619us; 2us; 600us; 620us; 2us; 601us; 621us; 1us; 602us; 1us; 603us; 1us; 604us; 1us; 605us; 1us; 606us; 1us; 607us; 1us; 608us; 1us; 609us; 1us; 610us; 1us; 611us; 1us; 612us; 1us; 613us; 1us; 614us; 1us; 615us; 1us; 616us; 1us; 617us; 1us; 618us; 1us; 619us; 1us; 620us; 1us; 621us; 1us; 623us; 1us; 624us; 1us; 624us; 1us; 624us; 1us; 625us; 1us; 625us; 2us; 626us; 627us; 2us; 626us; 627us; 1us; 626us; 1us; 627us; 1us; 628us; 2us; 629us; 630us; 1us; 629us; 1us; 630us; 1us; 631us; 1us; 632us; 5us; 633us; 634us; 635us; 636us; 637us; 4us; 633us; 634us; 635us; 636us; 2us; 634us; 635us; 1us; 634us; 1us; 635us; 1us; 636us; 1us; 637us; 1us; 638us; 1us; 640us; 1us; 640us; 1us; 641us; 1us; 641us; 1us; 642us; 2us; 643us; 644us; 2us; 643us; 644us; 2us; 643us; 644us; 1us; 643us; 1us; 644us; 1us; 646us; 2us; 647us; 648us; 2us; 647us; 648us; 2us; 647us; 648us; 1us; 647us; 1us; 648us; 2us; 649us; 650us; 1us; 649us; 1us; 650us; 2us; 651us; 652us; 1us; 652us; 2us; 653us; 654us; 1us; 653us; 1us; 655us; 2us; 655us; 961us; 1us; 655us; 1us; 656us; 2us; 656us; 957us; 1us; 656us; 1us; 657us; 2us; 657us; 960us; 1us; 657us; 1us; 658us; 2us; 658us; 973us; 1us; 658us; 1us; 659us; 2us; 659us; 968us; 1us; 659us; 1us; 660us; 2us; 660us; 969us; 1us; 660us; 3us; 661us; 662us; 663us; 7us; 661us; 662us; 663us; 805us; 806us; 807us; 808us; 2us; 661us; 662us; 6us; 661us; 662us; 805us; 806us; 807us; 808us; 2us; 661us; 662us; 4us; 661us; 662us; 806us; 807us; 1us; 661us; 3us; 661us; 806us; 807us; 1us; 662us; 1us; 663us; 1us; 664us; 1us; 664us; 1us; 665us; 1us; 665us; 2us; 666us; 667us; 6us; 666us; 667us; 781us; 785us; 786us; 787us; 5us; 667us; 781us; 785us; 786us; 787us; 1us; 667us; 6us; 668us; 671us; 672us; 673us; 675us; 678us; 1us; 669us; 6us; 669us; 671us; 672us; 673us; 675us; 678us; 6us; 670us; 671us; 672us; 673us; 675us; 678us; 6us; 671us; 671us; 672us; 673us; 675us; 678us; 6us; 671us; 672us; 672us; 673us; 675us; 678us; 6us; 671us; 672us; 673us; 674us; 675us; 678us; 6us; 671us; 672us; 673us; 675us; 678us; 901us; 1us; 671us; 1us; 672us; 1us; 673us; 1us; 673us; 1us; 674us; 2us; 674us; 951us; 1us; 675us; 1us; 675us; 1us; 676us; 1us; 676us; 1us; 676us; 1us; 677us; 2us; 677us; 967us; 1us; 677us; 1us; 678us; 1us; 678us; 1us; 679us; 1us; 680us; 4us; 681us; 682us; 683us; 684us; 2us; 681us; 682us; 1us; 681us; 1us; 682us; 1us; 683us; 1us; 684us; 3us; 685us; 686us; 819us; 2us; 685us; 686us; 1us; 685us; 1us; 686us; 1us; 687us; 1us; 688us; 1us; 689us; 1us; 691us; 6us; 692us; 693us; 946us; 947us; 949us; 950us; 1us; 692us; 1us; 692us; 1us; 692us; 1us; 692us; 1us; 693us; 1us; 693us; 6us; 694us; 695us; 696us; 697us; 698us; 699us; 2us; 694us; 695us; 1us; 694us; 1us; 695us; 2us; 696us; 697us; 1us; 696us; 1us; 697us; 1us; 698us; 1us; 699us; 2us; 700us; 701us; 1us; 700us; 1us; 700us; 2us; 702us; 703us; 1us; 704us; 1us; 705us; 1us; 707us; 1us; 708us; 1us; 709us; 1us; 710us; 1us; 711us; 1us; 712us; 1us; 713us; 1us; 714us; 1us; 715us; 1us; 716us; 4us; 717us; 718us; 719us; 720us; 2us; 717us; 718us; 1us; 717us; 1us; 718us; 1us; 719us; 1us; 719us; 1us; 720us; 4us; 721us; 722us; 723us; 724us; 5us; 721us; 722us; 723us; 724us; 976us; 2us; 721us; 722us; 1us; 721us; 1us; 722us; 1us; 723us; 1us; 724us; 4us; 725us; 726us; 727us; 728us; 2us; 725us; 726us; 1us; 725us; 1us; 726us; 1us; 727us; 1us; 728us; 9us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 737us; 14us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 737us; 742us; 946us; 947us; 949us; 950us; 13us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 737us; 946us; 947us; 949us; 950us; 1us; 729us; 2us; 730us; 731us; 1us; 730us; 1us; 731us; 1us; 732us; 2us; 732us; 947us; 1us; 733us; 1us; 734us; 1us; 735us; 1us; 736us; 1us; 737us; 1us; 738us; 1us; 738us; 1us; 738us; 1us; 738us; 1us; 738us; 1us; 738us; 1us; 739us; 1us; 740us; 1us; 741us; 2us; 741us; 744us; 2us; 742us; 743us; 1us; 742us; 1us; 743us; 1us; 743us; 5us; 745us; 746us; 747us; 748us; 749us; 2us; 745us; 746us; 1us; 745us; 1us; 746us; 1us; 747us; 1us; 748us; 1us; 749us; 1us; 750us; 1us; 751us; 1us; 752us; 1us; 753us; 1us; 755us; 1us; 756us; 3us; 757us; 758us; 759us; 1us; 758us; 1us; 759us; 1us; 760us; 1us; 760us; 3us; 761us; 762us; 763us; 1us; 762us; 1us; 763us; 1us; 764us; 2us; 765us; 766us; 1us; 765us; 1us; 766us; 1us; 767us; 1us; 768us; 1us; 769us; 1us; 769us; 1us; 769us; 2us; 769us; 770us; 1us; 769us; 1us; 769us; 1us; 770us; 1us; 773us; 1us; 775us; 1us; 775us; 1us; 775us; 1us; 775us; 2us; 777us; 778us; 1us; 777us; 5us; 778us; 871us; 892us; 893us; 904us; 1us; 778us; 1us; 779us; 1us; 779us; 1us; 779us; 1us; 779us; 2us; 779us; 796us; 1us; 779us; 1us; 780us; 1us; 781us; 1us; 781us; 2us; 781us; 796us; 1us; 781us; 3us; 782us; 783us; 784us; 2us; 783us; 784us; 1us; 784us; 2us; 784us; 796us; 1us; 784us; 1us; 785us; 1us; 785us; 2us; 785us; 796us; 1us; 785us; 2us; 786us; 787us; 1us; 786us; 1us; 786us; 1us; 787us; 2us; 787us; 796us; 1us; 787us; 1us; 787us; 1us; 788us; 2us; 788us; 796us; 2us; 790us; 793us; 2us; 791us; 792us; 1us; 792us; 1us; 793us; 3us; 794us; 944us; 945us; 1us; 795us; 1us; 796us; 5us; 798us; 799us; 800us; 801us; 802us; 3us; 798us; 799us; 800us; 1us; 798us; 1us; 800us; 1us; 802us; 2us; 803us; 804us; 1us; 803us; 1us; 803us; 1us; 803us; 1us; 804us; 1us; 804us; 1us; 806us; 1us; 809us; 2us; 811us; 813us; 1us; 811us; 1us; 812us; 1us; 812us; 1us; 812us; 1us; 813us; 1us; 813us; 1us; 814us; 1us; 814us; 1us; 816us; 1us; 816us; 1us; 817us; 1us; 817us; 1us; 818us; 4us; 818us; 868us; 869us; 870us; 1us; 818us; 1us; 818us; 1us; 818us; 1us; 819us; 1us; 819us; 1us; 820us; 5us; 821us; 822us; 823us; 824us; 825us; 2us; 821us; 822us; 1us; 821us; 1us; 822us; 1us; 823us; 1us; 824us; 1us; 825us; 2us; 826us; 827us; 2us; 826us; 827us; 2us; 826us; 827us; 1us; 826us; 1us; 827us; 6us; 828us; 829us; 830us; 831us; 832us; 833us; 5us; 828us; 829us; 830us; 831us; 832us; 4us; 828us; 829us; 830us; 831us; 2us; 828us; 829us; 1us; 828us; 1us; 829us; 1us; 830us; 1us; 830us; 1us; 831us; 1us; 832us; 1us; 832us; 1us; 833us; 1us; 833us; 1us; 834us; 1us; 834us; 1us; 835us; 1us; 835us; 1us; 835us; 2us; 836us; 837us; 1us; 837us; 2us; 838us; 839us; 1us; 839us; 1us; 841us; 1us; 841us; 2us; 842us; 843us; 1us; 842us; 1us; 842us; 2us; 844us; 845us; 1us; 844us; 1us; 844us; 2us; 846us; 847us; 1us; 846us; 1us; 846us; 3us; 848us; 849us; 850us; 5us; 848us; 850us; 868us; 869us; 870us; 1us; 848us; 4us; 848us; 868us; 869us; 870us; 1us; 849us; 1us; 849us; 1us; 849us; 4us; 849us; 868us; 869us; 870us; 5us; 851us; 853us; 868us; 869us; 870us; 1us; 851us; 4us; 851us; 868us; 869us; 870us; 1us; 852us; 1us; 852us; 1us; 852us; 4us; 852us; 868us; 869us; 870us; 2us; 854us; 855us; 1us; 854us; 1us; 854us; 1us; 856us; 1us; 856us; 6us; 857us; 859us; 860us; 868us; 869us; 870us; 1us; 857us; 1us; 857us; 1us; 858us; 1us; 858us; 1us; 859us; 1us; 859us; 6us; 861us; 862us; 863us; 868us; 869us; 870us; 1us; 861us; 1us; 861us; 1us; 862us; 1us; 862us; 3us; 864us; 944us; 945us; 1us; 865us; 2us; 865us; 873us; 2us; 866us; 867us; 4us; 866us; 867us; 905us; 908us; 1us; 866us; 1us; 866us; 7us; 868us; 869us; 870us; 894us; 895us; 896us; 897us; 1us; 868us; 1us; 869us; 1us; 869us; 1us; 870us; 4us; 871us; 892us; 893us; 904us; 1us; 871us; 1us; 871us; 1us; 871us; 1us; 872us; 1us; 873us; 1us; 873us; 2us; 874us; 891us; 1us; 874us; 1us; 874us; 4us; 875us; 876us; 877us; 878us; 1us; 875us; 3us; 876us; 877us; 878us; 1us; 876us; 2us; 877us; 878us; 1us; 877us; 1us; 878us; 1us; 878us; 1us; 879us; 1us; 879us; 1us; 879us; 3us; 879us; 880us; 881us; 4us; 880us; 881us; 911us; 912us; 2us; 880us; 881us; 1us; 880us; 1us; 881us; 2us; 883us; 884us; 1us; 884us; 1us; 884us; 4us; 885us; 892us; 893us; 904us; 1us; 885us; 1us; 885us; 1us; 885us; 3us; 886us; 906us; 907us; 3us; 887us; 906us; 907us; 1us; 888us; 1us; 889us; 3us; 889us; 906us; 907us; 1us; 890us; 1us; 891us; 3us; 892us; 893us; 904us; 2us; 892us; 893us; 5us; 892us; 893us; 918us; 919us; 920us; 1us; 892us; 1us; 893us; 5us; 894us; 895us; 896us; 897us; 898us; 5us; 894us; 895us; 896us; 897us; 898us; 3us; 894us; 895us; 896us; 2us; 894us; 895us; 1us; 894us; 1us; 895us; 1us; 896us; 1us; 897us; 1us; 898us; 1us; 899us; 1us; 900us; 1us; 901us; 1us; 902us; 1us; 903us; 1us; 904us; 1us; 904us; 1us; 905us; 2us; 906us; 907us; 4us; 906us; 907us; 944us; 945us; 1us; 907us; 1us; 908us; 1us; 908us; 1us; 909us; 1us; 910us; 1us; 910us; 7us; 911us; 912us; 913us; 914us; 915us; 916us; 917us; 3us; 911us; 912us; 913us; 3us; 911us; 912us; 913us; 2us; 911us; 912us; 1us; 911us; 1us; 912us; 1us; 913us; 3us; 914us; 915us; 921us; 1us; 914us; 1us; 915us; 1us; 916us; 1us; 917us; 3us; 918us; 919us; 920us; 2us; 919us; 920us; 1us; 919us; 1us; 921us; 1us; 922us; 2us; 924us; 925us; 3us; 924us; 935us; 936us; 1us; 924us; 1us; 925us; 1us; 925us; 3us; 926us; 944us; 945us; 1us; 927us; 1us; 928us; 3us; 928us; 935us; 936us; 1us; 928us; 2us; 929us; 930us; 1us; 930us; 1us; 930us; 1us; 931us; 2us; 932us; 933us; 1us; 933us; 1us; 934us; 3us; 935us; 935us; 936us; 3us; 935us; 936us; 936us; 3us; 935us; 936us; 937us; 1us; 935us; 1us; 936us; 1us; 937us; 1us; 938us; 1us; 938us; 1us; 939us; 1us; 940us; 2us; 940us; 954us; 1us; 940us; 1us; 941us; 1us; 942us; 1us; 943us; 2us; 944us; 945us; 1us; 944us; 1us; 945us; 4us; 946us; 947us; 949us; 950us; 1us; 946us; 1us; 946us; 1us; 947us; 1us; 947us; 1us; 948us; 3us; 949us; 950us; 979us; 3us; 949us; 950us; 979us; 1us; 949us; 1us; 950us; 1us; 950us; 1us; 950us; 1us; 951us; 1us; 952us; 1us; 953us; 1us; 954us; 1us; 955us; 1us; 956us; 1us; 957us; 1us; 958us; 1us; 959us; 1us; 960us; 1us; 961us; 1us; 962us; 1us; 963us; 1us; 964us; 1us; 965us; 1us; 966us; 1us; 967us; 1us; 968us; 1us; 969us; 1us; 970us; 1us; 971us; 1us; 972us; 1us; 973us; 2us; 974us; 975us; 1us; 975us; 1us; 976us; 1us; 976us; 1us; 977us; 1us; 978us; 1us; 978us; 1us; 979us; 1us; 980us; 1us; 981us; 3us; 982us; 984us; 985us; 1us; 983us; 2us; 984us; 985us; 1us; 984us; 1us; 985us; 1us; 986us; 1us; 987us; 1us; 988us; 1us; 989us; 2us; 990us; 991us; 1us; 991us; 1us; 992us; 1us; 992us; 2us; 994us; 996us; 2us; 995us; 997us; 1us; 996us; 1us; 997us; 1us; 998us; 1us; 999us; 1us; 1000us; 1us; 1001us; 1us; 1002us; 1us; 1003us; 1us; 1005us; 1us; 1007us; 1us; 1009us; 1us; 1011us; 1us; 1013us; 1us; 1017us; 1us; 1019us; 1us; 1021us; 1us; 1022us; 1us; 1023us; 1us; 1024us; 1us; 1025us; 1us; 1026us; 1us; 1027us; 1us; 1028us; 1us; 1029us; 1us; 1030us; 1us; 1031us; 1us; 1032us; 1us; 1033us; 1us; 1034us; 1us; 1036us; 1us; 1038us; 2us; 1038us; 1059us; 1us; 1038us; 1us; 1039us; 1us; 1040us; 1us; 1041us; 2us; 1041us; 1060us; 1us; 1041us; 1us; 1042us; 1us; 1043us; 1us; 1044us; 1us; 1044us; 1us; 1045us; 1us; 1046us; 1us; 1047us; 1us; 1048us; 1us; 1048us; 1us; 1049us; 1us; 1050us; 1us; 1051us; 1us; 1051us; 1us; 1052us; 1us; 1053us; 1us; 1054us; 1us; 1055us; 1us; 1056us; 1us; 1057us; 1us; 1058us; 1us; 1059us; 1us; 1060us; 1us; 1061us; 1us; 1062us; 1us; 1063us; 1us; 1064us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 22us; 24us; 26us; 28us; 30us; 32us; 35us; 37us; 40us; 42us; 45us; 47us; 49us; 51us; 53us; 55us; 57us; 59us; 62us; 64us; 72us; 80us; 129us; 131us; 134us; 136us; 138us; 140us; 142us; 144us; 147us; 149us; 151us; 154us; 156us; 158us; 160us; 164us; 166us; 168us; 170us; 172us; 176us; 178us; 180us; 184us; 187us; 189us; 192us; 194us; 196us; 198us; 200us; 207us; 214us; 218us; 220us; 222us; 224us; 228us; 231us; 233us; 235us; 237us; 241us; 243us; 245us; 248us; 251us; 254us; 256us; 258us; 260us; 262us; 264us; 266us; 272us; 278us; 281us; 284us; 286us; 288us; 290us; 292us; 294us; 298us; 300us; 302us; 304us; 306us; 308us; 310us; 312us; 314us; 316us; 318us; 321us; 370us; 372us; 421us; 423us; 427us; 429us; 431us; 433us; 435us; 437us; 439us; 441us; 443us; 445us; 447us; 449us; 452us; 454us; 456us; 459us; 461us; 463us; 465us; 469us; 471us; 473us; 475us; 477us; 479us; 481us; 483us; 485us; 487us; 489us; 491us; 493us; 495us; 497us; 501us; 504us; 506us; 508us; 510us; 512us; 515us; 518us; 520us; 522us; 525us; 528us; 530us; 532us; 535us; 538us; 540us; 542us; 544us; 546us; 548us; 550us; 552us; 560us; 573us; 581us; 594us; 596us; 598us; 600us; 602us; 604us; 606us; 608us; 610us; 612us; 614us; 619us; 621us; 626us; 628us; 630us; 634us; 636us; 638us; 640us; 642us; 644us; 646us; 648us; 650us; 652us; 655us; 658us; 660us; 662us; 665us; 667us; 669us; 671us; 674us; 676us; 678us; 680us; 682us; 684us; 686us; 689us; 691us; 693us; 695us; 698us; 700us; 703us; 705us; 708us; 710us; 712us; 714us; 716us; 728us; 739us; 742us; 744us; 746us; 750us; 753us; 755us; 757us; 759us; 762us; 764us; 766us; 768us; 779us; 789us; 840us; 843us; 845us; 847us; 849us; 854us; 856us; 859us; 861us; 863us; 866us; 869us; 871us; 873us; 875us; 877us; 884us; 891us; 893us; 897us; 899us; 905us; 907us; 909us; 911us; 913us; 915us; 917us; 919us; 921us; 924us; 926us; 928us; 932us; 934us; 938us; 944us; 947us; 949us; 951us; 954us; 956us; 958us; 960us; 962us; 966us; 970us; 973us; 975us; 977us; 979us; 981us; 983us; 985us; 987us; 990us; 992us; 997us; 1001us; 1004us; 1006us; 1008us; 1011us; 1013us; 1015us; 1017us; 1019us; 1021us; 1024us; 1026us; 1030us; 1032us; 1034us; 1037us; 1041us; 1043us; 1045us; 1047us; 1051us; 1053us; 1055us; 1057us; 1059us; 1061us; 1063us; 1065us; 1068us; 1070us; 1072us; 1074us; 1079us; 1081us; 1083us; 1085us; 1087us; 1089us; 1091us; 1093us; 1095us; 1097us; 1099us; 1104us; 1106us; 1108us; 1110us; 1112us; 1114us; 1116us; 1118us; 1120us; 1122us; 1124us; 1129us; 1132us; 1135us; 1138us; 1141us; 1143us; 1145us; 1147us; 1149us; 1151us; 1153us; 1155us; 1157us; 1159us; 1161us; 1163us; 1167us; 1170us; 1172us; 1174us; 1177us; 1179us; 1182us; 1185us; 1187us; 1189us; 1192us; 1195us; 1197us; 1199us; 1201us; 1203us; 1205us; 1207us; 1209us; 1211us; 1213us; 1215us; 1217us; 1220us; 1223us; 1225us; 1227us; 1230us; 1232us; 1234us; 1236us; 1238us; 1240us; 1242us; 1244us; 1246us; 1249us; 1252us; 1255us; 1257us; 1259us; 1261us; 1264us; 1266us; 1278us; 1295us; 1307us; 1324us; 1326us; 1328us; 1331us; 1333us; 1335us; 1337us; 1342us; 1344us; 1346us; 1348us; 1350us; 1352us; 1354us; 1356us; 1358us; 1360us; 1362us; 1364us; 1366us; 1368us; 1370us; 1372us; 1374us; 1376us; 1378us; 1380us; 1382us; 1384us; 1386us; 1388us; 1390us; 1392us; 1394us; 1396us; 1398us; 1400us; 1402us; 1404us; 1406us; 1408us; 1410us; 1412us; 1414us; 1416us; 1418us; 1420us; 1422us; 1425us; 1427us; 1429us; 1431us; 1433us; 1435us; 1437us; 1439us; 1441us; 1443us; 1445us; 1447us; 1449us; 1451us; 1453us; 1455us; 1457us; 1459us; 1461us; 1463us; 1467us; 1470us; 1472us; 1474us; 1476us; 1478us; 1480us; 1482us; 1484us; 1486us; 1488us; 1491us; 1493us; 1495us; 1498us; 1501us; 1503us; 1505us; 1507us; 1510us; 1513us; 1515us; 1520us; 1526us; 1530us; 1532us; 1534us; 1536us; 1538us; 1540us; 1542us; 1544us; 1546us; 1548us; 1550us; 1556us; 1562us; 1567us; 1569us; 1571us; 1573us; 1575us; 1577us; 1579us; 1585us; 1587us; 1589us; 1593us; 1596us; 1598us; 1600us; 1602us; 1604us; 1611us; 1613us; 1615us; 1619us; 1622us; 1624us; 1626us; 1628us; 1630us; 1633us; 1636us; 1638us; 1640us; 1642us; 1644us; 1646us; 1648us; 1652us; 1657us; 1659us; 1663us; 1665us; 1667us; 1669us; 1672us; 1674us; 1677us; 1681us; 1683us; 1686us; 1688us; 1690us; 1692us; 1694us; 1696us; 1698us; 1700us; 1702us; 1704us; 1706us; 1708us; 1710us; 1712us; 1714us; 1716us; 1719us; 1721us; 1724us; 1727us; 1730us; 1732us; 1734us; 1736us; 1738us; 1740us; 1742us; 1744us; 1753us; 1755us; 1757us; 1765us; 1767us; 1771us; 1773us; 1775us; 1777us; 1779us; 1781us; 1783us; 1786us; 1788us; 1790us; 1792us; 1794us; 1796us; 1798us; 1800us; 1802us; 1804us; 1809us; 1814us; 1816us; 1818us; 1820us; 1822us; 1824us; 1827us; 1829us; 1832us; 1834us; 1836us; 1841us; 1846us; 1851us; 1853us; 1855us; 1857us; 1859us; 1861us; 1863us; 1865us; 1867us; 1869us; 1871us; 1873us; 1880us; 1882us; 1884us; 1886us; 1888us; 1890us; 1896us; 1898us; 1901us; 1904us; 1907us; 1909us; 1911us; 1913us; 1916us; 1918us; 1920us; 1923us; 1925us; 1930us; 1935us; 1937us; 1939us; 1942us; 1945us; 1947us; 1949us; 1951us; 1953us; 1955us; 1957us; 1959us; 1961us; 1963us; 1965us; 1967us; 1969us; 1971us; 1973us; 1975us; 1977us; 1979us; 1982us; 1984us; 1986us; 1988us; 1992us; 1994us; 1998us; 2000us; 2002us; 2004us; 2006us; 2008us; 2010us; 2012us; 2014us; 2016us; 2018us; 2020us; 2022us; 2024us; 2026us; 2028us; 2030us; 2032us; 2034us; 2036us; 2038us; 2040us; 2042us; 2044us; 2046us; 2048us; 2050us; 2052us; 2055us; 2058us; 2060us; 2062us; 2064us; 2066us; 2069us; 2075us; 2077us; 2081us; 2086us; 2088us; 2090us; 2092us; 2094us; 2096us; 2098us; 2101us; 2103us; 2106us; 2108us; 2110us; 2112us; 2114us; 2116us; 2118us; 2120us; 2122us; 2126us; 2130us; 2134us; 2138us; 2141us; 2143us; 2145us; 2147us; 2150us; 2153us; 2155us; 2157us; 2159us; 2161us; 2164us; 2166us; 2168us; 2171us; 2173us; 2175us; 2177us; 2179us; 2181us; 2184us; 2186us; 2188us; 2190us; 2192us; 2194us; 2196us; 2198us; 2200us; 2202us; 2204us; 2206us; 2208us; 2210us; 2212us; 2214us; 2216us; 2219us; 2221us; 2223us; 2225us; 2227us; 2230us; 2232us; 2234us; 2237us; 2240us; 2242us; 2244us; 2246us; 2248us; 2250us; 2252us; 2254us; 2256us; 2258us; 2261us; 2263us; 2265us; 2272us; 2274us; 2276us; 2278us; 2281us; 2285us; 2287us; 2289us; 2291us; 2293us; 2295us; 2301us; 2304us; 2306us; 2308us; 2310us; 2313us; 2315us; 2317us; 2324us; 2331us; 2338us; 2345us; 2352us; 2359us; 2366us; 2374us; 2376us; 2378us; 2380us; 2382us; 2385us; 2388us; 2390us; 2392us; 2394us; 2396us; 2398us; 2401us; 2403us; 2406us; 2408us; 2410us; 2415us; 2417us; 2425us; 2431us; 2435us; 2437us; 2439us; 2441us; 2443us; 2445us; 2447us; 2449us; 2451us; 2461us; 2463us; 2465us; 2467us; 2472us; 2474us; 2476us; 2478us; 2480us; 2482us; 2484us; 2486us; 2488us; 2490us; 2492us; 2494us; 2496us; 2498us; 2500us; 2502us; 2504us; 2506us; 2508us; 2511us; 2513us; 2515us; 2517us; 2519us; 2521us; 2523us; 2532us; 2535us; 2537us; 2539us; 2543us; 2546us; 2548us; 2553us; 2558us; 2563us; 2565us; 2567us; 2570us; 2572us; 2574us; 2582us; 2590us; 2598us; 2606us; 2614us; 2622us; 2630us; 2637us; 2645us; 2653us; 2662us; 2677us; 2685us; 2687us; 2689us; 2691us; 2694us; 2697us; 2699us; 2701us; 2703us; 2705us; 2707us; 2709us; 2711us; 2713us; 2715us; 2718us; 2720us; 2723us; 2725us; 2729us; 2731us; 2733us; 2736us; 2738us; 2741us; 2744us; 2746us; 2748us; 2750us; 2752us; 2754us; 2756us; 2805us; 2808us; 2810us; 2813us; 2815us; 2817us; 2819us; 2821us; 2874us; 2930us; 2986us; 2989us; 2991us; 2993us; 2995us; 2997us; 2999us; 3001us; 3003us; 3009us; 3011us; 3014us; 3017us; 3020us; 3023us; 3026us; 3029us; 3032us; 3035us; 3038us; 3041us; 3045us; 3048us; 3051us; 3053us; 3056us; 3059us; 3061us; 3063us; 3068us; 3070us; 3072us; 3075us; 3077us; 3079us; 3081us; 3083us; 3085us; 3088us; 3091us; 3093us; 3095us; 3098us; 3101us; 3103us; 3105us; 3109us; 3113us; 3115us; 3117us; 3119us; 3121us; 3125us; 3175us; 3177us; 3179us; 3181us; 3183us; 3232us; 3235us; 3284us; 3286us; 3288us; 3291us; 3293us; 3300us; 3352us; 3356us; 3359us; 3361us; 3363us; 3365us; 3367us; 3369us; 3371us; 3373us; 3389us; 3396us; 3401us; 3404us; 3406us; 3408us; 3410us; 3412us; 3414us; 3420us; 3425us; 3428us; 3430us; 3432us; 3434us; 3436us; 3438us; 3440us; 3442us; 3444us; 3446us; 3448us; 3451us; 3453us; 3502us; 3504us; 3553us; 3555us; 3557us; 3559us; 3561us; 3563us; 3565us; 3568us; 3571us; 3574us; 3577us; 3580us; 3582us; 3584us; 3586us; 3588us; 3590us; 3592us; 3594us; 3596us; 3598us; 3600us; 3602us; 3604us; 3606us; 3655us; 3657us; 3659us; 3708us; 3757us; 3806us; 3855us; 3904us; 3953us; 4002us; 4051us; 4100us; 4149us; 4198us; 4247us; 4296us; 4345us; 4394us; 4443us; 4492us; 4541us; 4590us; 4639us; 4688us; 4737us; 4786us; 4835us; 4885us; 4934us; 4982us; 5031us; 5082us; 5131us; 5180us; 5232us; 5284us; 5334us; 5383us; 5432us; 5434us; 5436us; 5438us; 5440us; 5442us; 5444us; 5446us; 5449us; 5451us; 5453us; 5457us; 5463us; 5466us; 5469us; 5472us; 5475us; 5478us; 5481us; 5484us; 5487us; 5490us; 5493us; 5497us; 5499us; 5502us; 5505us; 5508us; 5511us; 5514us; 5517us; 5520us; 5523us; 5526us; 5528us; 5530us; 5532us; 5534us; 5536us; 5538us; 5540us; 5542us; 5544us; 5546us; 5548us; 5550us; 5552us; 5554us; 5556us; 5558us; 5560us; 5562us; 5564us; 5566us; 5568us; 5570us; 5572us; 5574us; 5576us; 5578us; 5581us; 5584us; 5586us; 5588us; 5590us; 5593us; 5595us; 5597us; 5599us; 5601us; 5607us; 5612us; 5615us; 5617us; 5619us; 5621us; 5623us; 5625us; 5627us; 5629us; 5631us; 5633us; 5635us; 5638us; 5641us; 5644us; 5646us; 5648us; 5650us; 5653us; 5656us; 5659us; 5661us; 5663us; 5666us; 5668us; 5670us; 5673us; 5675us; 5678us; 5680us; 5682us; 5685us; 5687us; 5689us; 5692us; 5694us; 5696us; 5699us; 5701us; 5703us; 5706us; 5708us; 5710us; 5713us; 5715us; 5717us; 5720us; 5722us; 5726us; 5734us; 5737us; 5744us; 5747us; 5752us; 5754us; 5758us; 5760us; 5762us; 5764us; 5766us; 5768us; 5770us; 5773us; 5780us; 5786us; 5788us; 5795us; 5797us; 5804us; 5811us; 5818us; 5825us; 5832us; 5839us; 5841us; 5843us; 5845us; 5847us; 5849us; 5852us; 5854us; 5856us; 5858us; 5860us; 5862us; 5864us; 5867us; 5869us; 5871us; 5873us; 5875us; 5877us; 5882us; 5885us; 5887us; 5889us; 5891us; 5893us; 5897us; 5900us; 5902us; 5904us; 5906us; 5908us; 5910us; 5912us; 5919us; 5921us; 5923us; 5925us; 5927us; 5929us; 5931us; 5938us; 5941us; 5943us; 5945us; 5948us; 5950us; 5952us; 5954us; 5956us; 5959us; 5961us; 5963us; 5966us; 5968us; 5970us; 5972us; 5974us; 5976us; 5978us; 5980us; 5982us; 5984us; 5986us; 5988us; 5990us; 5995us; 5998us; 6000us; 6002us; 6004us; 6006us; 6008us; 6013us; 6019us; 6022us; 6024us; 6026us; 6028us; 6030us; 6035us; 6038us; 6040us; 6042us; 6044us; 6046us; 6056us; 6071us; 6085us; 6087us; 6090us; 6092us; 6094us; 6096us; 6099us; 6101us; 6103us; 6105us; 6107us; 6109us; 6111us; 6113us; 6115us; 6117us; 6119us; 6121us; 6123us; 6125us; 6127us; 6130us; 6133us; 6135us; 6137us; 6139us; 6145us; 6148us; 6150us; 6152us; 6154us; 6156us; 6158us; 6160us; 6162us; 6164us; 6166us; 6168us; 6170us; 6174us; 6176us; 6178us; 6180us; 6182us; 6186us; 6188us; 6190us; 6192us; 6195us; 6197us; 6199us; 6201us; 6203us; 6205us; 6207us; 6209us; 6212us; 6214us; 6216us; 6218us; 6220us; 6222us; 6224us; 6226us; 6228us; 6231us; 6233us; 6239us; 6241us; 6243us; 6245us; 6247us; 6249us; 6252us; 6254us; 6256us; 6258us; 6260us; 6263us; 6265us; 6269us; 6272us; 6274us; 6277us; 6279us; 6281us; 6283us; 6286us; 6288us; 6291us; 6293us; 6295us; 6297us; 6300us; 6302us; 6304us; 6306us; 6309us; 6312us; 6315us; 6317us; 6319us; 6323us; 6325us; 6327us; 6333us; 6337us; 6339us; 6341us; 6343us; 6346us; 6348us; 6350us; 6352us; 6354us; 6356us; 6358us; 6360us; 6363us; 6365us; 6367us; 6369us; 6371us; 6373us; 6375us; 6377us; 6379us; 6381us; 6383us; 6385us; 6387us; 6389us; 6394us; 6396us; 6398us; 6400us; 6402us; 6404us; 6406us; 6412us; 6415us; 6417us; 6419us; 6421us; 6423us; 6425us; 6428us; 6431us; 6434us; 6436us; 6438us; 6445us; 6451us; 6456us; 6459us; 6461us; 6463us; 6465us; 6467us; 6469us; 6471us; 6473us; 6475us; 6477us; 6479us; 6481us; 6483us; 6485us; 6487us; 6490us; 6492us; 6495us; 6497us; 6499us; 6501us; 6504us; 6506us; 6508us; 6511us; 6513us; 6515us; 6518us; 6520us; 6522us; 6526us; 6532us; 6534us; 6539us; 6541us; 6543us; 6545us; 6550us; 6556us; 6558us; 6563us; 6565us; 6567us; 6569us; 6574us; 6577us; 6579us; 6581us; 6583us; 6585us; 6592us; 6594us; 6596us; 6598us; 6600us; 6602us; 6604us; 6611us; 6613us; 6615us; 6617us; 6619us; 6623us; 6625us; 6628us; 6631us; 6636us; 6638us; 6640us; 6648us; 6650us; 6652us; 6654us; 6656us; 6661us; 6663us; 6665us; 6667us; 6669us; 6671us; 6673us; 6676us; 6678us; 6680us; 6685us; 6687us; 6691us; 6693us; 6696us; 6698us; 6700us; 6702us; 6704us; 6706us; 6708us; 6712us; 6717us; 6720us; 6722us; 6724us; 6727us; 6729us; 6731us; 6736us; 6738us; 6740us; 6742us; 6746us; 6750us; 6752us; 6754us; 6758us; 6760us; 6762us; 6766us; 6769us; 6775us; 6777us; 6779us; 6785us; 6791us; 6795us; 6798us; 6800us; 6802us; 6804us; 6806us; 6808us; 6810us; 6812us; 6814us; 6816us; 6818us; 6820us; 6822us; 6824us; 6827us; 6832us; 6834us; 6836us; 6838us; 6840us; 6842us; 6844us; 6852us; 6856us; 6860us; 6863us; 6865us; 6867us; 6869us; 6873us; 6875us; 6877us; 6879us; 6881us; 6885us; 6888us; 6890us; 6892us; 6894us; 6897us; 6901us; 6903us; 6905us; 6907us; 6911us; 6913us; 6915us; 6919us; 6921us; 6924us; 6926us; 6928us; 6930us; 6933us; 6935us; 6937us; 6941us; 6945us; 6949us; 6951us; 6953us; 6955us; 6957us; 6959us; 6961us; 6963us; 6966us; 6968us; 6970us; 6972us; 6974us; 6977us; 6979us; 6981us; 6986us; 6988us; 6990us; 6992us; 6994us; 6996us; 7000us; 7004us; 7006us; 7008us; 7010us; 7012us; 7014us; 7016us; 7018us; 7020us; 7022us; 7024us; 7026us; 7028us; 7030us; 7032us; 7034us; 7036us; 7038us; 7040us; 7042us; 7044us; 7046us; 7048us; 7050us; 7052us; 7054us; 7056us; 7058us; 7061us; 7063us; 7065us; 7067us; 7069us; 7071us; 7073us; 7075us; 7077us; 7079us; 7083us; 7085us; 7088us; 7090us; 7092us; 7094us; 7096us; 7098us; 7100us; 7103us; 7105us; 7107us; 7109us; 7112us; 7115us; 7117us; 7119us; 7121us; 7123us; 7125us; 7127us; 7129us; 7131us; 7133us; 7135us; 7137us; 7139us; 7141us; 7143us; 7145us; 7147us; 7149us; 7151us; 7153us; 7155us; 7157us; 7159us; 7161us; 7163us; 7165us; 7167us; 7169us; 7171us; 7173us; 7175us; 7177us; 7180us; 7182us; 7184us; 7186us; 7188us; 7191us; 7193us; 7195us; 7197us; 7199us; 7201us; 7203us; 7205us; 7207us; 7209us; 7211us; 7213us; 7215us; 7217us; 7219us; 7221us; 7223us; 7225us; 7227us; 7229us; 7231us; 7233us; 7235us; 7237us; 7239us; 7241us; 7243us; |]
let _fsyacc_action_rows = 1833
let _fsyacc_actionTableElements = [|16us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 47us; 0us; 49152us; 86us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 216us; 0us; 49152us; 7us; 16542us; 10us; 14us; 21us; 12us; 67us; 13us; 73us; 298us; 84us; 11us; 88us; 38us; 101us; 689us; 0us; 49152us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 49152us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 49152us; 0us; 16389us; 0us; 16390us; 0us; 16391us; 0us; 16392us; 0us; 16393us; 0us; 16394us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16395us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16396us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16397us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 689us; 0us; 16398us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 689us; 0us; 16399us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 689us; 0us; 16400us; 16us; 16401us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 101us; 689us; 108us; 16542us; 121us; 16542us; 137us; 16542us; 149us; 16542us; 161us; 16542us; 0us; 16402us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 78us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 108us; 1803us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 121us; 678us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 137us; 695us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 149us; 1808us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 25us; 16403us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 0us; 16404us; 2us; 16405us; 21us; 37us; 84us; 36us; 0us; 16406us; 0us; 16407us; 0us; 16408us; 1us; 32768us; 190us; 39us; 0us; 16410us; 2us; 16409us; 191us; 1795us; 192us; 1794us; 0us; 16411us; 0us; 16412us; 2us; 32768us; 10us; 44us; 194us; 45us; 0us; 16413us; 1us; 32768us; 10us; 46us; 0us; 16414us; 4us; 16430us; 10us; 48us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 16415us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 17398us; 103us; 1781us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16416us; 77us; 1706us; 1us; 17398us; 103us; 1781us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16417us; 77us; 1706us; 1us; 16418us; 150us; 53us; 0us; 16419us; 1us; 16421us; 150us; 53us; 0us; 16420us; 1us; 17392us; 69us; 1778us; 16us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 0us; 16422us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 8us; 32768us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 108us; 1803us; 109us; 96us; 121us; 678us; 149us; 1808us; 18us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 69us; 1793us; 73us; 298us; 78us; 1792us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 0us; 16423us; 0us; 16424us; 0us; 16425us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 74us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 1us; 17394us; 21us; 1779us; 0us; 16426us; 0us; 16427us; 6us; 16430us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 16428us; 0us; 16429us; 3us; 16430us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 3us; 17377us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 15us; 16434us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 81us; 0us; 16432us; 3us; 32768us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 4us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 194us; 81us; 0us; 16433us; 0us; 16435us; 0us; 16436us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 8us; 32768us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 108us; 1803us; 109us; 96us; 121us; 678us; 149us; 1808us; 2us; 32768us; 69us; 1793us; 78us; 1792us; 5us; 32768us; 22us; 111us; 45us; 1704us; 56us; 1790us; 136us; 1791us; 190us; 1703us; 0us; 16437us; 0us; 16438us; 0us; 16439us; 0us; 16440us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16441us; 77us; 1706us; 1us; 16542us; 73us; 298us; 1us; 17402us; 110us; 1782us; 1us; 17404us; 118us; 1783us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 2us; 16682us; 33us; 1798us; 159us; 17421us; 1us; 32768us; 78us; 103us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16443us; 69us; 106us; 0us; 16442us; 71us; 32768us; 13us; 1089us; 22us; 108us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 25us; 16444us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 28us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 0us; 16445us; 8us; 16542us; 45us; 1704us; 56us; 1790us; 73us; 298us; 88us; 38us; 101us; 94us; 136us; 1791us; 190us; 1703us; 194us; 81us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 0us; 16446us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 1us; 32768us; 142us; 116us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 0us; 16447us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 1us; 32768us; 142us; 120us; 0us; 16448us; 1us; 16542us; 73us; 298us; 0us; 16449us; 1us; 16451us; 131us; 124us; 1us; 16542us; 73us; 298us; 0us; 16450us; 2us; 16491us; 69us; 127us; 87us; 209us; 7us; 16542us; 22us; 130us; 48us; 549us; 55us; 551us; 73us; 298us; 111us; 550us; 136us; 155us; 151us; 141us; 0us; 16452us; 0us; 16453us; 52us; 16471us; 14us; 16542us; 22us; 151us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 46us; 16542us; 47us; 16542us; 48us; 549us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 55us; 551us; 57us; 16542us; 66us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 88us; 16542us; 91us; 16542us; 92us; 16542us; 106us; 16542us; 109us; 16542us; 111us; 550us; 113us; 16542us; 119us; 16542us; 122us; 16542us; 136us; 155us; 147us; 16542us; 151us; 141us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 184us; 16542us; 187us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 1us; 17394us; 21us; 1779us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 1us; 16491us; 87us; 209us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 1us; 16491us; 87us; 209us; 0us; 16454us; 1us; 16491us; 87us; 209us; 0us; 16455us; 0us; 16456us; 0us; 16457us; 1us; 32768us; 120us; 142us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16458us; 0us; 16459us; 16us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 194us; 149us; 3us; 32768us; 10us; 987us; 142us; 147us; 194us; 973us; 0us; 16460us; 0us; 16461us; 1us; 32768us; 142us; 150us; 0us; 16462us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16463us; 0us; 16464us; 15us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 3us; 32768us; 10us; 987us; 142us; 157us; 194us; 973us; 0us; 16465us; 0us; 16466us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16467us; 0us; 16468us; 0us; 16469us; 0us; 16470us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 0us; 16472us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 10us; 32768us; 14us; 553us; 46us; 187us; 47us; 333us; 49us; 205us; 50us; 334us; 51us; 335us; 53us; 183us; 109us; 185us; 111us; 552us; 119us; 192us; 44us; 32768us; 14us; 553us; 45us; 1704us; 46us; 187us; 47us; 333us; 49us; 205us; 50us; 334us; 51us; 335us; 53us; 183us; 55us; 537us; 57us; 624us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 528us; 106us; 1645us; 109us; 185us; 111us; 552us; 113us; 1643us; 119us; 192us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17402us; 110us; 1782us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 2us; 16682us; 33us; 1798us; 159us; 17421us; 1us; 32768us; 78us; 177us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 16480us; 26us; 197us; 87us; 195us; 1us; 16443us; 69us; 106us; 0us; 16473us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 16474us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 16475us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 1us; 17404us; 118us; 1783us; 0us; 16476us; 5us; 32768us; 36us; 1799us; 37us; 1802us; 47us; 332us; 108us; 1803us; 109us; 188us; 1us; 17404us; 118us; 1783us; 0us; 16477us; 1us; 16542us; 73us; 298us; 0us; 16478us; 1us; 32768us; 78us; 193us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16479us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 16481us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 2us; 32768us; 20us; 199us; 194us; 200us; 0us; 16482us; 0us; 16483us; 1us; 16484us; 97us; 202us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 16485us; 0us; 16486us; 1us; 16487us; 47us; 206us; 0us; 16488us; 1us; 16491us; 87us; 209us; 0us; 16489us; 15us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 3us; 32768us; 19us; 1771us; 20us; 1772us; 142us; 1773us; 0us; 16490us; 2us; 32768us; 10us; 213us; 194us; 214us; 0us; 16492us; 1us; 32768us; 10us; 215us; 0us; 16493us; 4us; 32768us; 10us; 217us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 16494us; 1us; 16495us; 150us; 53us; 0us; 16496us; 1us; 16498us; 150us; 53us; 0us; 16497us; 1us; 17392us; 69us; 1778us; 86us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16499us; 4us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 194us; 245us; 78us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 108us; 1803us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 121us; 678us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 137us; 695us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 149us; 1808us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 87us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 69us; 269us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16500us; 0us; 16501us; 85us; 16507us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 235us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 1us; 17394us; 21us; 1779us; 0us; 16502us; 0us; 16503us; 6us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 16504us; 0us; 16505us; 0us; 16506us; 4us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 194us; 245us; 78us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 108us; 1803us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 121us; 678us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 137us; 695us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 149us; 1808us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 28us; 16510us; 21us; 1762us; 62us; 1158us; 63us; 1150us; 67us; 1761us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 84us; 1760us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 85us; 16509us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16508us; 0us; 16511us; 0us; 16512us; 21us; 16515us; 21us; 1762us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 67us; 1761us; 73us; 298us; 84us; 1760us; 88us; 38us; 101us; 689us; 108us; 16542us; 121us; 16542us; 137us; 16542us; 149us; 16542us; 161us; 16542us; 194us; 250us; 0us; 16513us; 85us; 16516us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16514us; 3us; 32768us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 6us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 4us; 32768us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 142us; 291us; 4us; 16542us; 73us; 298us; 88us; 38us; 101us; 689us; 194us; 250us; 0us; 16517us; 0us; 16518us; 0us; 16519us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 11us; 32768us; 32us; 697us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 40us; 710us; 108us; 1803us; 121us; 678us; 137us; 695us; 149us; 1808us; 161us; 691us; 0us; 16520us; 1us; 16520us; 127us; 989us; 0us; 16521us; 71us; 16521us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 994us; 0us; 16522us; 1us; 16542us; 73us; 298us; 1us; 16564us; 131us; 339us; 0us; 16523us; 0us; 16524us; 1us; 32768us; 69us; 269us; 5us; 32768us; 22us; 277us; 45us; 1704us; 55us; 1788us; 136us; 1789us; 190us; 1703us; 0us; 16525us; 2us; 16541us; 10us; 987us; 194us; 973us; 0us; 16526us; 0us; 16527us; 4us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 77us; 1706us; 0us; 16528us; 1us; 16529us; 77us; 1706us; 6us; 16542us; 55us; 1788us; 73us; 298us; 88us; 38us; 101us; 689us; 136us; 1789us; 194us; 251us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16530us; 0us; 16531us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16532us; 0us; 16533us; 0us; 16534us; 0us; 16535us; 1us; 16536us; 77us; 1706us; 85us; 16507us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 689us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 252us; 3us; 32768us; 10us; 987us; 142us; 289us; 194us; 973us; 0us; 16537us; 0us; 16538us; 0us; 16539us; 6us; 16542us; 19us; 16586us; 20us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 385us; 3us; 32768us; 19us; 1771us; 20us; 1772us; 142us; 1773us; 0us; 16540us; 0us; 16541us; 1us; 16543us; 73us; 298us; 0us; 16544us; 14us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1800us; 37us; 1802us; 38us; 1805us; 39us; 1807us; 45us; 1704us; 60us; 1829us; 94us; 1830us; 108us; 1803us; 149us; 1808us; 162us; 329us; 190us; 1703us; 194us; 303us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 8us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 54us; 301us; 60us; 1829us; 94us; 1830us; 194us; 973us; 1us; 17394us; 21us; 1779us; 0us; 16545us; 1us; 16902us; 54us; 304us; 1us; 17394us; 21us; 1779us; 0us; 16546us; 0us; 16547us; 0us; 16548us; 0us; 16549us; 9us; 17395us; 36us; 1799us; 37us; 1802us; 38us; 1804us; 39us; 1807us; 45us; 1704us; 108us; 1803us; 149us; 1808us; 162us; 329us; 190us; 1703us; 0us; 16550us; 3us; 17419us; 34us; 1797us; 35us; 1796us; 77us; 1706us; 28us; 17156us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16551us; 3us; 32768us; 22us; 318us; 45us; 1704us; 190us; 1703us; 3us; 17419us; 34us; 1797us; 35us; 1796us; 77us; 1706us; 28us; 17156us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16552us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 4us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 77us; 1706us; 2us; 17419us; 34us; 1797us; 35us; 1796us; 28us; 17156us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16553us; 1us; 32768us; 78us; 324us; 0us; 16554us; 1us; 32768us; 78us; 326us; 0us; 16555us; 1us; 17327us; 78us; 328us; 0us; 16556us; 1us; 32768us; 78us; 330us; 0us; 16557us; 10us; 32768us; 30us; 701us; 32us; 697us; 36us; 1799us; 37us; 1802us; 40us; 710us; 47us; 332us; 108us; 1803us; 109us; 448us; 137us; 695us; 161us; 691us; 0us; 16558us; 0us; 16559us; 0us; 16560us; 0us; 16561us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 16685us; 85us; 583us; 0us; 16562us; 1us; 16542us; 73us; 298us; 1us; 16564us; 131us; 339us; 0us; 16563us; 40us; 16542us; 10us; 16565us; 14us; 16565us; 15us; 16565us; 16us; 16565us; 17us; 16565us; 19us; 16565us; 20us; 16565us; 21us; 16565us; 30us; 16565us; 32us; 16565us; 36us; 16565us; 37us; 16565us; 38us; 16565us; 39us; 16565us; 40us; 16565us; 46us; 16565us; 47us; 16565us; 49us; 16565us; 50us; 16565us; 51us; 16565us; 53us; 16565us; 67us; 16565us; 69us; 343us; 73us; 298us; 84us; 16565us; 87us; 292us; 88us; 16565us; 101us; 16565us; 108us; 16565us; 109us; 16565us; 111us; 16565us; 119us; 16565us; 121us; 16565us; 131us; 16565us; 137us; 16565us; 142us; 16565us; 149us; 16565us; 150us; 16565us; 161us; 16565us; 194us; 16565us; 6us; 16542us; 22us; 353us; 48us; 549us; 55us; 551us; 73us; 298us; 111us; 550us; 151us; 365us; 0us; 16566us; 0us; 16567us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 2us; 17419us; 34us; 1797us; 35us; 1796us; 1us; 32768us; 92us; 819us; 1us; 16632us; 132us; 492us; 1us; 32768us; 69us; 351us; 6us; 16542us; 22us; 353us; 48us; 549us; 55us; 551us; 73us; 298us; 111us; 550us; 151us; 365us; 0us; 16568us; 11us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 22us; 375us; 48us; 549us; 55us; 551us; 73us; 298us; 111us; 550us; 151us; 365us; 194us; 385us; 1us; 17394us; 21us; 1779us; 7us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 87us; 16586us; 194us; 385us; 1us; 16627us; 87us; 481us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 1us; 16627us; 87us; 481us; 0us; 16569us; 0us; 16570us; 1us; 16627us; 87us; 481us; 0us; 16571us; 0us; 16572us; 0us; 16573us; 1us; 32768us; 120us; 366us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16574us; 0us; 16575us; 5us; 16542us; 10us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 373us; 3us; 32768us; 10us; 987us; 142us; 371us; 194us; 973us; 0us; 16576us; 0us; 16577us; 4us; 16542us; 10us; 16586us; 73us; 298us; 142us; 374us; 194us; 385us; 0us; 16578us; 6us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 194us; 385us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16579us; 0us; 16580us; 6us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 194us; 385us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16581us; 0us; 16582us; 0us; 16583us; 0us; 16584us; 10us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 19us; 16586us; 20us; 16586us; 73us; 298us; 87us; 16586us; 142us; 16586us; 194us; 385us; 0us; 16585us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 10us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 19us; 16586us; 20us; 16586us; 73us; 298us; 87us; 16586us; 142us; 16586us; 194us; 385us; 0us; 16587us; 1us; 17402us; 110us; 1782us; 0us; 16588us; 1us; 17402us; 110us; 1782us; 2us; 32768us; 20us; 394us; 194us; 395us; 0us; 16589us; 0us; 16590us; 1us; 16591us; 131us; 397us; 1us; 17402us; 110us; 1782us; 0us; 16592us; 1us; 16542us; 73us; 298us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17224us; 78us; 1532us; 1us; 32768us; 69us; 403us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16593us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17224us; 78us; 1532us; 3us; 32768us; 26us; 392us; 69us; 408us; 87us; 390us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16594us; 0us; 16595us; 1us; 16596us; 47us; 412us; 0us; 16597us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 15us; 32768us; 14us; 553us; 30us; 701us; 32us; 697us; 40us; 710us; 46us; 331us; 47us; 333us; 49us; 411us; 50us; 334us; 51us; 335us; 53us; 484us; 109us; 448us; 111us; 552us; 119us; 440us; 137us; 695us; 161us; 691us; 49us; 32768us; 14us; 553us; 30us; 701us; 32us; 697us; 40us; 710us; 45us; 1704us; 46us; 331us; 47us; 333us; 49us; 411us; 50us; 334us; 51us; 335us; 53us; 484us; 55us; 537us; 57us; 624us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 528us; 106us; 1645us; 109us; 448us; 111us; 552us; 113us; 1643us; 119us; 440us; 122us; 1644us; 137us; 695us; 147us; 1642us; 161us; 691us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16598us; 0us; 16599us; 2us; 17402us; 109us; 454us; 110us; 1782us; 1us; 17390us; 19us; 1777us; 0us; 16600us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 7us; 16625us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 87us; 478us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 0us; 16601us; 1us; 17402us; 110us; 1782us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 2us; 16682us; 33us; 1798us; 159us; 17421us; 1us; 32768us; 78us; 429us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 16480us; 26us; 197us; 87us; 195us; 1us; 17390us; 19us; 1777us; 0us; 16602us; 0us; 16603us; 1us; 17390us; 19us; 1777us; 0us; 16604us; 1us; 17390us; 19us; 1777us; 0us; 16605us; 1us; 17390us; 19us; 1777us; 0us; 16606us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16632us; 132us; 492us; 1us; 32768us; 69us; 443us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17390us; 19us; 1777us; 0us; 16607us; 1us; 16542us; 73us; 298us; 0us; 16608us; 1us; 17404us; 118us; 1783us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 32768us; 190us; 1703us; 1us; 32768us; 78us; 452us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16609us; 1us; 17404us; 118us; 1783us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 32768us; 190us; 1703us; 1us; 16611us; 78us; 462us; 1us; 32768us; 69us; 459us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 16480us; 26us; 197us; 87us; 195us; 0us; 16610us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16612us; 1us; 16851us; 77us; 465us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 16613us; 1us; 32768us; 77us; 468us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 16614us; 0us; 16615us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 16616us; 0us; 16618us; 0us; 16619us; 0us; 16620us; 0us; 16621us; 0us; 16622us; 2us; 16542us; 22us; 498us; 73us; 298us; 3us; 32768us; 19us; 1771us; 20us; 1772us; 142us; 1773us; 0us; 16624us; 6us; 16542us; 19us; 16586us; 20us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 385us; 3us; 32768us; 19us; 1771us; 20us; 1772us; 142us; 1773us; 0us; 16626us; 37us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 45us; 1704us; 55us; 1632us; 60us; 1829us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1616us; 94us; 1830us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 31us; 16635us; 34us; 1797us; 35us; 1796us; 55us; 17419us; 71us; 17419us; 72us; 17419us; 74us; 17419us; 92us; 17419us; 106us; 17419us; 122us; 17419us; 132us; 495us; 136us; 17419us; 147us; 17419us; 154us; 17419us; 164us; 17419us; 165us; 17419us; 166us; 17419us; 167us; 17419us; 168us; 17419us; 169us; 17419us; 170us; 17419us; 171us; 17419us; 172us; 17419us; 173us; 17419us; 174us; 17419us; 175us; 17419us; 176us; 17419us; 178us; 17419us; 179us; 17419us; 191us; 17419us; 192us; 17419us; 193us; 17419us; 0us; 16628us; 28us; 32768us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16635us; 132us; 495us; 0us; 16629us; 0us; 16630us; 0us; 16631us; 1us; 32768us; 190us; 1703us; 0us; 16633us; 0us; 16634us; 2us; 32768us; 153us; 497us; 190us; 1703us; 0us; 16636us; 0us; 16637us; 1us; 16542us; 73us; 298us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16638us; 0us; 16639us; 0us; 16640us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 14us; 16542us; 10us; 16642us; 14us; 16642us; 15us; 16642us; 16us; 16642us; 17us; 16642us; 19us; 16642us; 20us; 16642us; 21us; 16642us; 59us; 16642us; 60us; 16642us; 61us; 16642us; 73us; 298us; 111us; 16642us; 142us; 16642us; 0us; 16641us; 3us; 32768us; 47us; 517us; 50us; 518us; 194us; 514us; 4us; 17402us; 47us; 517us; 50us; 518us; 110us; 1782us; 194us; 514us; 3us; 17402us; 109us; 454us; 110us; 1782us; 194us; 513us; 1us; 17390us; 19us; 1777us; 0us; 16643us; 1us; 17390us; 19us; 1777us; 0us; 16644us; 0us; 16645us; 1us; 17402us; 110us; 1782us; 1us; 17390us; 19us; 1777us; 0us; 16646us; 0us; 16647us; 0us; 16648us; 3us; 16623us; 42us; 475us; 43us; 474us; 44us; 476us; 34us; 32768us; 45us; 1704us; 55us; 537us; 57us; 624us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 528us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 17248us; 77us; 1706us; 154us; 522us; 1us; 32768us; 192us; 523us; 2us; 32768us; 10us; 987us; 194us; 973us; 0us; 16649us; 0us; 16650us; 0us; 16651us; 0us; 16652us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 546us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1646us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16653us; 2us; 16542us; 73us; 298us; 194us; 535us; 5us; 32768us; 10us; 987us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 194us; 973us; 0us; 16654us; 0us; 16655us; 3us; 32768us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 0us; 16656us; 2us; 32768us; 72us; 540us; 92us; 1633us; 0us; 16657us; 0us; 16658us; 2us; 16542us; 73us; 298us; 194us; 544us; 3us; 32768us; 10us; 987us; 65us; 1813us; 194us; 973us; 0us; 16659us; 0us; 16660us; 1us; 32768us; 65us; 1813us; 0us; 16661us; 30us; 32768us; 45us; 1704us; 55us; 1632us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1627us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16797us; 88us; 548us; 0us; 16662us; 0us; 16663us; 0us; 16664us; 0us; 16665us; 0us; 16666us; 0us; 16667us; 5us; 32768us; 45us; 1704us; 91us; 1697us; 92us; 560us; 187us; 1700us; 190us; 1703us; 3us; 16668us; 33us; 1798us; 77us; 1706us; 159us; 17421us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16669us; 77us; 1706us; 0us; 16670us; 0us; 16671us; 1us; 16542us; 73us; 298us; 4us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 97us; 565us; 0us; 16672us; 2us; 16685us; 85us; 583us; 97us; 565us; 1us; 16678us; 97us; 566us; 1us; 16542us; 73us; 298us; 2us; 16542us; 73us; 298us; 143us; 575us; 0us; 16673us; 0us; 16674us; 2us; 32768us; 91us; 1697us; 187us; 1700us; 0us; 16675us; 1us; 32768us; 159us; 572us; 1us; 16542us; 73us; 298us; 1us; 32768us; 160us; 574us; 0us; 16676us; 0us; 16677us; 1us; 32768us; 159us; 577us; 3us; 16542us; 73us; 298us; 85us; 16679us; 160us; 16679us; 1us; 16685us; 85us; 583us; 1us; 32768us; 160us; 580us; 0us; 16680us; 0us; 16681us; 27us; 16683us; 10us; 16834us; 16us; 16834us; 21us; 16834us; 26us; 16834us; 36us; 16834us; 38us; 16834us; 57us; 16834us; 58us; 16834us; 59us; 16834us; 60us; 16834us; 61us; 16834us; 64us; 16834us; 69us; 16834us; 78us; 16834us; 79us; 16834us; 84us; 16834us; 85us; 16834us; 87us; 16834us; 89us; 16834us; 93us; 16834us; 94us; 16834us; 95us; 16834us; 97us; 16834us; 98us; 16834us; 127us; 16834us; 132us; 16834us; 194us; 16834us; 4us; 32768us; 51us; 590us; 91us; 1697us; 92us; 605us; 187us; 1700us; 1us; 16686us; 131us; 587us; 1us; 17221us; 131us; 587us; 1us; 17223us; 131us; 587us; 4us; 32768us; 51us; 590us; 91us; 1697us; 92us; 605us; 187us; 1700us; 0us; 16687us; 0us; 16688us; 2us; 32768us; 91us; 1697us; 187us; 1700us; 1us; 32768us; 78us; 592us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16689us; 2us; 32768us; 78us; 597us; 80us; 595us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16690us; 5us; 32768us; 55us; 598us; 92us; 602us; 147us; 601us; 151us; 612us; 190us; 599us; 0us; 16691us; 3us; 16698us; 33us; 1655us; 55us; 600us; 159us; 1657us; 0us; 16692us; 0us; 16693us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16694us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 4us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 102us; 615us; 1us; 32768us; 78us; 608us; 1us; 32768us; 92us; 609us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16695us; 2us; 32768us; 33us; 1655us; 159us; 1657us; 0us; 16696us; 0us; 16697us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 16699us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 6us; 16700us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 1us; 16542us; 73us; 298us; 0us; 16701us; 1us; 32768us; 57us; 624us; 1us; 16542us; 73us; 298us; 0us; 16702us; 2us; 16703us; 21us; 1779us; 57us; 17394us; 0us; 16704us; 1us; 16706us; 57us; 624us; 1us; 16542us; 73us; 298us; 0us; 16705us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 3us; 32768us; 92us; 642us; 100us; 1714us; 190us; 1703us; 4us; 17394us; 21us; 1779us; 69us; 638us; 78us; 635us; 120us; 632us; 0us; 16707us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17394us; 21us; 1779us; 0us; 16708us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17394us; 21us; 1779us; 0us; 16709us; 18us; 32768us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17394us; 21us; 1779us; 0us; 16710us; 0us; 16711us; 29us; 32768us; 57us; 1749us; 62us; 1731us; 63us; 1729us; 69us; 1733us; 70us; 645us; 75us; 1737us; 79us; 643us; 83us; 1741us; 89us; 1738us; 90us; 1739us; 96us; 1732us; 102us; 1734us; 143us; 1744us; 144us; 1740us; 154us; 1746us; 157us; 1743us; 159us; 1735us; 160us; 1736us; 180us; 1742us; 181us; 1730us; 182us; 1727us; 183us; 1726us; 184us; 1728us; 185us; 1721us; 186us; 1725us; 187us; 1724us; 188us; 1723us; 189us; 1722us; 194us; 1712us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16712us; 1us; 32768us; 58us; 646us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16713us; 4us; 17327us; 21us; 1779us; 57us; 17394us; 69us; 650us; 120us; 654us; 0us; 16714us; 18us; 32768us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17394us; 21us; 1779us; 45us; 16715us; 10us; 16718us; 14us; 16718us; 15us; 16718us; 16us; 16718us; 17us; 16718us; 19us; 16718us; 20us; 16718us; 21us; 16718us; 30us; 16718us; 32us; 16718us; 36us; 16718us; 37us; 16718us; 38us; 16718us; 39us; 16718us; 40us; 16718us; 42us; 16718us; 43us; 16718us; 44us; 16718us; 46us; 16718us; 47us; 16718us; 49us; 16718us; 50us; 16718us; 51us; 16718us; 53us; 16718us; 67us; 16718us; 73us; 16718us; 84us; 16718us; 87us; 16718us; 88us; 16718us; 93us; 16718us; 94us; 16718us; 95us; 16718us; 101us; 16718us; 108us; 16718us; 109us; 16718us; 111us; 16718us; 119us; 16718us; 121us; 16718us; 131us; 16718us; 137us; 16718us; 142us; 16718us; 149us; 16718us; 150us; 16718us; 161us; 16718us; 194us; 16718us; 0us; 16716us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16717us; 1us; 16720us; 96us; 657us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16719us; 1us; 17327us; 78us; 660us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 16721us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 6us; 16722us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 0us; 16723us; 0us; 16724us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 7us; 16542us; 10us; 17395us; 59us; 17395us; 60us; 17395us; 61us; 17395us; 65us; 17395us; 73us; 298us; 194us; 17395us; 0us; 16725us; 0us; 16726us; 1us; 17404us; 118us; 1783us; 0us; 16727us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 32768us; 190us; 1703us; 1us; 32768us; 78us; 674us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16728us; 1us; 16627us; 87us; 481us; 0us; 16729us; 0us; 16730us; 1us; 16542us; 73us; 298us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 32768us; 190us; 1703us; 1us; 16734us; 69us; 687us; 0us; 16731us; 1us; 16732us; 120us; 685us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 74us; 531us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16733us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16735us; 77us; 1706us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 1us; 16736us; 77us; 1706us; 1us; 17398us; 103us; 1781us; 2us; 16542us; 73us; 298us; 194us; 745us; 0us; 16737us; 0us; 16738us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16739us; 1us; 17398us; 103us; 1781us; 2us; 16542us; 73us; 298us; 194us; 745us; 3us; 32768us; 10us; 987us; 19us; 708us; 194us; 973us; 0us; 16740us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 10us; 987us; 19us; 708us; 194us; 973us; 0us; 16741us; 0us; 16742us; 0us; 16743us; 0us; 16744us; 0us; 16745us; 0us; 16746us; 0us; 16747us; 1us; 16542us; 73us; 298us; 3us; 16617us; 42us; 475us; 43us; 474us; 44us; 476us; 1us; 32768us; 190us; 1703us; 2us; 17419us; 34us; 1797us; 35us; 1796us; 1us; 32768us; 92us; 715us; 4us; 16542us; 73us; 298us; 93us; 16751us; 94us; 16751us; 95us; 16751us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16748us; 1us; 16749us; 97us; 720us; 1us; 16750us; 97us; 722us; 1us; 16542us; 73us; 298us; 0us; 16752us; 1us; 16542us; 73us; 298us; 0us; 16753us; 3us; 32768us; 41us; 734us; 45us; 1704us; 190us; 1703us; 6us; 16754us; 34us; 1797us; 35us; 1796us; 70us; 17419us; 89us; 733us; 96us; 732us; 190us; 1703us; 0us; 16755us; 1us; 16756us; 77us; 1706us; 5us; 16761us; 34us; 1797us; 35us; 1796us; 70us; 17419us; 89us; 733us; 96us; 732us; 1us; 32768us; 70us; 730us; 1us; 32768us; 58us; 731us; 0us; 16757us; 0us; 16758us; 0us; 16759us; 1us; 32768us; 96us; 736us; 1us; 16762us; 96us; 736us; 0us; 16760us; 3us; 32768us; 41us; 735us; 45us; 1704us; 190us; 1703us; 1us; 16765us; 131us; 740us; 0us; 16763us; 2us; 16542us; 73us; 298us; 194us; 745us; 1us; 16765us; 131us; 740us; 0us; 16764us; 1us; 17402us; 110us; 1782us; 0us; 16766us; 0us; 16767us; 1us; 17404us; 118us; 1783us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17224us; 78us; 1532us; 3us; 32768us; 10us; 987us; 69us; 750us; 194us; 973us; 72us; 32768us; 13us; 1089us; 22us; 754us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 752us; 0us; 16768us; 0us; 16769us; 0us; 16770us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16771us; 0us; 16772us; 0us; 16773us; 0us; 16776us; 1us; 16774us; 85us; 762us; 0us; 16775us; 2us; 32768us; 91us; 1697us; 187us; 1700us; 2us; 32768us; 69us; 764us; 131us; 766us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16777us; 2us; 32768us; 91us; 1697us; 187us; 1700us; 0us; 16778us; 0us; 16779us; 2us; 32768us; 55us; 772us; 78us; 770us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16780us; 0us; 16781us; 0us; 16782us; 0us; 16783us; 0us; 16784us; 0us; 16785us; 0us; 16786us; 0us; 16787us; 0us; 16788us; 0us; 16789us; 0us; 16790us; 0us; 16791us; 0us; 16792us; 0us; 16793us; 0us; 16794us; 1us; 16794us; 143us; 875us; 0us; 16795us; 0us; 16796us; 0us; 16797us; 0us; 16798us; 1us; 16801us; 184us; 792us; 1us; 32768us; 176us; 793us; 0us; 16799us; 1us; 32768us; 176us; 795us; 1us; 16802us; 184us; 796us; 1us; 32768us; 176us; 797us; 0us; 16800us; 0us; 16803us; 2us; 32768us; 62us; 794us; 176us; 791us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16804us; 0us; 16805us; 2us; 32768us; 92us; 799us; 176us; 798us; 0us; 16806us; 1us; 16807us; 33us; 806us; 1us; 32768us; 159us; 1674us; 0us; 16808us; 5us; 16809us; 57us; 837us; 79us; 838us; 89us; 845us; 97us; 843us; 132us; 835us; 0us; 16810us; 1us; 32768us; 190us; 1703us; 0us; 16811us; 1us; 16813us; 78us; 814us; 2us; 16814us; 78us; 814us; 97us; 817us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16812us; 3us; 32768us; 73us; 298us; 75us; 810us; 190us; 1703us; 3us; 32768us; 73us; 298us; 75us; 810us; 190us; 1703us; 0us; 16815us; 8us; 32768us; 10us; 987us; 73us; 298us; 75us; 810us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 190us; 1703us; 194us; 824us; 5us; 32768us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 0us; 16816us; 0us; 16817us; 0us; 16818us; 3us; 16902us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16819us; 0us; 16820us; 3us; 16822us; 79us; 838us; 89us; 845us; 97us; 843us; 1us; 16823us; 79us; 838us; 2us; 16827us; 79us; 838us; 89us; 845us; 2us; 16828us; 79us; 838us; 89us; 845us; 1us; 16829us; 79us; 838us; 1us; 16830us; 79us; 838us; 6us; 32768us; 57us; 837us; 69us; 1067us; 79us; 838us; 89us; 845us; 97us; 843us; 132us; 835us; 6us; 32768us; 57us; 837us; 69us; 1073us; 79us; 838us; 89us; 845us; 97us; 843us; 132us; 835us; 1us; 32768us; 190us; 1703us; 0us; 16821us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16824us; 97us; 842us; 0us; 16825us; 0us; 16826us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 0us; 16831us; 1us; 17395us; 190us; 1703us; 0us; 16832us; 1us; 32768us; 69us; 852us; 2us; 17366us; 69us; 852us; 77us; 1756us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 16833us; 57us; 924us; 78us; 927us; 79us; 930us; 89us; 935us; 97us; 933us; 132us; 922us; 29us; 16684us; 10us; 16853us; 16us; 16853us; 21us; 16853us; 26us; 16853us; 33us; 1798us; 36us; 16853us; 38us; 16853us; 57us; 16853us; 58us; 16853us; 59us; 16853us; 60us; 16853us; 61us; 16853us; 64us; 16853us; 69us; 16853us; 78us; 16853us; 79us; 16853us; 84us; 16853us; 85us; 16853us; 87us; 16853us; 89us; 16853us; 93us; 16853us; 94us; 16853us; 95us; 16853us; 97us; 16853us; 98us; 16853us; 127us; 16853us; 132us; 16853us; 159us; 17421us; 194us; 16853us; 37us; 32768us; 34us; 857us; 35us; 859us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 864us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16835us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 864us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16836us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 864us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16837us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1626us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1627us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16838us; 0us; 16839us; 63us; 16867us; 10us; 987us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1749us; 62us; 1731us; 63us; 1729us; 66us; 464us; 69us; 1733us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 887us; 82us; 861us; 83us; 1741us; 89us; 1738us; 90us; 1739us; 92us; 894us; 96us; 1732us; 100us; 1714us; 102us; 1734us; 106us; 892us; 122us; 891us; 143us; 1744us; 144us; 1740us; 147us; 893us; 154us; 1345us; 157us; 1743us; 159us; 1735us; 160us; 1736us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 180us; 1742us; 181us; 1730us; 182us; 1727us; 183us; 1726us; 184us; 1728us; 185us; 1721us; 186us; 1725us; 187us; 1724us; 188us; 1723us; 189us; 1722us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 898us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16840us; 0us; 16841us; 37us; 16845us; 34us; 872us; 35us; 870us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16842us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16843us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16844us; 0us; 16846us; 1us; 32768us; 166us; 876us; 0us; 16847us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 3us; 32768us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 0us; 16848us; 37us; 16883us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 58us; 882us; 0us; 16849us; 37us; 16883us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 64us; 885us; 0us; 16850us; 1us; 32768us; 190us; 1703us; 1us; 17351us; 190us; 1703us; 0us; 16852us; 0us; 16853us; 0us; 16854us; 0us; 16855us; 0us; 16856us; 0us; 16857us; 63us; 16867us; 10us; 987us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1749us; 62us; 1731us; 63us; 1729us; 66us; 464us; 69us; 1733us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 887us; 82us; 861us; 83us; 1741us; 89us; 1738us; 90us; 1739us; 92us; 894us; 96us; 1732us; 100us; 1714us; 102us; 1734us; 106us; 892us; 122us; 891us; 143us; 1744us; 144us; 1740us; 147us; 893us; 154us; 1345us; 157us; 1743us; 159us; 1735us; 160us; 1736us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 180us; 1742us; 181us; 1730us; 182us; 1727us; 183us; 1726us; 184us; 1728us; 185us; 1721us; 186us; 1725us; 187us; 1724us; 188us; 1723us; 189us; 1722us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 898us; 5us; 32768us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 0us; 16858us; 0us; 16859us; 3us; 16902us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 2us; 16860us; 33us; 17331us; 159us; 17331us; 0us; 16861us; 1us; 32768us; 92us; 902us; 39us; 32768us; 10us; 987us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 906us; 6us; 16870us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 97us; 932us; 194us; 973us; 0us; 16862us; 0us; 16863us; 3us; 16902us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 16864us; 0us; 16865us; 6us; 16866us; 57us; 924us; 78us; 927us; 79us; 930us; 89us; 935us; 97us; 933us; 132us; 922us; 4us; 16869us; 78us; 927us; 79us; 930us; 89us; 935us; 97us; 933us; 3us; 16873us; 78us; 927us; 79us; 930us; 89us; 935us; 2us; 16874us; 78us; 927us; 79us; 930us; 3us; 16876us; 78us; 927us; 79us; 930us; 89us; 935us; 3us; 16877us; 78us; 927us; 79us; 930us; 89us; 935us; 2us; 16878us; 78us; 927us; 79us; 930us; 6us; 32768us; 57us; 924us; 78us; 927us; 79us; 930us; 89us; 935us; 97us; 933us; 132us; 922us; 2us; 16879us; 78us; 927us; 79us; 930us; 6us; 16882us; 57us; 924us; 78us; 927us; 79us; 930us; 89us; 935us; 97us; 933us; 132us; 922us; 8us; 17396us; 21us; 1767us; 57us; 924us; 78us; 927us; 79us; 930us; 84us; 1768us; 89us; 935us; 97us; 933us; 132us; 922us; 15us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 57us; 924us; 60us; 1829us; 69us; 1407us; 78us; 927us; 79us; 930us; 89us; 935us; 94us; 1830us; 97us; 933us; 127us; 1403us; 132us; 922us; 194us; 978us; 7us; 17023us; 57us; 924us; 78us; 927us; 79us; 930us; 85us; 1205us; 89us; 935us; 97us; 933us; 132us; 922us; 1us; 32768us; 190us; 1703us; 0us; 16868us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 16870us; 97us; 932us; 1us; 16871us; 89us; 934us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16872us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16875us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 17396us; 21us; 1767us; 84us; 1768us; 0us; 16880us; 2us; 17395us; 45us; 1704us; 190us; 1703us; 0us; 16881us; 2us; 32768us; 69us; 941us; 77us; 1706us; 37us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16884us; 37us; 16883us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16885us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 16886us; 0us; 16887us; 0us; 16888us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 0us; 16889us; 25us; 16890us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 1us; 16892us; 18us; 955us; 0us; 16891us; 1us; 16894us; 78us; 957us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16893us; 1us; 32768us; 10us; 960us; 0us; 16895us; 29us; 16898us; 21us; 1767us; 28us; 968us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 84us; 1768us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 104us; 966us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 30us; 16898us; 21us; 1767us; 28us; 968us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 84us; 1768us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 17090us; 102us; 1144us; 104us; 966us; 128us; 1141us; 143us; 1324us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 30us; 16898us; 21us; 1767us; 28us; 968us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 84us; 1768us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 104us; 966us; 128us; 1141us; 143us; 1398us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 70us; 16897us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16896us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16899us; 1us; 32768us; 22us; 969us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 0us; 16900us; 73us; 16901us; 13us; 1089us; 21us; 995us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 994us; 0us; 16902us; 2us; 16902us; 19us; 1787us; 138us; 1786us; 2us; 16902us; 19us; 1787us; 138us; 1786us; 2us; 16902us; 19us; 1787us; 138us; 1786us; 2us; 16902us; 30us; 1785us; 137us; 1784us; 2us; 16902us; 19us; 1787us; 138us; 1786us; 1us; 16902us; 58us; 1295us; 1us; 16902us; 58us; 1319us; 1us; 16902us; 155us; 1349us; 1us; 16902us; 64us; 1355us; 3us; 16902us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 3us; 16902us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 3us; 16902us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 1us; 16902us; 65us; 1813us; 0us; 16903us; 1us; 32768us; 127us; 989us; 71us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 991us; 0us; 16904us; 0us; 16905us; 73us; 32768us; 13us; 1089us; 21us; 995us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 994us; 0us; 16906us; 0us; 16907us; 72us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 997us; 0us; 16908us; 0us; 16909us; 0us; 16910us; 0us; 16911us; 0us; 16912us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 4us; 32768us; 10us; 987us; 26us; 1188us; 87us; 1186us; 194us; 973us; 0us; 16913us; 0us; 16914us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 4us; 32768us; 10us; 987us; 26us; 1188us; 87us; 1186us; 194us; 973us; 0us; 16915us; 0us; 16916us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 32768us; 10us; 987us; 26us; 1188us; 87us; 1186us; 129us; 1013us; 194us; 973us; 0us; 16917us; 0us; 16918us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16919us; 72us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 29us; 32768us; 10us; 987us; 28us; 1211us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 104us; 1210us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 194us; 973us; 0us; 16920us; 0us; 16921us; 0us; 16922us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16923us; 62us; 16925us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 158us; 1066us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16924us; 71us; 32768us; 13us; 1089us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16926us; 63us; 16928us; 13us; 1089us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 158us; 1066us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16927us; 72us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 974us; 29us; 32768us; 10us; 987us; 30us; 1785us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 137us; 1784us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 194us; 973us; 72us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1034us; 4us; 32768us; 10us; 987us; 19us; 1787us; 138us; 1786us; 194us; 973us; 0us; 16929us; 0us; 16930us; 2us; 32768us; 19us; 1787us; 138us; 1786us; 0us; 16931us; 0us; 16932us; 0us; 16933us; 0us; 16934us; 44us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 60us; 1829us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 94us; 1830us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 977us; 10us; 17394us; 10us; 987us; 16us; 1831us; 21us; 1779us; 30us; 1785us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 94us; 1830us; 137us; 1784us; 194us; 973us; 78us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1831us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1827us; 38us; 1828us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1829us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 94us; 1830us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 975us; 9us; 32768us; 10us; 987us; 16us; 1831us; 19us; 1787us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 94us; 1830us; 138us; 1786us; 194us; 973us; 0us; 16935us; 0us; 16936us; 0us; 16937us; 0us; 16938us; 0us; 16939us; 4us; 32768us; 10us; 987us; 30us; 1785us; 137us; 1784us; 194us; 973us; 73us; 32768us; 10us; 987us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 976us; 4us; 32768us; 10us; 987us; 19us; 1787us; 138us; 1786us; 194us; 973us; 0us; 16940us; 0us; 16941us; 0us; 16942us; 0us; 16943us; 0us; 16944us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 32768us; 19us; 1787us; 138us; 1786us; 0us; 16945us; 0us; 16946us; 0us; 16947us; 0us; 16948us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 25us; 16949us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 25us; 16950us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 127us; 1069us; 1us; 17394us; 21us; 1779us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16951us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 10us; 987us; 19us; 708us; 194us; 973us; 1us; 17394us; 21us; 1779us; 72us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1078us; 0us; 16952us; 0us; 16953us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 127us; 1081us; 1us; 17394us; 21us; 1779us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16954us; 71us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 10us; 987us; 19us; 708us; 194us; 973us; 0us; 16955us; 1us; 32768us; 98us; 1401us; 0us; 16956us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 25us; 16957us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16958us; 25us; 16962us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 20us; 16965us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 20us; 16966us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 9us; 16967us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 20us; 16968us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 18us; 16969us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 18us; 16970us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 9us; 16971us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16972us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16973us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16974us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16975us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16977us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 9us; 16978us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 187us; 1154us; 189us; 1161us; 1us; 16979us; 189us; 1161us; 8us; 16980us; 62us; 1158us; 79us; 1156us; 82us; 1129us; 96us; 1159us; 157us; 1155us; 182us; 1157us; 184us; 1160us; 189us; 1161us; 4us; 16981us; 96us; 1159us; 157us; 1155us; 184us; 1160us; 189us; 1161us; 4us; 16982us; 96us; 1159us; 157us; 1155us; 184us; 1160us; 189us; 1161us; 1us; 16983us; 189us; 1161us; 1us; 16984us; 189us; 1161us; 1us; 16985us; 189us; 1161us; 25us; 17022us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 17026us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 17030us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 29us; 32768us; 10us; 987us; 28us; 1211us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 104us; 1210us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 194us; 973us; 23us; 17035us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 32768us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 23us; 17038us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 17090us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 102us; 1144us; 128us; 1141us; 143us; 1324us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 24us; 17086us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 24us; 17088us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 26us; 17145us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 143us; 1398us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 28us; 32768us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 105us; 1410us; 128us; 1141us; 139us; 1411us; 143us; 1398us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 26us; 17141us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 143us; 1399us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 17142us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 25us; 17149us; 62us; 1158us; 63us; 1150us; 69us; 1148us; 79us; 1156us; 80us; 1131us; 81us; 1133us; 82us; 1129us; 83us; 1135us; 89us; 1145us; 90us; 1146us; 96us; 1159us; 97us; 1227us; 102us; 1144us; 128us; 1141us; 144us; 1142us; 157us; 1155us; 159us; 1151us; 160us; 1153us; 182us; 1157us; 183us; 1147us; 184us; 1160us; 186us; 1143us; 187us; 1154us; 188us; 1149us; 189us; 1161us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16959us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16960us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16961us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17006us; 68us; 1137us; 71us; 32768us; 13us; 1089us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16963us; 1us; 16964us; 97us; 1225us; 6us; 16964us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 97us; 1225us; 194us; 973us; 71us; 32768us; 13us; 1089us; 16us; 1162us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1163us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1164us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1165us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1166us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1167us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1168us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1169us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1170us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1171us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 73us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1172us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 16976us; 71us; 32768us; 13us; 1089us; 16us; 1173us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1174us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1175us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1176us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1177us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1178us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1179us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1180us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 71us; 32768us; 13us; 1089us; 16us; 1181us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 16986us; 0us; 16987us; 0us; 16988us; 0us; 16989us; 0us; 16990us; 0us; 16991us; 0us; 16992us; 0us; 16993us; 0us; 16994us; 0us; 16995us; 0us; 16996us; 0us; 16997us; 0us; 16998us; 0us; 16999us; 0us; 17000us; 0us; 17001us; 0us; 17002us; 0us; 17003us; 0us; 17004us; 0us; 17005us; 0us; 17007us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17008us; 39us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1193us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1196us; 0us; 17009us; 39us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1193us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1196us; 3us; 32768us; 10us; 987us; 20us; 1190us; 194us; 973us; 0us; 17010us; 0us; 17011us; 0us; 17012us; 38us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1195us; 0us; 17013us; 0us; 17014us; 0us; 17015us; 0us; 17016us; 2us; 32768us; 98us; 1206us; 194us; 1204us; 2us; 17017us; 57us; 1200us; 194us; 1203us; 38us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1202us; 0us; 17018us; 0us; 17019us; 0us; 17020us; 0us; 17021us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17024us; 3us; 17029us; 27us; 1217us; 140us; 1216us; 141us; 1222us; 0us; 17025us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 22us; 1212us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 17027us; 0us; 17028us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 22us; 1218us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 32768us; 10us; 987us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 194us; 973us; 0us; 17031us; 0us; 17032us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17033us; 0us; 17034us; 77us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1831us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1827us; 38us; 1828us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1829us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 94us; 1830us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 17036us; 77us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1831us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1827us; 38us; 1828us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1829us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 94us; 1830us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 17037us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17345us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17039us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17341us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17040us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17344us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17041us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17357us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17042us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17352us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17043us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 44us; 17353us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17044us; 31us; 32768us; 45us; 1704us; 55us; 1632us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1616us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1256us; 31us; 32768us; 45us; 1704us; 55us; 1632us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1616us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1256us; 2us; 17419us; 34us; 1797us; 35us; 1796us; 35us; 17189us; 14us; 17192us; 21us; 17192us; 26us; 17192us; 34us; 1797us; 35us; 1796us; 55us; 17419us; 71us; 17419us; 72us; 17419us; 74us; 17419us; 87us; 17192us; 92us; 17419us; 106us; 17419us; 111us; 17192us; 122us; 17419us; 136us; 17419us; 147us; 17419us; 154us; 17419us; 164us; 17419us; 165us; 17419us; 166us; 17419us; 167us; 17419us; 168us; 17419us; 169us; 17419us; 170us; 17419us; 171us; 17419us; 172us; 17419us; 173us; 17419us; 174us; 17419us; 175us; 17419us; 176us; 17419us; 178us; 17419us; 179us; 17419us; 191us; 17419us; 192us; 17419us; 193us; 17419us; 29us; 32768us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1255us; 29us; 32768us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1255us; 0us; 17045us; 5us; 17045us; 14us; 17191us; 26us; 17191us; 87us; 17191us; 111us; 17191us; 132us; 495us; 0us; 17046us; 0us; 17047us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17048us; 44us; 32768us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 119us; 1247us; 122us; 1332us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17049us; 36us; 17050us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1266us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 39us; 17050us; 26us; 1448us; 45us; 1289us; 55us; 1297us; 69us; 1435us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 87us; 1444us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1266us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 39us; 32768us; 26us; 1448us; 45us; 1289us; 55us; 1297us; 69us; 1435us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 87us; 1444us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1266us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17051us; 5us; 17052us; 33us; 1275us; 34us; 1274us; 35us; 1273us; 75us; 1287us; 77us; 1279us; 35us; 32768us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 5us; 17053us; 33us; 1275us; 34us; 1274us; 35us; 1273us; 75us; 1287us; 77us; 1279us; 5us; 17054us; 33us; 1275us; 34us; 1274us; 35us; 1273us; 75us; 1287us; 77us; 1279us; 2us; 17055us; 33us; 1275us; 34us; 1274us; 1us; 17056us; 33us; 1275us; 5us; 17058us; 33us; 1275us; 34us; 1274us; 35us; 1273us; 75us; 1287us; 77us; 1279us; 5us; 17285us; 33us; 1275us; 34us; 1274us; 35us; 1273us; 75us; 1287us; 77us; 1279us; 35us; 32768us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 35us; 32768us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 159us; 1657us; 0us; 17057us; 35us; 32768us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 35us; 17335us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 7us; 17074us; 10us; 987us; 45us; 1303us; 70us; 1312us; 92us; 1305us; 100us; 1714us; 190us; 1703us; 194us; 973us; 0us; 17059us; 1us; 32768us; 77us; 1282us; 7us; 17074us; 10us; 987us; 45us; 1303us; 70us; 1312us; 92us; 1305us; 100us; 1714us; 190us; 1703us; 194us; 973us; 0us; 17060us; 3us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 3us; 17351us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 0us; 17061us; 2us; 32768us; 92us; 1183us; 190us; 1182us; 0us; 17062us; 0us; 17063us; 0us; 17064us; 72us; 17138us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 979us; 3us; 32768us; 10us; 987us; 58us; 1293us; 194us; 973us; 0us; 17065us; 0us; 17066us; 0us; 17067us; 0us; 17068us; 2us; 32768us; 72us; 1498us; 92us; 1298us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17069us; 0us; 17070us; 0us; 17071us; 0us; 17072us; 0us; 17073us; 0us; 17075us; 89us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 57us; 1749us; 62us; 1230us; 63us; 1729us; 69us; 1733us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1285us; 79us; 1306us; 83us; 1741us; 86us; 1028us; 89us; 1242us; 90us; 1245us; 92us; 1359us; 96us; 1732us; 98us; 1091us; 100us; 1714us; 102us; 1734us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 143us; 1744us; 144us; 1740us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1345us; 157us; 1239us; 158us; 1066us; 159us; 1735us; 160us; 1736us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 180us; 1742us; 181us; 1236us; 182us; 1233us; 183us; 1726us; 184us; 1728us; 185us; 1278us; 186us; 1725us; 187us; 1724us; 188us; 1723us; 189us; 1722us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1712us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 1us; 32768us; 77us; 1308us; 1us; 32768us; 176us; 1309us; 0us; 17076us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17077us; 74us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 96us; 1326us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 143us; 1325us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 980us; 3us; 32768us; 10us; 987us; 58us; 1314us; 194us; 973us; 0us; 17078us; 0us; 17079us; 3us; 32768us; 10us; 987us; 58us; 1317us; 194us; 973us; 0us; 17080us; 0us; 17081us; 0us; 17082us; 0us; 17083us; 1us; 17085us; 97us; 1322us; 72us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 96us; 1326us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 143us; 1325us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17084us; 70us; 17087us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17089us; 0us; 17091us; 0us; 17092us; 0us; 17093us; 0us; 17094us; 0us; 17095us; 0us; 17096us; 0us; 17097us; 0us; 17098us; 0us; 17099us; 0us; 17100us; 72us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 142us; 1343us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1341us; 3us; 32768us; 10us; 987us; 142us; 1339us; 194us; 973us; 0us; 17101us; 0us; 17102us; 1us; 32768us; 142us; 1342us; 0us; 17103us; 0us; 17104us; 72us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 981us; 73us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 155us; 1747us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 981us; 3us; 32768us; 10us; 987us; 155us; 1347us; 194us; 973us; 0us; 17105us; 0us; 17106us; 0us; 17107us; 0us; 17108us; 72us; 17138us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 982us; 3us; 32768us; 10us; 987us; 64us; 1353us; 194us; 973us; 0us; 17109us; 0us; 17110us; 0us; 17111us; 0us; 17112us; 81us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1369us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1366us; 38us; 1367us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1368us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 88us; 1412us; 89us; 1241us; 90us; 1244us; 92us; 1358us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 983us; 97us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1369us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1366us; 38us; 1367us; 40us; 710us; 45us; 1289us; 55us; 1297us; 57us; 1749us; 60us; 1368us; 62us; 1230us; 63us; 1729us; 69us; 1733us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1285us; 83us; 1741us; 86us; 1028us; 88us; 1412us; 89us; 1242us; 90us; 1245us; 92us; 1358us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 96us; 1732us; 98us; 1091us; 100us; 1714us; 102us; 1734us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 143us; 1744us; 144us; 1740us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1345us; 157us; 1239us; 158us; 1066us; 159us; 1735us; 160us; 1736us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 180us; 1742us; 181us; 1236us; 182us; 1233us; 183us; 1726us; 184us; 1728us; 185us; 1278us; 186us; 1725us; 187us; 1701us; 188us; 1723us; 189us; 1722us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 984us; 97us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1369us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1366us; 38us; 1367us; 40us; 710us; 45us; 1289us; 55us; 1297us; 57us; 1749us; 60us; 1368us; 62us; 1230us; 63us; 1729us; 69us; 1733us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1285us; 83us; 1741us; 86us; 1028us; 88us; 1412us; 89us; 1242us; 90us; 1245us; 92us; 1358us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 96us; 1732us; 98us; 1091us; 100us; 1714us; 102us; 1734us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 143us; 1744us; 144us; 1740us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1345us; 157us; 1239us; 158us; 1066us; 159us; 1735us; 160us; 1736us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 180us; 1742us; 181us; 1236us; 182us; 1233us; 183us; 1726us; 184us; 1728us; 185us; 1278us; 186us; 1725us; 187us; 1701us; 188us; 1723us; 189us; 1722us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 984us; 0us; 17113us; 9us; 32768us; 10us; 987us; 16us; 1825us; 36us; 1822us; 38us; 1823us; 60us; 1824us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 0us; 17114us; 0us; 17115us; 0us; 17116us; 0us; 17116us; 0us; 17117us; 0us; 17118us; 0us; 17119us; 0us; 17120us; 0us; 17121us; 1us; 32768us; 78us; 1372us; 1us; 32768us; 92us; 1373us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17122us; 0us; 17123us; 0us; 17124us; 0us; 17125us; 4us; 17125us; 93us; 17128us; 94us; 17128us; 95us; 17128us; 102us; 17128us; 4us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 102us; 1383us; 0us; 17126us; 1us; 32768us; 187us; 1700us; 0us; 17127us; 77us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 53us; 1428us; 55us; 1297us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 62us; 1229us; 66us; 1439us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1248us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 985us; 5us; 32768us; 10us; 987us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 194us; 973us; 0us; 17129us; 0us; 17130us; 0us; 17131us; 0us; 17132us; 0us; 17133us; 0us; 17134us; 0us; 17135us; 0us; 17136us; 0us; 17137us; 0us; 17139us; 0us; 17140us; 72us; 32768us; 10us; 987us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17143us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17144us; 77us; 32768us; 10us; 987us; 13us; 1089us; 16us; 1831us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1827us; 38us; 1828us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1829us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 94us; 1830us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 17146us; 0us; 17147us; 0us; 17148us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 70us; 32768us; 13us; 1089us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17150us; 0us; 17151us; 0us; 17152us; 2us; 32768us; 191us; 1795us; 192us; 1794us; 3us; 17158us; 36us; 1799us; 37us; 1802us; 108us; 1803us; 0us; 17155us; 37us; 17160us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 78us; 1424us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1266us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 88us; 1417us; 0us; 17153us; 0us; 17154us; 0us; 17157us; 1us; 32768us; 92us; 1421us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17159us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1426us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17161us; 36us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1646us; 0us; 17162us; 30us; 32768us; 45us; 1704us; 55us; 1632us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1616us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 2us; 17419us; 34us; 1797us; 35us; 1796us; 28us; 17156us; 55us; 1495us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 92us; 1357us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17181us; 2us; 17173us; 21us; 1457us; 84us; 1458us; 0us; 17163us; 0us; 17164us; 71us; 32768us; 13us; 1089us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17181us; 2us; 17173us; 21us; 1457us; 84us; 1458us; 0us; 17165us; 1us; 17166us; 69us; 1440us; 71us; 17167us; 13us; 1089us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17181us; 2us; 17173us; 21us; 1457us; 84us; 1458us; 0us; 17168us; 3us; 32768us; 45us; 1704us; 66us; 1462us; 190us; 1703us; 0us; 17181us; 2us; 17173us; 21us; 1457us; 84us; 1458us; 0us; 17169us; 5us; 17173us; 21us; 1457us; 45us; 1704us; 66us; 1462us; 84us; 1458us; 190us; 1703us; 1us; 32768us; 20us; 1450us; 0us; 17170us; 0us; 17181us; 2us; 17173us; 21us; 1457us; 84us; 1458us; 1us; 32768us; 20us; 1454us; 0us; 17171us; 0us; 17172us; 3us; 17172us; 45us; 1704us; 66us; 1462us; 190us; 1703us; 1us; 17174us; 84us; 1460us; 1us; 17175us; 21us; 1459us; 0us; 17176us; 0us; 17177us; 1us; 17178us; 77us; 1706us; 0us; 17179us; 0us; 17180us; 8us; 17185us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 69us; 1465us; 94us; 1830us; 194us; 973us; 78us; 17183us; 10us; 987us; 13us; 1089us; 16us; 1831us; 22us; 950us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 36us; 1827us; 38us; 1828us; 40us; 710us; 45us; 1289us; 55us; 1297us; 60us; 1829us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 94us; 1830us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 17182us; 0us; 17184us; 0us; 17186us; 3us; 17394us; 21us; 1779us; 26us; 1479us; 87us; 1477us; 1us; 17394us; 21us; 1779us; 3us; 17199us; 14us; 553us; 111us; 552us; 194us; 1488us; 0us; 17187us; 2us; 32768us; 14us; 553us; 111us; 552us; 0us; 17188us; 0us; 17190us; 0us; 17193us; 3us; 16542us; 22us; 498us; 73us; 298us; 194us; 745us; 0us; 17195us; 2us; 16542us; 73us; 298us; 194us; 745us; 1us; 32768us; 20us; 1481us; 0us; 17196us; 3us; 17388us; 19us; 1774us; 20us; 1775us; 142us; 1776us; 0us; 17197us; 3us; 17199us; 14us; 553us; 111us; 552us; 194us; 1488us; 0us; 17198us; 3us; 17199us; 14us; 553us; 111us; 552us; 194us; 1488us; 0us; 17200us; 3us; 17199us; 14us; 553us; 111us; 552us; 194us; 1488us; 0us; 17201us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 8us; 17194us; 26us; 1479us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 87us; 1477us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 3us; 17388us; 19us; 1774us; 20us; 1775us; 142us; 1776us; 1us; 17394us; 21us; 1779us; 0us; 17202us; 1us; 32768us; 72us; 1498us; 0us; 17203us; 0us; 17204us; 39us; 32768us; 10us; 987us; 45us; 1289us; 55us; 1297us; 65us; 1813us; 66us; 1439us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 986us; 3us; 32768us; 10us; 987us; 65us; 1813us; 194us; 973us; 0us; 17205us; 0us; 17206us; 0us; 17207us; 0us; 17208us; 0us; 17209us; 35us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 32768us; 98us; 1507us; 72us; 32768us; 13us; 1089us; 22us; 945us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1509us; 0us; 17210us; 0us; 17211us; 36us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 66us; 464us; 70us; 880us; 71us; 883us; 74us; 877us; 75us; 886us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1521us; 2us; 32768us; 98us; 1512us; 194us; 1519us; 73us; 32768us; 10us; 987us; 13us; 1089us; 18us; 1516us; 24us; 1510us; 25us; 1525us; 29us; 1084us; 30us; 701us; 31us; 1072us; 32us; 697us; 40us; 710us; 45us; 1289us; 55us; 1297us; 62us; 1229us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 86us; 1028us; 89us; 1241us; 90us; 1244us; 92us; 1359us; 98us; 1091us; 100us; 1714us; 106us; 1333us; 107us; 1009us; 114us; 1020us; 115us; 1024us; 116us; 1001us; 117us; 1005us; 119us; 1247us; 122us; 1332us; 123us; 1039us; 124us; 1505us; 125us; 1523us; 126us; 1015us; 130us; 1079us; 133us; 1022us; 134us; 1026us; 136us; 1337us; 145us; 1257us; 146us; 1259us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 157us; 1238us; 158us; 1066us; 161us; 691us; 162us; 1062us; 163us; 1064us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 181us; 1235us; 182us; 1232us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 3us; 32768us; 10us; 987us; 20us; 1514us; 194us; 973us; 0us; 17212us; 0us; 17213us; 1us; 32768us; 20us; 1517us; 0us; 17214us; 0us; 17215us; 1us; 32768us; 20us; 1520us; 0us; 17216us; 1us; 32768us; 20us; 1522us; 0us; 17217us; 39us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1193us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1196us; 0us; 17218us; 39us; 32768us; 42us; 475us; 43us; 474us; 44us; 476us; 45us; 467us; 55us; 901us; 57us; 1193us; 66us; 464us; 70us; 880us; 71us; 883us; 73us; 298us; 74us; 877us; 75us; 886us; 82us; 861us; 92us; 894us; 100us; 1714us; 106us; 892us; 122us; 891us; 147us; 893us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 786us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1196us; 1us; 32768us; 20us; 1527us; 0us; 17219us; 1us; 17220us; 85us; 1529us; 4us; 32768us; 51us; 590us; 91us; 1697us; 92us; 605us; 187us; 1700us; 1us; 17222us; 85us; 1531us; 4us; 32768us; 51us; 590us; 91us; 1697us; 92us; 605us; 187us; 1700us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17225us; 1us; 17227us; 98us; 1535us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17226us; 1us; 17229us; 96us; 1538us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17228us; 1us; 17231us; 96us; 1541us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 73us; 298us; 75us; 1554us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17230us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 75us; 1547us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 7us; 17234us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 78us; 1545us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 17232us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 1us; 32768us; 190us; 1703us; 1us; 32768us; 78us; 1549us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 17233us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 7us; 17237us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 78us; 1552us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 17235us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 1us; 32768us; 190us; 1703us; 1us; 32768us; 78us; 1556us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 6us; 17236us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 1us; 17239us; 98us; 1559us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17238us; 1us; 32768us; 10us; 1562us; 0us; 17240us; 8us; 17244us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 96us; 1564us; 184us; 1568us; 187us; 1700us; 190us; 1703us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17241us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17242us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17243us; 8us; 17247us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 96us; 1571us; 184us; 1573us; 187us; 1700us; 190us; 1703us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17245us; 31us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17246us; 1us; 17248us; 77us; 1706us; 0us; 17249us; 1us; 17249us; 80us; 1592us; 1us; 17251us; 187us; 1580us; 4us; 17251us; 33us; 1655us; 77us; 1652us; 159us; 1657us; 187us; 1580us; 3us; 32768us; 62us; 803us; 92us; 799us; 176us; 798us; 0us; 17250us; 9us; 32768us; 10us; 987us; 35us; 1584us; 45us; 1704us; 70us; 1597us; 91us; 1697us; 96us; 1634us; 187us; 1700us; 190us; 1703us; 194us; 973us; 0us; 17252us; 1us; 32768us; 70us; 1597us; 0us; 17253us; 0us; 17254us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1646us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 4us; 32768us; 45us; 1704us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 0us; 17255us; 0us; 17256us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17257us; 1us; 17275us; 80us; 1595us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17258us; 2us; 32768us; 58us; 1598us; 97us; 1599us; 0us; 17259us; 2us; 32768us; 58us; 1600us; 97us; 1601us; 0us; 17260us; 2us; 32768us; 58us; 1602us; 97us; 1603us; 0us; 17261us; 1us; 32768us; 58us; 1604us; 0us; 17262us; 1us; 32768us; 97us; 1606us; 32us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17266us; 1us; 17263us; 97us; 1610us; 4us; 32768us; 10us; 987us; 97us; 1610us; 160us; 1661us; 194us; 973us; 32us; 17307us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17264us; 0us; 17265us; 1us; 17267us; 187us; 1614us; 3us; 32768us; 62us; 803us; 92us; 799us; 176us; 798us; 0us; 17268us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1646us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 4us; 32768us; 45us; 1704us; 91us; 1697us; 187us; 1700us; 190us; 1703us; 0us; 17269us; 1us; 17270us; 77us; 1649us; 1us; 17271us; 77us; 1649us; 0us; 17272us; 30us; 32768us; 45us; 1704us; 55us; 1632us; 66us; 1626us; 88us; 1623us; 91us; 1697us; 92us; 1627us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 1us; 17273us; 77us; 1649us; 0us; 17274us; 0us; 17275us; 33us; 32768us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 1646us; 5us; 32768us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 6us; 17302us; 10us; 987us; 69us; 1670us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 0us; 17276us; 0us; 17277us; 1us; 32768us; 92us; 1633us; 33us; 32768us; 10us; 987us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 33us; 32768us; 10us; 987us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 5us; 32768us; 10us; 987us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 194us; 973us; 0us; 17278us; 0us; 17279us; 0us; 17280us; 0us; 17281us; 0us; 17282us; 0us; 17283us; 0us; 17284us; 35us; 32768us; 45us; 1289us; 55us; 1297us; 70us; 1291us; 71us; 1351us; 72us; 1498us; 74us; 1385us; 75us; 1284us; 92us; 1359us; 100us; 1714us; 106us; 1333us; 122us; 1332us; 136us; 1337us; 147us; 1331us; 153us; 1281us; 154us; 1344us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 185us; 1277us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17286us; 0us; 17287us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17288us; 0us; 17289us; 2us; 32768us; 45us; 1704us; 190us; 1703us; 3us; 17290us; 33us; 1655us; 77us; 1706us; 159us; 1657us; 0us; 17291us; 7us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 94us; 1830us; 194us; 973us; 0us; 17292us; 0us; 17293us; 1us; 32768us; 159us; 1657us; 0us; 17294us; 35us; 17307us; 10us; 987us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 160us; 1667us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 1us; 32768us; 97us; 1659us; 39us; 17307us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 45us; 1704us; 55us; 537us; 60us; 1829us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 94us; 1830us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 194us; 973us; 0us; 17266us; 0us; 17295us; 0us; 17296us; 0us; 17297us; 8us; 17305us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 94us; 1830us; 160us; 1665us; 194us; 973us; 0us; 17298us; 0us; 17299us; 0us; 17300us; 0us; 17301us; 1us; 17302us; 69us; 1670us; 32us; 17304us; 45us; 1704us; 55us; 537us; 66us; 1594us; 72us; 540us; 88us; 1623us; 91us; 1697us; 92us; 1587us; 106us; 1645us; 113us; 1643us; 122us; 1644us; 147us; 1642us; 164us; 788us; 165us; 787us; 166us; 785us; 167us; 784us; 168us; 783us; 169us; 781us; 170us; 782us; 171us; 780us; 172us; 778us; 173us; 776us; 174us; 774us; 175us; 779us; 176us; 777us; 178us; 775us; 179us; 773us; 184us; 1566us; 187us; 1700us; 190us; 1703us; 191us; 1795us; 192us; 1794us; 193us; 790us; 0us; 17303us; 0us; 17305us; 0us; 17306us; 8us; 32768us; 45us; 1704us; 66us; 1677us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 184us; 1696us; 187us; 1700us; 190us; 1703us; 3us; 32768us; 96us; 1694us; 160us; 1676us; 184us; 1695us; 0us; 17308us; 1us; 32768us; 160us; 1678us; 0us; 17309us; 1us; 17310us; 77us; 1706us; 0us; 17311us; 7us; 32768us; 45us; 1704us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 184us; 1696us; 187us; 1700us; 190us; 1703us; 5us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 96us; 1694us; 184us; 1695us; 0us; 17312us; 1us; 17313us; 187us; 1685us; 3us; 32768us; 62us; 803us; 92us; 799us; 176us; 798us; 0us; 17314us; 0us; 17315us; 6us; 17316us; 45us; 1704us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 187us; 1700us; 190us; 1703us; 0us; 17317us; 0us; 17318us; 0us; 17319us; 0us; 17320us; 0us; 17321us; 7us; 32768us; 45us; 1704us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 184us; 1696us; 187us; 1700us; 190us; 1703us; 7us; 32768us; 45us; 1704us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 184us; 1696us; 187us; 1700us; 190us; 1703us; 7us; 32768us; 45us; 1704us; 91us; 1697us; 92us; 1681us; 176us; 1687us; 184us; 1696us; 187us; 1700us; 190us; 1703us; 1us; 32768us; 190us; 1703us; 0us; 17322us; 0us; 17323us; 1us; 32768us; 190us; 1703us; 1us; 17338us; 190us; 1703us; 0us; 17324us; 0us; 17325us; 0us; 17326us; 0us; 17327us; 8us; 32768us; 10us; 987us; 16us; 1831us; 36us; 1827us; 38us; 1828us; 60us; 1829us; 94us; 1830us; 190us; 1703us; 194us; 973us; 0us; 17328us; 0us; 17329us; 27us; 32768us; 57us; 1749us; 62us; 1731us; 63us; 1729us; 69us; 1733us; 75us; 1737us; 83us; 1741us; 89us; 1738us; 90us; 1739us; 96us; 1732us; 102us; 1734us; 143us; 1744us; 144us; 1740us; 154us; 1746us; 157us; 1743us; 159us; 1735us; 160us; 1736us; 180us; 1742us; 181us; 1730us; 182us; 1727us; 183us; 1726us; 184us; 1728us; 185us; 1721us; 186us; 1725us; 187us; 1724us; 188us; 1723us; 189us; 1722us; 194us; 1712us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17330us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17331us; 0us; 17332us; 1us; 32768us; 57us; 1716us; 5us; 32768us; 66us; 1718us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 190us; 1748us; 0us; 17333us; 1us; 32768us; 57us; 1719us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17334us; 0us; 17335us; 0us; 17336us; 0us; 17337us; 0us; 17338us; 0us; 17339us; 0us; 17340us; 0us; 17341us; 0us; 17342us; 0us; 17343us; 0us; 17344us; 0us; 17345us; 0us; 17346us; 0us; 17347us; 0us; 17348us; 0us; 17349us; 0us; 17350us; 0us; 17351us; 0us; 17352us; 0us; 17353us; 0us; 17354us; 0us; 17355us; 0us; 17356us; 0us; 17357us; 1us; 17358us; 143us; 1745us; 0us; 17359us; 1us; 32768us; 155us; 1747us; 0us; 17360us; 0us; 17361us; 1us; 32768us; 190us; 1748us; 0us; 17362us; 0us; 17363us; 0us; 17364us; 0us; 17365us; 1us; 17366us; 77us; 1756us; 0us; 17367us; 4us; 32768us; 92us; 1709us; 100us; 1714us; 190us; 1703us; 194us; 1758us; 0us; 17368us; 0us; 17369us; 0us; 17370us; 0us; 17371us; 0us; 17372us; 0us; 17373us; 3us; 17374us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 17375us; 3us; 17377us; 21us; 1762us; 67us; 1761us; 84us; 1760us; 0us; 17376us; 1us; 17378us; 84us; 1769us; 1us; 17379us; 21us; 1770us; 0us; 17380us; 0us; 17381us; 0us; 17382us; 0us; 17383us; 0us; 17384us; 0us; 17385us; 0us; 17386us; 0us; 17387us; 0us; 17389us; 0us; 17391us; 0us; 17393us; 0us; 17395us; 0us; 17397us; 0us; 17401us; 0us; 17403us; 0us; 17405us; 0us; 17406us; 0us; 17407us; 0us; 17408us; 0us; 17409us; 0us; 17410us; 0us; 17411us; 0us; 17412us; 0us; 17413us; 0us; 17414us; 0us; 17415us; 0us; 17416us; 0us; 17417us; 0us; 17418us; 0us; 17420us; 3us; 32768us; 36us; 1799us; 37us; 1802us; 108us; 1803us; 3us; 17443us; 36us; 1799us; 37us; 1802us; 108us; 1803us; 0us; 17422us; 0us; 17423us; 0us; 17424us; 3us; 32768us; 38us; 1804us; 39us; 1807us; 149us; 1808us; 3us; 17444us; 38us; 1804us; 39us; 1807us; 149us; 1808us; 0us; 17425us; 0us; 17426us; 0us; 17427us; 3us; 32768us; 59us; 1812us; 60us; 1809us; 61us; 1811us; 0us; 17428us; 0us; 17429us; 0us; 17430us; 0us; 17431us; 3us; 32768us; 93us; 1817us; 94us; 1814us; 95us; 1816us; 0us; 17432us; 0us; 17433us; 0us; 17434us; 3us; 32768us; 15us; 1821us; 16us; 1818us; 17us; 1820us; 0us; 17435us; 0us; 17436us; 0us; 17437us; 0us; 17438us; 0us; 17439us; 0us; 17440us; 0us; 17441us; 0us; 17442us; 0us; 17443us; 0us; 17444us; 0us; 17445us; 0us; 17446us; 0us; 17447us; 0us; 17448us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 17us; 18us; 105us; 106us; 114us; 115us; 186us; 187us; 220us; 221us; 222us; 223us; 224us; 225us; 226us; 227us; 232us; 233us; 238us; 239us; 244us; 245us; 251us; 252us; 258us; 259us; 265us; 266us; 283us; 284us; 288us; 367us; 393us; 394us; 397us; 398us; 399us; 400us; 402us; 403us; 406us; 407us; 408us; 411us; 412us; 414us; 415us; 420us; 421us; 425us; 427us; 430us; 432us; 434us; 437us; 439us; 441us; 442us; 444us; 445us; 447us; 464us; 465us; 469us; 478us; 497us; 498us; 499us; 500us; 516us; 522us; 524us; 525us; 526us; 533us; 534us; 535us; 539us; 543us; 559us; 560us; 564us; 569us; 570us; 571us; 572us; 576us; 585us; 588us; 594us; 595us; 596us; 597us; 598us; 601us; 603us; 605us; 607us; 609us; 613us; 617us; 620us; 622us; 656us; 658us; 659us; 731us; 757us; 828us; 857us; 858us; 867us; 871us; 872us; 888us; 890us; 894us; 895us; 911us; 913us; 914us; 916us; 917us; 919us; 921us; 922us; 925us; 933us; 934us; 935us; 988us; 990us; 1005us; 1007us; 1011us; 1013us; 1014us; 1016us; 1017us; 1018us; 1019us; 1021us; 1055us; 1056us; 1057us; 1074us; 1078us; 1079us; 1080us; 1082us; 1083us; 1098us; 1104us; 1105us; 1106us; 1122us; 1126us; 1127us; 1128us; 1143us; 1149us; 1150us; 1151us; 1152us; 1153us; 1156us; 1171us; 1172us; 1176us; 1180us; 1191us; 1236us; 1238us; 1242us; 1246us; 1249us; 1251us; 1285us; 1288us; 1290us; 1291us; 1323us; 1330us; 1362us; 1369us; 1371us; 1372us; 1378us; 1380us; 1381us; 1383us; 1384us; 1386us; 1420us; 1421us; 1425us; 1426us; 1430us; 1433us; 1434us; 1435us; 1437us; 1441us; 1442us; 1443us; 1445us; 1446us; 1448us; 1449us; 1465us; 1469us; 1470us; 1473us; 1474us; 1476us; 1477us; 1482us; 1483us; 1485us; 1486us; 1488us; 1489us; 1491us; 1578us; 1579us; 1584us; 1663us; 1751us; 1752us; 1753us; 1839us; 1845us; 1847us; 1848us; 1849us; 1856us; 1857us; 1858us; 1859us; 1864us; 1943us; 1972us; 2058us; 2059us; 2060us; 2061us; 2083us; 2084us; 2170us; 2171us; 2175us; 2182us; 2187us; 2192us; 2193us; 2194us; 2195us; 2199us; 2211us; 2212us; 2214us; 2215us; 2287us; 2288us; 2290us; 2292us; 2293us; 2294us; 2296us; 2302us; 2303us; 2306us; 2307us; 2308us; 2313us; 2314us; 2316us; 2323us; 2329us; 2330us; 2331us; 2337us; 2338us; 2339us; 2340us; 2341us; 2343us; 2429us; 2433us; 2434us; 2435us; 2436us; 2443us; 2447us; 2448us; 2449us; 2451us; 2452us; 2467us; 2470us; 2479us; 2481us; 2482us; 2484us; 2486us; 2487us; 2488us; 2489us; 2490us; 2500us; 2501us; 2505us; 2534us; 2535us; 2539us; 2543us; 2572us; 2573us; 2576us; 2581us; 2584us; 2613us; 2614us; 2616us; 2617us; 2619us; 2620us; 2622us; 2623us; 2625us; 2626us; 2637us; 2638us; 2639us; 2640us; 2641us; 2645us; 2647us; 2648us; 2650us; 2652us; 2653us; 2694us; 2701us; 2702us; 2703us; 2707us; 2710us; 2712us; 2714us; 2716us; 2723us; 2724us; 2736us; 2738us; 2746us; 2748us; 2754us; 2756us; 2757us; 2758us; 2760us; 2761us; 2762us; 2763us; 2765us; 2799us; 2800us; 2801us; 2807us; 2811us; 2812us; 2813us; 2818us; 2819us; 2826us; 2832us; 2833us; 2834us; 2841us; 2847us; 2848us; 2849us; 2850us; 2851us; 2862us; 2863us; 2866us; 2877us; 2878us; 2880us; 2881us; 2883us; 2886us; 2887us; 2888us; 2890us; 2892us; 2893us; 2895us; 2932us; 2934us; 2936us; 3008us; 3009us; 3046us; 3048us; 3052us; 3124us; 3125us; 3126us; 3128us; 3129us; 3133us; 3137us; 3153us; 3203us; 3204us; 3205us; 3208us; 3210us; 3211us; 3243us; 3251us; 3252us; 3254us; 3258us; 3261us; 3263us; 3297us; 3300us; 3302us; 3303us; 3304us; 3306us; 3307us; 3309us; 3310us; 3312us; 3313us; 3349us; 3351us; 3353us; 3425us; 3427us; 3428us; 3430us; 3431us; 3433us; 3437us; 3439us; 3441us; 3474us; 3475us; 3477us; 3481us; 3483us; 3485us; 3487us; 3559us; 3562us; 3563us; 3596us; 3597us; 3599us; 3603us; 3604us; 3606us; 3610us; 3611us; 3612us; 3616us; 3617us; 3618us; 3619us; 3620us; 3621us; 3622us; 3625us; 3629us; 3630us; 3637us; 3641us; 3642us; 3680us; 3712us; 3713us; 3742us; 3744us; 3745us; 3746us; 3747us; 3749us; 3750us; 3751us; 3754us; 3755us; 3756us; 3758us; 3764us; 3765us; 3766us; 3767us; 3770us; 3785us; 3786us; 3790us; 3795us; 3799us; 3801us; 3802us; 3804us; 3805us; 3806us; 3808us; 3810us; 3811us; 3812us; 3813us; 3817us; 3852us; 3855us; 3857us; 3860us; 3861us; 3862us; 3863us; 3864us; 3898us; 3902us; 3903us; 3906us; 3912us; 3913us; 3914us; 3918us; 3919us; 3922us; 3923us; 3924us; 3927us; 3931us; 3932us; 3933us; 3935us; 3936us; 3967us; 3969us; 3970us; 3971us; 3972us; 3973us; 3974us; 3975us; 3981us; 3985us; 3988us; 3990us; 3991us; 3992us; 3994us; 3999us; 4000us; 4003us; 4005us; 4007us; 4010us; 4011us; 4012us; 4015us; 4016us; 4018us; 4020us; 4022us; 4023us; 4024us; 4026us; 4030us; 4032us; 4034us; 4035us; 4036us; 4064us; 4069us; 4071us; 4073us; 4075us; 4080us; 4081us; 4082us; 4085us; 4087us; 4120us; 4121us; 4124us; 4157us; 4158us; 4164us; 4165us; 4169us; 4170us; 4171us; 4173us; 4177us; 4178us; 4210us; 4215us; 4217us; 4219us; 4221us; 4225us; 4226us; 4229us; 4230us; 4231us; 4263us; 4270us; 4277us; 4279us; 4280us; 4282us; 4284us; 4285us; 4288us; 4289us; 4291us; 4293us; 4294us; 4298us; 4302us; 4307us; 4308us; 4341us; 4343us; 4344us; 4378us; 4380us; 4381us; 4400us; 4402us; 4403us; 4404us; 4434us; 4438us; 4439us; 4441us; 4445us; 4446us; 4451us; 4452us; 4471us; 4473us; 4519us; 4520us; 4553us; 4554us; 4556us; 4588us; 4589us; 4591us; 4623us; 4630us; 4637us; 4638us; 4639us; 4642us; 4650us; 4651us; 4652us; 4654us; 4655us; 4659us; 4661us; 4663us; 4696us; 4697us; 4699us; 4700us; 4701us; 4703us; 4707us; 4709us; 4711us; 4712us; 4714us; 4747us; 4748us; 4751us; 4753us; 4756us; 4758us; 4760us; 4763us; 4764us; 4765us; 4837us; 4838us; 4840us; 4843us; 4847us; 4848us; 4920us; 4924us; 4925us; 4926us; 4927us; 4928us; 4929us; 4930us; 4931us; 4933us; 4937us; 4939us; 4942us; 4944us; 4949us; 4953us; 4954us; 4956us; 4958us; 4960us; 4961us; 4963us; 4964us; 4968us; 4975us; 4976us; 4978us; 4984us; 4986us; 4988us; 4989us; 4990us; 4991us; 4993us; 4995us; 4996us; 5000us; 5002us; 5003us; 5006us; 5008us; 5009us; 5011us; 5012us; 5013us; 5015us; 5052us; 5054us; 5058us; 5131us; 5132us; 5133us; 5134us; 5205us; 5211us; 5212us; 5213us; 5214us; 5215us; 5217us; 5218us; 5221us; 5224us; 5296us; 5297us; 5300us; 5301us; 5302us; 5305us; 5338us; 5339us; 5340us; 5341us; 5342us; 5343us; 5344us; 5345us; 5346us; 5347us; 5348us; 5349us; 5350us; 5351us; 5352us; 5353us; 5355us; 5356us; 5357us; 5358us; 5359us; 5361us; 5363us; 5364us; 5366us; 5368us; 5370us; 5371us; 5372us; 5375us; 5379us; 5380us; 5381us; 5384us; 5385us; 5387us; 5389us; 5390us; 5396us; 5397us; 5399us; 5400us; 5402us; 5405us; 5438us; 5439us; 5443us; 5447us; 5448us; 5457us; 5463us; 5464us; 5465us; 5466us; 5470us; 5471us; 5472us; 5476us; 5478us; 5481us; 5484us; 5486us; 5488us; 5495us; 5502us; 5504us; 5505us; 5542us; 5579us; 5581us; 5582us; 5583us; 5620us; 5657us; 5694us; 5731us; 5734us; 5735us; 5737us; 5738us; 5740us; 5743us; 5781us; 5788us; 5818us; 5856us; 5857us; 5893us; 5894us; 5930us; 5931us; 5963us; 5964us; 5965us; 6029us; 6033us; 6034us; 6035us; 6073us; 6074us; 6110us; 6111us; 6147us; 6148us; 6149us; 6151us; 6152us; 6155us; 6159us; 6160us; 6198us; 6200us; 6201us; 6239us; 6241us; 6242us; 6244us; 6246us; 6247us; 6248us; 6249us; 6250us; 6251us; 6252us; 6316us; 6322us; 6323us; 6324us; 6328us; 6331us; 6332us; 6334us; 6374us; 6381us; 6382us; 6383us; 6387us; 6388us; 6389us; 6396us; 6401us; 6405us; 6408us; 6412us; 6416us; 6419us; 6426us; 6429us; 6436us; 6445us; 6461us; 6469us; 6471us; 6472us; 6510us; 6512us; 6514us; 6547us; 6548us; 6586us; 6624us; 6625us; 6663us; 6701us; 6739us; 6777us; 6780us; 6781us; 6784us; 6785us; 6788us; 6826us; 6827us; 6865us; 6866us; 6937us; 6943us; 6944us; 6945us; 6946us; 7017us; 7021us; 7022us; 7048us; 7050us; 7051us; 7053us; 7086us; 7087us; 7089us; 7090us; 7120us; 7151us; 7182us; 7253us; 7254us; 7325us; 7326us; 7328us; 7399us; 7403us; 7404us; 7478us; 7479us; 7482us; 7485us; 7488us; 7491us; 7494us; 7496us; 7498us; 7500us; 7502us; 7506us; 7510us; 7514us; 7516us; 7517us; 7519us; 7591us; 7592us; 7593us; 7667us; 7668us; 7669us; 7742us; 7743us; 7744us; 7745us; 7746us; 7747us; 7818us; 7823us; 7824us; 7825us; 7896us; 7901us; 7902us; 7903us; 7974us; 7980us; 7981us; 7982us; 8054us; 8055us; 8128us; 8158us; 8159us; 8160us; 8161us; 8232us; 8233us; 8296us; 8297us; 8369us; 8370us; 8434us; 8435us; 8508us; 8538us; 8611us; 8616us; 8617us; 8618us; 8621us; 8622us; 8623us; 8624us; 8625us; 8670us; 8681us; 8760us; 8770us; 8771us; 8772us; 8773us; 8774us; 8775us; 8780us; 8854us; 8859us; 8860us; 8861us; 8862us; 8863us; 8864us; 8936us; 8939us; 8940us; 8941us; 8942us; 8943us; 9014us; 9040us; 9111us; 9137us; 9174us; 9246us; 9248us; 9250us; 9322us; 9323us; 9360us; 9432us; 9436us; 9438us; 9511us; 9512us; 9513us; 9584us; 9586us; 9588us; 9660us; 9661us; 9733us; 9737us; 9738us; 9740us; 9741us; 9812us; 9838us; 9909us; 9910us; 9936us; 9957us; 9978us; 9988us; 10009us; 10028us; 10047us; 10057us; 10067us; 10077us; 10087us; 10097us; 10107us; 10117us; 10119us; 10128us; 10133us; 10138us; 10140us; 10142us; 10144us; 10170us; 10196us; 10222us; 10252us; 10276us; 10302us; 10326us; 10352us; 10377us; 10402us; 10429us; 10458us; 10485us; 10511us; 10537us; 10570us; 10571us; 10604us; 10605us; 10638us; 10639us; 10710us; 10712us; 10784us; 10785us; 10787us; 10794us; 10866us; 10938us; 11010us; 11082us; 11154us; 11226us; 11298us; 11370us; 11442us; 11514us; 11588us; 11589us; 11661us; 11733us; 11805us; 11877us; 11949us; 12021us; 12093us; 12165us; 12237us; 12238us; 12239us; 12240us; 12241us; 12242us; 12243us; 12244us; 12245us; 12246us; 12247us; 12248us; 12249us; 12250us; 12251us; 12252us; 12253us; 12254us; 12255us; 12256us; 12257us; 12258us; 12329us; 12333us; 12334us; 12374us; 12375us; 12415us; 12419us; 12420us; 12421us; 12422us; 12461us; 12462us; 12463us; 12464us; 12465us; 12468us; 12471us; 12510us; 12511us; 12512us; 12513us; 12514us; 12585us; 12656us; 12657us; 12661us; 12662us; 12733us; 12735us; 12806us; 12812us; 12813us; 12814us; 12885us; 12887us; 12958us; 12964us; 12965us; 12966us; 13037us; 13038us; 13039us; 13117us; 13118us; 13196us; 13197us; 13242us; 13287us; 13288us; 13333us; 13378us; 13379us; 13424us; 13469us; 13470us; 13515us; 13560us; 13561us; 13606us; 13651us; 13652us; 13697us; 13742us; 13743us; 13775us; 13807us; 13810us; 13846us; 13876us; 13906us; 13907us; 13913us; 13914us; 13915us; 13960us; 13961us; 14006us; 14007us; 14044us; 14084us; 14124us; 14125us; 14131us; 14167us; 14173us; 14179us; 14182us; 14184us; 14190us; 14196us; 14232us; 14268us; 14270us; 14271us; 14307us; 14343us; 14351us; 14352us; 14354us; 14362us; 14363us; 14367us; 14371us; 14372us; 14375us; 14376us; 14377us; 14378us; 14451us; 14455us; 14456us; 14457us; 14458us; 14459us; 14462us; 14533us; 14534us; 14535us; 14536us; 14537us; 14538us; 14539us; 14629us; 14633us; 14635us; 14637us; 14638us; 14642us; 14643us; 14718us; 14722us; 14723us; 14724us; 14728us; 14729us; 14730us; 14731us; 14732us; 14734us; 14807us; 14808us; 14879us; 14950us; 14951us; 14952us; 14953us; 14954us; 14955us; 14956us; 14957us; 14958us; 14959us; 14960us; 14961us; 15034us; 15038us; 15039us; 15040us; 15042us; 15043us; 15044us; 15117us; 15191us; 15195us; 15196us; 15197us; 15198us; 15199us; 15272us; 15276us; 15277us; 15278us; 15279us; 15280us; 15362us; 15460us; 15558us; 15559us; 15569us; 15570us; 15571us; 15572us; 15573us; 15574us; 15575us; 15576us; 15577us; 15578us; 15580us; 15582us; 15584us; 15588us; 15659us; 15660us; 15661us; 15662us; 15663us; 15668us; 15673us; 15674us; 15676us; 15677us; 15755us; 15761us; 15762us; 15763us; 15764us; 15765us; 15766us; 15767us; 15768us; 15769us; 15770us; 15771us; 15772us; 15845us; 15916us; 15917us; 15988us; 15989us; 16067us; 16068us; 16069us; 16070us; 16141us; 16212us; 16213us; 16214us; 16215us; 16218us; 16222us; 16223us; 16261us; 16263us; 16264us; 16265us; 16266us; 16268us; 16301us; 16305us; 16306us; 16339us; 16340us; 16377us; 16378us; 16409us; 16412us; 16441us; 16442us; 16445us; 16446us; 16447us; 16519us; 16520us; 16523us; 16524us; 16526us; 16598us; 16599us; 16602us; 16603us; 16607us; 16608us; 16611us; 16612us; 16618us; 16620us; 16621us; 16622us; 16625us; 16627us; 16628us; 16629us; 16633us; 16635us; 16637us; 16638us; 16639us; 16641us; 16642us; 16643us; 16652us; 16731us; 16732us; 16733us; 16734us; 16738us; 16740us; 16744us; 16745us; 16748us; 16749us; 16750us; 16751us; 16755us; 16756us; 16759us; 16761us; 16762us; 16766us; 16767us; 16771us; 16772us; 16776us; 16777us; 16781us; 16782us; 16814us; 16823us; 16827us; 16829us; 16830us; 16832us; 16833us; 16834us; 16874us; 16878us; 16879us; 16880us; 16881us; 16882us; 16883us; 16919us; 16921us; 16994us; 16995us; 16996us; 17033us; 17036us; 17110us; 17114us; 17115us; 17116us; 17118us; 17119us; 17120us; 17122us; 17123us; 17125us; 17126us; 17166us; 17167us; 17207us; 17209us; 17210us; 17212us; 17217us; 17219us; 17224us; 17258us; 17259us; 17261us; 17295us; 17296us; 17298us; 17332us; 17333us; 17335us; 17369us; 17370us; 17403us; 17411us; 17443us; 17450us; 17452us; 17454us; 17486us; 17493us; 17501us; 17533us; 17540us; 17542us; 17544us; 17576us; 17583us; 17585us; 17618us; 17619us; 17621us; 17622us; 17631us; 17663us; 17664us; 17696us; 17697us; 17729us; 17730us; 17739us; 17771us; 17772us; 17804us; 17805us; 17807us; 17808us; 17810us; 17812us; 17817us; 17821us; 17822us; 17832us; 17833us; 17835us; 17836us; 17837us; 17871us; 17875us; 17880us; 17881us; 17882us; 17915us; 17916us; 17918us; 17951us; 17952us; 17955us; 17956us; 17959us; 17960us; 17963us; 17964us; 17966us; 17967us; 17969us; 18002us; 18003us; 18005us; 18010us; 18043us; 18044us; 18045us; 18047us; 18051us; 18052us; 18086us; 18090us; 18095us; 18096us; 18098us; 18100us; 18101us; 18132us; 18134us; 18135us; 18136us; 18170us; 18176us; 18183us; 18184us; 18185us; 18187us; 18221us; 18255us; 18261us; 18262us; 18263us; 18264us; 18265us; 18266us; 18267us; 18268us; 18304us; 18305us; 18306us; 18310us; 18311us; 18312us; 18315us; 18319us; 18320us; 18328us; 18329us; 18330us; 18332us; 18333us; 18369us; 18371us; 18411us; 18412us; 18413us; 18414us; 18415us; 18424us; 18425us; 18426us; 18427us; 18428us; 18430us; 18463us; 18464us; 18465us; 18466us; 18475us; 18479us; 18480us; 18482us; 18483us; 18485us; 18486us; 18494us; 18500us; 18501us; 18503us; 18507us; 18508us; 18509us; 18516us; 18517us; 18518us; 18519us; 18520us; 18521us; 18529us; 18537us; 18545us; 18547us; 18548us; 18549us; 18551us; 18553us; 18554us; 18555us; 18556us; 18557us; 18566us; 18567us; 18568us; 18596us; 18600us; 18601us; 18605us; 18606us; 18607us; 18609us; 18615us; 18616us; 18618us; 18622us; 18623us; 18624us; 18625us; 18626us; 18627us; 18628us; 18629us; 18630us; 18631us; 18632us; 18633us; 18634us; 18635us; 18636us; 18637us; 18638us; 18639us; 18640us; 18641us; 18642us; 18643us; 18644us; 18645us; 18646us; 18648us; 18649us; 18651us; 18652us; 18653us; 18655us; 18656us; 18657us; 18658us; 18659us; 18661us; 18662us; 18667us; 18668us; 18669us; 18670us; 18671us; 18672us; 18673us; 18677us; 18678us; 18682us; 18683us; 18685us; 18687us; 18688us; 18689us; 18690us; 18691us; 18692us; 18693us; 18694us; 18695us; 18696us; 18697us; 18698us; 18699us; 18700us; 18701us; 18702us; 18703us; 18704us; 18705us; 18706us; 18707us; 18708us; 18709us; 18710us; 18711us; 18712us; 18713us; 18714us; 18715us; 18716us; 18717us; 18721us; 18725us; 18726us; 18727us; 18728us; 18732us; 18736us; 18737us; 18738us; 18739us; 18743us; 18744us; 18745us; 18746us; 18747us; 18751us; 18752us; 18753us; 18754us; 18758us; 18759us; 18760us; 18761us; 18762us; 18763us; 18764us; 18765us; 18766us; 18767us; 18768us; 18769us; 18770us; 18771us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 2us; 3us; 3us; 3us; 1us; 2us; 3us; 1us; 1us; 2us; 1us; 1us; 3us; 0us; 2us; 1us; 2us; 3us; 2us; 4us; 3us; 1us; 2us; 2us; 1us; 3us; 4us; 1us; 1us; 4us; 3us; 3us; 1us; 1us; 0us; 3us; 3us; 2us; 1us; 1us; 5us; 5us; 3us; 3us; 2us; 12us; 0us; 2us; 4us; 3us; 5us; 3us; 2us; 3us; 1us; 3us; 2us; 7us; 2us; 1us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 0us; 3us; 11us; 4us; 4us; 4us; 5us; 5us; 5us; 0us; 2us; 3us; 3us; 1us; 3us; 1us; 1us; 2us; 2us; 3us; 0us; 2us; 3us; 2us; 1us; 2us; 2us; 1us; 3us; 4us; 1us; 4us; 3us; 3us; 1us; 1us; 0us; 5us; 4us; 3us; 1us; 2us; 2us; 3us; 1us; 2us; 3us; 1us; 1us; 3us; 3us; 3us; 5us; 3us; 5us; 2us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 0us; 1us; 2us; 5us; 4us; 4us; 2us; 1us; 3us; 3us; 4us; 6us; 2us; 2us; 2us; 2us; 2us; 1us; 1us; 1us; 3us; 3us; 0us; 1us; 3us; 2us; 8us; 7us; 6us; 2us; 1us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 2us; 0us; 3us; 2us; 3us; 3us; 1us; 3us; 6us; 5us; 4us; 1us; 2us; 3us; 4us; 5us; 5us; 10us; 3us; 4us; 5us; 5us; 8us; 5us; 6us; 8us; 0us; 2us; 3us; 3us; 1us; 2us; 0us; 1us; 1us; 1us; 1us; 1us; 0us; 3us; 0us; 3us; 0us; 3us; 5us; 2us; 1us; 0us; 2us; 1us; 0us; 2us; 2us; 3us; 3us; 1us; 3us; 2us; 4us; 4us; 3us; 4us; 1us; 1us; 6us; 3us; 3us; 3us; 5us; 3us; 3us; 3us; 2us; 1us; 3us; 3us; 3us; 3us; 1us; 1us; 1us; 1us; 1us; 2us; 3us; 3us; 1us; 3us; 3us; 1us; 2us; 5us; 3us; 1us; 0us; 5us; 1us; 0us; 1us; 0us; 0us; 2us; 3us; 1us; 4us; 3us; 3us; 4us; 3us; 5us; 7us; 4us; 4us; 3us; 3us; 1us; 2us; 3us; 1us; 1us; 3us; 1us; 4us; 6us; 6us; 6us; 1us; 3us; 4us; 2us; 4us; 2us; 3us; 4us; 3us; 1us; 3us; 1us; 1us; 1us; 3us; 2us; 2us; 5us; 2us; 1us; 5us; 1us; 3us; 0us; 2us; 2us; 3us; 1us; 2us; 4us; 3us; 1us; 1us; 1us; 1us; 1us; 1us; 8us; 1us; 1us; 0us; 3us; 3us; 2us; 3us; 1us; 4us; 2us; 2us; 2us; 2us; 2us; 2us; 3us; 0us; 2us; 1us; 6us; 6us; 5us; 3us; 3us; 1us; 2us; 2us; 0us; 4us; 3us; 1us; 3us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 4us; 1us; 2us; 1us; 3us; 1us; 2us; 1us; 3us; 1us; 1us; 2us; 3us; 2us; 1us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 3us; 3us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 4us; 4us; 2us; 1us; 3us; 1us; 2us; 3us; 3us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 3us; 3us; 3us; 2us; 4us; 4us; 4us; 3us; 1us; 0us; 3us; 3us; 1us; 1us; 3us; 2us; 3us; 1us; 3us; 3us; 3us; 3us; 2us; 3us; 3us; 0us; 2us; 3us; 3us; 3us; 1us; 3us; 1us; 2us; 1us; 3us; 1us; 2us; 3us; 2us; 1us; 3us; 5us; 1us; 1us; 1us; 3us; 3us; 2us; 2us; 3us; 3us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 4us; 3us; 3us; 2us; 2us; 2us; 1us; 2us; 2us; 1us; 5us; 5us; 5us; 3us; 2us; 3us; 5us; 5us; 5us; 4us; 3us; 5us; 5us; 5us; 4us; 3us; 5us; 2us; 4us; 3us; 2us; 2us; 7us; 7us; 7us; 5us; 3us; 4us; 2us; 2us; 3us; 3us; 3us; 3us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 3us; 2us; 3us; 3us; 1us; 2us; 2us; 1us; 2us; 2us; 4us; 4us; 3us; 2us; 2us; 0us; 2us; 2us; 2us; 4us; 4us; 0us; 2us; 4us; 4us; 3us; 3us; 3us; 3us; 3us; 3us; 2us; 2us; 2us; 2us; 2us; 2us; 4us; 4us; 2us; 2us; 2us; 1us; 2us; 1us; 2us; 1us; 3us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 1us; 1us; 3us; 3us; 3us; 2us; 4us; 4us; 1us; 1us; 1us; 0us; 1us; 5us; 3us; 3us; 3us; 3us; 3us; 3us; 2us; 3us; 1us; 3us; 2us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 3us; 3us; 2us; 3us; 3us; 3us; 2us; 3us; 3us; 3us; 2us; 2us; 3us; 3us; 3us; 2us; 2us; 2us; 2us; 2us; 6us; 1us; 1us; 1us; 3us; 3us; 1us; 3us; 3us; 3us; 2us; 2us; 1us; 1us; 1us; 1us; 0us; 1us; 1us; 3us; 5us; 3us; 2us; 3us; 3us; 3us; 2us; 5us; 3us; 1us; 1us; 6us; 2us; 0us; 0us; 1us; 0us; 4us; 0us; 2us; 3us; 6us; 1us; 5us; 1us; 2us; 5us; 5us; 4us; 6us; 1us; 0us; 1us; 1us; 2us; 2us; 1us; 1us; 3us; 0us; 3us; 2us; 3us; 1us; 2us; 4us; 3us; 2us; 5us; 4us; 2us; 1us; 0us; 2us; 3us; 3us; 2us; 0us; 2us; 2us; 5us; 2us; 1us; 3us; 3us; 3us; 2us; 2us; 4us; 4us; 5us; 5us; 5us; 4us; 4us; 3us; 2us; 3us; 1us; 3us; 1us; 3us; 0us; 2us; 3us; 1us; 3us; 1us; 3us; 1us; 4us; 5us; 2us; 3us; 4us; 1us; 3us; 1us; 2us; 3us; 2us; 3us; 1us; 3us; 3us; 1us; 1us; 1us; 3us; 1us; 2us; 3us; 2us; 4us; 1us; 3us; 3us; 2us; 3us; 4us; 5us; 4us; 3us; 3us; 0us; 1us; 3us; 4us; 1us; 1us; 1us; 2us; 1us; 1us; 3us; 3us; 6us; 6us; 5us; 4us; 3us; 1us; 1us; 2us; 1us; 1us; 3us; 2us; 3us; 4us; 3us; 1us; 2us; 6us; 6us; 4us; 3us; 3us; 2us; 2us; 1us; 3us; 2us; 1us; 1us; 0us; 3us; 3us; 1us; 1us; 3us; 1us; 3us; 1us; 1us; 2us; 1us; 3us; 3us; 2us; 2us; 1us; 2us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 4us; 6us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 1us; 2us; 3us; 1us; 1us; 1us; 1us; 3us; 3us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 0us; 1us; 1us; 2us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 0us; 1us; 0us; 2us; 1us; 1us; 2us; 1us; 1us; 2us; 1us; 1us; 1us; 2us; 1us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 3us; 4us; 5us; 5us; 5us; 6us; 6us; 7us; 7us; 7us; 7us; 7us; 7us; 7us; 8us; 8us; 9us; 10us; 11us; 11us; 12us; 12us; 13us; 14us; 14us; 15us; 16us; 16us; 16us; 17us; 18us; 19us; 19us; 20us; 20us; 21us; 22us; 22us; 23us; 23us; 23us; 23us; 24us; 24us; 24us; 25us; 25us; 25us; 26us; 26us; 26us; 26us; 26us; 26us; 26us; 27us; 28us; 28us; 28us; 29us; 29us; 29us; 30us; 31us; 31us; 32us; 32us; 33us; 33us; 34us; 34us; 34us; 35us; 35us; 35us; 35us; 36us; 36us; 36us; 36us; 37us; 37us; 37us; 38us; 38us; 39us; 40us; 40us; 40us; 40us; 40us; 40us; 40us; 41us; 41us; 41us; 41us; 42us; 42us; 43us; 43us; 43us; 44us; 45us; 45us; 46us; 46us; 46us; 47us; 47us; 48us; 48us; 49us; 50us; 50us; 51us; 51us; 51us; 51us; 52us; 52us; 53us; 53us; 53us; 53us; 53us; 54us; 54us; 54us; 54us; 54us; 55us; 55us; 56us; 56us; 56us; 56us; 56us; 56us; 56us; 56us; 57us; 57us; 58us; 58us; 58us; 58us; 58us; 58us; 58us; 59us; 59us; 59us; 60us; 61us; 61us; 62us; 62us; 63us; 63us; 63us; 63us; 64us; 64us; 65us; 65us; 65us; 66us; 66us; 66us; 66us; 67us; 67us; 67us; 67us; 68us; 69us; 69us; 70us; 70us; 70us; 70us; 71us; 71us; 71us; 72us; 72us; 72us; 73us; 73us; 73us; 73us; 74us; 74us; 75us; 75us; 75us; 76us; 76us; 76us; 77us; 78us; 78us; 78us; 79us; 79us; 80us; 81us; 81us; 82us; 82us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 84us; 85us; 86us; 86us; 87us; 87us; 87us; 87us; 88us; 88us; 89us; 89us; 89us; 90us; 90us; 91us; 91us; 92us; 92us; 93us; 93us; 93us; 94us; 94us; 95us; 96us; 96us; 97us; 97us; 98us; 98us; 98us; 99us; 99us; 100us; 100us; 100us; 100us; 101us; 101us; 102us; 102us; 102us; 102us; 102us; 103us; 103us; 103us; 104us; 104us; 105us; 105us; 105us; 106us; 107us; 107us; 107us; 108us; 108us; 109us; 109us; 109us; 110us; 110us; 111us; 111us; 112us; 113us; 114us; 114us; 114us; 115us; 116us; 116us; 117us; 117us; 118us; 118us; 119us; 119us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 121us; 121us; 122us; 122us; 122us; 123us; 124us; 124us; 125us; 125us; 125us; 125us; 126us; 126us; 126us; 127us; 127us; 127us; 128us; 128us; 129us; 129us; 130us; 130us; 131us; 131us; 132us; 132us; 133us; 134us; 135us; 136us; 137us; 138us; 138us; 139us; 139us; 140us; 141us; 141us; 142us; 143us; 144us; 145us; 145us; 145us; 145us; 146us; 146us; 147us; 148us; 148us; 148us; 149us; 149us; 150us; 150us; 151us; 151us; 151us; 151us; 151us; 152us; 152us; 153us; 154us; 154us; 155us; 155us; 156us; 156us; 156us; 157us; 157us; 157us; 158us; 159us; 159us; 160us; 161us; 161us; 162us; 162us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 164us; 164us; 164us; 164us; 165us; 165us; 166us; 166us; 167us; 167us; 168us; 169us; 169us; 169us; 169us; 170us; 170us; 171us; 171us; 171us; 171us; 171us; 172us; 172us; 172us; 172us; 172us; 172us; 173us; 173us; 174us; 174us; 175us; 175us; 176us; 177us; 177us; 177us; 177us; 177us; 177us; 178us; 178us; 179us; 179us; 179us; 179us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 181us; 181us; 182us; 182us; 182us; 182us; 182us; 182us; 182us; 182us; 183us; 183us; 184us; 184us; 185us; 185us; 186us; 187us; 187us; 187us; 188us; 188us; 188us; 189us; 189us; 190us; 190us; 191us; 191us; 192us; 193us; 193us; 193us; 193us; 193us; 193us; 194us; 194us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 196us; 196us; 197us; 197us; 197us; 198us; 198us; 198us; 198us; 199us; 200us; 200us; 200us; 200us; 200us; 201us; 201us; 202us; 203us; 204us; 204us; 204us; 205us; 205us; 205us; 205us; 205us; 205us; 206us; 206us; 206us; 206us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 208us; 208us; 209us; 209us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 212us; 212us; 213us; 213us; 213us; 213us; 213us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 215us; 215us; 215us; 215us; 216us; 216us; 216us; 216us; 217us; 217us; 217us; 217us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 219us; 219us; 219us; 220us; 220us; 221us; 221us; 222us; 222us; 222us; 222us; 222us; 223us; 223us; 223us; 224us; 224us; 225us; 225us; 226us; 226us; 226us; 227us; 228us; 228us; 228us; 228us; 229us; 229us; 230us; 230us; 231us; 232us; 232us; 233us; 233us; 234us; 234us; 235us; 235us; 235us; 236us; 236us; 237us; 237us; 237us; 237us; 237us; 237us; 237us; 238us; 238us; 239us; 239us; 239us; 239us; 240us; 240us; 241us; 241us; 242us; 242us; 242us; 242us; 242us; 243us; 243us; 243us; 244us; 244us; 244us; 245us; 245us; 246us; 246us; 246us; 247us; 248us; 248us; 248us; 249us; 250us; 250us; 251us; 251us; 251us; 251us; 251us; 252us; 252us; 252us; 252us; 252us; 252us; 252us; 252us; 253us; 253us; 254us; 254us; 255us; 255us; 256us; 256us; 257us; 257us; 258us; 258us; 259us; 259us; 260us; 260us; 260us; 260us; 260us; 260us; 261us; 261us; 262us; 263us; 263us; 263us; 263us; 264us; 264us; 264us; 265us; 265us; 266us; 266us; 267us; 267us; 267us; 267us; 267us; 267us; 267us; 268us; 268us; 268us; 268us; 269us; 270us; 270us; 270us; 271us; 271us; 272us; 272us; 273us; 273us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 275us; 275us; 276us; 276us; 276us; 276us; 276us; 276us; 276us; 277us; 277us; 277us; 278us; 278us; 279us; 280us; 280us; 281us; 281us; 281us; 282us; 282us; 282us; 283us; 283us; 284us; 284us; 284us; 284us; 285us; 285us; 286us; 287us; 288us; 288us; 288us; 288us; 289us; 289us; 289us; 289us; 289us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 291us; 292us; 292us; 293us; 293us; 294us; 294us; 294us; 294us; 295us; 296us; 296us; 296us; 297us; 297us; 298us; 298us; 299us; 299us; 299us; 299us; 300us; 300us; 300us; 301us; 301us; 301us; 301us; 302us; 302us; 303us; 303us; 304us; 304us; 305us; 305us; 306us; 306us; 307us; 307us; 308us; 308us; 309us; 309us; 310us; 310us; 311us; 311us; 312us; 312us; 313us; 313us; 314us; 314us; 315us; 315us; 316us; 316us; 316us; 317us; 317us; 318us; 318us; 318us; 319us; 319us; 319us; 320us; 320us; 320us; 321us; 322us; 322us; 322us; 323us; 323us; 323us; 324us; 324us; 324us; 324us; 324us; 325us; 325us; 325us; 325us; 325us; 325us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 16389us; 16390us; 16391us; 16392us; 16393us; 16394us; 65535us; 16395us; 65535us; 16396us; 65535us; 16397us; 65535us; 16398us; 65535us; 16399us; 65535us; 16400us; 65535us; 16402us; 65535us; 65535us; 65535us; 16404us; 65535us; 16406us; 16407us; 16408us; 65535us; 65535us; 65535us; 16411us; 16412us; 65535us; 16413us; 65535us; 16414us; 65535us; 16415us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16419us; 65535us; 16420us; 65535us; 65535us; 16422us; 65535us; 65535us; 65535us; 16423us; 16424us; 16425us; 65535us; 65535us; 65535us; 16426us; 16427us; 65535us; 16428us; 16429us; 65535us; 65535us; 65535us; 16432us; 65535us; 65535us; 16433us; 16435us; 16436us; 65535us; 65535us; 65535us; 65535us; 16437us; 16438us; 16439us; 16440us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16442us; 65535us; 65535us; 65535us; 65535us; 16445us; 65535us; 65535us; 16446us; 65535us; 65535us; 65535us; 16447us; 65535us; 65535us; 16448us; 65535us; 16449us; 65535us; 65535us; 16450us; 65535us; 65535us; 16452us; 16453us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16454us; 65535us; 16455us; 16456us; 16457us; 65535us; 65535us; 16458us; 16459us; 65535us; 65535us; 16460us; 16461us; 65535us; 16462us; 65535us; 65535us; 16463us; 16464us; 65535us; 65535us; 16465us; 16466us; 65535us; 65535us; 16467us; 16468us; 16469us; 16470us; 65535us; 65535us; 16472us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16473us; 65535us; 65535us; 65535us; 65535us; 65535us; 16476us; 65535us; 65535us; 16477us; 65535us; 16478us; 65535us; 65535us; 16479us; 65535us; 16481us; 65535us; 65535us; 16482us; 16483us; 65535us; 65535us; 16485us; 16486us; 65535us; 16488us; 65535us; 16489us; 65535us; 65535us; 16490us; 65535us; 16492us; 65535us; 16493us; 65535us; 16494us; 65535us; 16496us; 65535us; 16497us; 65535us; 65535us; 16499us; 65535us; 65535us; 65535us; 16500us; 16501us; 65535us; 65535us; 65535us; 16502us; 16503us; 65535us; 16504us; 16505us; 16506us; 65535us; 65535us; 65535us; 65535us; 16508us; 16511us; 16512us; 65535us; 16513us; 65535us; 16514us; 65535us; 65535us; 65535us; 65535us; 16517us; 16518us; 16519us; 65535us; 65535us; 16520us; 65535us; 16521us; 65535us; 16522us; 65535us; 65535us; 16523us; 16524us; 65535us; 65535us; 16525us; 65535us; 16526us; 16527us; 65535us; 16528us; 65535us; 65535us; 65535us; 16530us; 16531us; 65535us; 16532us; 16533us; 16534us; 16535us; 65535us; 65535us; 65535us; 16537us; 16538us; 16539us; 65535us; 65535us; 16540us; 16541us; 65535us; 16544us; 65535us; 65535us; 65535us; 65535us; 16545us; 65535us; 65535us; 16546us; 16547us; 16548us; 16549us; 65535us; 16550us; 65535us; 65535us; 16551us; 65535us; 65535us; 65535us; 16552us; 65535us; 65535us; 65535us; 65535us; 16553us; 65535us; 16554us; 65535us; 16555us; 65535us; 16556us; 65535us; 16557us; 65535us; 16558us; 16559us; 16560us; 16561us; 65535us; 65535us; 16562us; 65535us; 65535us; 16563us; 65535us; 65535us; 16566us; 16567us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16568us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16569us; 16570us; 65535us; 16571us; 16572us; 16573us; 65535us; 65535us; 16574us; 16575us; 65535us; 65535us; 16576us; 16577us; 65535us; 16578us; 65535us; 65535us; 16579us; 16580us; 65535us; 65535us; 16581us; 16582us; 16583us; 16584us; 65535us; 16585us; 65535us; 65535us; 16587us; 65535us; 16588us; 65535us; 65535us; 16589us; 16590us; 65535us; 65535us; 16592us; 65535us; 65535us; 65535us; 65535us; 65535us; 16593us; 65535us; 65535us; 65535us; 65535us; 16594us; 16595us; 65535us; 16597us; 65535us; 65535us; 65535us; 65535us; 16598us; 16599us; 65535us; 65535us; 16600us; 65535us; 65535us; 16601us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16602us; 16603us; 65535us; 16604us; 65535us; 16605us; 65535us; 16606us; 65535us; 65535us; 65535us; 65535us; 65535us; 16607us; 65535us; 16608us; 65535us; 65535us; 65535us; 65535us; 65535us; 16609us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16610us; 65535us; 16612us; 65535us; 65535us; 16613us; 65535us; 65535us; 16614us; 16615us; 65535us; 16616us; 16618us; 16619us; 16620us; 16621us; 16622us; 65535us; 65535us; 16624us; 65535us; 65535us; 16626us; 65535us; 65535us; 16628us; 65535us; 65535us; 16629us; 16630us; 16631us; 65535us; 16633us; 16634us; 65535us; 16636us; 16637us; 65535us; 65535us; 16638us; 16639us; 16640us; 65535us; 65535us; 16641us; 65535us; 65535us; 65535us; 65535us; 16643us; 65535us; 16644us; 16645us; 65535us; 65535us; 16646us; 16647us; 16648us; 65535us; 65535us; 65535us; 65535us; 65535us; 16649us; 16650us; 16651us; 16652us; 65535us; 65535us; 16653us; 65535us; 65535us; 16654us; 16655us; 65535us; 16656us; 65535us; 16657us; 16658us; 65535us; 65535us; 16659us; 16660us; 65535us; 16661us; 65535us; 65535us; 16662us; 16663us; 16664us; 16665us; 16666us; 16667us; 65535us; 65535us; 65535us; 65535us; 16670us; 16671us; 65535us; 65535us; 16672us; 65535us; 65535us; 65535us; 65535us; 16673us; 16674us; 65535us; 16675us; 65535us; 65535us; 65535us; 16676us; 16677us; 65535us; 65535us; 65535us; 65535us; 16680us; 16681us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16687us; 16688us; 65535us; 65535us; 65535us; 16689us; 65535us; 65535us; 16690us; 65535us; 16691us; 65535us; 16692us; 16693us; 65535us; 65535us; 16694us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16695us; 65535us; 16696us; 16697us; 65535us; 65535us; 65535us; 65535us; 16701us; 65535us; 65535us; 16702us; 65535us; 16704us; 65535us; 65535us; 16705us; 65535us; 65535us; 65535us; 16707us; 65535us; 65535us; 16708us; 65535us; 65535us; 16709us; 65535us; 65535us; 16710us; 16711us; 65535us; 65535us; 16712us; 65535us; 65535us; 16713us; 65535us; 16714us; 65535us; 65535us; 65535us; 16716us; 65535us; 16717us; 65535us; 65535us; 16719us; 65535us; 65535us; 65535us; 65535us; 16723us; 16724us; 65535us; 65535us; 16725us; 16726us; 65535us; 16727us; 65535us; 65535us; 65535us; 65535us; 16728us; 65535us; 16729us; 16730us; 65535us; 65535us; 65535us; 65535us; 16731us; 65535us; 65535us; 16733us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16737us; 16738us; 65535us; 16739us; 65535us; 65535us; 65535us; 16740us; 65535us; 65535us; 16741us; 16742us; 16743us; 16744us; 16745us; 16746us; 16747us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16748us; 65535us; 65535us; 65535us; 16752us; 65535us; 16753us; 65535us; 65535us; 16755us; 65535us; 65535us; 65535us; 65535us; 16757us; 16758us; 16759us; 65535us; 65535us; 16760us; 65535us; 65535us; 16763us; 65535us; 65535us; 16764us; 65535us; 16766us; 16767us; 65535us; 65535us; 65535us; 65535us; 65535us; 16768us; 16769us; 16770us; 65535us; 65535us; 16771us; 16772us; 16773us; 65535us; 65535us; 16775us; 65535us; 65535us; 65535us; 16777us; 65535us; 16778us; 16779us; 65535us; 65535us; 16780us; 16781us; 16782us; 16783us; 16784us; 16785us; 16786us; 16787us; 16788us; 16789us; 16790us; 16791us; 16792us; 16793us; 16794us; 65535us; 16795us; 16796us; 16797us; 16798us; 65535us; 65535us; 16799us; 65535us; 65535us; 65535us; 16800us; 16803us; 65535us; 65535us; 16804us; 16805us; 65535us; 16806us; 65535us; 65535us; 16808us; 65535us; 16810us; 65535us; 16811us; 65535us; 65535us; 65535us; 16812us; 65535us; 65535us; 16815us; 65535us; 65535us; 16816us; 16817us; 16818us; 65535us; 16819us; 16820us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16821us; 65535us; 65535us; 65535us; 65535us; 16826us; 65535us; 65535us; 65535us; 65535us; 65535us; 16831us; 65535us; 16832us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16835us; 65535us; 16836us; 65535us; 16837us; 65535us; 16838us; 16839us; 65535us; 65535us; 16840us; 16841us; 65535us; 16842us; 65535us; 16843us; 65535us; 16844us; 16846us; 65535us; 16847us; 65535us; 65535us; 16848us; 65535us; 65535us; 16849us; 65535us; 65535us; 16850us; 65535us; 65535us; 16852us; 16853us; 16854us; 16855us; 16856us; 16857us; 65535us; 65535us; 16858us; 16859us; 65535us; 65535us; 16861us; 65535us; 65535us; 65535us; 16862us; 16863us; 65535us; 16864us; 16865us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16868us; 65535us; 65535us; 65535us; 65535us; 16872us; 65535us; 65535us; 16875us; 65535us; 65535us; 65535us; 65535us; 65535us; 16880us; 65535us; 16881us; 65535us; 65535us; 16884us; 65535us; 16885us; 65535us; 65535us; 16886us; 16887us; 16888us; 65535us; 65535us; 16889us; 65535us; 65535us; 16891us; 65535us; 65535us; 16893us; 65535us; 16895us; 65535us; 65535us; 65535us; 65535us; 16896us; 65535us; 16899us; 65535us; 65535us; 65535us; 16900us; 65535us; 16902us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16903us; 65535us; 65535us; 16904us; 16905us; 65535us; 16906us; 16907us; 65535us; 16908us; 16909us; 16910us; 16911us; 16912us; 65535us; 65535us; 16913us; 16914us; 65535us; 65535us; 16915us; 16916us; 65535us; 65535us; 16917us; 16918us; 65535us; 16919us; 65535us; 65535us; 16920us; 16921us; 16922us; 65535us; 65535us; 65535us; 65535us; 65535us; 16926us; 65535us; 16927us; 65535us; 65535us; 65535us; 65535us; 16929us; 16930us; 65535us; 16931us; 16932us; 16933us; 16934us; 65535us; 65535us; 65535us; 65535us; 16935us; 16936us; 16937us; 16938us; 16939us; 65535us; 65535us; 65535us; 16940us; 16941us; 16942us; 16943us; 16944us; 65535us; 65535us; 16945us; 16946us; 16947us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16951us; 65535us; 65535us; 65535us; 65535us; 65535us; 16952us; 16953us; 65535us; 65535us; 65535us; 65535us; 16954us; 65535us; 65535us; 16955us; 65535us; 16956us; 65535us; 65535us; 65535us; 16958us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16959us; 65535us; 16960us; 65535us; 16961us; 65535us; 65535us; 65535us; 16963us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16976us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16986us; 16987us; 16988us; 16989us; 16990us; 16991us; 16992us; 16993us; 16994us; 16995us; 16996us; 16997us; 16998us; 16999us; 17000us; 17001us; 17002us; 17003us; 17004us; 17005us; 17007us; 65535us; 65535us; 17008us; 65535us; 17009us; 65535us; 65535us; 17010us; 17011us; 17012us; 65535us; 17013us; 17014us; 17015us; 17016us; 65535us; 65535us; 65535us; 17018us; 17019us; 17020us; 17021us; 65535us; 65535us; 17024us; 65535us; 17025us; 65535us; 65535us; 65535us; 65535us; 17027us; 17028us; 65535us; 65535us; 65535us; 65535us; 17031us; 17032us; 65535us; 17033us; 17034us; 65535us; 17036us; 65535us; 17037us; 65535us; 65535us; 17039us; 65535us; 65535us; 17040us; 65535us; 65535us; 17041us; 65535us; 65535us; 17042us; 65535us; 65535us; 17043us; 65535us; 65535us; 17044us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17045us; 65535us; 17046us; 17047us; 65535us; 17048us; 65535us; 17049us; 65535us; 65535us; 65535us; 17051us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17057us; 65535us; 65535us; 65535us; 17059us; 65535us; 65535us; 17060us; 65535us; 65535us; 17061us; 65535us; 17062us; 17063us; 17064us; 65535us; 65535us; 17065us; 17066us; 17067us; 17068us; 65535us; 65535us; 17069us; 17070us; 17071us; 17072us; 17073us; 17075us; 65535us; 65535us; 65535us; 65535us; 17076us; 65535us; 17077us; 65535us; 65535us; 17078us; 17079us; 65535us; 17080us; 17081us; 17082us; 17083us; 65535us; 65535us; 17084us; 65535us; 65535us; 17089us; 17091us; 17092us; 17093us; 17094us; 17095us; 17096us; 17097us; 17098us; 17099us; 17100us; 65535us; 65535us; 17101us; 17102us; 65535us; 17103us; 17104us; 65535us; 65535us; 65535us; 17105us; 17106us; 17107us; 17108us; 65535us; 65535us; 17109us; 17110us; 17111us; 17112us; 65535us; 65535us; 65535us; 17113us; 65535us; 17114us; 17115us; 17116us; 65535us; 17117us; 17118us; 17119us; 17120us; 17121us; 65535us; 65535us; 65535us; 65535us; 65535us; 17122us; 17123us; 17124us; 17125us; 65535us; 65535us; 17126us; 65535us; 17127us; 65535us; 65535us; 17129us; 17130us; 17131us; 17132us; 17133us; 17134us; 17135us; 17136us; 17137us; 17139us; 17140us; 65535us; 65535us; 17143us; 65535us; 17144us; 65535us; 17146us; 17147us; 17148us; 65535us; 65535us; 17150us; 17151us; 17152us; 65535us; 65535us; 65535us; 65535us; 65535us; 17153us; 17154us; 17157us; 65535us; 65535us; 65535us; 17159us; 65535us; 17161us; 65535us; 17162us; 65535us; 65535us; 65535us; 65535us; 65535us; 17163us; 17164us; 65535us; 65535us; 65535us; 17165us; 65535us; 65535us; 65535us; 65535us; 17168us; 65535us; 65535us; 65535us; 17169us; 65535us; 65535us; 17170us; 65535us; 65535us; 65535us; 17171us; 17172us; 65535us; 65535us; 65535us; 17176us; 17177us; 65535us; 17179us; 17180us; 65535us; 65535us; 17182us; 17184us; 17186us; 65535us; 65535us; 65535us; 17187us; 65535us; 17188us; 17190us; 17193us; 65535us; 17195us; 65535us; 65535us; 17196us; 65535us; 17197us; 65535us; 17198us; 65535us; 17200us; 65535us; 17201us; 65535us; 65535us; 65535us; 65535us; 17202us; 65535us; 17203us; 17204us; 65535us; 65535us; 17205us; 17206us; 17207us; 17208us; 17209us; 65535us; 65535us; 65535us; 17210us; 17211us; 65535us; 65535us; 65535us; 65535us; 17212us; 17213us; 65535us; 17214us; 17215us; 65535us; 17216us; 65535us; 17217us; 65535us; 17218us; 65535us; 65535us; 17219us; 65535us; 65535us; 65535us; 65535us; 65535us; 17225us; 65535us; 65535us; 17226us; 65535us; 65535us; 17228us; 65535us; 65535us; 17230us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17238us; 65535us; 17240us; 65535us; 65535us; 17241us; 65535us; 17242us; 65535us; 17243us; 65535us; 65535us; 17245us; 65535us; 17246us; 65535us; 17249us; 65535us; 65535us; 65535us; 65535us; 17250us; 65535us; 17252us; 65535us; 17253us; 17254us; 65535us; 65535us; 65535us; 17255us; 17256us; 65535us; 17257us; 65535us; 65535us; 17258us; 65535us; 17259us; 65535us; 17260us; 65535us; 17261us; 65535us; 17262us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17264us; 17265us; 65535us; 65535us; 17268us; 65535us; 65535us; 65535us; 17269us; 65535us; 65535us; 17272us; 65535us; 65535us; 17274us; 17275us; 65535us; 65535us; 65535us; 17276us; 17277us; 65535us; 65535us; 65535us; 65535us; 17278us; 17279us; 17280us; 17281us; 17282us; 17283us; 17284us; 65535us; 17286us; 17287us; 65535us; 17288us; 17289us; 65535us; 65535us; 17291us; 65535us; 17292us; 17293us; 65535us; 17294us; 65535us; 65535us; 65535us; 65535us; 17295us; 17296us; 17297us; 65535us; 17298us; 17299us; 17300us; 17301us; 65535us; 65535us; 17303us; 17305us; 17306us; 65535us; 65535us; 17308us; 65535us; 17309us; 65535us; 17311us; 65535us; 65535us; 17312us; 65535us; 65535us; 17314us; 17315us; 65535us; 17317us; 17318us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17322us; 17323us; 65535us; 65535us; 17324us; 17325us; 17326us; 17327us; 65535us; 17328us; 17329us; 65535us; 65535us; 17330us; 65535us; 17331us; 17332us; 65535us; 65535us; 17333us; 65535us; 65535us; 17334us; 17335us; 17336us; 17337us; 17338us; 17339us; 17340us; 17341us; 17342us; 17343us; 17344us; 17345us; 17346us; 17347us; 17348us; 17349us; 17350us; 17351us; 17352us; 17353us; 17354us; 17355us; 17356us; 17357us; 65535us; 17359us; 65535us; 17360us; 17361us; 65535us; 17362us; 17363us; 17364us; 17365us; 65535us; 17367us; 65535us; 17368us; 17369us; 17370us; 17371us; 17372us; 17373us; 65535us; 17375us; 65535us; 17376us; 65535us; 65535us; 17380us; 17381us; 17382us; 17383us; 17384us; 17385us; 17386us; 17387us; 17389us; 17391us; 17393us; 17395us; 17397us; 17401us; 17403us; 17405us; 17406us; 17407us; 17408us; 17409us; 17410us; 17411us; 17412us; 17413us; 17414us; 17415us; 17416us; 17417us; 17418us; 17420us; 65535us; 65535us; 17422us; 17423us; 17424us; 65535us; 65535us; 17425us; 17426us; 17427us; 65535us; 17428us; 17429us; 17430us; 17431us; 65535us; 17432us; 17433us; 17434us; 65535us; 17435us; 17436us; 17437us; 17438us; 17439us; 17440us; 17441us; 17442us; 17443us; 17444us; 17445us; 17446us; 17447us; 17448us; |]
let _fsyacc_reductions ()  =    [| 
//# 2766 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedSigFile)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startsignatureFile));
//# 2775 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedImplFile)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startimplementationFile));
//# 2784 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedFsiInteraction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startinteraction));
//# 2793 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_starttypedSeqExprEOF));
//# 2802 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_starttypEOF));
//# 2811 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 496 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            IDefns (_1,lhs parseState) 
                   )
//# 496 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2822 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 499 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            warning(Error(FSComp.SR.parsUnexpectedSemicolon(),rhs parseState 1))
                            IDefns ([],lhs parseState) 
                   )
//# 499 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2833 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 503 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            IDefns ([],lhs parseState) 
                   )
//# 503 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2843 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 507 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              
                   )
//# 507 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveTerminator));
//# 2853 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 508 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   checkEndOfFileError _1 
                   )
//# 508 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveTerminator));
//# 2864 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 522 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 522 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2875 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 525 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 525 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2887 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 528 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 528 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2899 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveHash)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2911 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 534 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 534 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2924 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 537 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 537 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2937 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveHash)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2950 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 546 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 546 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveDefns));
//# 2961 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 549 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _2 
                   )
//# 549 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveDefns));
//# 2973 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 555 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] in 
                             attrDecls @ [ mkSynDoDecl(_3)] 
                   )
//# 555 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveExpr));
//# 2990 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 565 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [SynModuleDecl.HashDirective(_1,rhs parseState 1)] 
                   )
//# 565 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveHash));
//# 3001 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 570 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    
                   )
//# 570 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparators));
//# 3012 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 571 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                      
                   )
//# 571 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparators));
//# 3024 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparator));
//# 3034 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 577 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 577 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparator));
//# 3044 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArgs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            ParsedHashDirective (_2,_3,lhs parseState) 
                   )
//# 587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirective));
//# 3056 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 593 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 593 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArgs));
//# 3066 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArgs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 596 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ [_2] 
                   )
//# 596 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArgs));
//# 3078 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 602 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 602 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArg));
//# 3089 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 611 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            checkEndOfFileError _2; _1 
                   )
//# 611 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3101 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 614 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 614 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3113 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 620 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let emptySigFileFrag = ParsedSigFileFragment.AnonModule([],rhs parseState 1) in 
                            ParsedSigFile ([],[emptySigFileFrag]) 
                   )
//# 620 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3125 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 628 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3, _4.Lid, grabXmlDoc(parseState,1), _2 
                   )
//# 628 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleIntro));
//# 3139 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 634 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, _3.Lid, grabXmlDoc(parseState,1)  
                   )
//# 634 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namespaceIntro));
//# 3151 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 640 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ParsedSigFile ([],[ (_1 (false,[],PreXmlDoc.Empty)) ]) 
                   )
//# 640 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecs));
//# 3162 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 643 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // If there are namespaces, the first fileModuleImpl may only contain # directives 
                             let decls = 
                                 match (_1 (false,[],PreXmlDoc.Empty)) with 
                                 | ParsedSigFileFragment.AnonModule(decls,m) -> decls  
                                 | ParsedSigFileFragment.NamespaceFragment(_,_,_, decls, _,_,_) -> decls 
                                 | ParsedSigFileFragment.NamedModule(SynModuleOrNamespaceSig(_,_,_,_,_,_,_,m)) ->
                                     raiseParseErrorAt m (FSComp.SR.parsOnlyHashDirectivesAllowed())
                             let decls = 
                                 decls |> List.collect (function 
                                     | (SynModuleSigDecl.HashDirective (hd,_)) -> [hd]
                                     | d ->  
                                          reportParseErrorAt d.Range (FSComp.SR.parsOnlyHashDirectivesAllowed())
                                          [])
                             ParsedSigFile (decls, _2) 
                   )
//# 643 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecs));
//# 3187 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpec)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 661 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 661 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecList));
//# 3199 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecList));
//# 3210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namespaceIntro)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'deprecated_opt_equals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let isRec,path,xml = _1 in (_3 (isRec,path,xml)) 
                   )
//# 668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpec));
//# 3223 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmptyBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 674 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                           let m2 = rhs parseState 3
                           let m = (rhs2 parseState 3 4)
                           let isRec,path2,xml,vis = _3 
                           (fun (isRec2,path,_) -> 
                             if not (isNil path) then errorR(Error(FSComp.SR.parsNamespaceOrModuleNotBoth(),m2))
                             let lid = path@path2 
                             ParsedSigFileFragment.NamedModule(SynModuleOrNamespaceSig(lid, (isRec || isRec2), NamedModule, _4, xml,_1,vis,m)))  
                   )
//# 674 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleSpec));
//# 3244 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmptyBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = (rhs parseState 1) 
                           (fun (isRec, path, xml) -> 
                             match path with 
                             | [] -> ParsedSigFileFragment.AnonModule(_1, m)  
                             | _ -> ParsedSigFileFragment.NamespaceFragment(path, isRec, DeclaredNamespace, _1, xml,[],m))  
                   )
//# 684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleSpec));
//# 3259 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 693 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 693 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3270 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 696 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 696 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3283 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                              // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                              _2 
                            
                   )
//# 699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3298 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 705 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              [] 
                   )
//# 705 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3309 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 710 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 710 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3320 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 713 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 713 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3330 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 716 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 716 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3340 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 721 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 721 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3353 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) _3 
                   )
//# 724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3365 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 727 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 727 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3377 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 732 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynModuleSigDecl.HashDirective (_1,rhs2 parseState 1 1)  
                   )
//# 732 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3388 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'valSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 735 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 735 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'colonOrEquals)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'namedModuleAbbrevBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 738 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let isRec, path, xml, vis = _3 
                             if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                             if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                             if not (isNil _1) then raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviation())
                             match vis with
                             | Some vis -> raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreVisibilityOnModuleAbbreviationAlwaysPrivate(vis.ToString()))
                             | _ -> SynModuleSigDecl.ModuleAbbrev(List.head path,_5,rhs2 parseState 3 5) 
                   )
//# 738 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'colonOrEquals)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpecBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 748 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let isRec, path, xml, vis = _3 
                             if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleDefnMustBeSimpleName())
                             if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                             let info = ComponentInfo(_1,[],[],path,xml,false,vis,rhs parseState 3)
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             SynModuleSigDecl.NestedModule(info, isRec, _5, rhs2 parseState 3 5) 
                   )
//# 748 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3441 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSig list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 756 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (TypeDefnSig(ComponentInfo(cas,a,cs,b,c,d,d2,d3),e,f,g)),rest = 
                                match _3 with
                                | [] -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEmptyModuleDefn()) 
                                | h :: t -> h,t 
                             let tc = (TypeDefnSig(ComponentInfo(_1@cas,a,cs,b,c,d,d2,d3),e,f,g))in 
                             SynModuleSigDecl.Types (tc :: rest,rhs parseState 3) 
                   )
//# 756 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3460 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 765 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (SynExceptionSig(SynExceptionDefnRepr(cas,a,b,c,d,d2),e,f)) = _3 
                             let ec = (SynExceptionSig(SynExceptionDefnRepr(_1@cas,a,b,c,d,d2),e,f)) 
                             SynModuleSigDecl.Exception(ec, rhs parseState 3) 
                   )
//# 765 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3476 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 771 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynModuleSigDecl.Open (_2.Lid, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 771 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3487 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _11 = (let data = parseState.GetInput(11) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _12 = (let data = parseState.GetInput(12) in (Microsoft.FSharp.Core.Operators.unbox data : 'optLiteralValueSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 775 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let attr1,attr2,isInline,isMutable,vis2,id,doc,explicitValTyparDecls,(ty,arity),konst = (_1),(_4),(_5),(_6),(_7),(_8),grabXmlDoc(parseState,3),(_9),(_11),(_12) 
                             if not (isNil attr2) then errorR(Deprecated(FSComp.SR.parsAttributesMustComeBeforeVal(),rhs parseState 4))
                             let m = rhs2 parseState 3 11 
                             let valSpfn = ValSpfn((attr1@attr2),id,explicitValTyparDecls,ty,arity,isInline,isMutable,doc, vis2,konst,m) 
                             SynModuleSigDecl.Val(valSpfn,m)
                           
                   )
//# 775 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'valSpfn));
//# 3513 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3523 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 789 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_2) 
                   )
//# 789 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3534 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 792 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_3) 
                   )
//# 792 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3546 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3558 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'sigOrBegin)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 804 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 
                   )
//# 804 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3571 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sigOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 808 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 808 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3583 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 814 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 814 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSig list));
//# 3595 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnList));
//# 3607 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 822 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 822 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnList));
//# 3618 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 828 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = rhs parseState 1 
                             _3 lhsm _1 
                   )
//# 828 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfn));
//# 3631 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             TypeDefnSig(_1,SynTypeDefnSigRepr.Simple (SynTypeDefnSimpleRepr.None (lhs parseState),lhs parseState),_2,lhs parseState) 
                   )
//# 831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfn));
//# 3643 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            (fun lhsm nameInfo -> 
                                _2 lhsm nameInfo (checkForMultipleAugmentations m (_4 @ _5) _7)) 
                   )
//# 845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhsBlock));
//# 3661 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 850 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            (fun lhsm nameInfo -> 
                                _1 lhsm nameInfo _2) 
                   )
//# 850 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhsBlock));
//# 3675 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSimpleRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 858 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range 
                            (fun lhsm nameInfo augmentation -> 
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.Simple (_1,m),augmentation,m)) 
                   )
//# 858 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3688 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconClassSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 863 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let needsCheck,(kind,decls) = _1
                            (fun nameRange nameInfo augmentation -> 
                                if needsCheck && isNil decls then
                                   reportParseErrorAt nameRange (FSComp.SR.parsEmptyTypeDefinition())
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.ObjectModel (kind,decls,m),augmentation,m)) 
                   )
//# 863 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3704 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 871 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let ty,arity = _3
                            let invoke = SynMemberSig.Member(ValSpfn([],mkSynId m "Invoke",inferredTyparDecls,ty,arity,false,false,PreXmlDoc.Empty,None,None,m),AbstractMemberFlags MemberKind.Member,m) 
                            (fun nameRange nameInfo augmentation -> 
                                if not (isNil augmentation) then raiseParseErrorAt m (FSComp.SR.parsAugmentationsIllegalOnDelegateType())
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.ObjectModel (TyconDelegate (ty,arity),[invoke],m),[],m)) 
                   )
//# 871 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3720 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlockKindUnspecified)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 882 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,decls = _1 
                            needsCheck,(TyconUnspecified, decls) 
                   )
//# 882 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3732 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 886 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false,(_1,_2) 
                   )
//# 886 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3744 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 889 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedClassInterfaceOrStruct())
                            false,(_1,_2) 
                   )
//# 889 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3758 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 893 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            false,(_1,[]) 
                   )
//# 893 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            true, _2 
                   )
//# 900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3782 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 903 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeSignature())
                            false, _2 
                   )
//# 903 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3795 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false, _2 
                   )
//# 908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3806 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false, _2 
                   )
//# 911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3818 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 917 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 917 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3830 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeSignature())
                             _2 
                   )
//# 920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3843 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 923 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 923 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3854 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembersAtLeastOne)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 928 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 928 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembers));
//# 3865 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembers));
//# 3875 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 937 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 937 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembersAtLeastOne));
//# 3888 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberSpecFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _10 = (let data = parseState.GetInput(10) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            let _11 = (let data = parseState.GetInput(11) in (Microsoft.FSharp.Core.Operators.unbox data : 'optLiteralValueSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let isInline,doc,vis2,id,explicitValTyparDecls,(ty,arity),optLiteralValue = _4,grabXmlDoc(parseState,3),_5,_6,_7,_9,_11
                            let getSetRangeOpt, getSet = _10 
                            let getSetAdjuster arity = match arity,getSet with SynValInfo([],_),MemberKind.Member -> MemberKind.PropertyGet | _ -> getSet
                            let wholeRange = 
                                let m = rhs parseState 3 
                                match getSetRangeOpt with 
                                | None -> unionRanges m ty.Range
                                | Some m2 -> unionRanges m m2
                            let valSpfn = ValSpfn(_1,id,explicitValTyparDecls,ty,arity, isInline,false,doc, vis2,optLiteralValue,wholeRange)
                            let _,flags = _3 
                            SynMemberSig.Member(valSpfn, flags (getSetAdjuster arity),wholeRange) 
                   )
//# 943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3919 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 957 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.Interface (_4,unionRanges (rhs parseState 3) (_4).Range) 
                   )
//# 957 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3934 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 961 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.Inherit (_4,unionRanges (rhs parseState 3) (_4).Range) 
                   )
//# 961 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3948 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 965 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let fld = _4 _1 false 
                            SynMemberSig.ValField(fld,rhs2 parseState 3 4) 
                   )
//# 965 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3963 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.ValField(_5 _1 true,rhs2 parseState 3 5) 
                   )
//# 970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3977 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 974 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.NestedType(_5,rhs2 parseState 3 5) 
                   )
//# 974 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3992 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 978 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let vis,doc,(ty,valSynInfo) = _2,grabXmlDoc(parseState,3),_5 
                            let m = unionRanges (rhs parseState 3) ty.Range 
                            let isInline = false 
                            let valSpfn = ValSpfn (_1, mkSynId (rhs parseState 3) "new", noInferredTypars, ty, valSynInfo, isInline, false, doc, vis, None, m)
                            SynMemberSig.Member(valSpfn, CtorMemberFlags,m) 
                   )
//# 978 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 4009 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           None, MemberKind.Member 
                   )
//# 988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4019 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           Some (rhs2 parseState 1 2), _2 
                   )
//# 991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4030 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 994 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           Some (rhs2 parseState 1 2), _2 
                   )
//# 994 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4041 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 997 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedWith())
                            Some (rhs2 parseState 1 2), _2 
                   )
//# 997 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4053 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1004 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           (let (id:Ident) = _1 
                            if id.idText = "get" then MemberKind.PropertyGet 
                            else if id.idText = "set" then MemberKind.PropertySet 
                            else raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsGetOrSetRequired())) 
                   )
//# 1004 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSetElements));
//# 4067 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1010 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let (id:Ident) = _1 
                           if not ((id.idText = "get" && _3.idText = "set") ||
                                   (id.idText = "set" && _3.idText = "get")) then 
                              raiseParseErrorAt (rhs2 parseState 1 3) (FSComp.SR.parsGetOrSetRequired())
                           MemberKind.PropertyGetSet 
                   )
//# 1010 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSetElements));
//# 4083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       _1 
                   )
//# 1017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,AbstractMemberFlags) 
                   )
//# 1018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4104 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,AbstractMemberFlags) 
                   )
//# 1019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4114 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefnRepr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1025 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionSig(_1,_2,lhs parseState) 
                   )
//# 1025 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconSpfn));
//# 4126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1031 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1031 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classSpfn));
//# 4138 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classSpfn));
//# 4148 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpls)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            checkEndOfFileError _2; _1 
                   )
//# 1043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4160 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1046 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1046 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4172 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1052 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let emptyImplFileFrag = ParsedImplFileFragment.AnonModule([],rhs parseState 1) in 
                            ParsedImplFile ([],[emptyImplFileFrag]) 
                   )
//# 1052 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4184 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1059 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ParsedImplFile ([], [ (_1 (false,[],PreXmlDoc.Empty)) ]) 
                   )
//# 1059 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpls));
//# 4195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImplList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1062 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // If there are namespaces, the first fileModuleImpl may only contain # directives 
                             let decls = 
                                 match (_1 (false,[],PreXmlDoc.Empty)) with 
                                 | ParsedImplFileFragment.AnonModule(decls,m) -> decls  
                                 | ParsedImplFileFragment.NamespaceFragment(_,_,_, decls, _,_,_) -> decls 
                                 | ParsedImplFileFragment.NamedModule(SynModuleOrNamespace(_,_,_,_,_,_,_,m)) ->
                                     raiseParseErrorAt m (FSComp.SR.parsOnlyHashDirectivesAllowed())
                             let decls = 
                                 decls |> List.collect (function 
                                     | (SynModuleDecl.HashDirective (hd,_)) -> [hd]
                                     | d ->  
                                          reportParseErrorAt d.Range (FSComp.SR.parsOnlyHashDirectivesAllowed())
                                          [])
                             ParsedImplFile (decls, _2) 
                   )
//# 1062 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpls));
//# 4220 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImplList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1081 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 1081 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImplList));
//# 4232 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1084 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 1084 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImplList));
//# 4243 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namespaceIntro)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'deprecated_opt_equals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1090 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let isRec, path, xml = _1 in (_3 (isRec, path, xml)) 
                   )
//# 1090 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpl));
//# 4256 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynModuleDecl list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1096 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                           let m2 = rhs parseState 3
                           let m = (m2, _4) ||> unionRangeWithListBy (fun modu -> modu.Range)
                           let isRec2,path2,xml,vis = _3 
                           (fun (isRec, path, _) -> 
                             if not (isNil path) then errorR(Error(FSComp.SR.parsNamespaceOrModuleNotBoth(),m2))
                             let lid = path@path2 
                             ParsedImplFileFragment.NamedModule(SynModuleOrNamespace(lid, (isRec || isRec2), NamedModule, _4, xml,_1,vis,m))) 
                   )
//# 1096 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleImpl));
//# 4277 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynModuleDecl list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = (rhs parseState 1) 
                           (fun (isRec, path, xml) -> 
                             match path with 
                             | [] -> ParsedImplFileFragment.AnonModule(_1,m)  
                             | _ -> ParsedImplFileFragment.NamespaceFragment(path, isRec, DeclaredNamespace, _1, xml,[],m)) 
                   )
//# 1106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleImpl));
//# 4292 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1116 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1116 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4305 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                            _2 
                   )
//# 1119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4319 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            []  
                   )
//# 1124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4330 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1127 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1127 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4341 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1133 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1133 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExprPossiblyEmpty));
//# 4352 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1136 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1136 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExprPossiblyEmpty));
//# 4362 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1143 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ mkSynDoDecl (_3) :: _5 
                   )
//# 1143 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4381 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1150 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ [ mkSynDoDecl(_3) ] 
                   )
//# 1150 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ [ mkSynDoDecl(_3) ] 
                   )
//# 1157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4416 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1164 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1164 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4427 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1167 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                   )
//# 1167 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4438 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1173 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _2 
                   )
//# 1173 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4450 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1176 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _3 
                   )
//# 1176 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4463 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1179 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1179 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4474 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1182 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1182 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4486 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1185 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 
                   )
//# 1185 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4498 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1  
                   )
//# 1191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnOrDirective));
//# 4509 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1194 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [ SynModuleDecl.HashDirective (_1,rhs2 parseState 1 1) ] 
                   )
//# 1194 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnOrDirective));
//# 4520 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1203 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             parseState.ResetSynArgNameGenerator()
                             let (BindingSetPreAttrs(_,_,_,_,mWhole)) = _3 
                             mkDefnBindings (mWhole,_3,_1,_2,mWhole)  
                   )
//# 1203 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4536 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1210 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let hwlb,m = _3
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             parseState.ResetSynArgNameGenerator()
                             mkDefnBindings (m,hwlb,_1,_2,m)  
                   )
//# 1210 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4552 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1217 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let mWhole = rhs parseState 3 
                             mkDefnBindings (mWhole,_3,_1,_2,mWhole) 
                   )
//# 1217 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4567 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1223 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let      (TypeDefn(ComponentInfo(cas,a,cs,b,c,d,d2,d3),e,f,g)) = _4
                             let tc = (TypeDefn(ComponentInfo(_1@cas,a,cs,b,c,d,d2,d3),e,f,g))
                             let types = tc :: _5
                             [ SynModuleDecl.Types(types, (rhs parseState 3, types) ||> unionRangeWithListBy (fun t -> t.Range) ) ] 
                   )
//# 1223 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4586 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1231 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (SynExceptionDefn(SynExceptionDefnRepr(cas,a,b,c,d,d2),e,f)) = _3 
                             let f = (f, _1) ||> unionRangeWithListBy (fun a -> a.Range)
                             let ec = (SynExceptionDefn(SynExceptionDefnRepr(_1@cas,a,b,c,d,d2),e,f)) 
                             [ SynModuleDecl.Exception(ec, f) ] 
                   )
//# 1231 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'namedModuleDefnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1239 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let attribs, (isRec, path, xml, vis) = _1,_3 
                             match _5 with 
                             | Choice1Of2 eqn -> 
                                 if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                                 if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                                 if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                                 if not (isNil _1) then raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviation())
                                 match vis with
                                 | Some vis -> raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviationAlwaysPrivate(vis.ToString()))
                                 | _ -> ()
                                 [ SynModuleDecl.ModuleAbbrev(List.head path,eqn,(rhs parseState 3, eqn) ||> unionRangeWithListBy (fun id -> id.idRange) ) ]
                             | Choice2Of2 def -> 
                                 if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                                 let info = ComponentInfo(attribs,[],[],path,xml,false,vis,rhs parseState 3)
                                 [ SynModuleDecl.NestedModule(info, isRec, def, false,(rhs2 parseState 3 4, def) ||> unionRangeWithListBy (fun d -> d.Range) ) ] 
                   )
//# 1239 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4632 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1258 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             errorR(Error(FSComp.SR.parsAttributeOnIncompleteCode(),rhs parseState 1))
                             [] 
                   )
//# 1258 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4645 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1263 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [SynModuleDecl.Open(_1, _1.Range)] 
                   )
//# 1263 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4656 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2.Lid 
                   )
//# 1271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleAbbrevBlock));
//# 4668 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1274 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1.Lid  
                   )
//# 1274 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleAbbrevBlock));
//# 4679 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1280 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 _2  
                   )
//# 1280 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4691 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1283 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            Choice2Of2 _2 
                   )
//# 1283 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4704 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1287 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // There is an ambiguity here 
                              // In particular, consider the following two:
                              //
                              // module M2 = 
                              //    System.DateTime.Now
                              // module M2 = 
                              //    Microsoft.FSharp.Core.List
                              // The second is a module abbreviation, the first a module containing a single expression.
                              // The resolution is in favour of the module abbreviation, i.e. anything of the form 
                              //    module M2 = ID.ID.ID.ID
                              // will be taken as a module abbreviation, regardles of the identifiers themselves.
                              //
                              // This is similar to the ambiguitty between 
                              //    type X = int
                              // and 
                              //    type X = OneValue
                              // However in that case we do use type name lookup to make the resolution.
                              match _2 with 
                              | [ SynModuleDecl.DoExpr (_,LongOrSingleIdent(false,LongIdentWithDots(path,_),None,_),_) ] -> 
                                  Choice1Of2  path
                              | _ -> 
                                  Choice2Of2 _2 
                            
                   )
//# 1287 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4738 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                            Choice2Of2 _2 
                   )
//# 1313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4752 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1318 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 [] 
                   )
//# 1318 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4763 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 _1 
                   )
//# 1321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4774 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1324 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice1Of2 _1.Lid 
                   )
//# 1324 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4785 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4797 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBeginOrStruct())  
                            _2 
                   )
//# 1333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4811 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1337 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1337 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4822 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1342 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1342 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynMemberDefns));
//# 4834 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1348 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1348 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_attributes));
//# 4845 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1351 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 1351 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_attributes));
//# 4855 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1356 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1356 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributes));
//# 4866 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeList)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1359 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _2 
                   )
//# 1359 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributes));
//# 4878 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1365 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkAttributeList _2 (rhs2 parseState 1 3) 
                   )
//# 1365 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4891 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkAttributeList [] (rhs2 parseState 1 3) 
                   )
//# 1368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4902 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedLBrackLess())
                             mkAttributeList _2 (rhs2 parseState 1 2) 
                   )
//# 1371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4916 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedLBrackLess())
                             mkAttributeList [] (rhs parseState 1) 
                   )
//# 1375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4928 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attribute)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 1382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeListElements));
//# 4939 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attribute)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1385 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ [_3] 
                   )
//# 1385 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeListElements));
//# 4952 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1392 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _3 with None -> mkSynUnit _1.Range | Some e -> e 
                            ({ TypeName=_1; ArgExpr=arg; Target=None; AppliesToGetterAndSetter=false; Range=_1.Range } : SynAttribute) 
                   )
//# 1392 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4966 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeTarget)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1397 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _4 with None -> mkSynUnit _2.Range | Some e -> e 
                            ({ TypeName=_2; ArgExpr=arg; Target=_1; AppliesToGetterAndSetter=false; Range=_2.Range } : SynAttribute) 
                   )
//# 1397 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4981 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeTarget)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1402 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _6 with None -> mkSynUnit _3.Range | Some e -> e 
                            ({ TypeName=_3; ArgExpr=arg; Target=_1; AppliesToGetterAndSetter=false; Range=_3.Range } : SynAttribute) 
                   )
//# 1402 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4997 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1409 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(ident("module",(rhs parseState 1))) 
                   )
//# 1409 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5008 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1412 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(ident("type",(rhs parseState 1))) 
                   )
//# 1412 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5019 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1414 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some(_1) 
                   )
//# 1414 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5030 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1418 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSyntaxError())
                             Some(ident("return",(rhs parseState 1))) 
                   )
//# 1418 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5042 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1423 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (true,StaticMemberFlags) 
                   )
//# 1423 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5052 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1424 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,NonVirtualMemberFlags) 
                   )
//# 1424 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1425 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,OverrideMemberFlags) 
                   )
//# 1425 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1426 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          (false,OverrideMemberFlags) 
                   )
//# 1426 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5082 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconNameAndTyparDecls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1431 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let typars,lid,fixity,tpcs1,vis,xmlDoc = _2 
                            let tpcs2 = _3 
                            ComponentInfo(_1,typars,(tpcs1 @ tpcs2),lid,xmlDoc,fixity,vis,rangeOfLid lid)  
                   )
//# 1431 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeNameInfo));
//# 5097 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1438 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 :: _3 
                   )
//# 1438 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnList));
//# 5109 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1440 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1440 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnList));
//# 5119 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1445 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            TypeDefn(_1,SynTypeDefnRepr.Simple(SynTypeDefnSimpleRepr.None(_1.Range),_1.Range),[],_1.Range) 
                   )
//# 1445 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5130 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1448 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let nameRange = rhs parseState 1
                            let (tcDefRepr:SynTypeDefnRepr),members = _3 nameRange
                            let declRange = unionRanges (rhs parseState 1) tcDefRepr.Range
                            let mWhole = (declRange, members) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)    
                            TypeDefn(_1, tcDefRepr, members, mWhole) 
                   )
//# 1448 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5146 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynMemberDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1455 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun mem -> mem.Range)
                            TypeDefn(_1,SynTypeDefnRepr.ObjectModel(TyconAugmentation,[],m),_2,m) 
                   )
//# 1455 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5159 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatterns)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'optAsSpec)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1459 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let vis,spats, az = _3,_5,_6
                            let nameRange = rhs parseState 1
                            let (tcDefRepr,members) = _8 nameRange
                            let (ComponentInfo(_,_,_,lid,_,_,_,_)) = _1 
                            let memberCtorPattern = SynMemberDefn.ImplicitCtor (vis,_2,spats,az,rangeOfLid lid)
                            let tcDefRepr = 
                              match tcDefRepr with
                              | SynTypeDefnRepr.ObjectModel (k,cspec,m) -> SynTypeDefnRepr.ObjectModel (k,memberCtorPattern :: cspec,m)
                              | _ -> reportParseErrorAt (rhs2 parseState 1 5) (FSComp.SR.parsOnlyClassCanTakeValueArguments()); tcDefRepr
                            let declRange = unionRanges (rhs parseState 1) tcDefRepr.Range
                            let mWhole = (declRange, members) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)
                            
                            TypeDefn(_1,tcDefRepr,members,mWhole) 
                   )
//# 1459 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5188 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1485 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = unionRanges (rhs parseState 1) (match _7 with [] -> (match _5 with [] -> (rhs parseState 4) | _ -> (rhs parseState 5)) | _ -> (rhs parseState 7))
                            (fun nameRange -> _2 nameRange (checkForMultipleAugmentations m (_4 @ _5) _7)) 
                   )
//# 1485 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5205 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1489 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _6 then reportParseErrorAt (rhs parseState 6) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                            let m = unionRanges (rhs parseState 1) (match _5 with [] -> (rhs parseState 4) | _ -> (rhs parseState 5))
                            (fun nameRange -> _2 nameRange (checkForMultipleAugmentations m (_4 @ _5) [])) 
                   )
//# 1489 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1494 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            (fun nameRange -> _1 nameRange _2) 
                   )
//# 1494 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5235 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSimpleRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1503 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range
                            (fun nameRange augmentation -> SynTypeDefnRepr.Simple (_1,m),augmentation) 
                   )
//# 1503 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5247 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconClassDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1508 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,(kind,decls),mopt = _1 
                            let m = match mopt with 
                                    | None -> (lhs parseState).StartRange // create a zero-width range
                                    | Some m -> m
                            (fun nameRange augmentation -> 
                                if needsCheck && isNil decls then 
                                    reportParseErrorAt nameRange (FSComp.SR.parsEmptyTypeDefinition())
                                SynTypeDefnRepr.ObjectModel (kind,decls,m),augmentation) 
                   )
//# 1508 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5265 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1519 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let ty,arity = _3
                            (fun nameRange augmentation -> 
                                let valSpfn = ValSpfn([],mkSynId m "Invoke",inferredTyparDecls,ty,arity,false,false,PreXmlDoc.Empty,None,None,m) 
                                let invoke = SynMemberDefn.AbstractSlot(valSpfn,AbstractMemberFlags MemberKind.Member,m) 
                                if not (isNil augmentation) then raiseParseErrorAt m (FSComp.SR.parsAugmentationsIllegalOnDelegateType())
                                SynTypeDefnRepr.ObjectModel (TyconDelegate (ty,arity),[invoke],m),[]) 
                   )
//# 1519 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5282 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlockKindUnspecified)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,decls,mopt = _1 
                            needsCheck,(TyconUnspecified, decls),mopt 
                   )
//# 1531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5294 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range)
                            false,(_1,_2),Some(m) 
                   )
//# 1535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5307 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1539 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedClassInterfaceOrStruct())
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range)
                            false,(_1,_2),Some(m) 
                   )
//# 1539 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5322 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1544 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            false,(_1,[]),Some(rhs parseState 1) 
                   )
//# 1544 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5334 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1551 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                            let mopt =
                                match _2 with
                                | _ :: _ -> Some( (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range) )
                                | _ -> None
                            false,_2,mopt 
                   )
//# 1551 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlockKindUnspecified));
//# 5351 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1559 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mopt =
                                match _2 with
                                | _ :: _ -> Some( (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range) )
                                | _ -> None
                            true, _2, mopt 
                   )
//# 1559 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlockKindUnspecified));
//# 5367 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1569 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                             _2 
                   )
//# 1569 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5380 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1573 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 1573 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5392 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5403 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembersAtLeastOne)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1582 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1582 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5414 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1586 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1586 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5425 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1589 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1589 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5435 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1595 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @  _3 
                   )
//# 1595 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembersAtLeastOne));
//# 5448 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1601 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2  
                   )
//# 1601 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5459 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1604 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2  
                   )
//# 1604 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5470 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1607 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedWith())
                            _2  
                   )
//# 1607 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5482 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1613 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1]  
                   )
//# 1613 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElements));
//# 5493 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1615 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1;_3] 
                   )
//# 1615 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElements));
//# 5505 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1619 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mRhs = (_6 : SynExpr).Range 
                            (_1,_2,_3,_4,_6,mRhs) 
                   )
//# 1619 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElement));
//# 5521 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mRhs = _5.Range 
                             let mWhole = unionRanges (rhs2 parseState 3 4) mRhs 
                             let optReturnType = _3 
                             let bindingBuilder,mBindLhs = _2 
                             (fun vis memFlagsBuilder attrs -> 
                                  [ SynMemberDefn.Member (bindingBuilder (vis,_1,false,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,_5,mRhs,[],attrs,Some(memFlagsBuilder MemberKind.Member)),unionRanges mWhole mBindLhs) ]) 
                   )
//# 1627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberCore));
//# 5540 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSet)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1636 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mWhole = (rhs parseState 2, _4) ||> unionRangeWithListBy (fun (_,_,_,_,_,m2) -> m2) 
                            let propertyNameBindingBuilder,_ = _2 
                            let optPropertyType = _3 
                            let isMutable = false
                            (fun visNoLongerUsed memFlagsBuilder attrs -> 
                                  let hasGet = ref false
                                  let hasSet = ref false
                                  // Iterate over 1 or 2 'get'/'set' entries
                                  _4 |> List.choose (fun (optInline,optAttrs,(bindingBuilder,mBindLhs),optReturnType,expr,exprm) ->
                                        let optInline = _1 || optInline 
                                        // optional attributes are only applied to getters and setters
                                        // the "top level" attrs will be applied to both
                                        let optAttrs =
                                            optAttrs |> List.map (fun attrList ->
                                                { attrList with Attributes = attrList.Attributes |> List.map (fun a -> { a with AppliesToGetterAndSetter = true } ) })
                                        let attrs = attrs @ optAttrs
                                        
                                        let binding = bindingBuilder (visNoLongerUsed,optInline,isMutable,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,expr,exprm,[],attrs,Some (memFlagsBuilder MemberKind.Member))
                                        let (Binding (vis, _, isInline, _, attrs, doc, valSynData, pv, _, _, mBindLhs, spBind)) = binding 
                                        let memberKind = 
                                              let getset = 
                                                    let rec go p = 
                                                        match p with 
                                                        | SynPat.LongIdent (LongIdentWithDots([id],_),_,_,_,_,_) ->  id.idText
                                                        | SynPat.Named (_,nm,_,_,_) ->  nm.idText
                                                        | SynPat.Typed (p,_,_) ->  go p
                                                        | SynPat.Attrib (p,_,_) ->  go p
                                                        | _ -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                                    go pv 
                                              if getset = "get" then (
                                                  if !hasGet then 
                                                      reportParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                                      None
                                                  else
                                                      hasGet := true
                                                      Some MemberKind.PropertyGet
                                              ) else if getset = "set" then (
                                                  if !hasSet then 
                                                      reportParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                                      None
                                                  else
                                                      hasSet := true
                                                      Some MemberKind.PropertySet
                                              ) else 
                                                  raiseParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                        match memberKind with
                                        | None -> None
                                        | Some memberKind ->
                                        // REVIEW: It's hard not to ignore the optPropertyType type annotation for 'set' properties. To apply it, 
                                        // we should apply it to the last argument, but at this point we've already pushed the patterns that 
                                        // make up the arguments onto the RHS. So we just always give a warning. 
                                        begin match optPropertyType with 
                                        | Some _ -> errorR(Error(FSComp.SR.parsTypeAnnotationsOnGetSet(),mBindLhs))
                                        | None -> ()
                                        end
                                        
                                        let optReturnType = 
                                            match (memberKind, optReturnType) with 
                                            | MemberKind.PropertySet,_ -> optReturnType
                                            | _, None -> optPropertyType
                                            | _ -> optReturnType 
                                        // REDO with the correct member kind 
                                        let binding = bindingBuilder(vis,isInline,isMutable,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,expr,exprm,[],attrs,Some(memFlagsBuilder memberKind)) 
                                        let (Binding (vis, _, isInline, _, attrs, doc, valSynData, pv, rhsRetInfo, rhsExpr, mBindLhs, spBind)) = binding 
                                     
                                        let (SynValData(_,valSynInfo,_)) = valSynData 
                                        // Setters have all arguments tupled in their internal TAST form, though they don't appear to be 
                                        // tupled from the syntax
                                        let memFlags = memFlagsBuilder memberKind
                                        let valSynInfo = 
                                            let adjustValueArg valueArg = 
                                                match valueArg with
                                                | [_] -> valueArg
                                                | _ -> SynInfo.unnamedTopArg
                                            match memberKind, valSynInfo, memFlags.IsInstance with 
                                            | MemberKind.PropertyGet,SynValInfo ([],_ret),         false
                                            | MemberKind.PropertyGet,SynValInfo ([_],_ret), true  -> 
                                                raiseParseErrorAt mBindLhs (FSComp.SR.parsGetterMustHaveAtLeastOneArgument()) 
                                            | MemberKind.PropertyGet,SynValInfo (thisArg :: indexOrUnitArgs :: rest,ret), true  -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsGetterAtMostOneArgument())
                                                SynValInfo ([thisArg; indexOrUnitArgs],ret)
                                            | MemberKind.PropertyGet,SynValInfo (indexOrUnitArgs :: rest,ret),          false ->
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsGetterAtMostOneArgument())
                                                SynValInfo ([indexOrUnitArgs],ret)
                                            | MemberKind.PropertySet,SynValInfo ([thisArg;valueArg],ret),                 true  -> 
                                                SynValInfo ([thisArg; adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo (thisArg :: indexArgs :: valueArg :: rest,ret), true  -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsSetterAtMostTwoArguments())
                                                SynValInfo ([thisArg; indexArgs @ adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo ([valueArg],ret),                         false -> 
                                                SynValInfo ([adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo (indexArgs :: valueArg :: rest,ret),          _     -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsSetterAtMostTwoArguments())
                                                SynValInfo ([indexArgs @ adjustValueArg valueArg],ret)
                                            | _ -> 
                                                // should be unreachable, cover just in case
                                                raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidProperty())
                                        let valSynData = SynValData(Some(memFlags), valSynInfo,None) 
                                        // Fold together the information from the first lambda pattern and the get/set binding
                                        // This uses the 'this' variable from the first and the patterns for the get/set binding, 
                                        // replacing the get/set identifier. A little gross. 
                                        let bindingPatAdjusted, xmlDocAdjusted = 
                                            let bindingOuter = propertyNameBindingBuilder(vis,optInline,isMutable,mBindLhs,spBind,optReturnType,expr,exprm,[],attrs,Some(memFlagsBuilder MemberKind.Member))
                                            let (Binding (_,_,_,_,_,doc2,_,bindingPatOuter,_,_,_,_)) = bindingOuter 
                                            
                                        
                                            let lidOuter,lidVisOuter = 
                                                match bindingPatOuter with 
                                                | SynPat.LongIdent (lid,None,None, SynConstructorArgs.Pats [],lidVisOuter,m) ->  lid,lidVisOuter
                                                | SynPat.Named (_,id,_,visOuter,m) -> LongIdentWithDots([id],[]),visOuter
                                                | p -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                            // Merge the visibility from the outer point with the inner point, e.g.
                                            //    member <VIS1>  this.Size with <VIS2> get ()      = m_size
                                            
                                            let mergeLidVisOuter lidVisInner =
                                                match lidVisInner,lidVisOuter with 
                                                | None,None -> None
                                                | Some lidVisInner,None | None,Some lidVisInner -> Some lidVisInner
                                                | Some _, Some _ ->  
                                                    errorR(Error(FSComp.SR.parsMultipleAccessibilitiesForGetSet(),mBindLhs))
                                                    lidVisInner
                                        
                                            // Replace the "get" or the "set" with the right name
                                            let rec go p = 
                                                match p with 
                                                | SynPat.LongIdent (LongIdentWithDots([id],_),_,tyargs,SynConstructorArgs.Pats args,lidVisInner,m) ->  
                                                    // Setters have all arguments tupled in their internal form, though they don't 
                                                    // appear to be tupled from the syntax. Somewhat unfortunate
                                                    let args = 
                                                        if id.idText = "set" then 
                                                            match args with 
                                                            | [SynPat.Paren(SynPat.Tuple (false,indexPats,_),indexPatRange);valuePat] when id.idText = "set" -> 
                                                                [SynPat.Tuple(false,indexPats@[valuePat],unionRanges indexPatRange valuePat.Range)] 
                                                            | [indexPat;valuePat] -> 
                                                                [SynPat.Tuple(false,args,unionRanges indexPat.Range valuePat.Range)] 
                                                            | [valuePat] -> 
                                                                [valuePat] 
                                                            | _ -> 
                                                                raiseParseErrorAt m (FSComp.SR.parsSetSyntax())
                                                        else 
                                                            args
                     //                               let idTool : Ident list = lidOuter |> List.map (fun (li:Ident) -> ident(li.idText,id.idRange)) |> List.rev |> List.take 1
                                                    SynPat.LongIdent (lidOuter,Some(id),tyargs, SynConstructorArgs.Pats args,mergeLidVisOuter lidVisInner,m)
                                                | SynPat.Named (_,nm,_,lidVisInner,m) ->  SynPat.LongIdent (lidOuter,None,None, SynConstructorArgs.Pats [], mergeLidVisOuter lidVisInner,m)
                                                | SynPat.Typed (p,ty,m) ->  SynPat.Typed(go p,ty,m)
                                                | SynPat.Attrib (p,attribs,m) ->  SynPat.Attrib(go p,attribs,m)
                                                | SynPat.Wild(m) ->  SynPat.Wild(m)
                                                | _ -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                            go pv,PreXmlDoc.Merge doc2 doc
                                        Some <| SynMemberDefn.Member (Binding (vis, NormalBinding, isInline, isMutable, attrs, xmlDocAdjusted, valSynData, bindingPatAdjusted, rhsRetInfo, rhsExpr, mBindLhs, spBind),mWhole)))
                            
                   )
//# 1636 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberCore));
//# 5704 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1816 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   
                   )
//# 1816 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'abstractMemberFlags));
//# 5714 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1817 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 1817 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'abstractMemberFlags));
//# 5724 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            [mkClassMemberLocalBindings(false,None,_1,_2,_3)] 
                   )
//# 1823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5738 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            [mkClassMemberLocalBindings(true,Some (rhs parseState 3),_1,_2,_4)] 
                   )
//# 1827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5752 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let _,flags = _3
                            _4 _2 flags _1 
                   )
//# 1831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5769 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_interfaceImplDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1836 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesAreNotPermittedOnInterfaceImplementations(),rhs parseState 1))
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsInterfacesHaveSameVisibilityAsEnclosingType(),rhs parseState 3))
                             let mWhole = 
                                 match _5 with
                                 | None -> rhs2 parseState 3 4
                                 | Some(mems) -> (rhs2 parseState 3 4, mems) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)
                             [ SynMemberDefn.Interface (_4, _5, mWhole) ] 
                   )
//# 1836 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5790 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'abstractMemberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            let _10 = (let data = parseState.GetInput(10) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _8
                            let isInline,doc,id,explicitValTyparDecls = _4,grabXmlDoc(parseState,3),_5,_6
                            let getSetRangeOpt, getSet = _9
                            let getSetAdjuster arity = match arity,getSet with SynValInfo([],_),MemberKind.Member -> MemberKind.PropertyGet | _ -> getSet
                            let wholeRange = 
                                let m = rhs parseState 3
                                match getSetRangeOpt with 
                                | None -> unionRanges m ty.Range
                                | Some m2 -> unionRanges m m2
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsAccessibilityModsIllegalForAbstract(),wholeRange))
                            let valSpfn = ValSpfn(_1,id,explicitValTyparDecls,ty,arity, isInline,false,doc, None,None,wholeRange)
                            [ SynMemberDefn.AbstractSlot(valSpfn,AbstractMemberFlags (getSetAdjuster arity), wholeRange) ] 
                   )
//# 1845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5820 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'inheritsDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1859 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalOnInherit(),rhs parseState 1))
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityIllegalOnInherit(),rhs parseState 1))
                             [ _3 ] 
                   )
//# 1859 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5835 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'valDefnDecl)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             _3 None _1 false 
                   )
//# 1864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5850 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'valDefnDecl)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             _4 (Some (rhs parseState 3)) _1 true  
                   )
//# 1868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5865 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'autoPropsDefnDecl)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1872 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let isStatic, flags = _3
                             _4 _1 isStatic flags 
                   )
//# 1872 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5882 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'optAsSpec)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1877 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = unionRanges (rhs2 parseState 3 6) _7.Range 
                             let expr = _7
                             let valSynData = SynValData (Some CtorMemberFlags, SynValInfo([SynInfo.InferSynArgInfoFromPat _4],SynInfo.unnamedRetVal), _5) 
                             let vis = _2 
                             let declPat = SynPat.LongIdent (LongIdentWithDots([mkSynId (rhs parseState 3) "new"],[]),None,Some noInferredTypars, SynConstructorArgs.Pats [_4],vis,rhs parseState 3)
                             // Check that 'SynPatForConstructorDecl' matches this correctly
                             assert (match declPat with SynPatForConstructorDecl _ -> true | _ -> false)
                             [ SynMemberDefn.Member(Binding (None,NormalBinding,false,false,_1,grabXmlDoc(parseState,3),valSynData, declPat,None,expr,m,NoSequencePointAtInvisibleBinding),m) ] 
                   )
//# 1877 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5905 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1887 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             [ SynMemberDefn.NestedType(_5,None,rhs2 parseState 3 5) ] 
                   )
//# 1887 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5920 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1894 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mRhs = rhs2 parseState 4 6
                             let doc = grabXmlDoc(parseState,4)
                             let mValDecl = rhs2 parseState 1 6
                             (fun mLeft attribs isStatic -> 
                                 let mValDecl = match mLeft with None -> mValDecl | Some m -> unionRanges m mValDecl
                                 let fld = Field(attribs,isStatic,Some _4,_6,_2,doc,_3,mRhs)
                                 [ SynMemberDefn.ValField(fld, mValDecl) ]) 
                   )
//# 1894 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'valDefnDecl));
//# 5940 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typ)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1906 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let doc = grabXmlDoc(parseState,5)
                             let mValDecl = unionRanges (rhs parseState 1) _7.Range
                             let mGetSetOpt, getSet = _8
                             if _2 then errorR(Error(FSComp.SR.parsMutableOnAutoPropertyShouldBeGetSet(),rhs parseState 3))
                             (fun attribs isStatic flags -> 
                                 [ SynMemberDefn.AutoProperty(attribs, isStatic, _4, _5, getSet, flags, doc, _3, _7, mGetSetOpt, mValDecl) ]) 
                   )
//# 1906 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'autoPropsDefnDecl));
//# 5961 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1916 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        None 
                   )
//# 1916 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typ));
//# 5971 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1917 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      Some _2 
                   )
//# 1917 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typ));
//# 5982 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                
                         if not (parseState.LexBuffer.SupportsFeature LanguageFeature.SingleUnderscorePattern) then
                             raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedSymbolDot())
                         let (LongIdentWithDots(lid,dotms)) = _3 in (None,LongIdentWithDots(ident("_",rhs parseState 1)::lid, rhs parseState 2::dotms))
                         
                   )
//# 1920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 5997 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1925 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              let (LongIdentWithDots(lid,dotms)) = _3 in (None,LongIdentWithDots(ident(MangledGlobalName,rhs parseState 1) :: lid, rhs parseState 2 :: dotms)) 
                   )
//# 1925 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 6008 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1926 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  (None,_1) 
                   )
//# 1926 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 6019 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1927 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         (Some(_1), _2) 
                   )
//# 1927 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 6031 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 1931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_access));
//# 6041 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1932 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  Some(_1) 
                   )
//# 1932 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_access));
//# 6052 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1936 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Private 
                   )
//# 1936 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1937 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Public 
                   )
//# 1937 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1938 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Internal 
                   )
//# 1938 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6082 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1942 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some(_1) 
                   )
//# 1942 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declVisibility));
//# 6093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 1943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declVisibility));
//# 6103 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  Some(_2) 
                   )
//# 1947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_interfaceImplDefn));
//# 6115 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1948 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  None 
                   )
//# 1948 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_interfaceImplDefn));
//# 6125 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1952 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       _2 
                   )
//# 1952 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classDefn));
//# 6137 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1953 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       [] 
                   )
//# 1953 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classDefn));
//# 6147 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'optBaseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1959 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = unionRanges (rhs parseState 1) ((_2): SynType).Range 
                            SynMemberDefn.Inherit(_2,_3,mDecl) 
                   )
//# 1959 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6160 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'optBaseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1963 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = unionRanges (rhs parseState 1) _4.Range 
                            SynMemberDefn.ImplicitInherit(_2,_4,_5,mDecl) 
                   )
//# 1963 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6175 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1967 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = (rhs parseState 1)
                            if not _2 then errorR(Error(FSComp.SR.parsTypeNameCannotBeEmpty(), mDecl))
                            SynMemberDefn.Inherit(SynType.LongIdent(LongIdentWithDots([], [])), None,mDecl) 
                   )
//# 1967 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6188 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'asSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1972 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  Some(_1) 
                   )
//# 1972 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optAsSpec));
//# 6199 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1973 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  None 
                   )
//# 1973 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optAsSpec));
//# 6209 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1976 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    _2 
                   )
//# 1976 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'asSpec));
//# 6220 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'baseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1980 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    Some(_1) 
                   )
//# 1980 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optBaseSpec));
//# 6231 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1981 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  None 
                   )
//# 1981 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optBaseSpec));
//# 6241 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1986 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if (_2).idText <> "base" then 
                                  errorR(Error(FSComp.SR.parsInheritDeclarationsCannotHaveAsBindings(),rhs2 parseState 1 2)) 
                             ident("base",rhs parseState 2) 
                   )
//# 1986 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'baseSpec));
//# 6254 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             errorR(Error(FSComp.SR.parsInheritDeclarationsCannotHaveAsBindings(),rhs2 parseState 1 2)) 
                             ident("base",rhs parseState 2) 
                   )
//# 1991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'baseSpec));
//# 6265 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1998 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 1998 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6277 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2001 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileObjectMembers())
                             _2 
                   )
//# 2001 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6290 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2005 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2005 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6301 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2011 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @  _3 
                   )
//# 2011 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMembers));
//# 6314 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2014 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2014 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMembers));
//# 6326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2020 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 None OverrideMemberFlags _1 
                   )
//# 2020 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6340 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'autoPropsDefnDecl)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 _1 false OverrideMemberFlags 
                   )
//# 2023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6354 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2026 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2026 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6366 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6379 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2033 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    
                   )
//# 2033 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberOrOverride));
//# 6389 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      
                   )
//# 2034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberOrOverride));
//# 6399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Error(FSComp.SR.parsUnexpectedQuotationOperatorInTypeAliasDidYouMeanVerbatimString(), rhs parseState 4)) 
                            SynTypeDefnSimpleRepr.TypeAbbrev (ParserDetail.ThereWereSignificantParseErrorsSoDoNotTypecheckThisNode, SynType.LongIdent(_3), unionRanges (rhs parseState 1) _3.Range)  
                   )
//# 2042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6416 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsTypeAbbreviationsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            SynTypeDefnSimpleRepr.TypeAbbrev (ParserDetail.Ok, _3, unionRanges (rhs parseState 1) _3.Range) 
                   )
//# 2047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            let rangesOf3 = _3 |> List.map (function |Choice1Of2(ec)->ec.Range | Choice2Of2(uc)->uc.Range)
                            let mWhole = (rhs2 parseState 1 2, rangesOf3) ||> List.fold unionRanges 
                            if _3 |> List.exists (function Choice1Of2 _ -> true | _ -> false) then (
                                if Option.isSome _2 then errorR(Error(FSComp.SR.parsEnumTypesCannotHaveVisibilityDeclarations(),rhs parseState 2));
                                SynTypeDefnSimpleRepr.Enum (_3 |> List.choose (function 
                                                                   | Choice1Of2 data ->  
                                                                     Some(data) 
                                                                   | Choice2Of2(UnionCase(_,_,_,_,_,m)) -> 
                                                                     errorR(Error(FSComp.SR.parsAllEnumFieldsRequireValues(),m)); None),
                                                mWhole)
                            ) else 
                                SynTypeDefnSimpleRepr.Union (_2, 
                                                 _3 |> List.choose (function Choice2Of2 data -> Some(data) | Choice1Of2 _ -> failwith "huh?"),
                                                 mWhole) 
                   )
//# 2053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6458 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2071 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            SynTypeDefnSimpleRepr.Record (_2,_3,lhs parseState) 
                   )
//# 2071 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6472 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'inlineAssemblyTyconRepr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2076 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            libraryOnlyError (lhs parseState)
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsInlineAssemblyCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            _4 
                   )
//# 2076 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6489 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2085 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 2085 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6501 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2088 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace()) 
                            _2 
                   )
//# 2088 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6514 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2092 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2092 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6525 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarFieldDeclListCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2096 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               _2,true 
                   )
//# 2096 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonRecdType));
//# 6536 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarFieldDeclListCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2098 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               _1,false 
                   )
//# 2098 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonRecdType));
//# 6547 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2103 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 2103 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6559 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar()) 
                            _2 
                   )
//# 2106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6572 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2110 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2110 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6583 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            libraryOnlyError (lhs parseState)
                            let lhsm = lhs parseState 
                            SynTypeDefnSimpleRepr.LibraryOnlyILAssembly (internalParseAssemblyCodeType _2 parseState.LexBuffer.SupportsFeature (rhs parseState 2),lhsm) 
                   )
//# 2114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inlineAssemblyTyconRepr));
//# 6596 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconClass 
                   )
//# 2119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6606 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconInterface 
                   )
//# 2120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6616 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2121 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconStruct 
                   )
//# 2121 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6626 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 2124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interfaceMember));
//# 6636 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2125 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                
                   )
//# 2125 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interfaceMember));
//# 6646 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2129 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [], _2.Lid,false,[],_1,grabXmlDoc(parseState,2) 
                   )
//# 2129 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6658 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prefixTyparDecls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2132 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, _3.Lid,false,[],_1,grabXmlDoc(parseState,2) 
                   )
//# 2132 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6671 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'postfixTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2135 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let tps,tpcs = _3 
                             tps, _2.Lid,true,tpcs,_1,grabXmlDoc(parseState,2) 
                   )
//# 2135 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6685 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2139 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 [ TyparDecl([],_1) ] 
                   )
//# 2139 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'prefixTyparDecls));
//# 6696 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2140 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        List.rev _2 
                   )
//# 2140 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'prefixTyparDecls));
//# 6708 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2143 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                         _3 :: _1 
                   )
//# 2143 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDeclList));
//# 6720 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2144 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     [_1] 
                   )
//# 2144 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDeclList));
//# 6731 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2148 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             TyparDecl(_1,_2) 
                   )
//# 2148 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDecl));
//# 6743 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_TYAPP)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2154 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then warning(Error(FSComp.SR.parsNonAdjacentTypars(),rhs2 parseState 2 5))
                             List.rev _3, _4 
                   )
//# 2154 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'postfixTyparDecls));
//# 6759 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2161 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (List.rev _1,true) 
                   )
//# 2161 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2163 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (List.rev _1,false) 
                   )
//# 2163 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6781 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2165 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ([],false) 
                   )
//# 2165 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6791 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_TYAPP)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDeclsCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2169 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then warning(Error(FSComp.SR.parsNonAdjacentTypars(),rhs2 parseState 2 5))
                             let tps,flex = _3 
                             SynValTyparDecls(tps,flex,_4) 
                   )
//# 2169 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDecls));
//# 6808 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2175 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2175 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls));
//# 6819 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2177 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynValTyparDecls([],true,[]) 
                   )
//# 2177 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls));
//# 6829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2181 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _1 
                   )
//# 2181 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls2));
//# 6840 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2183 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 2183 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls2));
//# 6850 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2189 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2189 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typeConstraints));
//# 6860 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            List.rev _2 
                   )
//# 2191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typeConstraints));
//# 6871 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraint)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2196 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                              _3 :: _1 
                   )
//# 2196 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraints));
//# 6883 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraint)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2197 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          [_1] 
                   )
//# 2197 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraints));
//# 6894 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2203 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             libraryOnlyError (lhs parseState); WhereTyparDefaultsToType(_2,_4,lhs parseState) 
                   )
//# 2203 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6906 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2206 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSubtypeOfType(_1,_3,lhs parseState) 
                   )
//# 2206 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6918 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2209 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparIsValueType(_1,lhs parseState) 
                   )
//# 2209 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6929 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2212 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _3 <> "not" then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(_3))  
                             WhereTyparIsReferenceType(_1,lhs parseState) 
                   )
//# 2212 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6942 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2216 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSupportsNull(_1,lhs parseState) 
                   )
//# 2216 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6953 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2219 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let tp = _1
                             WhereTyparSupportsMember([ SynType.Var(tp, tp.Range) ],_4,lhs parseState) 
                   )
//# 2219 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6967 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2223 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSupportsMember(List.rev(_2),_6,lhs parseState) 
                   )
//# 2223 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6981 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2226 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let _ltm,_gtm,args,_commas,mWhole = _4 in WhereTyparIsDelegate(_1, args, unionRanges _1.Range mWhole) 
                   )
//# 2226 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6993 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2229 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _3 with 
                             | "enum" -> let _ltm,_gtm,args,_commas,mWhole = _4 in WhereTyparIsEnum(_1, args, unionRanges _1.Range mWhole)
                             | nm -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(nm)) 
                   )
//# 2229 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 7008 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2234 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _3 with 
                             | "comparison" -> WhereTyparIsComparable(_1,lhs parseState)
                             | "equality" -> WhereTyparIsEquatable(_1,lhs parseState)
                             | "unmanaged" -> WhereTyparIsUnmanaged(_1,lhs parseState)
                             | nm -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(nm)) 
                   )
//# 2234 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 7024 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2241 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                  _3 :: _1 
                   )
//# 2241 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarAlts));
//# 7036 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2242 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     [_1] 
                   )
//# 2242 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarAlts));
//# 7047 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2249 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 _1 
                   )
//# 2249 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7059 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDeclOfMany)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2252 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 _2 
                   )
//# 2252 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2255 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2255 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2258 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               grabXmlDoc(parseState,1) 
                   )
//# 2258 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'barAndgrabXmlDoc));
//# 7093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2261 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                  (fun xmlDoc -> _1 xmlDoc  :: _3 _2) 
                   )
//# 2261 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecls));
//# 7106 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2262 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             (fun xmlDoc -> [ _1 xmlDoc ]) 
                   )
//# 2262 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecls));
//# 7117 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2267 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs parseState 3
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFields [],xmlDoc,None,mDecl))) 
                           
                   )
//# 2267 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7134 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2273 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFields _5,xmlDoc,None,mDecl))) 
                           
                   )
//# 2273 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7152 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2279 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             libraryOnlyWarning(lhs parseState)
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFullType _5,xmlDoc,None,mDecl))) 
                           
                   )
//# 2279 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7171 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2286 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsEnumFieldsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice1Of2 (EnumCase ( _1, _3,_5,xmlDoc,mDecl))) 
                           
                   )
//# 2286 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7189 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2294 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2294 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7200 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2297 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              ident(opNameCons,rhs parseState 2) 
                   )
//# 2297 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7211 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2300 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              ident(opNameNil,rhs2 parseState 2 3) 
                   )
//# 2300 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2304 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice2Of2 (UnionCase ( [], _1,UnionCaseFields [],PreXmlDoc.Empty,None,rhs parseState 1)) 
                   )
//# 2304 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7234 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2307 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice1Of2 (EnumCase ([],_1,_3,PreXmlDoc.Empty,rhs2 parseState 1 3)) 
                   )
//# 2307 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7247 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2310 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2310 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7259 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2314 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 (UnionCase ( [],_1,UnionCaseFields _3,PreXmlDoc.Empty,None,rhs2 parseState 1 3)) 
                   )
//# 2314 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDecl));
//# 7271 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2317 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice1Of2 (EnumCase ([],_1,_3,PreXmlDoc.Empty,rhs2 parseState 1 3))  
                   )
//# 2317 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDecl));
//# 7284 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElement)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2320 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                           _1 :: _3 
                   )
//# 2320 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElements));
//# 7296 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                [_1] 
                   )
//# 2321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElements));
//# 7307 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2324 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               mkNamedField(_1, _3) 
                   )
//# 2324 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElement));
//# 7319 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2325 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   mkAnonField _1 
                   )
//# 2325 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElement));
//# 7330 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2329 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Deprecated(FSComp.SR.parsConsiderUsingSeparateRecordType(),lhs parseState)) 
                            _1 
                   )
//# 2329 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseRepr));
//# 7342 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 2333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseRepr));
//# 7353 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2338 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 2338 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDeclList));
//# 7366 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2341 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2341 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDeclList));
//# 7378 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2346 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let fld = _2 _1 false 
                            let (Field(a,b,c,d,e,f,vis,g)) = fld 
                            if Option.isSome vis then errorR(Error(FSComp.SR.parsRecordFieldsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            Field(a,b,c,d,e,f,None,g)  
                   )
//# 2346 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDecl));
//# 7393 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2354 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mRhs = rhs2 parseState 3 5 
                            let xmlDoc = grabXmlDoc(parseState,3)
                            (fun attrs stat -> Field(attrs, stat,Some _3,_5,_1,xmlDoc,_2,mRhs)) 
                   )
//# 2354 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fieldDecl));
//# 7409 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefnRepr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2362 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionDefn(_1,_2, (_1.Range,_2) ||> unionRangeWithListBy (fun cd -> cd.Range) ) 
                   )
//# 2362 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExceptionDefn));
//# 7421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2366 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     grabXmlDoc(parseState,1) 
                   )
//# 2366 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exceptionAndGrabDoc));
//# 7431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'exceptionAndGrabDoc)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconIntro)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionDefnRepr(_2,_4,_5,_1,_3,(match _5 with None -> rhs2 parseState 1 4 | Some p -> unionRanges (rangeOfLongIdent p) (rhs2 parseState 1 4))) 
                   )
//# 2371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExceptionDefnRepr));
//# 7446 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2376 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             UnionCase ( [], _1,UnionCaseFields [],PreXmlDoc.Empty,None,lhs parseState) 
                   )
//# 2376 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconIntro));
//# 7457 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2379 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             UnionCase ( [], _1,UnionCaseFields _3,PreXmlDoc.Empty,None,lhs parseState) 
                   )
//# 2379 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconIntro));
//# 7469 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 2382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconRepr));
//# 7479 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some (_2.Lid) 
                   )
//# 2383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconRepr));
//# 7490 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     _2 
                   )
//# 2386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 7501 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2395 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let isUse = _1
                             let isRec = _2 
                             let localBindingsLastRangeOpt, localBindingsBuilder = _3
                             
                             // Calculate the precise range of the binding set, up to the end of the last r.h.s. expression
                             let bindingSetRange = 
                                 match localBindingsLastRangeOpt with 
                                 | None -> rhs2 parseState 1 2 (* there was some error - this will be an approximate range *)
                                 | Some lastRange -> unionRanges mLetKwd lastRange
                             // The first binding swallows any attributes prior to the 'let'
                             BindingSetPreAttrs(mLetKwd,isRec,isUse,
                                 (fun attrs vis -> 
                                     // apply the builder
                                     let binds = localBindingsBuilder attrs vis mLetKwd
                                     if not isRec && not (isNilOrSingleton binds) then 
                                           reportParseErrorAt mLetKwd (FSComp.SR.parsLetAndForNonRecBindings())
                                     [],binds), 
                                 bindingSetRange) 
                   )
//# 2395 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'defnBindings));
//# 7532 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cPrototype)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2417 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let bindRange = lhs parseState
                             BindingSetPreAttrs(bindRange, false,false,_1,bindRange)  
                   )
//# 2417 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'defnBindings));
//# 7544 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2424 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mDoKwd = rhs parseState 1 
                             let mWhole = unionRanges mDoKwd _2.Range
                             // any attributes prior to the 'let' are left free, e.g. become top-level attributes 
                             // associated with the module, 'main' function or assembly depending on their target 
                             BindingSetPreAttrs(mDoKwd,false,false,(fun attrs vis -> attrs,[mkSynDoBinding (vis,true,_2,mWhole)]), mWhole) 
                   )
//# 2424 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doBinding));
//# 7559 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2434 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let isUse = _1
                             let isRec = _2
                             _4 (if isUse then "use" else "let") mLetKwd  // report unterminated error 
                             
                             let localBindingsLastRangeOpt, localBindingsBuilder = _3
                             
                             // Calculate the precise range of the binding set, up to the end of the last r.h.s. expression
                             let bindingSetRange = 
                                 match localBindingsLastRangeOpt with 
                                 | None -> rhs parseState 1 (* there was some error - this will be an approximate range *)
                                 | Some lastRange -> unionRanges mLetKwd lastRange
                             // the first binding swallow any attributes prior to the 'let' 
                             BindingSetPreAttrs(mLetKwd,isRec,isUse,
                               (fun attrs vis ->
                                 let binds = localBindingsBuilder attrs vis mLetKwd
                                 if not isRec && not (isNilOrSingleton binds) then
                                     reportParseErrorAt mLetKwd (FSComp.SR.parsLetAndForNonRecBindings())
                                 [],binds),
                               bindingSetRange), (unionRanges mLetKwd bindingSetRange) 
                   )
//# 2434 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteLetBindings));
//# 7592 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2460 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let bindingSetRange = unionRanges mLetKwd _2.Range 
                             let seqPt = NoSequencePointAtDoBinding 
                             // any attributes prior to the 'let' are left free, e.g. become top-level attributes 
                             // associated with the module, 'main' function or assembly depending on their target 
                             BindingSetPreAttrs(mLetKwd,false,false,(fun attrs vis -> attrs,[mkSynDoBinding (vis,true,_2,bindingSetRange)]),bindingSetRange), _2 
                   )
//# 2460 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDoBinding));
//# 7609 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2470 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 2470 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7620 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'doBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2471 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     _1 
                   )
//# 2471 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7631 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2472 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                let b,m = _1 in b 
                   )
//# 2472 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7642 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDoBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2473 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               fst _1 
                   )
//# 2473 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7653 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2479 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun _ m -> ()) 
                   )
//# 2479 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDefnBindingsTerminator));
//# 7663 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2481 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun kwd m -> reportParseErrorAt m (match kwd with 
                                                                | "let!" -> FSComp.SR.parsUnmatchedLetBang() 
                                                                | "use!" -> FSComp.SR.parsUnmatchedUseBang() 
                                                                | "use" -> FSComp.SR.parsUnmatchedUse() 
                                                                | _ (*"let" *) -> FSComp.SR.parsUnmatchedLet()))  
                   )
//# 2481 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDefnBindingsTerminator));
//# 7678 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cRetType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArgs)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2490 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let rty,vis,nm,args  = _2,_3,_4,_7 
                             let xmlDoc = grabXmlDoc(parseState,1) 
                             let nmm = rhs parseState 3 
                             let argsm = rhs parseState 6 
                             let mBindLhs = lhs parseState
                             let mWhole = lhs parseState
                             let mRhs = lhs parseState 
                             let rhsExpr = SynExpr.App (ExprAtomicFlag.NonAtomic,
                                                       false, 
                                                       SynExpr.Ident (ident("failwith",rhs parseState 6)),
                                                       SynExpr.Const (SynConst.String("extern was not given a DllImport attribute",rhs parseState 8),rhs parseState 8),
                                                       mRhs)
                             (fun attrs vis -> 
                                 let bindingId = SynPat.LongIdent (LongIdentWithDots([nm],[]), None, Some noInferredTypars, SynConstructorArgs.Pats [SynPat.Tuple(false,args,argsm)], vis, nmm)
                                 let binding = mkSynBinding 
                                                   (xmlDoc, bindingId) 
                                                   (vis, false, false, mBindLhs, NoSequencePointAtInvisibleBinding, Some rty, rhsExpr, mRhs, [], attrs, None)
                                 [], [binding]) 
                   )
//# 2490 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cPrototype));
//# 7711 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cMoreArgs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2512 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            List.rev _1 
                   )
//# 2512 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7722 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2515 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2515 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7733 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2517 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2517 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7743 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cMoreArgs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2523 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 :: _1 
                   )
//# 2523 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cMoreArgs));
//# 7755 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2526 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_3; _1] 
                   )
//# 2526 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cMoreArgs));
//# 7767 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2532 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState in SynPat.Typed(SynPat.Wild m,_2,m) |> addAttribs _1 
                   )
//# 2532 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArg));
//# 7779 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState in SynPat.Typed(SynPat.Named (SynPat.Wild m,_3,false,None,m),_2,m) |> addAttribs _1 
                   )
//# 2535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArg));
//# 7792 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range
                            SynType.App(SynType.LongIdent(_1),None,[],[],None,false,m) 
                   )
//# 2540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7804 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2544 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("[]",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2544 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7817 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2548 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("nativeptr",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2548 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2552 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("byref",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2552 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7841 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2556 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("nativeint",m)],[])),None,[],[],None,true,m) 
                   )
//# 2556 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7852 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2563 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynReturnInfo((_2,SynArgInfo(_1,false,None)),rhs parseState 2) 
                   )
//# 2563 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cRetType));
//# 7864 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2566 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 2 
                            SynReturnInfo((SynType.App(SynType.LongIdent(LongIdentWithDots([ident("unit",m)],[])),None,[],[],None,false,m),SynArgInfo(_1,false,None)),m) 
                   )
//# 2566 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cRetType));
//# 7876 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attr_localBinding)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreLocalBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2572 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (moreBindings, moreBindingRanges) = List.unzip _2
                             let moreLocalBindingsLastRange = if moreBindingRanges.IsEmpty then None else Some (List.last moreBindingRanges)
                             match _1 with 
                             | Some (localBindingRange,attrLocalBindingBuilder) -> 
                                let lastRange = 
                                    match moreLocalBindingsLastRange with 
                                    | None -> localBindingRange 
                                    | Some m -> m
                                Some lastRange, (fun attrs vis mLetKwd -> attrLocalBindingBuilder attrs vis mLetKwd true ::  moreBindings)
                             | None -> 
                                moreLocalBindingsLastRange, (fun _attrs _vis _letm -> moreBindings) 
                   )
//# 2572 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBindings));
//# 7898 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attr_localBinding)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreLocalBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1
                             (match _2 with 
                              | Some (localBindingRange,attrLocalBindingBuilder) -> (attrLocalBindingBuilder [] None mLetKwd false,localBindingRange) :: _3 
                              | None -> _3) 
                   )
//# 2587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moreLocalBindings));
//# 7913 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2593 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2593 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moreLocalBindings));
//# 7923 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2599 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let attrs2 = _1
                             let localBindingRange,localBindingBuilder = _2
                             let attrLocalBindingBuilder = (fun attrs vis mLetKwd _ -> localBindingBuilder (attrs@attrs2) vis mLetKwd)
                             Some(localBindingRange,attrLocalBindingBuilder) 
                   )
//# 2599 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attr_localBinding));
//# 7938 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2605 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 2605 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attr_localBinding));
//# 7948 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizationsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2611 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (expr:SynExpr),opts = _6
                             let eqm = rhs parseState 5 
                             let mRhs = expr.Range 
                             let optReturnType = _4 
                             let bindingBuilder, mBindLhs = _3 
                             let localBindingRange = unionRanges (rhs2 parseState 3 5) mRhs
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let mWhole = unionRanges mLetKwd mRhs
                                 let spBind = if IsControlFlowExpression expr then NoSequencePointAtLetBinding else SequencePointAtBinding(mWhole)
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,expr,mRhs,opts,attrs,None))
                             localBindingRange,localBindingBuilder 
                   )
//# 2611 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 7974 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2625 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWhole = rhs2 parseState 3 5 
                             let mRhs = rhs parseState 5
                             let optReturnType = _4 
                             let bindingBuilder,mBindLhs = _3 
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let spBind = SequencePointAtBinding(unionRanges mLetKwd mRhs)
                                 let eqm = rhs parseState 5
                                 let zeroWidthAtEnd = eqm.EndRange
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,arbExpr("localBinding1",zeroWidthAtEnd),mRhs,[],attrs,None))  
                             mWhole,localBindingBuilder 
                   )
//# 2625 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 7998 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2638 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 5) (FSComp.SR.parsUnexpectedEndOfFileDefinition())
                             let optReturnType = _4 
                             let mWhole = match optReturnType with None -> rhs parseState 3 | Some _ -> rhs2 parseState 3 4
                             let mRhs = mWhole.EndRange  // zero-width range at end of last good token
                             let bindingBuilder,mBindLhs = _3 
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let spBind = SequencePointAtBinding(unionRanges mLetKwd mRhs)
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,arbExpr("localBinding2",mRhs),mRhs,[],attrs,None))  
                             mWhole,localBindingBuilder 
                   )
//# 2638 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 8022 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2653 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2653 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8034 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2656 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFile())
                             let a,b = _2
                             (exprFromParseError a, b) 
                   )
//# 2656 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8048 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2661 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2661 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8059 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_staticOptimizations)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                _1, List.rev _2 
                   )
//# 2664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizations));
//# 8071 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_staticOptimizations)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimization)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2667 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                      _2 :: _1 
                   )
//# 2667 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_staticOptimizations));
//# 8083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [] 
                   )
//# 2668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_staticOptimizations));
//# 8093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationConditions)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2671 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                      (_2,_4) 
                   )
//# 2671 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimization));
//# 8105 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationConditions)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationCondition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2674 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                        _3 :: _1 
                   )
//# 2674 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationConditions));
//# 8117 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationCondition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       [_1 ] 
                   )
//# 2675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationConditions));
//# 8128 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2678 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           WhenTyparTyconEqualsTycon(_1,_3,lhs parseState) 
                   )
//# 2678 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationCondition));
//# 8140 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2679 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        WhenTyparIsStruct(_1,lhs parseState) 
                   )
//# 2679 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationCondition));
//# 8151 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : sbyte * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2682 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                if snd _1 then errorR(Error(FSComp.SR.lexOutsideEightBitSigned(), lhs parseState))
                                SynConst.SByte (fst _1) 
                   )
//# 2682 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8163 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 SynConst.Byte _1 
                   )
//# 2684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8174 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int16 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2685 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideSixteenBitSigned(), lhs parseState))
                                 SynConst.Int16 (fst _1) 
                   )
//# 2685 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8186 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint16)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2687 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt16 _1 
                   )
//# 2687 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8197 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2688 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynConst.Int32 (fst _1) 
                   )
//# 2688 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8209 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2690 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt32 _1 
                   )
//# 2690 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8220 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2691 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideSixtyFourBitSigned(), lhs parseState))
                                 SynConst.Int64 (fst _1) 
                   )
//# 2691 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8232 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2693 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt64 _1 
                   )
//# 2693 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8243 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2694 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     SynConst.IntPtr _1 
                   )
//# 2694 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8254 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2695 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      SynConst.UIntPtr _1 
                   )
//# 2695 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8265 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : single)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2696 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.Single _1 
                   )
//# 2696 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8276 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2697 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.Double _1 
                   )
//# 2697 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8287 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2698 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                SynConst.Char _1 
                   )
//# 2698 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8298 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.Decimal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   SynConst.Decimal _1 
                   )
//# 2699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8309 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : (string * string))) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2700 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UserNum _1 
                   )
//# 2700 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8320 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2701 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 SynConst.String (_1,lhs parseState) 
                   )
//# 2701 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8331 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2702 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     SynConst.Bytes (_1,lhs parseState) 
                   )
//# 2702 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8342 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2706 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure())
                           if fst _3 = 0 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsIllegalDenominatorForMeasureExponent())
                           if (snd _1) || (snd _3) then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                           SynRationalConst.Rational(fst _1, fst _3, lhs parseState) 
                   )
//# 2706 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8358 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _3 <> "/" then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure())
                           if fst _4 = 0 then reportParseErrorAt (rhs parseState 4) (FSComp.SR.parsIllegalDenominatorForMeasureExponent())
                           if (snd _2) || (snd _4) then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                           SynRationalConst.Negate(SynRationalConst.Rational(fst _2, fst _4, lhs parseState)) 
                   )
//# 2712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8374 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2717 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynRationalConst.Integer(fst _1) 
                   )
//# 2717 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8386 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2720 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       if snd _2 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                       SynRationalConst.Negate(SynRationalConst.Integer(fst _2)) 
                   )
//# 2720 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8398 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynRationalConst.Integer(fst _1) 
                   )
//# 2724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicUnsignedRationalConstant));
//# 8410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rationalConstant)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2728 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _2 
                   )
//# 2728 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicUnsignedRationalConstant));
//# 8422 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicUnsignedRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2731 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          _1 
                   )
//# 2731 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicRationalConstant));
//# 8433 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicUnsignedRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2734 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynRationalConst.Negate(_2) 
                   )
//# 2734 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicRationalConstant));
//# 8444 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2737 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       _1 
                   )
//# 2737 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constant));
//# 8455 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2738 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                            SynConst.Measure(_1, _3) 
                   )
//# 2738 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constant));
//# 8467 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              let xmlDoc = grabXmlDoc(parseState,1)
                              mkSynBinding (xmlDoc,_1), rhs parseState 1 
                   )
//# 2742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'bindingPattern));
//# 8479 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2750 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = rhs parseState 1 
                             SynPat.Named(SynPat.Wild m, _1, false, None, m) 
                   )
//# 2750 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8491 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2753 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.OptionalVal(_2, rhs parseState 2) 
                   )
//# 2753 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8502 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2755 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Typed(_1, _3, lhs parseState) 
                   )
//# 2755 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8514 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2757 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Attrib(_2, _1, lhs parseState) 
                   )
//# 2757 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8526 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2761 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2761 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatternCommaList));
//# 8537 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2763 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _3 with
                             | SynPat.Tuple(_, pats, _) -> SynPat.Tuple(false, _1 :: pats, rhs2 parseState 1 3)
                             | _ -> SynPat.Tuple(false, [_1; _3], rhs2 parseState 1 3) 
                   )
//# 2763 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatternCommaList));
//# 8551 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2769 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let parenPat = SynPat.Paren(_2, rhs2 parseState 1 3)
                             let simplePats, _ = SimplePatsOfPat parseState.SynArgNameGenerator parenPat
                             simplePats 
                   )
//# 2769 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8565 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2773 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let pat = SynPat.Const(SynConst.Unit, rhs2 parseState 1 2)
                             let simplePats, _ = SimplePatsOfPat parseState.SynArgNameGenerator pat
                             simplePats 
                   )
//# 2773 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8578 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2777 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let parenPat = SynPat.Paren(SynPat.Tuple(false, [], rhs2 parseState 1 2), rhs2 parseState 1 2) // todo: report parsed pats anyway?
                             let simplePats, _ = SimplePatsOfPat parseState.SynArgNameGenerator parenPat
                             simplePats 
                   )
//# 2777 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8593 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2782 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let parenPat = SynPat.Paren(SynPat.Wild(rhs parseState 2), rhs2 parseState 1 3) // silent recovery
                             let simplePats, _ = SimplePatsOfPat parseState.SynArgNameGenerator parenPat
                             simplePats 
                   )
//# 2782 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8606 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let pat = SynPat.Wild(lhs parseState)
                             let simplePats, _ = SimplePatsOfPat parseState.SynArgNameGenerator pat
                             simplePats 
                   )
//# 2786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8620 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2794 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Named (_1,_3,false,None,rhs2 parseState 1 3) 
                   )
//# 2794 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8632 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Or(_1,_3,rhs2 parseState 1 3) 
                   )
//# 2796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8644 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2798 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.LongIdent (LongIdentWithDots(mkSynCaseName (rhs parseState 2) opNameCons,[]), None, None, SynConstructorArgs.Pats [SynPat.Tuple (false,[_1;_3],rhs2 parseState 1 3)],None,lhs parseState) 
                   )
//# 2798 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8656 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(false,List.rev _1, lhs parseState) 
                   )
//# 2800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8667 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2802 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Ands(List.rev _1, lhs parseState) 
                   )
//# 2802 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8678 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constrPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2804 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2804 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8689 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2808 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2808 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tuplePatternElements));
//# 8701 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2810 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2810 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tuplePatternElements));
//# 8713 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2814 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2814 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjPatternElements));
//# 8725 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2816 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2816 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjPatternElements));
//# 8737 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPair)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 [_1], lhs parseState 
                   )
//# 2819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPairs));
//# 8749 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPair)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2820 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          let (rs, _) = _3 in (_1 :: rs), lhs parseState 
                   )
//# 2820 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPairs));
//# 8762 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      (_1, _3) 
                   )
//# 2823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPair));
//# 8774 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,Some _2, SynConstructorArgs.Pats [],vis,lhs parseState) 
                   )
//# 2827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8786 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2829 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _3,vis,lhs parseState) 
                   )
//# 2829 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8799 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _4,vis,lhs parseState) 
                   )
//# 2831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8812 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2833 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _4,vis,lhs parseState) 
                   )
//# 2833 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8825 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2835 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.IsInst(_2,lhs parseState) 
                   )
//# 2835 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8836 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2837 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2837 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8847 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPairs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2840 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      SynConstructorArgs.NamePatPairs _2 
                   )
//# 2840 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatsOrNamePatPairs));
//# 8859 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2841 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          SynConstructorArgs.Pats _1 
                   )
//# 2841 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatsOrNamePatPairs));
//# 8870 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 :: _2 
                   )
//# 2845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8882 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2847 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessivePatternsShouldBeSpacedOrTupled())
                             _1 :: _3 
                   )
//# 2847 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8895 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2850 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessivePatternsShouldBeSpacedOrTupled())
                             _1 :: _3 
                   )
//# 2850 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8908 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2852 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         [_1] 
                   )
//# 2852 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8919 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'quoteExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2857 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.QuoteExpr(_1,lhs parseState) 
                   )
//# 2857 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8930 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2858 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             SynPat.DeprecatedCharRange (_1,_3,rhs2 parseState 1 3) 
                   )
//# 2858 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8942 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElementsAux)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2860 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let rs, m = _2 in SynPat.Record (rs, rhs2 parseState 1 3) 
                   )
//# 2860 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8954 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2862 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.ArrayOrList(false,_2,lhs parseState) 
                   )
//# 2862 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8965 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.ArrayOrList(true,_2, lhs parseState) 
                   )
//# 2864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8976 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2866 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Wild (lhs parseState) 
                   )
//# 2866 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8986 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.OptionalVal(_2,lhs parseState) 
                   )
//# 2868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8997 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2870 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lidwd = _1 
                             if not (isNilOrSingleton lidwd.Lid) || (String.isUpper (List.head lidwd.Lid).idText) 
                             then mkSynPatMaybeVar lidwd vis (lhs parseState)
                             else mkSynPatVar vis (List.head lidwd.Lid) 
                   )
//# 2870 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9011 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2875 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const (_1,_1.Range (lhs parseState)) 
                   )
//# 2875 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9022 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2877 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const(SynConst.Bool false,lhs parseState) 
                   )
//# 2877 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9032 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2879 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const(SynConst.Bool true,lhs parseState) 
                   )
//# 2879 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9042 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2881 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Null(lhs parseState) 
                   )
//# 2881 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9052 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPatternBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = (lhs parseState)
                             SynPat.Paren(_2 m,m) 
                   )
//# 2883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9065 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPatternBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2886 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             patFromParseError (_2 (rhs2 parseState 1 2)) 
                   )
//# 2886 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9078 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2889 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynPat.Wild (lhs parseState) 
                   )
//# 2889 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9089 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2891 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                              SynPat.Wild (lhs parseState)
                   )
//# 2891 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9101 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2894 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(true, List.rev _3,lhs parseState) 
                   )
//# 2894 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9113 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2896 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()); 
                             SynPat.Tuple(true, List.rev _3,lhs parseState) 
                   )
//# 2896 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2899 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynPat.Wild (lhs parseState) 
                   )
//# 2899 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9137 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2901 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()); 
                              SynPat.Wild (lhs parseState)
                   )
//# 2901 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9149 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> _1) 
                   )
//# 2908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPatternBody));
//# 9160 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2910 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> SynPat.Const(SynConst.Unit,m)) 
                   )
//# 2910 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPatternBody));
//# 9170 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2939 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Named (_1,_3,false,None,rhs2 parseState 1 3) 
                   )
//# 2939 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9182 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2941 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Or(_1,_3,rhs2 parseState 1 3) 
                   )
//# 2941 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9194 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(false,List.rev _1,lhs parseState) 
                   )
//# 2943 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9205 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjParenPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Ands(List.rev _1,rhs2 parseState 1 3) 
                   )
//# 2945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9216 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynPat.Typed(_1,_3,lhsm) 
                   )
//# 2947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9229 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2950 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynPat.Attrib(_2,_1,lhsm) 
                   )
//# 2950 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9242 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2953 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.LongIdent (LongIdentWithDots(mkSynCaseName (rhs parseState 2) opNameCons,[]), None, None, SynConstructorArgs.Pats [ SynPat.Tuple (false,[_1;_3],rhs2 parseState 1 3) ],None,lhs parseState) 
                   )
//# 2953 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9254 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constrPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2954 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         _1 
                   )
//# 2954 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9265 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2958 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2958 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleParenPatternElements));
//# 9277 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2960 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2960 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleParenPatternElements));
//# 9289 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjParenPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2964 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2964 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjParenPatternElements));
//# 9301 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2966 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2966 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjParenPatternElements));
//# 9313 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElement)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1],lhs parseState 
                   )
//# 2970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElementsAux));
//# 9325 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElement)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElementsAux)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2972 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let r = _1 in let (rs,dropMark) = _3 in (r :: rs),lhs parseState 
                   )
//# 2972 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElementsAux));
//# 9338 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2975 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                    (List.frontAndBack _1.Lid,_3) 
                   )
//# 2975 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElement));
//# 9350 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9360 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2981 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 2981 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9372 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2983 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 :: _3 
                   )
//# 2983 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9385 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9397 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2990 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileExpression())
                             exprFromParseError _2 
                   )
//# 2990 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2993 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2993 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2998 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2998 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9433 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9444 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3005 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                         _1 
                   )
//# 3005 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExprBlockR));
//# 9455 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3006 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 3006 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExprBlockR));
//# 9466 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3009 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                               SynExpr.Typed (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3009 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExpr));
//# 9478 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3010 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 3010 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExpr));
//# 9489 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3013 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            checkEndOfFileError _2; _1 
                   )
//# 3013 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9501 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,true,_1,_3,unionRanges _1.Range _3.Range) 
                   )
//# 3017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9514 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9526 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3021 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3021 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9537 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,false,_1,_3,unionRanges _1.Range _3.Range ) 
                   )
//# 3023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9549 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3025 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,false,_1,_4,unionRanges _1.Range _4.Range) 
                   )
//# 3025 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9562 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3027 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            let mLetKwd,isUse = match hwlb with (BindingSetPreAttrs(m,_,isUse,_,_))  -> m,isUse
                            let usedKeyword = if isUse then "use" else "let"
                            reportParseErrorAt mLetKwd (FSComp.SR.parsExpectedExpressionAfterLet(usedKeyword,usedKeyword))
                            let fauxRange = m.EndRange // zero width range at end of m
                            mkLocalBindings (m,hwlb,arbExpr("seqExpr",fauxRange)) 
                   )
//# 3027 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9578 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3039 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  debugPrint("recovering via error"); true 
                   )
//# 3039 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recover));
//# 9588 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3040 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                debugPrint("recovering via EOF"); false 
                   )
//# 3040 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recover));
//# 9599 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3045 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            mkLocalBindings (unionRanges (rhs2 parseState 1 2) _3.Range,_1,_3) 
                   )
//# 3045 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9611 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3048 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            mkLocalBindings (rhs2 parseState 1 2,_1,arbExpr("declExpr1",(rhs parseState 3))) 
                   )
//# 3048 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9622 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3054 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            mkLocalBindings (unionRanges m _2.Range,hwlb,_2) 
                   )
//# 3054 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9635 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3058 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            reportParseErrorAt (match hwlb with (BindingSetPreAttrs(m,_,_,_,_))  -> m) (FSComp.SR.parsErrorInReturnForLetIncorrectIndentation())
                            mkLocalBindings (m,hwlb,arbExpr("declExpr2",(rhs parseState 2))) 
                   )
//# 3058 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9648 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3063 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            mkLocalBindings (unionRanges m _3.Range, hwlb, _3) 
                   )
//# 3063 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9661 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3067 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            //reportParseErrorAt (match hwlb with (BindingSetPreAttrs(m,_,_,_,_))  -> m) (FSComp.SR.parsErrorInReturnForLetIncorrectIndentation())
                            mkLocalBindings (unionRanges m (rhs parseState 3),hwlb,arbExpr("declExpr3",(rhs parseState 3))) 
                   )
//# 3067 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9674 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDoBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3072 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let e = snd _1
                            SynExpr.Do (e,e.Range) 
                   )
//# 3072 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9686 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonMatchingExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3076 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3076 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9697 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonLambdaExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3079 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3079 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9708 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3082 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mMatch = (rhs parseState 1)
                             let mWith,(clauses,mLast) = _3 
                             let spBind = SequencePointAtBinding(unionRanges mMatch mWith) 
                             SynExpr.Match (spBind, _2,clauses,unionRanges mMatch mLast) 
                   )
//# 3082 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9723 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3088 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileMatch())
                             // Produce approximate expression during error recovery 
                             exprFromParseError _2 
                   )
//# 3088 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9737 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3093 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mMatch = (rhs parseState 1)
                             let mWith,(clauses,mLast) = _3 
                             let spBind = SequencePointAtBinding(unionRanges mMatch mWith) 
                             SynExpr.MatchBang (spBind, _2,clauses,unionRanges mMatch mLast) 
                   )
//# 3093 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9752 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3099 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileMatch())
                             // Produce approximate expression during error recovery 
                             exprFromParseError _2 
                   )
//# 3099 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9766 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3104 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mTry = (rhs parseState 1)
                             let spTry = SequencePointAtTry(mTry) 
                             let mWith,(clauses,mLast) = _3 
                             let spWith = SequencePointAtWith(mWith) 
                             let mTryToWith = unionRanges mTry mWith 
                             let mWithToLast = unionRanges mWith mLast 
                             let mTryToLast = unionRanges mTry mLast
                             SynExpr.TryWith (_2, mTryToWith, clauses,mWithToLast, mTryToLast,spTry,spWith) 
                   )
//# 3104 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9785 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // Produce approximate expression during error recovery 
                             // Include any expressions to make sure they gets type checked in case that generates useful results for intellisense 
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileTry())
                             exprFromParseError _2 
                   )
//# 3114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9800 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mTry = rhs parseState 1 
                             let spTry = SequencePointAtTry(mTry) 
                             let spFinally = SequencePointAtFinally(rhs parseState 3) 
                             let mTryToLast = unionRanges mTry _4.Range 
                             SynExpr.TryFinally (_2, _4,mTryToLast,spTry,spFinally) 
                   )
//# 3120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9816 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprCases)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3127 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mIf = (rhs parseState 1)
                             _3 _2 mIf 
                   )
//# 3127 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3131 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsIncompleteIf()) 
                             // Produce an approximate expression during error recovery. 
                             // Include expressions to make sure they get type checked in case that generates useful results for intellisense. 
                             // Generate a throwAway for the expression so it isn't forced to have a type 'bool' 
                             // from the context it is used in. 
                             exprFromParseError _2 
                   )
//# 3131 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9846 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3139 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsIncompleteIf())
                             // Produce an approximate expression during error recovery. There can still be value in doing this even
                             // for this pathological case.
                             let m = (rhs parseState 1)
                             let mEnd = m.EndRange
                             let spIfToThen = SequencePointAtBinding mEnd
                             exprFromParseError (SynExpr.IfThenElse (arbExpr("ifGuard1",mEnd),arbExpr("thenBody1",mEnd),None,spIfToThen,true,m,m)) 
                   )
//# 3139 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9863 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3148 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Lazy (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3148 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9874 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3151 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Assert (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3151 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9885 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3154 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsAssertIsNotFirstClassValue()) 
                   )
//# 3154 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9895 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Lazy (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9906 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3160 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Assert (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3160 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9917 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3163 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsAssertIsNotFirstClassValue()) 
                   )
//# 3163 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9927 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3166 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.While (spWhile,_2,_4,mWhileAll) 
                   )
//# 3166 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9944 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3172 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWhile())
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileAll = unionRanges (rhs parseState 1) _4.Range
                             exprFromParseError (SynExpr.While (spWhile,_2,_4,mWhileAll)) 
                   )
//# 3172 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9962 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3179 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = unionRanges (rhs parseState 4) (rhs parseState 5)
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 5)
                             SynExpr.While (spWhile,_2,arbExpr("whileBody1",mWhileBodyArb),mWhileAll) 
                   )
//# 3179 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9980 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3187 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsWhileDoExpected())
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = rhs parseState 3
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 3)
                             exprFromParseError (SynExpr.While (spWhile,_2,arbExpr("whileBody2",mWhileBodyArb),mWhileAll))  
                   )
//# 3187 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9997 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3195 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWhile())
                             arbExpr("whileLoop1",rhs parseState 1)  
                   )
//# 3195 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10009 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3199 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             //silent recovery
                             let mWhileHeader = rhs parseState 1
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = rhs parseState 3
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 3)
                             exprFromParseError (SynExpr.While (spWhile,arbExpr("whileGuard1",mWhileHeader),arbExpr("whileBody3",mWhileBodyArb),mWhileAll))  
                   )
//# 3199 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10025 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3207 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let spBind = SequencePointAtForLoop(rhs2 parseState 1 3)
                             let (a,b,_) = _2 
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3207 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10041 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3212 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let spBind = SequencePointAtForLoop(rhs2 parseState 1 3)
                             let (a,b,_) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,_4,mForLoopAll) 
                   )
//# 3212 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10059 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3219 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // Silent recovery
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,_) = _2 
                             let mForLoopBodyArb = rhs parseState 5
                             let mForLoopAll = rhs2 parseState 1 5
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody2a",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3219 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10078 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3228 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,_) = _2 
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody2",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3228 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10097 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3237 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (a,b,ok) = _2 
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsForDoExpected())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody1",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3237 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10115 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3246 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.For (spBind,a,b,c,d,_4,mForLoopAll) 
                   )
//# 3246 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10133 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3253 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             // Still produce an expression
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,_4,mForLoopAll)) 
                   )
//# 3253 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10153 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3262 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = rhs parseState 5
                             let mForLoopAll = rhs2 parseState 1 5
                             SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3262 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10172 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10191 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3280 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = (rhs parseState 2).EndRange
                             let mForLoopAll = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3280 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10209 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3290 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mForLoopHeader = rhs2 parseState 1 2
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             let spBind = SequencePointAtForLoop(mForLoopHeader)
                             SynExpr.For (spBind,mkSynId mForLoopHeader "_loopVar",arbExpr("startLoopRange1",mForLoopHeader),true,arbExpr("endLoopRange1",rhs parseState 3),_4,mForLoopAll) 
                   )
//# 3290 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10226 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3309 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsIdentifierExpected())
                             arbExpr("declExpr12",(rhs parseState 1)) 
                   )
//# 3309 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10238 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsInOrEqualExpected())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = rhs parseState 4
                             let mForLoopAll = rhs2 parseState 1 4
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,_2,arbExpr("forLoopCollection",mForLoopHeader),arbExpr("forLoopBody3",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10255 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = (rhs parseState 2).EndRange
                             let mForLoopAll = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.ForEach (spBind,SeqExprOnly false,true,_2,arbExpr("forLoopCollection",mForLoopHeader),arbExpr("forLoopBody3",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3321 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10272 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturn ((_1,not _1),_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10284 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturnFrom ((_1,not _1), _2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3333 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10296 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3336 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = SequencePointAtBinding(rhs2 parseState 1 5)
                            let m = unionRanges (rhs parseState 1) _7.Range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4,_7,m) 
                   )
//# 3336 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10313 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3341 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _5 (if _1 = "use" then "use!" else "let!") (rhs parseState 1)  // report unterminated error 
                            let spBind = SequencePointAtBinding(unionRanges (rhs parseState 1) _4.Range)
                            let m = unionRanges (rhs parseState 1) _7.Range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4,_7,m) 
                   )
//# 3341 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10332 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3347 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // error recovery that allows intellisense when writing incomplete computation expressions 
                            let spBind = SequencePointAtBinding(unionRanges (rhs parseState 1) _4.Range) 
                            let mAll = unionRanges (rhs parseState 1) (rhs parseState 7)
                            let m = _4.Range.EndRange // zero-width range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4, SynExpr.ImplicitZero m, mAll) 
                   )
//# 3347 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10351 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3354 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = NoSequencePointAtDoBinding
                            SynExpr.LetOrUseBang (spBind,false,true,SynPat.Const(SynConst.Unit,_2.Range),_2,_5, unionRanges (rhs parseState 1) _5.Range) 
                   )
//# 3354 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10365 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3358 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.DoBang (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3358 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10377 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrowThenExprR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3361 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = SequencePointAtForLoop(rhs2 parseState 1 2)
                            let (a,b,_) = _2 in SynExpr.ForEach (spBind,SeqExprOnly true,true,a,b,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3361 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10391 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3365 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.Fixed (_2, (unionRanges (rhs parseState 1) _2.Range)) 
                   )
//# 3365 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10402 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Error(FSComp.SR.parsArrowUseIsLimited(),lhs parseState))
                            SynExpr.YieldOrReturn ((true,true),_2, (unionRanges (rhs parseState 1) _2.Range)) 
                   )
//# 3368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10414 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3373 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.TypeTest (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3373 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10426 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3374 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.Upcast (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3374 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10438 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.Downcast (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10450 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3378 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 ":=" _3 
                   )
//# 3378 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10462 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3379 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                         mkSynAssign _1 _3 
                   )
//# 3379 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10474 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3381 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        let exprs,commas = _1 in SynExpr.Tuple (false, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ) 
                   )
//# 3381 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10485 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    SynExpr.JoinIn (_1,rhs parseState 2,_3,unionRanges _1.Range _3.Range) 
                   )
//# 3382 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10497 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "||" _3 
                   )
//# 3383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10509 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3384 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3384 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10522 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3385 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "or" _3 
                   )
//# 3385 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10534 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "&" _3 
                   )
//# 3386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10546 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3387 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "&&" _3 
                   )
//# 3387 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10558 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3388 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3388 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10571 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3389 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "=" _3 
                   )
//# 3389 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10583 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3390 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3390 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10596 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3391 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "$" _3 
                   )
//# 3391 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10608 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3392 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "<" _3 
                   )
//# 3392 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10621 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3393 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                   if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("<"))  
                                                                   exprFromParseError (mkSynInfix (rhs parseState 2) _1 "<" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3393 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10635 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3395 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 ">" _3 
                   )
//# 3395 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10648 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3396 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3396 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10661 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3397 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3397 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10674 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3398 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    SynExpr.App (ExprAtomicFlag.NonAtomic, true, mkSynIdGet (rhs parseState 2) opNameCons,SynExpr.Tuple (false,[_1;_3],[rhs parseState 2],unionRanges _1.Range _3.Range),unionRanges _1.Range _3.Range) 
                   )
//# 3398 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10686 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3399 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3399 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10699 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3400 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "-" _3 
                   )
//# 3400 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10711 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3401 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "*" _3 
                   )
//# 3401 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10723 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3402 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3402 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10736 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3403 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3403 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10749 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3405 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("in")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "@in" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3405 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10761 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3407 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("||")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "||" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3407 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10773 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3409 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3409 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10786 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3411 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("or")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "or" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3411 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10798 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3413 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("&")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "&" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3413 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10810 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3415 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("&&")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "&&" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3415 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10822 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3417 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3417 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10835 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3419 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("=")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "=" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3419 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10847 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3421 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3421 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10860 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3423 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("$")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "$" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3423 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10872 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3425 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("<")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "<" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3425 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10885 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3427 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(">")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 ">" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3427 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10898 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3429 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3429 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10911 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3431 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3431 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10924 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3433 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("::")) 
                                                                                 SynExpr.App (ExprAtomicFlag.NonAtomic, true, mkSynIdGet (rhs parseState 2) opNameCons,SynExpr.Tuple (false,[_1;(arbExpr("declExprInfix",(rhs parseState 3).StartRange))],[rhs parseState 2],unionRanges _1.Range (rhs parseState 3).StartRange),unionRanges _1.Range (rhs parseState 3).StartRange) 
                   )
//# 3433 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10936 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3435 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3435 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10949 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3437 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("-")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "-" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3437 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10961 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3439 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("*")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "*" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3439 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10973 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3441 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3441 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10986 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3443 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3443 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10999 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3446 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  _1 
                   )
//# 3446 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11010 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3450 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let con = SynConst.String (_1,rhs parseState 1)
                             let arg2 = SynExpr.Const (con,con.Range (rhs parseState 1)) 
                             arg2 
                   )
//# 3450 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dynamicArg));
//# 11023 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3454 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 3454 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dynamicArg));
//# 11035 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3458 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             rhs parseState 1, _2 
                   )
//# 3458 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11046 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3460 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             rhs parseState 1, _2 
                   )
//# 3460 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11057 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3462 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWith())
                             rhs parseState 1, _2 
                   )
//# 3462 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11070 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3467 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3467 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11081 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3469 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              _2 
                   )
//# 3469 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11092 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3471 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // silent recovery 
                              let mLast = rhs parseState 1
                              [], mLast 
                   )
//# 3471 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11104 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3475 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // silent recovery 
                              let mLast = rhs parseState 1
                              [], mLast 
                   )
//# 3475 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11116 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternGuard)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3482 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1, _2, rhs parseState 1 
                   )
//# 3482 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternAndGuard));
//# 11128 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3486 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = _2.Range 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast  
                   )
//# 3486 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11142 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3490 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let clauses,mLast = _4 
                            (Clause(pat,guard,_2,patm,SequencePointAtTarget) :: clauses), mLast 
                   )
//# 3490 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11157 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3494 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = rhs parseState 3 
                            // silent recovery 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast  
                   )
//# 3494 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11172 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3499 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = _2.Range 
                            // silent recovery 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast 
                   )
//# 3499 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11187 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3504 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = rhs parseState 2
                            // silent recovery 
                            [Clause(pat,guard,SynExpr.Const (SynConst.Unit,mLast.EndRange),patm,SequencePointAtTarget)], mLast 
                   )
//# 3504 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11201 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3511 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Some _2 
                   )
//# 3511 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternGuard));
//# 11212 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3513 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            None 
                   )
//# 3513 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternGuard));
//# 11222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3517 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 3517 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11233 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprThen)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprElifs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3521 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprThen,mThen = _1 
                             (fun exprGuard mIf -> 
                                 let mIfToThen = unionRanges mIf mThen
                                 let lastBranch : SynExpr = match _2 with None -> exprThen | Some e -> e
                                 let mIfToEndOfLastBranch = unionRanges mIf lastBranch.Range
                                 let spIfToThen = SequencePointAtBinding(mIfToThen)
                                 SynExpr.IfThenElse (exprGuard,exprThen,_2,spIfToThen,false,mIfToThen,mIfToEndOfLastBranch)) 
                   )
//# 3521 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprCases));
//# 11251 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, rhs parseState 1 
                   )
//# 3531 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11262 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3533 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3,rhs parseState 1 
                   )
//# 3533 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11274 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileThen())
                             exprFromParseError _3,rhs parseState 1 
                   )
//# 3535 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11287 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 3540 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11297 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3543 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _2 
                   )
//# 3543 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11308 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3546 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _3 
                   )
//# 3546 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11320 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3549 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileElse())
                             Some (exprFromParseError _3) 
                   )
//# 3549 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11333 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprCases)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3553 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mElif = rhs parseState 1 
                             Some (_3 _2 mElif) 
                   )
//# 3553 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11346 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3557 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some (exprFromParseError _2) 
                   )
//# 3557 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11358 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3561 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprs,commas = _1 in (_3 :: exprs),((rhs parseState 2) :: commas) 
                   )
//# 3561 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11370 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3564 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let exprs,commas = _1     
                             let zeroWidthAtNextToken = (rhs parseState 3).StartRange
                             ((arbExpr("tupleExpr1",zeroWidthAtNextToken)) :: exprs), (rhs parseState 2) :: commas 
                   )
//# 3564 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11385 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3570 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let zeroWidthAtNextToken = (rhs parseState 3).StartRange 
                             ((arbExpr("tupleExpr2",zeroWidthAtNextToken)) :: [_1]), [rhs parseState 2] 
                   )
//# 3570 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3575 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_3 ; _1], [rhs parseState 2] 
                   )
//# 3575 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11411 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3579 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) "~-" _2 
                   )
//# 3579 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11422 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3582 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3582 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11435 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3586 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3586 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11448 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3590 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3590 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11461 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3594 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.AddressOf (true,_2,rhs parseState 1,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3594 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11472 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3597 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.AddressOf (false,_2,rhs parseState 1, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3597 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11483 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3600 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.New (false,_2,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3600 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11496 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3603 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.New (false,_2,arbExpr("minusExpr",(rhs parseState 4)),unionRanges (rhs parseState 1) (_2).Range) 
                   )
//# 3603 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11508 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3606 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             arbExpr("minusExpr2",(rhs parseState 1)) 
                   )
//# 3606 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11518 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3609 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.InferredUpcast (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3609 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11529 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3612 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.InferredDowncast (_2,unionRanges (rhs parseState 1) _2.Range)
                   )
//# 3612 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11540 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3615 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3615 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11551 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3619 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.App (ExprAtomicFlag.NonAtomic, false, _1,_2,unionRanges _1.Range _2.Range)  
                   )
//# 3619 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11563 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3622 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg,_ = _1 
                             arg 
                   )
//# 3622 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11575 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg2,hpa2 = _2 
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt arg2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             if hpa2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessiveArgsShouldBeSpacedOrTupled())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) arg2.Range) ("~"+(_1)) arg2 
                   )
//# 3627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11590 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3633 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg,hpa = _1 
                             if hpa then reportParseErrorAt arg.Range (FSComp.SR.parsSuccessiveArgsShouldBeSpacedOrTupled())
                             arg 
                   )
//# 3633 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3639 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let arg2,_ = _3 
                             SynExpr.App (ExprAtomicFlag.Atomic, false, arg1,arg2,unionRanges arg1.Range arg2.Range),true  
                   )
//# 3639 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11617 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3644 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let arg2,_ = _3 
                             SynExpr.App (ExprAtomicFlag.Atomic, false, arg1,arg2,unionRanges arg1.Range arg2.Range),true  
                   )
//# 3644 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11631 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3649 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let mLessThan,mGreaterThan,_,args,commas,mTypeArgs = _3
                             let mWholeExpr = unionRanges arg1.Range mTypeArgs
                             SynExpr.TypeApp (arg1, mLessThan, args, commas, mGreaterThan, mTypeArgs, mWholeExpr), false 
                   )
//# 3649 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11646 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3655 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg2,hpa2 = _2 
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt arg2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefixPrim (rhs parseState 1) (unionRanges (rhs parseState 1) arg2.Range) _1 arg2,hpa2 
                   )
//# 3655 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11660 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicExprQualification)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3660 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,hpa1 = _1 
                             _3 arg1 (lhs parseState) (rhs parseState 2),hpa1 
                   )
//# 3660 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11673 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicExprQualification)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1 = SynExpr.Ident (ident("base",rhs parseState 1))
                             _3 arg1 (lhs parseState) (rhs parseState 2),false 
                   )
//# 3664 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11685 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.LongIdent (true,LongIdentWithDots([_2],[]),None,rhs parseState 2),false 
                   )
//# 3668 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11696 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'dynamicArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3671 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,hpa1 = _1
                             mkSynInfix (rhs parseState 2) arg1 "?" _3, hpa1 
                   )
//# 3671 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11709 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Ident (ident(MangledGlobalName,rhs parseState 1)), false 
                   )
//# 3675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11719 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3678 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Ident (_1),false 
                   )
//# 3678 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11730 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3681 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 (lhs parseState) false,false 
                   )
//# 3681 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11741 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             exprFromParseError (_2 (rhs2 parseState 1 2) false), false 
                   )
//# 3684 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3688 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             SynExpr.ArrayOrList (false,[ ], lhs parseState),false  
                   )
//# 3688 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11765 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3692 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             // silent recovery 
                             exprFromParseError (SynExpr.ArrayOrList (false,[ ], rhs parseState 1)),false  
                   )
//# 3692 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11778 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3697 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprs,commas = _3 in SynExpr.Tuple (true, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ), false 
                   )
//# 3697 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11790 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3700 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedBracket()); 
                             let exprs,commas = _3 in SynExpr.Tuple (true, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ), false 
                   )
//# 3700 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11803 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3704 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1,false 
                   )
//# 3704 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11814 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'identOrOp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3708 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let idm = rhs parseState 1 
                             (fun e lhsm dotm -> mkSynDot dotm lhsm e _1) 
                   )
//# 3708 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11826 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt (rhs parseState 3) (FSComp.SR.nrGlobalUsedOnlyAsFirstName()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 mkSynDotMissing dotm fixedLhsm e) 
                   )
//# 3712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11839 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3718 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt dotm (FSComp.SR.parsMissingQualificationAfterDot()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 mkSynDotMissing dotm fixedLhsm e) 
                   )
//# 3718 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11852 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3723 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt dotm (FSComp.SR.parsMissingQualificationAfterDot()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 // Include 'e' in the returned expression but throw it away
                                 SynExpr.DiscardAfterMissingQualificationAfterDot (e,fixedLhsm)) 
                   )
//# 3723 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11867 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3729 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 libraryOnlyError(lhs parseState)
                                 SynExpr.LibraryOnlyUnionCaseFieldGet (e,mkSynCaseName lhsm opNameCons,(fst _5),lhsm)) 
                   )
//# 3729 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11881 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3734 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 mlCompatWarning (FSComp.SR.parsParenFormIsForML()) (lhs parseState) 
                                 mkSynDotParenGet lhsm dotm e _2) 
                   )
//# 3734 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11895 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3739 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> mkSynDotBrackGet lhsm dotm e _2) 
                   )
//# 3739 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11906 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackGet lhsm dotm e _2)) 
                   )
//# 3742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11919 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3746 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> mkSynDotBrackSeqSliceGet lhsm dotm e _2) 
                   )
//# 3746 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11930 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3749 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackSeqSliceGet lhsm dotm e _2)) 
                   )
//# 3749 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11943 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3753 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mArg = rhs2 parseState 1 3
                             (fun e lhsm dotm -> mkSynDotBrackGet lhsm dotm e (arbExpr("indexerExpr1",mArg))) 
                   )
//# 3753 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11954 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3757 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket())
                             let mArg = (rhs parseState 1).EndRange 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackGet lhsm dotm e (arbExpr("indexerExpr2",mArg)))) 
                   )
//# 3757 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11967 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3762 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                            _1 :: _3 
                   )
//# 3762 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRangeSeqExpr));
//# 11979 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRange)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3763 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    [_1] 
                   )
//# 3763 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRangeSeqExpr));
//# 11990 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3767 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) (Some _1), mkSynOptionalExpr (rhs parseState 3) (Some _3)) 
                   )
//# 3767 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12002 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3770 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) (Some _1), mkSynOptionalExpr (rhs parseState 2) None) 
                   )
//# 3770 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12013 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3773 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) None, mkSynOptionalExpr (rhs parseState 2) (Some _2)) 
                   )
//# 3773 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12024 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3776 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) None, mkSynOptionalExpr (rhs parseState 1) None) 
                   )
//# 3776 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12034 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3779 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.One(_1) 
                   )
//# 3779 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12045 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3784 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (_1,_1.Range (lhs parseState)) 
                   )
//# 3784 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12056 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3786 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12067 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3788 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3788 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12078 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3790 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3790 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12089 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3792 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Null (lhs parseState) 
                   )
//# 3792 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12099 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3794 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Bool false,lhs parseState) 
                   )
//# 3794 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12109 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Bool true,lhs parseState) 
                   )
//# 3796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12119 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'quoteExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3798 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3798 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12130 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12141 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'beginEndExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3802 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3802 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12152 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3806 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Paren (_2, rhs parseState 1, Some(rhs parseState 3), rhs2 parseState 1 3) 
                   )
//# 3806 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12163 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3809 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBegin()); exprFromParseError _2 
                   )
//# 3809 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12175 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3812 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) arbExpr("beginEndExpr",(lhs parseState))  
                   )
//# 3812 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12185 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3815 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkSynUnit (lhs parseState) 
                   )
//# 3815 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMismatchedQuote(fst _1))
                             (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)), snd _1, _2, false, lhs parseState)) 
                   )
//# 3819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12209 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatched(fst _1))  
                             let mExpr = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, _2, false, mExpr))  
                   )
//# 3823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12224 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3828 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, arbExpr("quoteExpr",(rhs parseState 2)), false, lhs parseState)  
                   )
//# 3828 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12236 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatched(fst _1))
                             exprFromParseError (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, arbExpr("quoteExpr2",(rhs parseState 1).EndRange), false, rhs parseState 1))  
                   )
//# 3831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12249 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3836 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              _2 (lhs parseState) true 
                   )
//# 3836 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12260 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3839 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracketBar()) 
                             exprFromParseError (_2 (rhs2 parseState 1 2) true) 
                   )
//# 3839 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12273 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3843 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              (* silent recovery *) SynExpr.ArrayOrList (true,[ ], lhs parseState) 
                   )
//# 3843 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12283 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3846 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracketBar())  
                             (* silent recovery *) 
                             exprFromParseError (SynExpr.ArrayOrList (true,[ ], rhs parseState 1)) 
                   )
//# 3846 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12296 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3852 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Unit,(rhs2 parseState 1 2)) 
                   )
//# 3852 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12307 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3855 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = rhs2 parseState 1 3
                             SynExpr.Paren (_2 m, rhs parseState 1, Some(rhs parseState 3), m) 
                   )
//# 3855 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12320 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_other_than_rparen_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3859 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).End
                             SynExpr.Paren (exprFromParseError (_2 lhsm), rhs parseState 1, None, lhsm) 
                   )
//# 3859 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12334 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery
                             SynExpr.Paren (arbExpr("parenExpr1",(rhs parseState 1).EndRange),(rhs parseState 1),Some(rhs parseState 3),(rhs2 parseState 1 3)) 
                   )
//# 3864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12346 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2tcs", lhsm) 
                   )
//# 3868 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12358 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3873 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2mcs", lhsm) 
                   )
//# 3873 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12370 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3878 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2rbcs", lhsm) 
                   )
//# 3878 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12382 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lparenRange = (rhs parseState 1)
                             reportParseErrorAt lparenRange (FSComp.SR.parsUnmatchedParen())
                             SynExpr.Paren(arbExpr("parenExpr2obecs", lparenRange.EndRange), lparenRange, None, lparenRange) 
                   )
//# 3883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12394 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3888 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             arbExpr("parenExpr2",(lhs parseState))  
                   )
//# 3888 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12406 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> SynExpr.TraitCall (_1,_4,_6,m)) 
                   )
//# 3900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12420 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3902 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun _m -> _1) 
                   )
//# 3902 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'inlineAssemblyExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3904 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3904 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12442 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 3908 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypars));
//# 12453 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTyparAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             List.rev _2 
                   )
//# 3911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypars));
//# 12465 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTyparAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3915 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 :: _1
                   )
//# 3915 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTyparAlts));
//# 12477 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3918 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 3918 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTyparAlts));
//# 12488 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3922 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m,r = _2 in r (rhs2 parseState 1 3) 
                   )
//# 3922 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12500 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3925 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace())  
                            let m,r = _2 
                            // Note, we can't use 'exprFromParseError' because the extra syntax node interferes with some syntax-directed transformations for computation expressions
                            r (unionRanges (rhs parseState 1) m) 
                   )
//# 3925 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12515 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            arbExpr("braceExpr",rhs2 parseState 1 3)  
                   )
//# 3931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12527 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3935 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace())  
                            // Note, we can't use 'exprFromParseError' because the extra syntax node interferes with some syntax-directed transformations for computation expressions
                            SynExpr.Record (None,None,[],rhs parseState 1) 
                   )
//# 3935 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12540 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3940 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = rhs2 parseState 1 2 
                             SynExpr.Record (None,None,[],m) 
                   )
//# 3940 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12552 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (lhs parseState), (fun m -> let a,b,c = _1 in SynExpr.Record (a,b,c,m)) 
                   )
//# 3945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12563 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3948 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 3948 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12574 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'monadicExprInitial)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3951 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _1 in (m, r false) 
                   )
//# 3951 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12585 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'monadicExprInitial)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3955 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _1 in (fun lhsm isArray -> SynExpr.ArrayOrListOfSeqExpr (isArray, r true m, lhsm)) 
                   )
//# 3955 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listExprElements));
//# 12596 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3957 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun lhsm isArray -> SynExpr.ArrayOrList (isArray,[ ], lhsm)) 
                   )
//# 3957 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listExprElements));
//# 12606 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3961 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1.Range, (fun isArrayOrList lhsm -> SynExpr.CompExpr (isArrayOrList,ref(isArrayOrList),_1,lhsm)) 
                   )
//# 3961 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'monadicExprInitial));
//# 12617 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3964 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 3964 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'monadicExprInitial));
//# 12628 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3968 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let opm = (rhs parseState 2)
                            (unionRanges _1.Range _3.Range),(fun _isArray wholem -> 
                                                                     // in the case of "{ 1 .. 10 }", we want the range of the expression to include the curlies, that comes from a higher level rule in the grammar,
                                                                     // passed down as 'wholem', so patch up that range here
                                                                     match (mkSynInfix opm _1 ".." _3) with
                                                                     | SynExpr.App (a,b,c,d,_) -> SynExpr.App (a,b,c,d,wholem)
                                                                     | _ -> failwith "impossible") 
                   )
//# 3968 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12646 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3976 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (unionRanges _1.Range _5.Range),(fun _isArray wholem -> mkSynTrifix wholem ".. .." _1 _3 _5) 
                   )
//# 3976 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12659 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileExpression())
                            let opm = (rhs parseState 2)
                            let e = arbExpr("rangeSeqError1", (rhs parseState 3).StartRange)
                            (unionRanges _1.Range e.Range),(fun _isArray wholem -> 
                                                                     // in the case of "{ 1 .. 10 }", we want the range of the expression to include the curlies, that comes from a higher level rule in the grammar,
                                                                     // passed down as 'wholem', so patch up that range here
                                                                     match (mkSynInfix opm _1 ".." e) with
                                                                     | SynExpr.App (a,b,c,d,_) -> SynExpr.App (a,b,c,d,wholem)
                                                                     | _ -> failwith "impossible") 
                   )
//# 3979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12679 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3992 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturn ((true,false), _2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3992 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrowThenExprR));
//# 12690 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3997 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_1, _3, true) 
                   )
//# 3997 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12702 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _3 in (_1, r false m, true) 
                   )
//# 4000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12714 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4003 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                            (_1, arbExpr("forLoopBinder",(rhs parseState 2)), false) 
                   )
//# 4003 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12727 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4007 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInOrEqualExpected())
                            (_1, arbExpr("forLoopBinder2",(rhs parseState 1).EndRange), false) 
                   )
//# 4007 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12740 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopDirection)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4012 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             idOfPat parseState (rhs parseState 1) _1,_3,_4,_5 
                   )
//# 4012 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopRange));
//# 12754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4015 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedSymbolEqualsInsteadOfIn()) 
                   )
//# 4015 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopRange));
//# 12766 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  true 
                   )
//# 4018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopDirection));
//# 12776 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  false 
                   )
//# 4019 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopDirection));
//# 12786 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inlineAssemblyTypeArg)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_curriedArgExprs)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inlineAssemblyReturnTypes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             libraryOnlyWarning (lhs parseState)
                             let s,sm = _2,rhs parseState 2
                             (fun m -> SynExpr.LibraryOnlyILAssembly (internalParseAssemblyCodeInstructions s parseState.LexBuffer.SupportsFeature sm, _3, List.rev _4, _5, m)) 
                   )
//# 4023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inlineAssemblyExpr));
//# 12802 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_curriedArgExprs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 :: _1 
                   )
//# 4029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_curriedArgExprs));
//# 12814 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4032 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 4032 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_curriedArgExprs));
//# 12824 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4036 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 4036 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_atomicExprAfterType));
//# 12834 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4039 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_1) 
                   )
//# 4039 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_atomicExprAfterType));
//# 12845 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyTypeArg));
//# 12855 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                           [_3] 
                   )
//# 4043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyTypeArg));
//# 12868 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12878 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4050 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_2] 
                   )
//# 4050 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12889 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 4053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12900 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4057 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _4 with None -> mkSynUnit (lhs parseState) | Some e -> e 
                            let l = List.rev _5
                            let dummyField = mkRecdField (LongIdentWithDots([], [])) // dummy identifier, it will be discarded
                            let l = rebindRanges (dummyField, None) l _6 
                            let (_, _, inheritsSep) = List.head l
                            let bindings = List.tail l
                            (Some (_2,arg,rhs2 parseState 2 4, inheritsSep, rhs parseState 1), None, bindings) 
                   )
//# 4057 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExpr));
//# 12921 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4065 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let a,b = _1 in (None, a, b) 
                   )
//# 4065 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExpr));
//# 12932 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4069 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _1 with 
                            | LongOrSingleIdent(false, (LongIdentWithDots(_,_) as f),None,m) ->  
                                 let f = mkRecdField f
                                 let l = List.rev _4
                                 let l = rebindRanges (f, Some _3) l _5
                                 (None, l)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsFieldBinding()) 
                   )
//# 4069 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12952 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4082 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())
                           reportParseErrorAt m (FSComp.SR.parsFieldBinding())
                           let f = mkUnderscoreRecdField m
                           (None, [ (f, None, None)  ]) 
                   )
//# 4082 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12966 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4089 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())      
                           let f = mkUnderscoreRecdField m
                           reportParseErrorAt (rhs2 parseState 1 2) (FSComp.SR.parsFieldBinding())
                           
                           (None, [ (f, None, None) ]) 
                   )
//# 4089 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12981 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4098 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnderscoreInvalidFieldName())
                           let f = mkUnderscoreRecdField (rhs parseState 1)
                           let l = List.rev _4
                           let l = rebindRanges (f, Some _3) l _5
                           (None, l) 
                   )
//# 4098 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12998 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let l = List.rev _4
                             let l = rebindRanges _3 l _5
                             (Some (_1, (rhs parseState 2, None)), l) 
                   )
//# 4106 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 13014 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4111 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (Some (_1, (rhs parseState 2, None)), []) 
                   )
//# 4111 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 13026 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let l = List.rev _4
                             let l = rebindRanges _3 l _5
                             (Some (_1, (rhs parseState 2, None)), l) 
                   )
//# 4114 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 13042 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     Some _1 
                   )
//# 4119 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps_recd));
//# 13053 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           None 
                   )
//# 4120 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps_recd));
//# 13063 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4123 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     (rhs parseState 1), None 
                   )
//# 4123 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13073 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      let m = (rhs parseState 1) in (m, Some m.End) 
                   )
//# 4124 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4125 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               (rhs2 parseState 1 2), Some (rhs parseState 1).End 
                   )
//# 4125 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4126 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               (rhs2 parseState 1 2), Some (rhs parseState 2).End 
                   )
//# 4126 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13103 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4133 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                mkRecdField _1 
                   )
//# 4133 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'pathOrUnderscore));
//# 13114 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4135 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())
                           mkUnderscoreRecdField m 
                   )
//# 4135 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'pathOrUnderscore));
//# 13126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps_recd)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4141 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_3, Some _2) :: _1 
                   )
//# 4141 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprBindings));
//# 13139 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4142 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4142 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprBindings));
//# 13149 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4146 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (_1, Some _3) 
                   )
//# 4146 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13161 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4149 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4149 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13173 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4153 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4153 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13186 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4157 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13198 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4161 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4161 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13211 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBaseCall)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4172 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1
                            let fullRange = match _4 with [] -> (rhs parseState 1) | _ -> (rhs2 parseState 1 4)
                            fullRange, (fun m -> let (a,b) = _1 in SynExpr.ObjExpr (a,b,_2,_4, mNewExpr, m)) 
                   )
//# 4172 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13227 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBaseCall)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4177 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1 
                            let fullRange = match _3 with [] -> (rhs parseState 1) | _ -> (rhs2 parseState 1 3)
                            fullRange, (fun m -> let (a,b) = _1 in SynExpr.ObjExpr (a,b,[],_3, mNewExpr, m)) 
                   )
//# 4177 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13242 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4182 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1 
                            (rhs2 parseState 1 2), (fun m -> let (a,b) = _2,None in SynExpr.ObjExpr (a,b,[],[], mNewExpr, m)) 
                   )
//# 4182 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13254 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'baseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4188 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2, Some(_4,Some(_5))) 
                   )
//# 4188 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13268 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2, Some(_4,None)) 
                   )
//# 4191 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13281 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4194 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2,None 
                   )
//# 4194 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13292 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4199 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           _1 
                   )
//# 4199 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprBindings));
//# 13303 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4200 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           [] 
                   )
//# 4200 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprBindings));
//# 13313 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4204 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWithKwd = (rhs parseState 1)
                             let _localBindingsLastRange, localBindingsBuilder = _2 
                             localBindingsBuilder [] None mWithKwd 
                   )
//# 4204 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4209 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWithKwd = (rhs parseState 1)
                             let _localBindingsLastRange, localBindingsBuilder = _2 
                             localBindingsBuilder [] None mWithKwd 
                   )
//# 4209 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13339 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4214 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 |> 
                             (List.choose (function 
                                               | SynMemberDefn.Member(b,m) -> Some b
                                               | SynMemberDefn.AutoProperty(_,_,_,_,_,_,_,_,_,_,m) -> errorR(Error(FSComp.SR.parsIllegalMemberVarInObjectImplementation(),m)); None
                                               | x -> errorR(Error(FSComp.SR.parsMemberIllegalInObjectImplementation(),x.Range)); None)) 
                   )
//# 4214 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13355 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterface)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4221 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  _1 :: _2 
                   )
//# 4221 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprInterfaces));
//# 13367 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4225 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4225 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13377 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterface)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4228 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 4228 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13389 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4231 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) _2 
                   )
//# 4231 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13400 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprBindings)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declEnd)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4235 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           InterfaceImpl(_2, _3, lhs parseState) 
                   )
//# 4235 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprInterface));
//# 13415 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4239 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 true 
                   )
//# 4239 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExpr));
//# 13426 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4241 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 false 
                   )
//# 4241 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExpr));
//# 13437 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4245 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let orig, flds = _2
                            let flds = 
                                flds |> List.choose (function 
                                  | ((LongIdentWithDots([id],_),_),Some e,_) -> Some (id,e) 
                                  | ((LongIdentWithDots([id],_),_),None,_) -> Some (id, arbExpr("anonField",id.idRange)) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None) 
                            let m = rhs2 parseState 1 3
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,orig,flds,m)) 
                   )
//# 4245 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13456 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4255 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar())  
                            let orig, flds = _2 
                            let flds = 
                                flds |> List.choose (function 
                                  | ((LongIdentWithDots([id],_),_),Some e,_) -> Some (id,e) 
                                  | ((LongIdentWithDots([id],_),_),None,_) -> Some (id, arbExpr("anonField",id.idRange)) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None) 
                            let m = rhs2 parseState 1 2
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,orig,flds,m)) 
                   )
//# 4255 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13476 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4266 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            let m = rhs2 parseState 1 3
                            (fun _ -> arbExpr("braceBarExpr",m)) 
                   )
//# 4266 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13489 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar())  
                            let m = rhs2 parseState 1 1
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,None,[],m)) 
                   )
//# 4271 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13502 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4276 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs2 parseState 1 2
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,None,[],m)) 
                   )
//# 4276 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13514 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4281 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4 
                   )
//# 4281 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13527 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4285 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = rhs2 parseState 1 3
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 (arbExpr("anonLambdaExpr1",(rhs parseState 4))) 
                   )
//# 4285 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13539 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4289 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4 
                   )
//# 4289 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13552 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4293 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFunBody());
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4) 
                   )
//# 4293 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13567 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4298 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs2 parseState 1 3) (FSComp.SR.parsMissingFunctionBody())
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 3) _2 (arbExpr("anonLambdaExpr2",(rhs parseState 4))) 
                   )
//# 4298 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13579 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4302 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFunBody())
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 3) _2 (arbExpr("anonLambdaExpr3",(rhs parseState 4)))) 
                   )
//# 4302 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13592 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4306 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 2) _2 (arbExpr("anonLambdaExpr4",(rhs parseState 3)))) 
                   )
//# 4306 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4309 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs parseState 1) [] (arbExpr("anonLambdaExpr5",(rhs parseState 2)))) 
                   )
//# 4309 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13613 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let clauses,mLast = _2
                             let mAll = unionRanges (rhs parseState 1) mLast
                             SynExpr.MatchLambda (false,(rhs parseState 1),clauses,NoSequencePointAtInvisibleBinding,mAll) 
                   )
//# 4313 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonMatchingExpr));
//# 13626 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4318 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let clauses,mLast = _2
                             let mAll = unionRanges (rhs parseState 1) mLast
                             SynExpr.MatchLambda (false,(rhs parseState 1),clauses,NoSequencePointAtInvisibleBinding,mAll) 
                   )
//# 4318 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonMatchingExpr));
//# 13639 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4327 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4327 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeWithTypeConstraints));
//# 13650 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.WithGlobalConstraints(_1, List.rev _3,lhs parseState) 
                   )
//# 4330 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeWithTypeConstraints));
//# 13662 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4334 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4334 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTypeWithTypeConstraints));
//# 13673 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4337 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _1 
                            // nb. it doesn't matter where the constraints go in the structure of the type. 
                            SynType.WithGlobalConstraints(ty,List.rev _3,lhs parseState), arity 
                   )
//# 4337 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTypeWithTypeConstraints));
//# 13687 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4343 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            None 
                   )
//# 4343 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topReturnTypeWithTypeConstraints));
//# 13697 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4346 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _2 
                            let arity = (match arity with SynValInfo([],rmdata)-> rmdata | _ -> SynInfo.unnamedRetVal)
                            Some (SynReturnInfo((ty,arity),rhs parseState 2)) 
                   )
//# 4346 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topReturnTypeWithTypeConstraints));
//# 13710 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4352 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let dty,dmdata= _1 
                            let rty,(SynValInfo(dmdatas,rmdata)) = _3 
                            SynType.Fun(dty,rty,lhs parseState), (SynValInfo(dmdata :: dmdatas, rmdata)) 
                   )
//# 4352 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topType));
//# 13724 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4357 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,rmdata = _1 in ty, (SynValInfo([],(match rmdata with [md] -> md | _ -> SynInfo.unnamedRetVal))) 
                   )
//# 4357 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topType));
//# 13735 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4361 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,mdata = _1 in let tys,mdatas = List.unzip _3 in (SynType.Tuple(false,List.map (fun ty -> (false,ty)) (ty :: tys), lhs parseState)),(mdata :: mdatas) 
                   )
//# 4361 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleType));
//# 13747 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4364 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,mdata = _1 in ty,[mdata] 
                   )
//# 4364 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleType));
//# 13758 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 4368 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleTypeElements));
//# 13770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 4371 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleTypeElements));
//# 13781 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _2 with 
                            | SynType.LongIdent(LongIdentWithDots([id],_)) -> _4,SynArgInfo(_1,false,Some id)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsSyntaxErrorInLabeledType())  
                   )
//# 4375 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13796 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4380 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _5,SynArgInfo(_1,true,Some _3) 
                   )
//# 4380 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13809 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2,SynArgInfo(_1,false,None)) 
                   )
//# 4383 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13821 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _1 with 
                            | SynType.LongIdent(LongIdentWithDots([id],_)) -> _3,SynArgInfo([],false,Some id)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsSyntaxErrorInLabeledType())  
                   )
//# 4386 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13835 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4391 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _4,SynArgInfo([],true,Some _2) 
                   )
//# 4391 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13847 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4394 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1,SynArgInfo([],false,None) 
                   )
//# 4394 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13858 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4400 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.Fun(_1,_3,lhs parseState) 
                   )
//# 4400 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13870 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4403 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4403 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13881 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4406 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   checkEndOfFileError _2; _1 
                   )
//# 4406 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13893 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4411 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Tuple(false,(false,_1) :: _3,lhs parseState) 
                   )
//# 4411 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13905 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4414 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _1 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           SynType.Tuple(false,(true, SynType.StaticConstant (SynConst.Int32 1, lhs parseState)) :: _2, lhs parseState) 
                   )
//# 4414 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13918 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4418 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           SynType.Tuple(false,(true,_1) :: _3, lhs parseState) 
                   )
//# 4418 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13932 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4422 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4422 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13943 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4426 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           (false,_1) :: _3 
                   )
//# 4426 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13955 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4429 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           (true,_1) :: _3 
                   )
//# 4429 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13969 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4433 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [(false,_1)] 
                   )
//# 4433 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13980 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4437 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.LongIdent(_1) 
                   )
//# 4437 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeCon));
//# 13991 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4440 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Var(_1, lhs parseState) 
                   )
//# 4440 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeCon));
//# 14002 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4444 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedInfixOperator());
                           if _2 = "^-" then SynType.MeasurePower(_1, SynRationalConst.Negate(_3), lhs parseState)
                           else SynType.MeasurePower(_1, _3, lhs parseState)  
                   )
//# 4444 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeConPower));
//# 14017 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4449 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4449 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeConPower));
//# 14028 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayTypeSuffix)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4453 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.Array(_2,_1,lhs parseState) 
                   )
//# 4453 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14040 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayTypeSuffix)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4456 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.Array(_3,_1,lhs parseState) 
                   )
//# 4456 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14052 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4459 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.App(_2, None, [_1], [], None, true, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 4459 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14064 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypePrefixArguments)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4462 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let args, commas = _2
                             mlCompatWarning (FSComp.SR.parsMultiArgumentGenericTypeFormDeprecated()) (unionRanges (rhs parseState 1) _4.Range); 
                             SynType.App(_4, None, args, commas, None, true, unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 4462 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14079 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'powerType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4467 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4467 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14090 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4470 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              let tp,typ = _1,_3 
                              let m = lhs parseState 
                              SynType.WithGlobalConstraints(SynType.Var (tp, rhs parseState 1), [WhereTyparSubtypeOfType(tp,typ,m)],m)  
                   )
//# 4470 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14104 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4475 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.HashConstraint(_3, lhs parseState) 
                   )
//# 4475 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14115 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4479 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             1 
                   )
//# 4479 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14125 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4482 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             2 
                   )
//# 4482 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14135 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4485 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             3 
                   )
//# 4485 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14145 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4488 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             4 
                   )
//# 4488 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14155 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4492 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let typeArgs, commas = _4 in _1 :: _3 :: List.rev typeArgs, (rhs parseState 2) :: (List.rev commas) 
                   )
//# 4492 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypePrefixArguments));
//# 14168 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4496 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let typeArgs, commas = _1
                             _3 :: typeArgs, (rhs parseState 2) :: commas 
                   )
//# 4496 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14181 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'dummyTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4500 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let typeArgs, commas = _1
                            _3 :: typeArgs, (rhs parseState 2) :: commas 
                   )
//# 4500 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4505 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [], [] 
                   )
//# 4505 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14205 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4509 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4509 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'powerType));
//# 14216 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4512 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedInfixOperator());
                            if _2 = "^-" then SynType.MeasurePower(_1, SynRationalConst.Negate(_3), lhs parseState)
                            else SynType.MeasurePower(_1, _3, lhs parseState) 
                   )
//# 4512 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'powerType));
//# 14231 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypePrefixArguments)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4521 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let args, commas = _2
                             mlCompatWarning (FSComp.SR.parsMultiArgumentGenericTypeFormDeprecated()) (unionRanges (rhs parseState 1) _4.Range); 
                             SynType.App(_4, None, args, commas, None, true, unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 4521 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeNonAtomicDeprecated));
//# 14246 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4526 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4526 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeNonAtomicDeprecated));
//# 14257 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4530 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4530 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeOrAnonRecdType));
//# 14268 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4532 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let flds,isStruct = _1
                            let flds2 = 
                                flds |> List.choose (function 
                                  | (Field([],false,Some id,ty,false,_xmldoc,None,_m)) -> Some (id,ty) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None)
                            SynType.AnonRecd (isStruct,flds2, rhs parseState 1) 
                   )
//# 4532 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeOrAnonRecdType));
//# 14284 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4545 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.HashConstraint(_2, lhs parseState) 
                   )
//# 4545 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14295 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4548 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4548 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14306 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4551 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.Anon (lhs parseState) 
                   )
//# 4551 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14316 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4554 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 4554 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14328 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4557 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                            _2 
                   )
//# 4557 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14341 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4561 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Tuple(true, (false,_3) :: _5,lhs parseState) 
                   )
//# 4561 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14354 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4564 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Tuple(true, (false,_3) :: _5,lhs parseState) 
                   )
//# 4564 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14368 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4568 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4568 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14381 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4572 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4572 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14394 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4576 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14406 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4580 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.StaticConstant(_1, rhs parseState 1) 
                   )
//# 4580 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14417 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4583 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            SynType.StaticConstant(SynConst.String (null, m), m) 
                   )
//# 4583 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14428 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let e,_ = _2
                             SynType.StaticConstantExpr(e, e.Range) 
                   )
//# 4587 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14440 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4591 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.StaticConstant(SynConst.Bool false,lhs parseState) 
                   )
//# 4591 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14450 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4594 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.StaticConstant(SynConst.Bool true,lhs parseState) 
                   )
//# 4594 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14460 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4597 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) SynType.Anon (lhs parseState) 
                   )
//# 4597 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14471 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4600 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan,mGreaterThan,args,commas,mWhole = _2 in SynType.App(_1, Some(mLessThan), args, commas, mGreaterThan, false, unionRanges _1.Range mWhole) 
                   )
//# 4600 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14483 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4603 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.LongIdentApp(_1, _3, None, [], [], None, unionRanges (rhs parseState 1) _3.Range) 
                   )
//# 4603 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14495 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4606 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan,mGreaterThan,args,commas,mWhole = _4 
                            SynType.LongIdentApp(_1, _3, Some(mLessThan), args, commas, mGreaterThan, unionRanges _1.Range mWhole) 
                   )
//# 4606 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14509 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4610 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedNameAfterToken())
                            _1 
                   )
//# 4610 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14522 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4616 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan, mGreaterThan, parsedOk, args, commas, mAll = _1
                            if parsedOk then // if someone has "foo<bar" without a closing greater-than, then the lexfilter does not introduce a HPA, even though it is adjacent
                                warning(Error(FSComp.SR.parsNonAdjacentTyargs(),rhs parseState 1))
                            mLessThan, mGreaterThan, args, commas, mAll 
                   )
//# 4616 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * Ast.SynType list * range list * range));
//# 14536 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4622 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan, mGreaterThan, _, args, commas, mAll = _2
                            mLessThan, mGreaterThan, args, commas, mAll 
                   )
//# 4622 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * Ast.SynType list * range list * range));
//# 14548 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let typeArgs, commas = _5
                            (rhs parseState 1), Some(rhs parseState 6), true, (_2 :: _4 :: List.rev typeArgs), (rhs parseState 3) :: (List.rev commas), lhs parseState 
                   )
//# 4627 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14564 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4631 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _6 then 
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileTypeArgs())
                            else
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMissingGreaterThan())
                            let typeArgs, commas = _5
                            let nextToken = rhs parseState 6
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, (_2 :: _4 :: List.rev typeArgs), (rhs parseState 3) :: (List.rev commas), unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4631 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14586 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4641 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _4 then reportParseErrorAt (rhs parseState 4) (FSComp.SR.parsMissingTypeArgs())
                            let nextToken = rhs parseState 4
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [_2], [rhs parseState 3], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4641 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14602 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4647 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (rhs parseState 1), Some(rhs parseState 3), true, [_2], [], lhs parseState 
                   )
//# 4647 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14615 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4650 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let nextToken = rhs parseState 3
                            if not _3 then reportParseErrorAt nextToken (FSComp.SR.parsMissingTypeArgs())
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [_2], [], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4650 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14631 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4656 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (rhs parseState 1), Some(rhs parseState 2), true, [], [], lhs parseState 
                   )
//# 4656 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14643 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4659 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _2 then  
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsExpectedTypeAfterToken())
                            else
                                reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let nextToken = rhs parseState 2
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [], [], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4659 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14661 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4669 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4669 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14672 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4672 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.StaticConstantNamed(_1, _3, unionRanges _1.Range _3.Range) 
                   )
//# 4672 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14684 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let dummy = SynType.StaticConstant(SynConst.Int32(0), rhs parseState 2)
                            SynType.StaticConstantNamed(_1, dummy, (rhs2 parseState 1 2))
                          
                   )
//# 4675 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14698 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4682 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4682 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActualOrDummyIfEmpty));
//# 14709 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'dummyTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4685 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMissingTypeArgs())
                            _1 
                   )
//# 4685 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActualOrDummyIfEmpty));
//# 14721 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4690 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            let dummyStatVal = SynType.StaticConstant(SynConst.Int32(0), m)
                            let dummyName = SynType.LongIdent(LongIdentWithDots([ident("",m)],[]))
                            let dummyTypeArg = SynType.StaticConstantNamed(dummyName, dummyStatVal, m)
                            dummyTypeArg 
                   )
//# 4690 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dummyTypeArg));
//# 14735 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 4699 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeArg));
//# 14748 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4702 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Anon (lhs parseState) 
                   )
//# 4702 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeArg));
//# 14760 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4706 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Named(_1.Lid, _1.Range) 
                   )
//# 4706 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14771 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4709 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Var(_1, lhs parseState) 
                   )
//# 4709 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14782 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 4712 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14794 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeAtom)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4716 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4716 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14805 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeAtom)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4719 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                            if _2 = "^-" then SynMeasure.Power(_1, SynRationalConst.Negate(_3), lhs parseState)
                            else SynMeasure.Power(_1, _3, lhs parseState) 
                   )
//# 4719 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14820 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if fst _1 <> 1 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedIntegerLiteralForUnitOfMeasure());
                            SynMeasure.One 
                   )
//# 4724 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14832 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypePower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4729 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [_1] 
                   )
//# 4729 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeSeq));
//# 14843 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypePower)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4732 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 :: _2 
                   )
//# 4732 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeSeq));
//# 14855 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4736 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynMeasure.Seq(_1, lhs parseState) 
                   )
//# 4736 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14866 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4739 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynMeasure.Product(_1, _3, lhs parseState) 
                   )
//# 4739 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14878 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "*" && _2 <> "/" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                           if _2 = "*" then SynMeasure.Product(_1, _3, lhs parseState)
                           else SynMeasure.Divide(_1, _3, lhs parseState) 
                   )
//# 4742 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14893 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4747 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _1 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                            SynMeasure.Divide(SynMeasure.One, _2, lhs parseState) 
                   )
//# 4747 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14906 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4752 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let id = mkSynId (lhs parseState) (_2).idText
                             Typar(id, NoStaticReq,false) 
                   )
//# 4752 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypar));
//# 14918 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4756 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4756 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypar));
//# 14929 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4760 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _1 <> "^" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedTypeParameter());
                            let id = mkSynId (lhs parseState) (_2).idText
                            Typar(id,HeadTypeStaticReq,false) 
                   )
//# 4760 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypar));
//# 14943 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4768 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            ident(_1,rhs parseState 1) 
                   )
//# 4768 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.Ident));
//# 14954 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4774 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             LongIdentWithDots([ident(MangledGlobalName,rhs parseState 1)],[]) 
                   )
//# 4774 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14964 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4777 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4777 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14975 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4780 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let (LongIdentWithDots(lid,dotms)) = _1 in LongIdentWithDots(lid @ [_3], dotms @ [rhs parseState 2]) 
                   )
//# 4780 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14987 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4783 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedNameAfterToken())
                            let (LongIdentWithDots(lid,dotms)) = _1 in LongIdentWithDots(lid, dotms @ [rhs parseState 2])  
                   )
//# 4783 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15000 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'operatorName)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4790 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ident(CompileOpName _2,rhs parseState 2) 
                   )
//# 4790 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15012 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4793 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (lhs parseState) (FSComp.SR.parsErrorParsingAsOperatorName()); ident(CompileOpName "****",rhs parseState 2) 
                   )
//# 4793 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15023 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ident(CompileOpName "*",rhs parseState 1) 
                   )
//# 4796 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15033 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let text = ("|" + String.concat "|" (List.rev _2) + "|")
                            ident(text,rhs2 parseState 2 3) 
                   )
//# 4800 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15046 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4805 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let text = ("|" + String.concat "|" (List.rev _2) + "|_|" )
                            ident(text,rhs2 parseState 2 5) 
                   )
//# 4805 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15059 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4811 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorDefinitionName _1) then 
                                 reportParseErrorAt (lhs parseState) (FSComp.SR.parsInvalidPrefixOperatorDefinition());
                             _1 
                   )
//# 4811 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4815 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               _1 
                   )
//# 4815 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4817 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            _1 
                   )
//# 4817 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            _1 
                   )
//# 4819 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15105 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4821 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         _1 
                   )
//# 4821 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15116 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 4823 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15127 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4825 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          _1 
                   )
//# 4825 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15138 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 _1 
                   )
//# 4827 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15149 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4829 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  "$" 
                   )
//# 4829 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15159 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              _1 
                   )
//# 4831 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15170 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4833 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 "-" 
                   )
//# 4833 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15180 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4835 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                "*" 
                   )
//# 4835 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15190 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4837 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  "=" 
                   )
//# 4837 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15200 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4839 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              "or" 
                   )
//# 4839 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4841 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                "<" 
                   )
//# 4841 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15221 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4843 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   ">" 
                   )
//# 4843 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15232 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 "?" 
                   )
//# 4845 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15242 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4847 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               "&" 
                   )
//# 4847 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15252 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4849 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   "&&" 
                   )
//# 4849 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15262 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4851 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   "||" 
                   )
//# 4851 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15272 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4853 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        ":=" 
                   )
//# 4853 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15282 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4856 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> ".[]"  && _1 <> ".()" && _1 <> ".()<-" then 
                                  deprecatedOperator (lhs parseState); 
                             _1 
                   )
//# 4856 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15295 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4860 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      _1 
                   )
//# 4860 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15306 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4862 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   ".." 
                   )
//# 4862 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15316 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           ".. .." 
                   )
//# 4864 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4867 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMismatchedQuotationName(fst _1));  
                             fst _1 
                   )
//# 4867 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15339 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4873 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (String.isUpper _1) then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsActivePatternCaseMustBeginWithUpperCase());  
                             if (_1.IndexOf('|') <> -1) then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsActivePatternCaseContainsPipe());  
                             _1 
                   )
//# 4873 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseName));
//# 15352 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4880 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_2] 
                   )
//# 4880 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseNames));
//# 15363 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 4883 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseNames));
//# 15375 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4888 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4888 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'identOrOp));
//# 15386 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4891 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4891 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'identOrOp));
//# 15397 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4897 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4897 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15408 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4900 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15419 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4903 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let (LongIdentWithDots(lid,dotms)) = _3 in LongIdentWithDots(_1 :: lid, rhs parseState 2 :: dotms) 
                   )
//# 4903 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4906 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) LongIdentWithDots([_1],[rhs parseState 2]) 
                   )
//# 4906 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15442 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'identOrOp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      _1 
                   )
//# 4911 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'nameop));
//# 15453 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4914 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4914 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15463 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4915 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4915 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15473 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4916 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4916 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15483 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4919 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                            
                   )
//# 4919 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparators));
//# 15494 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      
                   )
//# 4920 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparators));
//# 15506 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4923 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          
                   )
//# 4923 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topSeparators));
//# 15518 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4924 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          
                   )
//# 4924 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topSeparators));
//# 15528 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4928 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4928 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15538 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4929 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4929 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15548 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4930 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4930 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15558 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4931 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15568 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4936 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4936 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15578 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4938 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4938 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15588 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4940 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4940 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15598 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4945 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15608 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4947 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15618 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4949 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4949 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15628 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4951 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4951 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15638 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4954 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4954 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_ODECLEND));
//# 15648 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4955 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4955 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_ODECLEND));
//# 15658 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4958 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       deprecatedWithError (FSComp.SR.parsNoEqualShouldFollowNamespace()) (lhs parseState); () 
                   )
//# 4958 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'deprecated_opt_equals));
//# 15668 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4959 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        
                   )
//# 4959 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'deprecated_opt_equals));
//# 15678 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4962 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4962 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_OBLOCKSEP));
//# 15688 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4963 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4963 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_OBLOCKSEP));
//# 15698 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4966 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4966 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps));
//# 15709 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4967 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4967 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps));
//# 15719 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4970 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_rec));
//# 15729 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4971 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4971 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_rec));
//# 15739 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4974 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4974 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_bar));
//# 15749 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4975 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4975 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_bar));
//# 15759 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4978 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4978 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inline));
//# 15769 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4979 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inline));
//# 15779 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4982 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4982 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_mutable));
//# 15789 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4983 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4983 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_mutable));
//# 15799 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4987 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4987 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doToken));
//# 15809 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4988 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doToken));
//# 15819 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                
                   )
//# 4991 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doneDeclEnd));
//# 15829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4992 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    
                   )
//# 4992 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doneDeclEnd));
//# 15839 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4995 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  mlCompatWarning (FSComp.SR.parsSyntaxModuleStructEndDeprecated()) (lhs parseState); 
                   )
//# 4995 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'structOrBegin));
//# 15849 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4996 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 
                   )
//# 4996 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'structOrBegin));
//# 15859 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4999 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               mlCompatWarning (FSComp.SR.parsSyntaxModuleSigEndDeprecated()) (lhs parseState); 
                   )
//# 4999 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'sigOrBegin));
//# 15869 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 
                   )
//# 5000 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'sigOrBegin));
//# 15879 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5003 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 mlCompatWarning (FSComp.SR.parsSyntaxModuleSigEndDeprecated()) (lhs parseState); 
                   )
//# 5003 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'colonOrEquals));
//# 15889 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5004 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5004 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'colonOrEquals));
//# 15899 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5008 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  _1 
                   )
//# 5008 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'stringOrKeywordString));
//# 15910 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5009 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          _1 
                   )
//# 5009 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'stringOrKeywordString));
//# 15921 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5012 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5012 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15931 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5013 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5013 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15941 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5014 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         
                   )
//# 5014 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15951 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 
                   )
//# 5017 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_TYAPP));
//# 15961 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         
                   )
//# 5018 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_TYAPP));
//# 15971 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5022 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        
                   )
//# 5022 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 15982 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        
                   )
//# 5023 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 15992 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5024 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                
                   )
//# 5024 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 16002 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5028 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                            
                   )
//# 5028 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 16013 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5029 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 16023 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5030 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5030 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 16033 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5033 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5033 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16044 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5034 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16054 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5035 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5035 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16064 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5038 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      
                   )
//# 5038 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'bar_rbrace));
//# 16074 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5041 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5041 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16085 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5042 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16095 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5043 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16105 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5046 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                           
                   )
//# 5046 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16116 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             
                   )
//# 5047 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5048 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 5048 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16136 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5051 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            false 
                   )
//# 5051 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16146 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5052 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5052 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16156 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5053 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16166 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5054 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 false 
                   )
//# 5054 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16176 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5055 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 5055 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16187 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5058 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            false 
                   )
//# 5058 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16197 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5059 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5059 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16207 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5060 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5060 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16217 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5061 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5061 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16227 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5062 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 false 
                   )
//# 5062 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16237 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5063 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 5063 "/Users/alfonsogarciacaronunez/dev/fsharp_fable/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
|]
//# 16249 "pars.fs"
let tables () : Internal.Utilities.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Internal.Utilities.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 197;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let signatureFile lexer lexbuf : Ast.ParsedSigFile =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
let implementationFile lexer lexbuf : Ast.ParsedImplFile =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 2))
let interaction lexer lexbuf : Ast.ParsedFsiInteraction =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 4))
let typedSeqExprEOF lexer lexbuf : Ast.SynExpr =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 6))
let typEOF lexer lexbuf : Ast.SynType =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 8))
